DCBINI ;
 ;	$DCBINIT - code to initialize DCB's
 ;
 ;
 OVLYH	EQU	019DH		;high overlay flag
 LOCDCB	EQU	032AH		;locate DCB
 LOCDCT	EQU	032DH		;locate DCT
 KEYBUFF	EQU	1AA0H		;keyboard buffer
 ;
 KBINIT	EQU	1		;init keyboard
 VDINIT	EQU	7		;init video
 PRINIT	EQU	17		;init printer
 RS232C	EQU	55		;init RS232
 ;
 SVC	EQU	08H		;execute SVC
 ;
 DDCB	EQU	1		;display DCB #
 PRDCB	EQU	2		;printer DCB #
 ;
 RETN	EQU	45EDH		;RETN opcode
 ;
 ;
 ;	$DCBINIT - init all DCBS
 ;
 DCBINIT	EQU	$
 ;
 ;
 ;	initialize keyboard
 ;
 	LD	A,KBINIT	;SVC #
 	RST	SVC		;init it
 ;
 ;	initialize display
 ;
 	LD	A,DDCB		;display DCB
 	CALL	LOCDCB		;find it
 ;
 	LD	A,(IX+10)	;get flag
 	AND	80H		;normal reverse
 	LD	C,A		;save param
 ;
 	LD	A,(IX+9)	;get flag
 	AND	10H		;char/line
 	CPL			;reverse it
 	LD	B,A		;save param
 ;
 	LD	A,VDINIT	;video init
 	RST	SVC		;init it
 ;
 ;	initialize printer
 ;
 	LD	A,PRDCB		;DCB #
 	CALL	LOCDCB		;find it
 ;
 	LD	B,(IX+20)	;page length
 	LD	C,(IX+19)	;printed lines
 	LD	D,(IX+22)	;max chars/line
 ;
 	LD	A,PRINIT	;SVC #
 	RST	SVC		;init it
 ;
 ;	initialize RS232 channels
 ;
 	LD	A,'A'		;channel A
 	JR	INITRS		;init it
 BACK1	LD	A,'B'		;channel B
 	JR	INITRS		;init it
 ;
 ;	initialize all disk drives
 ;
 BACK2	LD	BC,0800H	;B=looper, C=drive
 ;
 DRVLP	CALL	LOCDCT		;locate the DCT
 	SET	0,(IY+5)	;force an init next time
 ;
 	INC	C		;bump drive
 	DJNZ	DRVLP		;do all 8
 ;
 ;	all done, move data to correct areas
 ;
 	JR	MOVDAT		;move it in
 ;
 INITRS	LD	HL,KEYBUFF	;use keyboard buffer
 	LD	(HL),A		;put in the data area
 	SUB	'A'-3		;get DCB #
 	CALL	LOCDCB		;load IX with DCB
 ;
 	BIT	1,(IX+5)	;channel initialized?
 	JR	NZ,INITRSO	;turn it off
 ;
 	LD	A,(IX+25)	;get flag byte
 	PUSH	HL		;save pointer
 	INC	HL		;bump it
 ;
 ;	fetch baud rate
 ;
 	PUSH	AF		;save byte
 	RRCA			;align it to low bits
 	RRCA
 	RRCA
 	RRCA
 	AND	7		;low 3 only
 	LD	(HL),A		;put into param block
 	POP	AF		;restore it
 	INC	HL		;bump it
 ;
 ;	fetch word length
 ;
 	PUSH	AF		;save again
 	AND	0CH		;bits 2&3 only
 	LD	(HL),A		;put into block
 	POP	AF		;restore
 	INC	HL		;next
 ;
 ;	fetch parity
 ;
 	LD	B,'N'		;no parity
 	AND	3		;low 2 bits
 	JR	Z,RSIG		;have it
 	DEC	A		;1?
 	LD	B,'O'		;odd parity
 	JR	Z,RSIG		;have it
 	LD	B,'E'		;even parity
 ;
 RSIG	LD	(HL),B		;put in buffer
 	INC	HL		;bump pointer
 ;
 ;	fetch stop bits
 ;
 	LD	A,(IX+5)	;get flag
 	RRCA			;align it
 	RRCA
 	AND	3		;low 2 only
 	LD	(HL),A		;put in buffer
 ;
 	POP	HL		;get start back
 	LD	B,-1		;turn on channel
 ;
 INITCONT LD	A,RS232C	;init the RS232
 	RST	SVC		;do it
 ;
 RSIRET	LD	A,(KEYBUFF)	;get which one done
 	CP	'A'		;channel A?
 	JR	Z,BACK1		;yes, do B
 	JR	BACK2		;no, continue
 ;
 INITRSO	LD	B,0		;turn off channel
 	LD	HL,KEYBUFF	;key buffer
 	LD	(HL),A		;put in channel
 	JR	INITCONT	;continue
 ;
 MOVDAT	LD	HL,(0066H)	;fetch NMI data
 	PUSH	HL		;save on stack
 	LD	HL,RETN		;RETN opcode
 	LD	(0066H),HL	;disable NMI
 ;
 	DI			;disable interrupts
 	LD	HL,2800H	;data is here
 	LD	DE,0100H	;it goes here
 	LD	BC,400H		;length of code
 	LDIR			;move it in
 ;
 MEMVEC	JR	MOVTOP		;move top memory in
 ;
 MEMRET	POP	HL		;fetch NMI data
 	LD	(0066H),HL	;put it back
 	EI			;can enable now
 	XOR	A		;set ZERO
 	RET			;back to caller
 ;
 MOVTOP	LD	HL,2C00H	;data is here
 	LD	DE,0		;where it goes
 MEMWHR	EQU	$-2		;set from WRITDATA
 	LD	BC,0		;how long it is
 MEMLEN	EQU	$-2		;set from WRITDATA
 	LDIR			;move it in
 	JR	MEMRET		;continue
 ;
 DCBINITL EQU	$-DCBINIT
