DIRCHE ; dircheck/asm - kjw/bqsd - 07/82
 ;
 	TITLE	'<Dos+ II - Directory Checker - A.00>'
 ;
 	ORG	2200H		;high overlay area
 ;
 VDLINE	EQU	9		;line to video
 VIDKEY	EQU	12		;video/keyboard
 FSPEC	EQU	84		;fetch file spec
 OPEN	EQU	40		;open file
 VDCHAR	EQU	8		;character to video
 KBCHAR	EQU	4		;character from keyboard
 SERROR	EQU	39		;display error
 FDRV	EQU	89		;fetch drive spec
 HLDKEY	EQU	29		;hold processor
 BINDEC	EQU	21		;binary to decimal
 SETBRK	EQU	3		;setup break processor
 ;
 LOCDCT	EQU	032DH		;locate drive DCT
 UCASE	EQU	031EH
 REGSAV	EQU	0303H
 TOPMEM	EQU	0180H
 OVLYH	EQU	019DH		;high overlay in memory
 ;
 DCHECK	EQU	0		;check drive for ready
 DREAD	EQU	3		;read sector
 SREAD	EQU	6		;read system sector
 ;
 SVC	EQU	8		;execute SVC
 DISKIO	EQU	10H		;direct disk I/O
 ;
 NOTIN	EQU	58		;device not avail
 IMEM	EQU	82		;'insufficient memory'
 ERROR2	EQU	19		;conversion
 ERROR5	EQU	92
 ERROR7	EQU	93
 ERROR8	EQU	94
 ERROR10	EQU	95
 ERROR11	EQU	96
 ;
 	PAGE
 ;
 ;	program entry point
 ;
 ENTRY	LD	(STACK),SP	;save stack pointer
 	LD	A,-1		;clear the current overly
 	LD	(OVLYH),A	;set to nil
 ;
 	PUSH	HL		;save command pointer
 	LD	HL,HELLO	;sign on message
 	CALL	DISPLAY		;display message
 ;
 	LD	HL,0		;turn off break processor
 	LD	A,SETBRK	;SVC #
 	RST	SVC
 ;
 	LD	A,HLDKEY	;turn on hold processor
 	LD	B,0		;turn it off
 	RST	SVC
 ;
 	POP	HL		;restore pointer
 ;
 ;	evaluate input line
 ;
 SCAN	CALL	POSHL		;position to input
 	JR	C,APARMS	;nil, prompt for input
 ;
 CNTSCN	CP	':'		;drive requested?
 	JP	NZ,MAPFIL	;nope, map a file
 	INC	HL		;bump pointer
 ;
 ;	drive being mapped
 ;
 MAPDRV	LD	A,FDRV		;fetch drivespec
 	RST	SVC		;get it
 	JR	NZ,ERROR	;error, prompt again
 	SUB	8		;make it 0-7 for DCT
 	LD	(DRIVE),A	;save drive number
 	JP	CONT1		;check it!
 ;
 ;	file being mapped
 ;
 MAPFIL	LD	DE,DCB		;DCB area for file
 	LD	A,FSPEC		;fetch filespec
 	RST	SVC		;get it
 	JP	Z,CONT3		;go if good!
 	JR	ERROR
 ;
 ;	error vector
 ;	display the error, and prompt for command
 ;
 PERROR	LD	A,3		;parameter error
 ;
 ERROR	AND	7FH		;make sure it returns
 	LD	B,A		;pass number here
 	LD	A,SERROR	;SVC #
 	RST	SVC		;dislay the error
 	JR	APARMS		;ask again
 ;
 ;	program exit vectors
 ;
 TERMIN	LD	HL,EXMSG	;banner message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,ABMSG	;program aborted
 	CALL	DISPLAY		;display it
 ;
 LEAVE	LD	SP,0		;reset stack
 STACK	EQU	$-2
 	XOR	A		;set Z
 	RET			;back to caller
 ;
 ;	prompt for parameters
 ;
 APARMS	LD	SP,(STACK)	;reset stack
 	LD	HL,PMSG		;prompt line
 	LD	BC,1<8+79	;disp len + key len
 	LD	DE,STRING	;input buffer
 	LD	A,VIDKEY	;SVC #
 	RST	SVC		;display & keyboard
 ;
 	JR	NZ,ERROR	;display error
 	JR	C,TERMIN	;break, terminate
 ;
 	CALL	POSHL		;any input?
 	JR	NC,SCAN		;yep, scan it!
 ;
 	LD	HL,HELP1	;help list
 	CALL	DISPLAY		;show the syntax
 	JR	APARMS		;ask again
 ;
 	PAGE
 ;
 ;	$POSHL	- position HL to first significant char
 ;
 	INC	HL		;bump pointer
 POSHL	LD	A,(HL)		;fetch a character
 ;
 	CP	' '		;separator?
 	JR	Z,POSHL-1	;get next if yes
 	CP	','		;sep?
 	JR	Z,POSHL-1	;go if yes
 ;
 	CP	13		;terminator?
 	SCF			;C = yes
 	RET	Z		;yes, return
 	CP	3		;term?
 	SCF
 	RET	Z		;yes, return
 	CP	';'		;term?
 	SCF
 	RET	Z		;yes, go back
 ;
 	CP	A		;nope, clear carry
 	RET			;back
 ;
 	PAGE
 ;
 ;	$BADRD	- disk error intercept
 ;
 BADRD	LD	(ERNO),A	;save error number
 	SUB	56		;read system sector?
 	RET	Z		;ignore error
 	DEC	A		;read deleted sector?
 	RET	Z		;ignore it
 ;
 	CALL	REGSAV		;save registers
 ;
 	LD	HL,BADRMSG	;read error message
 	CALL	DISPLAY		;display message
 ;
 	LD	B,0		;fetch error number
 ERNO	EQU	$-1
 	RES	7,B		;assure a return
 	LD	A,SERROR	;SVC #
 	RST	SVC		;display error
 ;
 ;	prompt for retry, skip, abort
 ;
 GETBAD	LD	HL,ASKBAD	;prompt message
 	LD	BC,ASKBADL<8+1	;one key input
 	LD	DE,STRING	;input buffer
 	LD	A,VIDKEY	;display & fetch keys
 	RST	SVC		;do it
 	JR	NZ,ERROR	;error, abort
 	JP	C,TERMIN	;BREAK, abort
 ;
 	LD	A,(HL)		;fetch the key
 	CALL	UCASE		;make it upper case
 ;
 	CP	'S'		;skip?
 	RET	Z		;yes, return Z
 ;
 	CP	'R'		;retry?
 	JR	NZ,GETBAD	;nope, ask again
 	OR	1		;yes, return NZ
 	RET			;back to caller
 ;
 	PAGE
 ;
 ;	vector to check a drive
 ;
 CONT1	LD	C,0		;fetch drive number
 DRIVE	EQU	$-1
 	CALL	LOCDCT		;load IY with DCT
 	LD	A,DCHECK	;check drive
 	RST	DISKIO		;check it out
 	LD	A,NOTIN		;not available
 	JP	NZ,ERROR	;no good, restart
 ;
 	LD	HL,0		;set error counter
 	LD	(ERRORS),HL	;to zero
 ;
 	CALL	SETUPS		;setup pointers
 	JR	CONT2		;continue
 ;
 	PAGE
 ;
 ;	$SETUPS	- setup information from DCT
 ;
 SETUPS	CALL	CLRGAT		;clear the GAT table
 	CALL	CLRHIT		;clear the HIT table
 ;
 	LD	A,(IY+21)	;grans/cylinder
 	LD	E,1		;set mask bit
 	DEC	A		;less one
 ;
 GPTSF	JR	Z,GOTGPT	;have the mask
 	SLA	E		;move mask bit
 	DEC	A		;less gran
 	JR	GPTSF		;go again
 GOTGPT	LD	A,E		;fetch mask
 	LD	(TOPGRAN),A	;save top gran mask
 ;
 ;	check for sufficient memory
 ;
 	LD	HL,(TOPMEM)	;fetch topmem
 	LD	B,(IY+22)	;fetch top sector
 	LD	DE,BUFFER	;end of program buffer
 	DEC	H		;make an even page
 	LD	L,0		;HL = last full page
 	OR	A		;clear carry flag
 	SBC	HL,DE		;compare
 ;
 	LD	A,H		;fetch # pages available
 	CP	B		;enough?
 	JR	NC,MEMOK	;yes, continue
 	LD	A,IMEM		;error number
 	JP	ERROR		;can't check this drive
 ;
 ;	all OK, read in the directory
 ;
 MEMOK	CALL	RDDIR		;read directory
 	JP	NZ,ERROR	;error, abort
 ;
 	CALL	SHOWDRV		;display details
 	JP	NZ,ERROR	;not in system
 ;
 ;	compute # free grans
 ;
 	LD	HL,BUFFER	;start of buffer
 	LD	B,(IY+16)	;fetch cylinder count
 	LD	DE,0		;DE = free gran counter
 ;
 FREELP	LD	C,8		;check 8 bits
 	LD	A,(HL)		;get GAT byte
 FREEL	RRA			;shift out a bit
 	CALL	NC,BUMPDE	;bump DE if set
 	DEC	C		;C = bit counter
 	JR	NZ,FREEL	;go more
 	INC	HL		;next track
 	DJNZ	FREELP		;do all tracks
 ;
 	LD	HL,FREEMSG	;message for ascii
 	PUSH	HL		;save string pointer
 	CALL	WRLNO		;move DE>HL in ascii
 ;
 ;	fetch name and date
 ;
 	LD	HL,BUFFER+0D0H	;name
 	LD	DE,NAMMSG	;string to put it
 	LD	BC,8		;8 chars
 	PUSH	BC		;save count
 	LDIR			;move it in
 	POP	BC		;restore count
 	LD	DE,DATMSG	;date string
 	LDIR			;move it in
 ;
 	POP	HL		;get message ptr back
 	JP	DISPLAY		;display in dual mode
 ;
 ;
 CONT2	LD	HL,BUFFER+200H	;start of file entries
 	LD	(DIRPOS),HL	;save position
 	LD	A,2		;current real sector
 	LD	(DIRSEC),A	;save it
 	LD	A,(IY+22)	;fetch top sector
 	SUB	2		;less 2
 	LD	B,A		;here for looper
 	LD	DE,20H		;offset between files
 ;
 ;	use bit 5 as a flag bit, reset 'em all
 ;
 CK00	LD	C,8		;8 entries / sector
 CK000	RES	5,(HL)		;reset it
 	ADD	HL,DE		;point to next one
 	DEC	C		;less sector counter
 	JR	NZ,CK000	;finish this sector
 	DJNZ	CK00		;do rest of directory
 ;
 ;	setup loop to check all files
 ;
 CHKLP	LD	HL,0		;get directory position
 DIRPOS	EQU	$-2
 	BIT	4,(HL)		;active entry?
 ;
 	PUSH	AF		;save the flag
 	CALL	NZ,CHECKA	;checker A (GAT)
 	POP	AF		;restore flag
 ;
 	PUSH	AF		;put 'em back
 	CALL	NZ,CHECKB	;checker B (HIT)
 	POP	AF
 ;
 	CALL	NZ,CHECKC	;checker C
 ;
 	LD	HL,(DIRPOS)	;refetch position
 	LD	BC,20H		;offset between
 	ADD	HL,BC		;next entry
 	LD	(DIRPOS),HL	;resave position
 ;
 	LD	A,L		;see if new sector
 	OR	A		;at relative 00?
 	JR	NZ,CHKLP	;nope, continue
 ;
 	LD	A,0		;fetch directory sector
 DIRSEC	EQU	$-1
 	INC	A		;bump it
 	LD	(DIRSEC),A	;resave it
 	CP	(IY+22)		;test for top sector
 	JR	NZ,CHKLP	;nope, go more
 ;
 	BIT	5,(IY+5)	;rigid drive?
 	JR	NZ,GOTRIG	;yes, skip lockout
 ;
 ;	merge lockout table with created GAT
 ;
 	LD	DE,BUFFER+60H	;start of table
 	LD	HL,GATBUFF	;created table
 	LD	B,(IY+16)	;get cylinder count
 ;
 RIGLP	LD	A,(DE)		;get lockout byte
 	OR	(HL)		;merge with GAT
 	LD	(HL),A		;put in table
 	INC	DE		;bump table pointers
 	INC	HL
 	DJNZ	RIGLP		;finish it off
 ;
 GOTRIG	LD	HL,BUFFER	;GAT from disk
 	LD	DE,GATBUFF	;created GAT
 	LD	B,(IY+16)	;cylinder count
 	LD	C,0		;relative cylinder
 ;
 CHECKD	LD	A,(DE)		;get a byte
 	CP	(HL)		;same?
 	CALL	NZ,CHECKDB	;nope, display it
 	INC	DE		;bump pointers
 	INC	HL
 	INC	C		;bump relative cylinder
 	DJNZ	CHECKD		;finish it off
 ;
 ;	check HIT table
 ;
 	LD	HL,BUFFER+100H	;start of HIT
 	LD	DE,HITBUFF	;created HIT
 	LD	BC,0		;B=looper, C=rel byte
 ;
 CHECKE	LD	A,(DE)		;get a byte
 	CP	(HL)		;same?
 	CALL	NZ,CHECKEB	;nope, display it
 	INC	HL		;bump pointers
 	INC	DE
 	INC	C		;bump rel byte
 	DJNZ	CHECKE		;do 'em all
 ;
 ;	check for extraneous files leftover
 ;
 	LD	HL,BUFFER+200H	;start of records
 	LD	(DIRPOS),HL	;save position
 	LD	A,2		;relative sector
 	LD	(DIRSEC),A	;save it
 ;
 CHECK3	BIT	4,(HL)		;active entry?
 	CALL	NZ,LEFTOVER	;yes, show it
 	LD	BC,20H		;offset between
 	ADD	HL,BC		;next entry
 	LD	(DIRPOS),HL	;update position
 ;
 	LD	A,L		;see if new sector
 	OR	A		;yes?
 	JR	NZ,CHECK3	;nope, continue
 ;
 	LD	A,(DIRSEC)	;fetch dir sector
 	INC	A		;bump it
 	LD	(DIRSEC),A	;put it back
 	CP	(IY+22)		;test for end
 	JR	NZ,CHECK3	;nope, continue
 	JP	COMPLETE	;program completed
 ;
 ;	active file, see if checked
 ;
 LEFTOVER BIT	5,(HL)		;flag bit set?
 	RET	NZ		;yes, it's OK
 ;
 	PUSH	HL		;save pointer
 	LD	HL,ERROR12	;error message
 	CALL	SHOWERR		;display it & count
 	POP	HL		;restore pointer
 	RET			;return
 ;
 	PAGE
 ;
 ;	$CHECKB	- check HIT table
 ;
 CHECKB	LD	HL,(DIRPOS)	;get record pointer
 	BIT	7,(HL)		;extension?
 	RET	NZ		;skip if yes
 ;
 	PUSH	HL		;save pointer
 	POP	IX		;pass it here
 	LD	DE,BUFFER+200H	;start of file records
 	OR	A		;clear carry
 	SBC	HL,DE		;compute relative HIT
 	LD	A,H		;fetch relative sector
 	OR	L		;or with relative byte
 	LD	(DEC),A		;save directory entry cod
 ;
 	CALL	HASH		;compute HASH for file
 	LD	(HIT),A		;save it
 ;
 CHECKA1	LD	HL,BUFFER+100H	;HIT table
 	LD	L,0		;get directory entry code
 DEC	EQU	$-1
 ;
 	LD	A,(HL)		;get the byte
 	OR	A		;check for nil hit
 	JR	Z,ZERHIT	;yes, display it
 	LD	A,0		;get real HIT byte
 HIT	EQU	$-1
 	CP	(HL)		;same?
 	JR	Z,HITOK		;yes, continue
 ;
 	LD	HL,ERROR18	;error message
 	JR	HITERR		;display it
 ;
 ZERHIT	LD	HL,ERROR19	;error message
 ;
 HITERR	CALL	SHOWERR		;display the error
 ;
 HITOK	LD	HL,HITBUFF	;computed table
 	LD	A,(DEC)		;get DEC
 	LD	L,A		;HL => relative byte
 	LD	A,(HIT)		;get HIT
 	LD	(HL),A		;save actual byte
 ;
 	LD	IX,(DIRPOS)	;get current position
 ;
 ;	check for any extended entries
 ;
 HITAA	LD	B,5		;5 extent areas max
 ;
 HITA	LD	A,(IX+22)	;get extent byte
 	CP	0FFH		;terminator?
 	RET	Z		;yes, return
 	CP	0FEH		;extension?
 	JR	Z,HITB		;yes, check it out
 ;
 	INC	IX		;next extent
 	INC	IX
 	DJNZ	HITA		;go more
 	RET			;done with this record
 ;
 HITB	LD	A,(IX+23)	;get extension DEC
 	AND	0E0H		;compute relative byte
 	LD	C,A		;save here
 	LD	A,(IX+23)	;get again
 	LD	(DEC),A		;save it
 	AND	1FH		;get relative sector
 	LD	B,A		;save here, BC = offset
 	LD	HL,BUFFER+200H	;start of records
 	ADD	HL,BC		;point to record
 	PUSH	HL		;pass it
 	POP	IX		;to IX for next loop
 ;
 	LD	HL,BUFFER+100H	;HIT table
 	LD	A,(DEC)		;get entry code
 	LD	L,A		;HL => relative byte
 	LD	A,(HL)		;get it
 	OR	A		;zero?
 	JR	Z,DOZERHIT	;zero extension
 	LD	A,(HIT)		;get hit
 	CP	(HL)		;same?
 	JR	Z,HITOKA	;yes, continue
 ;
 	LD	HL,ERROR22	;error message
 	JR	DOERHIT		;post the error
 ;
 DOZERHIT LD	HL,ERROR21	;error message
 ;
 DOERHIT	CALL	SHOWERR		;display the error
 ;
 HITOKA	LD	HL,HITBUFF	;created table
 	LD	A,(DEC)		;get entry code
 	LD	L,A		;HL => rel byte
 	LD	A,(HIT)		;get real HIT
 	LD	(HL),A		;save in created table
 	JP	HITAA		;continue with extension
 ;
 	PAGE
 ;
 ;	$CHECKA	- check GAT table
 ;
 CHECKA	LD	HL,(DIRPOS)	;get position
 	BIT	7,(HL)		;extended record?
 	RET	NZ		;yes, skip this file
 ;
 	SET	5,(HL)		;flag as done
 	PUSH	HL		;pass pointer
 	POP	IX		;to IX
 	LD	B,11		;check filename area
 ;
 CK1A	LD	A,(IX+5)	;get a byte
 	CALL	VALCHR		;valid file char?
 	JR	Z,CK1B		;nope, invalid
 ;
 	INC	IX		;bump to next char
 	DJNZ	CK1A		;finish it off
 	JR	CK1C		;check next function
 ;
 CK1B	LD	A,ERROR2	;error message
 	CALL	SHOWER		;display it
 ;
 CK1C	LD	IX,(DIRPOS)	;next record
 	PUSH	IX		;pass to HL
 	POP	HL
 	LD	DE,BUFFER+200H	;start of names
 	OR	A		;clear carry
 	SBC	HL,DE		;compute DEC
 	LD	A,H		;fetch DEC into A
 	OR	L
 	LD	(DEC),A		;save it
 	LD	BC,0		;for file positioning
 	LD	(RELSEC),BC	;save relative sector
 ;
 CK1D	XOR	A		;set rel extent to 0
 	LD	(CKEXT),A	;save it
 ;
 CK1E	LD	A,(IX+22)	;get extent byte
 	CP	0FFH		;terminator?
 	JP	Z,DONEWITH	;yes, done with it
 	CP	0FEH		;extension?
 	JR	Z,NXFIL		;yes, get it
 ;
 	LD	D,A		;save rel track
 	LD	E,0		;start sector
 	LD	C,(IY+20)	;sectors / gran
 	LD	A,(IX+23)	;get extent
 	AND	0E0H		;start grans bit
 	SRL	A
 	SRL	A
 	SRL	A
 	SRL	A
 	SRL	A		;align the bits
 GNLP	OR	A		;have it?
 	JR	Z,STGN		;have it
 	PUSH	AF		;save
 	LD	A,E		;get current sector
 	ADD	A,C		;add sect/gran
 	LD	E,A		;put it back
 	POP	AF		;get counter
 	DEC	A		;less one
 	JR	GNLP		;try again
 ;
 STGN	LD	A,(IX+23)	;get extent
 	AND	1FH		;number of grans
 	INC	A		;make it real
 	LD	C,A		;save here
 	CALL	SHOPRT		;check it out
 ;
 	INC	IX		;bump to next element
 	INC	IX
 ;
 	LD	A,0		;see if end of extents
 CKEXT	EQU	$-1
 	INC	A		;bump it
 	LD	(CKEXT),A	;put it back
 	CP	5		;used 5 now?
 	JR	NZ,CK1E		;nope, continue
 ;
 	LD	A,ERROR5	;error message
 	JP	SHOWER		;display it
 ;
 NXFIL	LD	A,(CKEXT)	;get extent
 	CP	4		;last one?
 	LD	HL,ERROR9	;assigned too early!
 	CALL	NZ,SHOWERR	;display error if true
 ;
 	LD	A,(IX+23)	;get element back
 	PUSH	AF		;save it
 	AND	1FH		;relative sector
 	LD	B,A		;save here
 	POP	AF		;get back
 	AND	0E0H		;relative byte
 	LD	C,A		;BC = extension offset
 	LD	HL,BUFFER+200H	;start of records
 	ADD	HL,BC		;HL => extension
 ;
 	PUSH	HL		;save it
 	SET	5,(HL)		;set tested
 	BIT	4,(HL)		;active entry?
 	LD	A,ERROR10	;error message
 	JP	Z,SHOWER-1	;if yes, abort file
 	POP	HL		;restore stack
 	PUSH	HL		;put HL back
 ;
 	BIT	7,(HL)		;really an extension?
 	LD	A,ERROR11	;error #
 	JP	Z,SHOWER-1	;error, abort file
 ;
 	LD	A,(IX+23)	;get DEC
 	POP	IX		;load IX with file record
 	PUSH	AF		;save DEC
 	LD	A,(DEC)		;fetch last DEC
 	CP	(IX+1)		;backward link OK?
 	LD	A,ERROR7	;error message
 	JP	NZ,SHOWER-1	;nope, abort file
 	POP	AF		;restore DEC
 ;
 	LD	(DEC),A		;save extension DEC
 	JP	CK1D		;check it out
 ;
 DONEWITH PUSH	HL		;save current pointer
 	PUSH	DE		;save more
 	PUSH	IX		;save too
 	LD	IX,(DIRPOS)	;get current file
 	LD	E,(IX+20)	;get end of file sector
 	LD	D,(IX+21)
 	LD	A,D		;nil?
 	OR	E
 	JR	NZ,DWTH		;yes, skip it
 ;
 	LD	A,(IX+3)	;get end of file byte
 	OR	A		;zero?
 	JR	Z,DWTHY		;yes, go
 ;
 DWTH	LD	HL,(RELSEC)	;# sectors allocated
 	SBC	HL,DE		;compare
 ;
 DWTHY	POP	IX
 	POP	DE		;restore stack
 	POP	HL
 	RET	NC		;OK, return
 ;
 ;	end of file beyond assigned sectors
 ;
 	PUSH	HL		;save pointer
 	LD	HL,ERROR3	;error message
 	CALL	SHOWERR		;post it
 	POP	HL		;restore stack
 	RET			;done
 ;
 ;
 SHOPRT	PUSH	HL		;save registers
 	PUSH	DE
 	PUSH	BC
 ;
 PRTRLP	LD	B,(IY+20)	;sectors / gran
 ;
 PRTLP	CALL	PRTHIS		;this extent
 	JR	C,SKPFRS	;error, go!
 ;
 	CALL	NEXSEC		;bump to next sector
 	DJNZ	PRTLP		;finish this block off
 	DEC	C
 	JR	NZ,PRTRLP
 ;
 SKPFRS	POP	BC		;unstack
 	POP	DE
 	POP	HL
 	RET
 ;
 PRTHIS	PUSH	HL		;save pointer
 	LD	HL,0		;get relative sector
 RELSEC	EQU	$-2
 	INC	HL		;bump it
 	LD	(RELSEC),HL	;put it back
 	POP	HL		;restore pointer
 ;
 	LD	A,(IY+16)	;cylinder count
 	CP	D		;past disk boundary?
 	RET	NC		;nope, return
 ;
 	PUSH	HL		;save pointer
 	LD	A,ERROR8	;error message
 	CALL	SHOWER		;post it
 	POP	HL		;restore pointer
 	SCF			;set error
 	RET			;return
 ;
 	PAGE
 ;
 ;	$SHOWERR - post error type
 ;
 	POP	DE		;fixup the stack
 ;
 SHOWER	LD	HL,0		;use 0
 ;
 SHOWERR	CALL	REGSAV		;save 'em
 	LD	(ERRSAV),HL	;save error message
 	LD	(ERRSV),A	;save error number
 ;
 	LD	HL,FILMSG	;string for filename
 	LD	DE,FILMSG+1	;clear it out
 	LD	BC,20		;20 chars long
 	LD	(HL),20H	;put a blank
 	LDIR			;put all blanks
 ;
 	LD	IX,(DIRPOS)	;get file pointer
 	LD	A,(IX)		;get file type
 	LD	(SHOPAS),A	;save it for display
 	LD	DE,FILMSG	;point to message
 	LD	B,8		;8 chars in name
 ;
 SHO1	LD	A,(IX+5)	;get name byte
 	CP	' '		;a char here?
 	JR	Z,SHO2		;not part of name
 ;
 	CALL	VALCHR		;valid filename char?
 	CALL	Z,FIXSHO	;put a block here
 	LD	(DE),A		;put into string
 ;
 	INC	IX		;bump pointers
 	INC	DE
 	DJNZ	SHO1		;finish it off
 	LD	A,(IX+5)	;check for any extension
 	CP	' '		;any?
 	JR	Z,SHO4		;nope, go
 ;
 SHO2	LD	B,3		;3 char extension
 	LD	A,'/'		;put into name
 	LD	(DE),A		;to the string
 	INC	DE		;bump pointer
 ;
 	LD	IX,(DIRPOS)	;fetch start
 ;
 SHO3	LD	A,(IX+13)	;get ext char
 	CP	' '		;done?
 	JR	Z,SHO4		;yes, go
 ;
 	CALL	VALCHR		;valid char?
 	CALL	Z,FIXSHO	;put a block if no
 	LD	(DE),A		;put into string
 	INC	DE		;bump pointer
 	INC	IX		;bump filename ptr
 	DJNZ	SHO3		;finish it off
 ;
 SHO4	LD	B,0		;get attribute byte
 SHOPAS	EQU	$-1
 	INC	DE		;bump string pointer
 ;
 	LD	A,'S'		;system file?
 	BIT	6,B		;yes?
 	JR	Z,SHO5		;no, go
 	LD	(DE),A		;else put in buffer
 	INC	DE		;bump pointer
 ;
 SHO5	LD	A,'I'		;invisible
 	BIT	3,B		;yes?
 	JR	Z,SHO6		;no, go
 	LD	(DE),A		;else put in buffer
 	INC	DE		;bump it
 ;
 SHO6	LD	A,B		;get byte
 	AND	7		;get prot level
 	JR	Z,SHO8		;0, go
 	PUSH	AF		;save it
 	LD	A,'P'		;set protected
 	LD	(DE),A		;to the string
 	INC	DE		;bump it
 	LD	A,'='		;for numeric
 	LD	(DE),A		;to the string
 	INC	DE		;bump it
 	POP	AF		;restore value
 	ADD	A,'0'		;make it ascii
 	LD	(DE),A		;to the string
 	INC	DE		;bump it
 ;
 SHO8	LD	HL,(ERRORS)	;get number of errors
 	INC	HL		;bump it
 	LD	(ERRORS),HL	;put it back
 ;
 	LD	A,(DIRPOS)	;directory position
 	CALL	HEXCV		;make it hex
 	LD	(WHR2),BC	;put into string
 ;
 	LD	A,(DIRSEC)	;get directory sector
 	CALL	ASCII		;make it decimal
 	LD	(WHR1),A	;to the string
 	LD	(WHR1+1),BC	;rest of it
 ;
 	LD	HL,ERRWHR	;location message
 	CALL	DISPLAY		;dual display
 	LD	HL,0		;get real message
 ERRSAV	EQU	$-2
 	LD	A,H		;see if 0
 	OR	L
 	JP	NZ,DISPLAY	;display it
 ;
 SPSHOW	LD	B,0		;get error number
 ERRSV	EQU	$-1
 	LD	A,SERROR	;SVC #
 	RST	SVC		;display it
 	JP	PAUSE		;check for pause
 ;
 FIXSHO	LD	A,5FH		;char to replace with
 	RET
 ;
 	PAGE
 ;
 ;	check a file
 ;
 CONT3	LD	HL,DCB+1	;DCB for file
 	CALL	DISPLAY		;display it
 	LD	HL,SPCS		;then a gap
 	CALL	DISPLAY		;display it too
 ;
 	LD	DE,DCB+1	;get it back
 	LD	HL,OLIST	;open list
 	LD	A,OPEN		;SVC #
 	RST	SVC		;open it up
 	JP	NZ,ERROR	;nope, cancel
 ;
 	LD	IX,DCB+1	;point to it
 	LD	A,(IX+16)	;get device number
 	LD	(DRIVE),A	;save it
 	LD	C,A		;need it here
 	CALL	LOCDCT		;get drive DCT
 ;
 	LD	A,(IX+17)	;get DEC
 	LD	(DEC),A		;save it
 	CALL	HEXCV		;make it hex
 	LD	(MXB),BC	;put into string
 ;
 	LD	A,(IX+11)	;end of file byte
 	CALL	HEXCV		;to hex ascii
 	LD	(MXC),BC	;to the string
 ;
 	LD	A,(IX+15)	;logical record length
 	CALL	ASCII		;to decimal
 	LD	(MXE),A		;to the string
 	LD	(MXE+1),BC
 ;
 	LD	E,(IX+14)	;end of file sector
 	LD	D,(IX+13)	;next MSB
 	LD	HL,MXD		;dest string
 	CALL	WRLNO		;decimal ascii
 ;
 	LD	HL,MX0		;point to string
 	CALL	DISPLAY		;dual display
 ;
 	CALL	SETUPS		;setup pointers
 	LD	A,(DEC)		;get DEC
 	AND	0E0H		;relative position
 	LD	C,A		;pass here
 	LD	A,(DEC)		;get again
 	AND	1FH		;relative sector
 	LD	B,A		;BC = entry offset
 	ADD	A,2		;adjust to actual sector
 	LD	(DIRSEC),A	;save it
 	LD	HL,BUFFER+200H	;start of records
 	ADD	HL,BC		;HL => directory record
 	LD	(DIRPOS),HL	;save it
 ;
 	CALL	CHECKA		;checker A
 	CALL	CHECKB		;checker B
 	CALL	CHECKC		;checker C
 ;
 	JP	COMPLETE	;finished
 ;
 	PAGE
 ;
 ;	clear out the created HIT table
 ;
 CLRHIT	LD	HL,HITBUFF	;start of buffer
 	LD	DE,HITBUFF+1
 	LD	BC,0FFH		;length to fill
 	LD	(HL),0		;with zeroes
 	LDIR			;do 'em all
 	RET			;done
 ;
 	PAGE
 ;
 ;	clear out the created GAT table
 ;
 CLRGAT	LD	HL,GATBUFF	;start of table
 	LD	DE,GATBUFF+1
 	LD	BC,0FFH		;length
 	LD	(HL),0FFH	;set all nil
 	LDIR			;do 'em all
 ;
 	LD	B,(IY+21)	;grans / cylinder
 	LD	C,8		;bits / byte
 ;
 	XOR	A		;start bit pattern
 NXNY	SCF			;set a bit
 	RRA			;move it in
 	DEC	C		;less counter
 	DJNZ	NXNY		;less grans / track
 	DEC	C		;see if done
 	INC	C
 	JR	Z,NXNZ		;yes, go!
 ;
 NXNU	OR	A		;clear carry
 	RRA			;align bits
 	DEC	C		;continue
 	JR	NZ,NXNU		;for rest of mask
 ;
 NXNZ	LD	IX,GATBUFF	;start of gat
 	CPL			;reverse pattern
 	LD	B,(IY+16)	;cylinder count
 	BIT	5,(IY+5)	;rigid drive?
 	JR	NZ,NXNT		;yes, no lockout
 ;
 NXNV	LD	(IX),A		;put in the byte
 	LD	(IX+60H),A	;to lockout table too
 	INC	IX		;bump pointer
 	DJNZ	NXNV		;do whole GAT
 	RET			;done, return
 ;
 NXNT	LD	(IX),A		;put in GAT byte
 	INC	IX		;next cylinder
 	DJNZ	NXNT		;do whole GAT
 	RET			;done, return
 ;
 PAUSE	LD	A,KBCHAR	;keyboard character
 	RST	SVC		;fetch one
 	RET	NZ		;nope, return
 ;
 	LD	A,B		;fetch the char
 	CP	3		;break?
 	JP	Z,TERMIN	;yes, abort
 ;
 	OR	A		;hold?
 	RET	NZ		;nope, return
 ;
 PAUWT	LD	A,KBCHAR	;keyboard
 	RST	SVC		;get a key
 	JR	NZ,PAUWT	;wait for one
 ;
 	LD	A,B		;get char
 	CP	3		;break?
 	JP	Z,TERMIN	;abort if yes
 	OR	A		;hold?
 	JR	NZ,PAUWT	;nope, wait more
 	RET			;back
 ;
 ;	advance DE to next sector
 ;
 NEXSEC	INC	E		;bump sector
 	LD	A,(IY+22)	;fetch top sector
 	SUB	E		;at end?
 	RET	NZ		;nope, cancel
 ;
 	LD	E,A		;reset to 0
 	LD	A,D		;get track
 	CP	(IY+16)		;end of disk?
 	RET	NC		;yes, don't bump it
 	INC	D		;else advance track
 	RET			;done
 ;
 	PAGE
 ;
 ;	function completed
 ;
 COMPLETE LD	DE,0		;fetch # of errors
 ERRORS	EQU	$-2
 	LD	HL,ERROR0	;where it goes
 	CALL	WRLNO		;move to string
 ;
 	LD	HL,ERROR0-1	;point to string
 	CALL	DISPLAY		;dual display
 ;
 	LD	HL,EXMSG	;exit message
 	CALL	DISPLAY		;to video
 	LD	HL,PLETEMSG	;completed
 	CALL	DISPLAY		;to video
 	JP	LEAVE		;exit program
 ;
 	PAGE
 ;
 ;	convert DE hex to (HL) ascii decimal
 ;
 WRLNO	LD	A,BINDEC	;SVC #
 	LD	B,0		;bin => ascii
 	RST	SVC		;move it in
 	RET			;done, return
 ;
 	PAGE
 ;
 ;	display relevant drive information
 ;
 SHOWDRV	CALL	LOCDCT		;locate the DCT
 	BIT	3,(IY)		;nil drive?
 	LD	A,70		;not available
 	RET	NZ		;forget it
 ;
 	LD	A,C		;get relative drive
 	ADD	A,'0'		;make it ascii
 	LD	(CO0),A		;to the message
 ;
 ;	fetch real drive name
 ;
 	LD	A,C		;get drive number
 	ADD	A,8		;make it real
 	SLA	A		;X2
 	SLA	A		;X4
 	ADD	A,2		;+ 2 for name offset
 	LD	L,A		;give to L
 	LD	H,1		;HL => drive name
 	LD	A,(HL)		;get a char
 	LD	(CO1),A		;to the string
 	INC	HL		;next char
 	LD	A,(HL)		;get it
 	LD	(CO1+1),A	;to the string
 ;
 	LD	HL,2020H	;spaces
 	BIT	6,(IY+5)	;write protected?
 	JR	Z,NOTWP		;nope
 	LD	HL,5057H	;WP
 NOTWP	LD	(CO2),HL	;to the string
 ;
 	LD	A,'5'		;5" drive
 	BIT	7,(IY+5)
 	JR	NZ,MMY1
 	LD	A,'8'		;8" drive
 MMY1	LD	(CO3),A		;to the string
 ;
 	LD	HL,FLPMSG	;floppy?
 	LD	DE,CO4		;where it goes
 	LD	BC,6		;length
 	BIT	5,(IY+5)	;yes?
 	JR	Z,MMY2
 	LD	HL,HRDMSG	;rigid drive
 	LD	A,'F'		;fixed?
 	BIT	1,(IY+5)	;yes?
 	JR	Z,MMYY2		;yes, go
 	LD	A,'R'		;removable
 ;
 MMYY2	LD	(DE),A		;to the string
 	INC	DE		;bump pointer
 	DEC	BC		;less one char
 ;
 MMY2	LDIR			;to the string
 ;
 	LD	A,(IY+12)	;binary drive #
 	AND	0FH
 	ADD	A,'0'
 	LD	(CO5),A		;to the string
 ;
 	LD	A,(IY+16)	;cylinder count
 	CALL	ASCII		;make it ascii
 	LD	(CO6),A
 	LD	(CO6+1),BC	;to the string
 ;
 	LD	A,'S'
 	BIT	7,(IY+14)
 	JR	Z,MMY3
 	LD	A,'D'
 MMY3	LD	(CO8),A		;put in density
 ;
 	LD	A,(IY+15)	;surface count
 	ADD	A,'0'
 	LD	(CO7),A		;to the string
 ;
 	LD	A,'Y'		;motor delay
 	BIT	4,(IY+5)
 	JR	NZ,MMY4
 	LD	A,'N'
 MMY4	LD	(CO10),A	;to the string
 ;
 	LD	A,'Y'		;head load?
 	BIT	3,(IY+5)	;yes
 	JR	NZ,MMYY4	;go
 	LD	A,'N'
 MMYY4	LD	(CO11),A	;to the string
 ;
 	LD	A,(IY+6)	;step rate
 	CALL	ASCII
 	LD	(CO9),A		;to the string
 	LD	(CO9+1),BC
 ;
 	LD	A,'Y'		;skip?
 	BIT	2,(IY+5)	;yes?
 	JR	NZ,MMYY44
 	LD	A,'N'
 MMYY44	LD	(CO12),A	;to the string
 ;
 	LD	HL,COMSG	;message
 	LD	BC,COMSGL<8+13	;len + term
 	LD	A,VDLINE
 	RST	SVC		;display it
 	RET			;done
 ;
 ;
 	PAGE
 ;
 ;	read the directory
 ;
 RDDIR	LD	A,(DRIVE)	;fetch the drive number
 	LD	C,A		;pass it here
 	LD	B,(IY+22)	;get number of sectors
 	LD	E,0		;starting sector
 	LD	HL,BUFFER	;where to load data
 ;
 RDDLP	PUSH	BC		;save drive, counter
 	LD	B,0		;for sector offset
 	LD	A,SREAD		;read directory sector
 	RST	DISKIO		;read the sector
 	POP	BC		;unstack
 ;
 	CALL	NZ,BADRD	;if error, go monitor
 	JR	NZ,RDDLP	;try it again
 ;
 	INC	H		;bump buffer pointer
 	INC	E		;bump sector
 	DJNZ	RDDLP		;finish it off
 	XOR	A		;set Z
 	RET			;back
 ;
 ;	convert to hex ascii
 ;
 HEXCV	LD	B,A		;save it
 	RRCA			;align to low nibble
 	RRCA
 	RRCA
 	RRCA
 	CALL	HEXTST		;make it ascii
 	LD	C,A		;save MSB
 	LD	A,B		;fetch LSB
 	CALL	HEXTST		;adjust it
 	LD	B,A		;save LSB
 	RET			;done
 ;
 HEXTST	AND	0FH		;mask upper bits
 	ADD	A,'0'		;add the ascii
 	CP	'9'+1		;out of numeric range
 	RET	M		;nope, return
 	ADD	A,7		;adjust for A-F
 	RET			;done
 ;
 ;	binary to decimal ascii
 ;
 ASCII	PUSH	HL		;save this
 	CALL	ASCI		;adjust it
 	LD	H,B		;save MSB
 	PUSH	HL		;save it
 	LD	A,C		;get NSB
 	SUB	'0'		;remove ascii
 	CALL	ASCI		;convert it
 	LD	A,C		;get MSB
 	CP	'0'		;0?
 	JR	NZ,ASCIGO1	;nope, go
 	LD	A,' '		;convert MSB to space
 ASCIGO1	POP	HL		;unstack
 	LD	C,B		;adjust bytes
 	LD	B,H
 	POP	HL		;restore HL
 	RET			;ACB = ascii
 ;
 ASCI	LD	C,'0'		;start digit
 ASCII1	SUB	10		;remove 10
 	JR	C,ASCII2	;done, adjust it
 	INC	C		;else bump ascii
 	JR	ASCII1		;go more
 ASCII2	ADD	A,'0'+10	;make it ascii
 	LD	B,A		;pass it here
 	RET			;done
 ;
 	PAGE
 ;
 BUMPDE	INC	DE		;bumper for DE
 	RET
 ;
 ;	compute HASH code
 ;
 HASH	PUSH	IX		;save pointer
 	PUSH	BC		;need for compute
 	LD	C,0		;start hash
 	LD	B,0BH		;# chars to hash
 ;
 HASHL	LD	A,(IX+5)	;fetch a byte
 	INC	IX		;bump pointer
 	XOR	C		;'hash' it
 	RLCA
 	LD	C,A
 	DJNZ	HASHL		;finish it
 ;
 	OR	A		;see if 0
 	JR	NZ,HASHOK	;nope, return
 	INC	A		;make it one
 ;
 HASHOK	POP	BC		;unstack & return
 	POP	IX
 	RET
 ;
 	PAGE
 ;
 ;	checker C
 ;
 CHECKC	LD	HL,(DIRPOS)	;current file ptr
 	BIT	7,(HL)		;extension?
 	RET	NZ		;yes, return
 ;
 	PUSH	HL		;pass to IX
 	POP	IX
 	XOR	A		;set check flag
 	LD	(CFLAG),A	;to nil
 ;
 CHECKC1	LD	B,5		;5 extents per entry
 ;
 CHECKC2	LD	A,(IX+22)	;get an extent
 ;
 	CP	0FFH		;terminator?
 	RET	Z		;yes, done
 ;
 	CP	0FEH		;extension?
 	JP	Z,CHECKC3	;yes, fetch it
 ;
 	LD	D,A		;save track
 	LD	A,(IX+23)	;get extent
 	AND	1FH		;# grans
 	INC	A		;adjust to real
 	LD	C,A		;save here
 	LD	A,(IX+23)	;get again
 	LD	E,1		;bit mask
 	RRCA			;align the bits
 	RRCA
 	RRCA
 	RRCA
 	RRCA
 	AND	7		;want top 3 only
 ;
 FINGLP	JR	Z,FINGHV	;have the gran
 	SLA	E		;shift the bit over
 	DEC	A		;continue
 	JR	FINGLP
 ;
 FINGHV	LD	HL,GATBUFF	;GAT table start
 	LD	L,D		;D = track
 ;
 RELGRNS	LD	A,(HL)		;get a byte
 	AND	E		;mask with gran bits
 	JR	Z,RELNXT	;go if done
 ;
 	LD	A,0		;check the flag
 CFLAG	EQU	$-1
 	OR	A		;used?
 	JR	NZ,RELNXT	;no, go
 ;
 	INC	A		;else reset it
 	LD	(CFLAG),A	;don't display error
 	PUSH	HL		;the next time (oneshot)
 	LD	HL,ERROR16	;error message
 	CALL	SHOWERR		;display it
 	POP	HL
 ;
 RELNXT	LD	A,(HL)		;fix the byte
 	OR	E
 	LD	(HL),A		;put it back
 	DEC	C		;more to do?
 	JR	Z,RELGDNE	;nope, done
 	LD	A,0		;get the top gran
 TOPGRAN	EQU	$-1
 	SLA	E		;move test bit over
 	CP	E		;done with cylinder?
 	JR	NC,RELGRNS	;nope, continue
 ;
 	INC	L		;next cylinder
 	LD	E,1		;reset the mask
 	JR	RELGRNS		;go more
 ;
 RELGDNE	INC	IX		;next extent
 	INC	IX
 	DJNZ	CHECKC2		;finish it off
 	RET			;done
 ;
 CHECKC3	LD	A,(IX+23)	;get DEC for extension
 	AND	0E0H		;relative byte
 	LD	C,A		;save it
 	LD	A,(IX+23)	;get again
 	AND	1FH		;sector offset
 	LD	B,A		;BC = file offset
 	LD	HL,BUFFER+200H	;start of records
 	ADD	HL,BC		;HL => name
 	PUSH	HL		;pass to IX
 	POP	IX
 	JP	CHECKC1		;check this out
 ;
 CHECKDB	PUSH	HL		;save 'em
 	PUSH	DE
 	PUSH	BC
 	LD	A,C		;get relative byte
 	CALL	ASCII		;make it ascii
 	LD	(ERRMAN),A	;to the string
 	LD	(ERRMAN+1),BC	;rest of it
 	BIT	5,(IY+5)	;rigid?
 	JR	NZ,GODBCK	;yes, go
 ;
 	LD	BC,60H		;offset to lockout
 	ADD	HL,BC		;point to it
 	LD	A,(HL)		;fetch it
 	INC	A		;locked out?
 	JR	Z,OKBCK		;else it is locked
 ;
 GODBCK	LD	HL,ERRMA	;error message
 	JR	CONTCKB		;continue
 ;
 CHECKEB	PUSH	HL		;save 'em
 	PUSH	DE
 	PUSH	BC
 ;
 	LD	A,C		;get rel byte
 	CALL	HEXCV		;to ascii
 	LD	(ERRMBN),BC	;to the string
 	LD	HL,ERRMB	;point to it
 ;
 CONTCKB	CALL	DISPLAY		;display it
 	LD	HL,(ERRORS)	;get error count
 	INC	HL		;bump it
 	LD	(ERRORS),HL	;update
 ;
 OKBCK	POP	BC		;unstack & return
 	POP	DE
 	POP	HL
 	RET
 ;
 	PAGE
 ;
 ;	display string
 ;
 DISPLAY	PUSH	BC		;save it
 	PUSH	HL		;this too
 DISPLP	LD	A,(HL)		;get a char
 	CP	3		;terminator?
 	JR	Z,DISPDN
 	INC	A		;FF terminator?
 	JR	Z,DISPDN
 	DEC	A		;put it back
 	LD	B,A		;pass it here
 	LD	A,VDCHAR	;video char
 	RST	SVC		;output it
 	INC	HL		;bump pointer
 	JR	DISPLP		;do next one
 ;
 DISPDN	POP	HL		;unstack
 	POP	BC
 	JP	PAUSE		;check for pause
 ;
 	PAGE
 ;
 ;	check for valid character
 ;
 VALCHR	PUSH	HL		;save
 	PUSH	BC
 	LD	HL,VALTBL	;table of chars
 	LD	BC,16		;16 here
 	CPIR
 	POP	BC
 	POP	HL
 	RET
 ;
 VALTBL	DEFM	'!'
 	DEFM	'('
 	DEFM	')'
 	DEFM	','
 	DEFM	'.'
 	DEFM	'/'
 	DEFM	';'
 	DEFM	':'
 	DEFM	'@'
 	DEFM	'='
 	DEFM	'"'
 	DEFB	27H
 	DEFB	3
 	DEFB	13
 	DEFB	7BH
 	DEFB	7DH
 ;##
 	PAGE
 ;
 ;	text
 ;
 HELP1	DEFM	'drivespec     = check this drive'
 	DEFB	13
 	DEFM	'filespec      = check this file'
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 ;
 ERRMA	DEFB	13
 	DEFM	'Cylinder'
 ERRMAN	DEFM	'xxx Has An Invalid GAT Table Byte'
 	DEFB	13
 	DEFB	-1
 ;
 ERRMB	DEFB	13
 	DEFM	'HIT Byte at '
 ERRMBN	DEFM	'xxH invalid or extraneous'
 	DEFB	13
 	DEFB	-1
 ;
 FREEMSG	DEFM	'xxxxx Free Grans, Name = '
 NAMMSG	DEFM	'xxxxxxxx, Date = '
 DATMSG	DEFM	'xxxxxxxx'
 	DEFB	13
 	DEFB	-1
 ;
 	DEFB	13
 ERROR0	DEFM	'xxxxx Total Errors'
 	DEFB	13
 	DEFB	-1
 ERRWHR	DEFB	13
 ;
 FILMSG	DEFM	'xxxxxxxxxxxxxxxxxxxxx '
 	DEFM	'@ Directory Sector'
 WHR1	DEFM	'xxx, Relative Byte '
 WHR2	DEFM	'xxH'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR3	DEFM	'End of File Sector Beyond '
 	DEFM	'Allocated Sectors'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR9	DEFM	'Extension Assigned Before '
 	DEFM	'End of Extents'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR12	DEFM	'Extension Record Not Assigned '
 	DEFM	'to Any Files'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR16	DEFM	'Multiple Files Assigned to '
 	DEFM	'to Single Granule'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR18	DEFM	'Directory Record Has Invalid HIT Byte'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR19	DEFM	'Directory Record Has a Zero HIT Byte'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR21	DEFM	'Extended Directory Record Has An '
 	DEFM	'Invalid HIT Byte'
 	DEFB	13
 	DEFB	-1
 ;
 ERROR22	DEFM	'Extended Directory Record Has A '
 	DEFM	'Zero HIT Byte'
 	DEFB	13
 	DEFB	-1
 ;
 EXMSG	DEFB	13
 	DEFM	'DIRCHECK '
 	DEFB	-1
 ;
 PLETEMSG DEFM	'* Completed *'
 	DEFB	13
 	DEFB	-1
 ;
 COMSG	DEFM	'$'
 CO0	DEFM	'x :'
 CO1	DEFM	'xx'
 CO2	DEFM	'xx '
 CO3	DEFM	'x" '
 CO4	DEFM	'xxxxxx #'
 CO5	DEFM	'x Cyls='
 CO6	DEFM	'xxx Sides='
 CO7	DEFM	'x Den='
 CO8	DEFM	'x Step='
 CO9	DEFM	'xxx Delay='
 CO10	DEFM	'x Hload='
 CO11	DEFM	'x Skip='
 CO12	DEFM	'x'
 COMSGL	EQU	$-COMSG
 ;
 FLPMSG	DEFM	'Floppy'
 HRDMSG	DEFM	'Rigid'
 ;
 SPCS	DEFM	' - '
 	DEFB	-1
 MX0	DEFM	'DEC='
 MXB	DEFM	'xxH, EOFB='
 MXC	DEFM	'xxH, LRL='
 MXE	DEFM	'xxx, EOFS='
 MXD	DEFM	'xxxxx'
 	DEFB	13
 	DEFB	-1
 ;
 ASKBAD	DEFM	'R>etry, S>kip, <BREAK> ? '
 ASKBADL	EQU	$-ASKBAD
 BADRMSG	DEFB	13
 	DEFM	'Disk READ Error'
 	DEFB	13
 	DEFB	-1
 ABMSG	DEFM	'* Aborted *'
 	DEFB	13
 	DEFB	-1
 HELLO	DEFB	13
 	DEFM	'DIRCHECK - '
 	DEFM	'DosPLUS II Directory Check Utility - '
 	DEFM	'Series A.00'
 	DEFB	13
 	DEFM	'(c)(p) 1982 by MicroPower, Inc.'
 	DEFB	13
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 PMSG	DEFB	'*'
 OLIST	DEFW	BUFFER
 	DEFW	BUFFER
 	DEFW	0000H
 	DEFB	'R'
 	DEFB	0
 	DEFB	'F'
 	DEFB	0
 	DEFB	0
 DBUFF	EQU	$&0FF00H
 STRING	EQU	DBUFF+100H
 DCB	EQU	STRING+81
 GATBUFF	EQU	DBUFF+200H
 HITBUFF	EQU	GATBUFF+100H
 BUFFER	EQU	HITBUFF+100H
 	END	ENTRY
