DIRFIX ; dirfix/asm - kjw/bqsd - 07/82
 ;
 	TITLE	'<Dos+ II - Directory Fixer - A.00>'
 ;
 	ORG	2200H		;high overlay area
 ;
 VERSION	EQU	10H		;1.0
 MPASSW	EQU	0E02H		;password 'PASSWORD'
 ;
 FSPEC	EQU	84		;fetch filespec
 VDLINE	EQU	9		;line to video
 VIDKEY	EQU	12		;video/keyboard
 VDCHAR	EQU	8		;char to video
 KBCHAR	EQU	4		;char from keyboard
 SERROR	EQU	39		;display error
 FDRV	EQU	89		;fetch drive spec
 HLDKEY	EQU	29		;hold processor
 SETBRK	EQU	3		;setup break processor
 ;
 RUNDCB	EQU	01BCH		;DCB area
 LOCDCT	EQU	032DH		;locate drive DCT
 UCASE	EQU	031EH		;char to upper case
 REGSAV	EQU	0303H		;save registers
 TOPMEM	EQU	0180H		;top memory
 OVLYH	EQU	019DH		;high overlay in
 DATE$	EQU	0160H		;date storage
 ;
 DCHECK	EQU	0		;check drive
 DREAD	EQU	3		;read sector
 SREAD	EQU	6		;read system sector
 DWRITE	EQU	5		;write data sector
 SWRITE	EQU	7		;write system sector
 ;
 SVC	EQU	8		;execute SVC
 DISKIO	EQU	10H		;disk I/O
 OVLAY	EQU	18H		;overlay access
 ;
 IMEM	EQU	82		;'insufficient memory'
 ILLDRV	EQU	32		;invalid drive
 NOTIN	EQU	58		;device not avail
 ;
 	PAGE
 ;
 ;	program entry point
 ;
 ENTRY	LD	(STACK),SP	;save stack
 	LD	A,-1		;clear high overlay
 	LD	(OVLYH),A	;set to nil
 ;
 	PUSH	HL		;save string pointer
 	LD	HL,HELLO	;sign on message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,0		;turn off break processor
 	LD	A,SETBRK	;SVC #
 	RST	SVC		;do it
 ;
 	LD	A,HLDKEY	;SVC #
 	LD	B,0		;turn off hold processor
 	RST	SVC		;do it
 ;
 	POP	HL		;restore pointer
 ;
 ;	evaluate input line
 ;
 SCAN	CALL	POSHL		;position to input
 	JP	C,APARMS	;ask for params if nil
 ;
 ;	find the drive
 ;
 	LD	DE,RUNDCB	;run DCB area
 	LD	A,FSPEC		;fetch drivespec
 	RST	SVC		;do it
 	JR	NZ,ERROR	;bad, go!
 ;
 	LD	B,32		;invalid drive
 	LD	A,(DE)		;get flags
 	BIT	7,A		;device issued?
 	JP	Z,ERRORB	;error
 	BIT	6,A		;filespec?
 	JP	NZ,ERRORB	;go it bad
 	AND	0FH		;low bits
 	SUB	8		;low one?
 	JP	C,ERRORB	;go if bad
 	LD	(DRIVE),A	;save the drive #
 ;
 ;	check for additional params
 ;
 	INC	HL		;bump pointer
 	CALL	POSHL		;position to input
 	JR	C,PERROR	;parameter error
 ;
 ;	additional input on line, evaluate it
 ;
 SCAN2	CALL	POSHL		;position to a char
 	JP	C,CONT		;go if done
 	CALL	UCASE		;make it upper case
 	LD	IX,FLAG		;point to flag
 ;
 	CP	'P'		;prompt?
 	JP	Z,FORCEIT	;yes, go!
 ;
 	CP	'G'		;repair GAT?
 	JR	Z,FIXGAT	;yes, go!
 ;
 	CP	'H'		;repair HIT?
 	JR	Z,FIXHIT	;yes, go!
 ;
 	CP	'B'		;repair BOOT?
 	JR	Z,FIXBOOT	;yes, go!
 ;
 	CP	'F'		;repair FILES?
 	JR	Z,FIXFILE	;yes, go
 ;
 	CP	'L'
 	JR	Z,SETLAR	;set LAREDO type drive
 ;
 	JR	PERROR		;no good, try again
 ;
 FIXGAT	SET	7,(IX)		;turn on GAT fix
 	JR	FIXVEC		;continue
 ;
 FIXHIT	SET	6,(IX)		;set HIT fix
 	JR	FIXVEC		;continue
 ;
 FIXBOOT	SET	5,(IX)		;turn on BOOT fix
 ;
 	INC	HL		;bump pointer
 	LD	A,(HL)		;fetch the char
 	CP	'='		;must be drive number
 	JR	NZ,PERROR	;param error if not
 ;
 	INC	HL		;bump again
 	LD	A,(HL)		;fetch next char
 	CP	':'		;must be drive number
 	JR	NZ,PERROR	;nope, error
 	INC	HL
 ;
 	LD	A,FDRV		;fetch drivespec
 	RST	SVC		;fetch it
 	JR	NZ,ERROR	;error, try again
 	SUB	8		;adjust for DCT
 	LD	(WBOOT),A	;save where it is
 	JR	FIXVEC		;continue
 ;
 FIXFILE	SET	4,(IX)		;turn on FILE fix
 ;
 FIXVEC	INC	HL		;bump string pointer
 	JR	SCAN2		;check for more params
 ;
 SETLAR	LD	(LFLAG),A	;set LAREDO flag
 	JR	FIXVEC		;continue
 ;
 	PAGE
 ;
 PERROR	LD	A,3		;parameter error
 ;
 ERROR	AND	7FH		;make sure it comes back
 	LD	B,A		;pass it here
 ERRORB	LD	A,SERROR	;SVC #
 	RST	SVC		;display it
 	JR	APARMS		;prompt for command
 ;
 ;	program exit vectors
 ;
 TERMIN	LD	HL,EXMSG	;banner message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,ABMSG	;program aborted
 	CALL	DISPLAY		;display it
 ;
 LEAVE	LD	SP,0		;reset stack
 STACK	EQU	$-2
 	XOR	A		;return ZERO
 	RET			;back to caller
 ;
 ;	prompt for parameters
 ;
 APARMS	XOR	A		;clear the partial flag
 	LD	(FLAG),A	;set it
 	LD	(LFLAG),A	;set laredo flag
 ;
 	LD	HL,PMSG		;prompt message
 	LD	BC,1<8+79	;disp len + key len
 	LD	DE,STRING	;input buffer
 	LD	A,VIDKEY	;SVC #
 	RST	SVC		;display & keyboard
 ;
 	JR	NZ,ERROR	;error, display it
 	JR	C,TERMIN	;break, abort
 ;
 	CALL	POSHL		;any input?
 	JP	NC,SCAN		;yes, scan it!
 ;
 	LD	HL,HELP1	;help commands
 	CALL	DISPLAY		;display 'em
 	JR	APARMS		;ask again
 ;
 	PAGE
 ;
 ;	position HL to first valid character
 ;
 	INC	HL		;bump pointer
 POSHL	LD	A,(HL)		;fetch a char
 ;
 	CP	' '		;separator?
 	JR	Z,POSHL-1	;yes, next one
 	CP	','		;sep?
 	JR	Z,POSHL-1	;yes, skip
 ;
 CKTERM	CP	13		;terminator?
 	SCF			;C = yes
 	RET	Z		;yes, go!
 	CP	3		;etx?
 	SCF
 	RET	Z		;yes, go!
 	CP	';'		;term?
 	SCF
 	RET	Z		;yes, go
 ;
 	CP	A		;set Z, clear C
 	RET			;done
 ;
 	PAGE
 ;
 ;	prompt for diskette type to force data > DCT
 ;
 FORCEIT	CALL	GETSP2		;get specs for drive
 	JR	NZ,FORCEIT	;nope, try again
 ;
 	JR	SPECBAK		;else resume
 ;
 	PAGE
 ;
 ;	disk error monitor services
 ;
 ;	ENT	A = error number
 ;
 ;	EXT	Z = skip selected
 ;		NZ = retry selected
 ;		break immediately vectors to TERMIN
 ;
 ;
 ;	bad write monitor
 ;
 BADWRT	LD	(ERNO),A	;save error number
 	CALL	REGSAV		;save 'em
 ;
 	LD	HL,BADWMSG	;bad write message
 	JR	DOBAD		;go common
 ;
 ;	bad read monitor
 ;
 BADRD	LD	(ERNO),A	;save error
 	SUB	56		;read sys sect?
 	RET	Z		;yes, OK
 	DEC	A		;read del sect?
 	RET	Z		;yes, OK
 ;
 	CALL	REGSAV		;save 'em
 ;
 	LD	HL,BADRMSG	;bad read message
 ;
 DOBAD	CALL	DISPLAY		;dislay the message
 ;
 	LD	B,0		;fetch error number
 ERNO	EQU	$-1
 	RES	7,B		;FORCE a return
 	LD	A,SERROR	;SVC #
 	RST	SVC		;display it
 ;
 ;	prompt for retry, skip, break
 ;
 GETBAD	LD	HL,ASKBAD	;prompt message
 	LD	BC,ASKBADL<8+1	;one key input
 	LD	DE,STRING	;input buffer
 	LD	A,VIDKEY	;SVC #
 	RST	SVC		;do it
 	JP	NZ,ERROR	;error, go!
 	JP	C,TERMIN	;break, abort!
 ;
 	LD	A,(HL)		;fetch the key
 	CALL	UCASE		;make it upper
 ;
 	CP	'S'		;skip?
 	RET	Z		;yes, back!
 ;
 	CP	'R'		;retry?
 	JR	NZ,GETBAD	;nope, ask again
 	OR	1		;else set NZ
 	RET			;done!
 ;
 	PAGE
 ;
 ;	begin compiling disk
 ;
 CONT	LD	C,0		;fetch drive number
 DRIVE	EQU	$-1
 	CALL	LOCDCT		;load IY with DCT
 	LD	A,DCHECK	;check drive
 	RST	DISKIO		;check it out
 	LD	A,NOTIN		;drive not in system
 	CALL	NZ,GETSPS	;get specs for drive
 	JR	NZ,CONT		;error, try again
 ;
 ;
 SPECBAK	LD	A,(DRIVE)	;fetch drive number
 	LD	C,A		;pass here for locate
 	CALL	LOCDCT		;load IY with it
 ;
 ;
 	CALL	CLRGAT		;clear out the GAT
 	CALL	CLRHIT		;HIT too
 ;
 	LD	A,(IY+21)	;fetch grans / cyl
 	LD	E,1		;set mask bit
 	DEC	A		;less one
 ;
 GPTSF	JR	Z,GOTGPT	;have the mask
 	SLA	E		;move mask bit
 	DEC	A		;less gran
 	JR	GPTSF		;go again
 GOTGPT	LD	A,E		;fetch mask
 	LD	(TOPGRAN),A	;save top gran mask
 ;
 ;	check for sufficient memory
 ;
 	LD	HL,(TOPMEM)	;fetch topmem
 	LD	A,(IY+22)	;fetch top sector
 	LD	B,A		;pass here for count
 	LD	DE,BUFFER	;start of dir buffer
 	DEC	H		;make an even page
 	LD	L,0		;HL = last full page
 	OR	A		;clear carry
 	SBC	HL,DE		;compare
 ;
 	LD	A,H		;fetch # pages free
 	CP	B		;enough?
 	JR	NC,MEMOK	;yes, continue
 	LD	A,IMEM		;error number
 	JP	ERROR		;can't fix this one
 ;
 ;	all OK, read in the directory
 ;
 MEMOK	CALL	RDDIR		;read it
 	JP	NZ,ERROR	;no good, show why
 ;
 	CALL	SHOWDRV		;display details
 ;
 	LD	HL,BUFFER+200H	;start of file records
 	LD	(DIRPOS),HL	;save pointer
 	LD	A,2		;relative sector
 	LD	(DIRSEC),A	;save it
 ;
 ;	go to it!
 ;
 CHKLP	LD	HL,0		;fetch current posit
 DIRPOS	EQU	$-2
 	BIT	4,(HL)		;active entry?
 ;
 	PUSH	AF		;save 'em
 	CALL	NZ,CHECKA	;checker A (GAT, names)
 	POP	AF
 ;
 	PUSH	AF		;save again
 	CALL	NZ,CHECKB	;checker B
 	POP	AF
 ;
 	CALL	NZ,CHECKC	;checker C
 ;
 	LD	HL,(DIRPOS)	;fetch position
 	LD	BC,20H		;offset between
 	ADD	HL,BC		;point to next file
 	LD	(DIRPOS),HL	;resave position
 ;
 	LD	A,L		;see if new sector
 	OR	A		;zero?
 	JR	NZ,CHKLP	;nope, continue
 ;
 	LD	A,0		;get relative sector
 DIRSEC	EQU	$-1
 	INC	A		;bump it
 	LD	(DIRSEC),A	;put it back
 	CP	(IY+22)		;at top?
 	JR	NZ,CHKLP	;nope, go more
 	JP	COMPLETE	;finished, exit
 ;
 	PAGE
 ;
 ;	$CHECKB - check HIT table
 ;
 CHECKB	LD	HL,(DIRPOS)	;current record
 	BIT	7,(HL)		;extended entry?
 	RET	NZ		;yes, skip it
 ;
 	PUSH	HL		;pass pointer to IX
 	POP	IX		;get it
 	LD	DE,BUFFER+200H	;start of records
 	OR	A		;clear carry
 	SBC	HL,DE		;compute DEC
 	LD	A,H		;fetch rel sec
 	OR	L		;or with rel byte
 	LD	(DEC),A		;save entry code
 ;
 	CALL	HASH		;compute HASH
 	LD	(HIT),A		;save it
 ;
 CHECKA1	LD	HL,HITBUFF	;HIT table
 	LD	L,0		;get DEC
 DEC	EQU	$-1
 ;
 	LD	A,0		;fetch the HIT
 HIT	EQU	$-1
 	LD	(HL),A		;put it in
 ;
 ;	check for extended records
 ;
 	LD	IX,(DIRPOS)	;fetch position
 ;
 HITAA	LD	B,5		;go for 5 extents
 ;
 HITA	LD	A,(IX+22)	;fetch extent element
 	CP	0FFH		;terminator?
 	RET	Z		;yes, return
 ;
 	CP	0FEH		;extended record?
 	JR	Z,HITB		;yes, fix that hit too
 ;
 	INC	IX		;next extent
 	INC	IX
 	DJNZ	HITA		;go for 5 max
 	RET
 ;
 HITB	LD	A,(IX+23)	;get extension DEC
 	AND	0E0H		;relative byte
 	LD	C,A		;pass here
 	LD	A,(IX+23)	;fetch again
 	LD	(DEC),A		;save it for link
 	AND	1FH		;relative sector
 	LD	B,A		;BC = directory offset
 	LD	HL,BUFFER+200H	;start of records
 	ADD	HL,BC		;point to it
 	PUSH	HL
 	POP	IX		;IX => extended record
 ;
 	LD	HL,HITBUFF	;start of HIT table
 	LD	A,(DEC)		;fetch DEC
 	LD	L,A		;HL => hit this extent
 	LD	A,(HIT)		;fetch file HIT
 	LD	(HL),A		;put in table
 	JP	HITAA		;continue
 ;
 	PAGE
 ;
 ;	$CHECKA	- check GAT table and filenames
 ;
 CHECKA	LD	HL,(DIRPOS)	;get position
 	BIT	7,(HL)		;extended entry?
 	RET	NZ		;yes, skip for now
 ;
 	PUSH	HL		;pass to IX
 	POP	IX
 	LD	B,11		;check filename area
 ;
 CK1A	LD	A,(IX+5)	;get name byte
 	CALL	VALCHR		;valid character?
 	CALL	Z,CK1B		;change to 5F if yes
 	LD	(IX+5),A	;put it back fixed
 	INC	IX		;bump pointer
 	DJNZ	CK1A		;finish the area
 	JR	CK1C		;continue
 ;
 CK1B	LD	A,0		;get flag byte
 FLAG	EQU	$-1
 	BIT	4,A		;filename area to be done
 	JP	Z,CANTFIX	;if not, can't fix disk
 ;
 	LD	A,5FH		;default character
 	RET
 ;
 CK1C	LD	IX,(DIRPOS)	;fetch position again
 	PUSH	IX		;need in HL too
 	POP	HL
 	LD	DE,BUFFER+200H	;start of names
 	OR	A		;compute DEC again
 	SBC	HL,DE		;HL = DEC
 	LD	A,H		;merge into single byte
 	OR	L
 	LD	(DEC),A		;save it
 	LD	BC,0		;for file positioning
 	LD	(RELSEC),BC	;save relative sector
 ;
 CK1D	XOR	A		;set rel extent to 0
 	LD	(CKEXT),A	;save it
 ;
 CK1E	LD	A,(IX+22)	;fetch extent byte
 	CP	0FFH		;terminator?
 	JP	Z,DONEWITH	;yes, done
 	CP	0FEH		;extension?
 	JR	Z,NXFIL		;yes, get it
 ;
 	LD	D,A		;D = track
 	LD	E,0		;start sector
 	LD	C,(IY+20)	;sectors / gran
 	LD	A,(IX+23)	;get extent
 	AND	0E0H		;start grans bits
 	SRL	A		;align to low bits
 	SRL	A
 	SRL	A
 	SRL	A
 	SRL	A
 GNLP	OR	A		;have it?
 	JR	Z,STGN		;yes, go!
 	PUSH	AF		;save
 	LD	A,E		;current sector
 	ADD	A,C		;add sects this gran
 	LD	E,A		;put it back
 	POP	AF		;restore
 	DEC	A		;less one
 	JR	GNLP		;continue
 ;
 STGN	LD	A,(IX+23)	;get extent
 	AND	1FH		;number of grans
 	INC	A		;adjust for real
 	LD	C,A		;save here
 	CALL	SHOPRT		;check it out
 ;
 	JR	C,CANFIL	;error, terminate NOW
 	INC	IX		;else next extent
 	INC	IX
 	LD	A,0		;see if all used
 CKEXT	EQU	$-1
 	INC	A		;bump it
 	LD	(CKEXT),A	;put it back
 	CP	5		;all used?
 	JR	NZ,CK1E		;nope, continue
 	DEC	IX		;no, kill last extent
 	DEC	IX
 ;
 ;	no terminator field for file
 ;	kill last extent by placing a terminator
 ;
 CANFIL	LD	(IX+22),0FFH	;set terminator in
 	LD	(IX+23),0FFH
 ;
 	LD	A,(FLAG)	;fetch flag
 	BIT	4,A		;filename fix specified?
 	JP	Z,CANTFIX	;nope, can't fix GAT
 ;
 	JR	DONEWITH	;else done with this file
 ;
 NXFIL	LD	A,(IX+23)	;fetch extent DEC
 	AND	1FH		;relative sector
 	LD	B,A		;save here
 	LD	A,(IX+23)	;fetch again
 	AND	0E0H		;relative byte
 	LD	C,A		;BC = displacement
 	LD	HL,BUFFER+200H	;start of records
 	ADD	HL,BC		;HL => record
 ;
 ;	make sure it correctly links
 ;
 	BIT	4,(HL)		;active file?
 	JR	Z,CANFIL	;nope, can last record
 	BIT	7,(HL)		;valid extension?
 	JR	Z,CANFIL	;nope, can last record
 ;
 	LD	A,(IX+23)	;save the DEC
 	PUSH	HL		;now can pass to IX
 	POP	IX
 	PUSH	AF		;save DEC
 	LD	A,(DEC)		;fetch last one
 	LD	(IX+1),A	;fix the backward link
 	POP	AF		;restore this DEC
 	LD	(DEC),A		;save it
 	JP	CK1D		;continue with it
 ;
 DONEWITH LD	IX,(DIRPOS)	;fetch file start
 	LD	E,(IX+20)	;get end of file sector
 	LD	D,(IX+21)
 	LD	A,D		;is it 0?
 	OR	E		;yes?
 	JR	NZ,DWTH		;nope, continue
 	LD	A,(IX+3)	;end of file byte
 	OR	A		;this zero too?
 	RET	Z		;yes, it's OK
 ;
 DWTH	LD	HL,(RELSEC)	;get real sectors
 	OR	A		;clear carry
 	SBC	HL,DE		;test for end of file
 	RET	NC		;not beyond limits
 ;
 ;	force end of allocation sector into EOF sector
 ;
 	LD	HL,(RELSEC)	;get EOA sector
 	LD	(IX+20),L	;stuff into EOF in DIR
 	LD	(IX+21),H
 ;
 	LD	A,(FLAG)	;fetch the flag
 	BIT	4,A		;files being fixed?
 	JP	Z,CANTFIX	;nope, can't fix rest
 	RET			;else done, return
 ;
 ;
 SHOPRT	PUSH	HL		;save registers
 	PUSH	DE
 	PUSH	BC
 ;
 PRTRLP	LD	B,(IY+20)	;sectors / gran
 ;
 PRTLP	CALL	PRTHIS		;do this extent
 	JR	C,PRTBAD	;error, go!
 ;
 	CALL	NEXSEC		;advance the sector
 	DJNZ	PRTLP		;finish this block
 	DEC	C		;sectors / gran
 	JR	NZ,PRTRLP	;finish it
 	XOR	A
 ;
 PRTBAD	POP	BC		;unstack and return
 	POP	DE
 	POP	HL
 	RET
 ;
 PRTHIS	PUSH	HL		;save pointer
 	LD	HL,0		;get relative sector
 RELSEC	EQU	$-2
 	INC	HL		;bump it
 	LD	(RELSEC),HL	;put it back
 	POP	HL		;restore pointer
 ;
 	LD	A,(IY+16)	;cylinder count
 	CP	D		;past disk boundary?
 	RET			;return with C flag
 ;
 	PAGE
 ;
 ;	$CLRHIT	- clear out the HIT table
 ;
 CLRHIT	LD	HL,HITBUFF	;start of buffer
 	LD	DE,HITBUFF+1	;plus one
 	LD	BC,0FFH		;length -1
 	LD	(HL),0		;put in a zero
 	LDIR			;put in all zeroes
 	RET			;done, return
 ;
 	PAGE
 ;
 ;	$CLRGAT	- clear out the GAT table
 ;
 CLRGAT	LD	HL,GATBUFF	;start of table
 	LD	DE,GATBUFF+1
 	LD	BC,0FFH		;length -1
 	LD	(HL),0FFH	;set all full
 	LDIR			;in whole sector
 ;
 	LD	B,(IY+21)	;grans / cylinder
 	LD	C,8		;bits / byte
 ;
 	XOR	A		;start bit pattern
 NXNY	SCF			;set a bit
 	RRA			;move it in
 	DEC	C		;less byte
 	DJNZ	NXNY		;do # grans / cyl
 	DEC	C		;check if done
 	INC	C
 	JR	Z,NXNZ		;yes, go!
 ;
 NXNU	OR	A		;clear carry
 	RRA			;align bits
 	DEC	C		;continue
 	JR	NZ,NXNU		;finish off C
 ;
 NXNZ	LD	IX,GATBUFF	;start of GAT
 	CPL			;reverse pattern
 	LD	B,(IY+16)	;cylinder count
 	LD	(GATNUL),A	;null byte
 	BIT	5,(IY+5)	;rigid drive?
 	JR	NZ,NXNT		;yes, no lockout
 ;
 NXNV	LD	(IX),A		;put in a byte
 	LD	(IX+60H),A	;lockout byte too
 	INC	IX		;next track
 	DJNZ	NXNV		;for track count
 	JR	NXZZY		;done, finish it out
 ;
 NXNT	LD	(IX),A		;put in GAT byte
 	INC	IX		;next track
 	DJNZ	NXNT		;for track count
 ;
 NXZZY	LD	HL,DEFNAME	;default name for disk
 	LD	DE,GATBUFF+0D0H	;where it goes
 	LD	BC,17		;length of string
 	LDIR			;move into GAT
 ;
 ;	fetch today's date
 ;
 	LD	HL,DATE$	;point to date
 ;
 GOTDAT	LD	A,(HL)		;get day in month
 	CALL	ASCII		;make it ascii
 	LD	(GATBUFF+0DBH),BC	;put in GAT
 	INC	HL		;next
 ;
 	LD	A,(HL)		;get month
 	CALL	ASCII		;make it ascii
 	LD	(GATBUFF+0D8H),BC	;put in GAT
 	INC	HL		;next
 ;
 	LD	A,(HL)		;get year
 	ADD	A,80		;add offset
 	CALL	ASCII		;make it ascii
 	LD	(GATBUFF+0DEH),BC	;put in GAT
 ;
 	LD	HL,MPASSW	;password 'PASSWORD'
 	LD	(GATBUFF+0CEH),HL	;put in GAT
 	RET			;done, return
 ;
 	PAGE
 ;
 PAUSE	LD	A,KBCHAR	;keyboard char
 	RST	SVC		;fetch one
 	RET	NZ		;nothing, return
 ;
 	LD	A,B		;get the char
 	CP	3		;break?
 	JP	Z,TERMIN	;abort
 ;
 	OR	A		;hold?
 	RET	NZ		;nope, return
 ;
 PAUWT	LD	A,KBCHAR	;keyboard char
 	RST	SVC		;get a key
 	JR	NZ,PAUWT	;wait for one
 ;
 	LD	A,B		;get the key
 	CP	3		;break?
 	JP	Z,TERMIN	;yes, abort
 	OR	A		;hold?
 	JR	NZ,PAUWT	;nope, wait
 	RET			;else done
 ;
 ;
 NEXSEC	INC	E		;bump sector
 	LD	A,(IY+22)	;fetch top sector
 	SUB	E		;at end?
 	RET	NZ		;nope, return
 ;
 	LD	E,A		;reset to 0
 	LD	A,D		;get track
 	CP	(IY+16)		;at end of disk?
 	RET	NC		;don't bump if yes
 	INC	D		;else OK
 	RET			;back
 ;
 	PAGE
 ;
 ;	functions completed
 ;
 COMPLETE LD	A,(FLAG)	;fetch the flag
 	BIT	4,A		;write back filenames?
 	CALL	NZ,WRDIR	;yes, write 'em back
 ;
 	LD	A,(FLAG)	;fetch again
 	BIT	6,A		;write back HIT?
 	CALL	NZ,WRHIT	;yes, do it
 ;
 	LD	A,(FLAG)	;fetch
 	BIT	7,A		;write back GAT?
 	CALL	NZ,WRGAT	;yes, do it
 ;
 	LD	A,(FLAG)	;get again
 	BIT	5,A		;repair BOOT?
 	CALL	NZ,WRBOOT	;yes, do it
 ;
 ;
 	LD	HL,EXMSG	;banner message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,PLETEMSG	;completed
 	CALL	DISPLAY		;show it
 	JP	LEAVE		;exit the program
 ;
 	PAGE
 ;
 ;	display drive specifiecs
 ;
 SHOWDRV	LD	A,(DRIVE)	;get relative drive num
 ;
 	BIT	3,(IY)		;nil drive?
 	RET	NZ		;forget it
 ;
 	ADD	A,'0'		;make it ascii
 	LD	(CO0),A		;to the message
 ;
 ;	fetch real drive name
 ;
 	LD	A,C		;get drive number
 	ADD	A,8		;make it real
 	SLA	A		;X2
 	SLA	A		;X4
 	ADD	A,2		;+ 2 for name offset
 	LD	L,A		;give to L
 	LD	H,1		;HL => drive name
 	LD	A,(HL)		;get a char
 	LD	(CO1),A		;to the string
 	INC	HL		;next char
 	LD	A,(HL)		;get it
 	LD	(CO1+1),A	;to the string
 ;
 	LD	HL,2020H	;spaces
 	BIT	6,(IY+5)	;write protected?
 	JR	Z,NOTWP		;nope
 	LD	HL,5057H	;WP
 NOTWP	LD	(CO2),HL	;to the string
 ;
 	LD	A,'5'		;5" drive
 	BIT	7,(IY+5)
 	JR	NZ,MMY1
 	LD	A,'8'		;8" drive
 MMY1	LD	(CO3),A		;to the string
 ;
 	LD	HL,FLPMSG	;floppy?
 	LD	DE,CO4		;where it goes
 	LD	BC,6		;length
 	BIT	5,(IY+5)	;yes?
 	JR	Z,MMY2
 	LD	HL,HRDMSG	;rigid drive
 	LD	A,'F'		;fixed?
 	BIT	1,(IY+5)	;yes?
 	JR	Z,MMYY2		;yes, go
 	LD	A,'R'		;removable
 ;
 MMYY2	LD	(DE),A		;to the string
 	INC	DE		;bump pointer
 	DEC	BC		;less one char
 ;
 MMY2	LDIR			;to the string
 ;
 	LD	A,(IY+12)	;binary drive #
 	AND	0FH
 	ADD	A,'0'
 	LD	(CO5),A		;to the string
 ;
 	LD	A,(IY+16)	;cylinder count
 	CALL	ASCII		;make it ascii
 	LD	(CO6),A
 	LD	(CO6+1),BC	;to the string
 ;
 	LD	A,'S'
 	BIT	7,(IY+14)
 	JR	Z,MMY3
 	LD	A,'D'
 MMY3	LD	(CO8),A		;put in density
 ;
 	LD	A,(IY+15)	;surface count
 	ADD	A,'0'
 	LD	(CO7),A		;to the string
 ;
 	LD	A,'Y'		;motor delay
 	BIT	4,(IY+5)
 	JR	NZ,MMY4
 	LD	A,'N'
 MMY4	LD	(CO10),A	;to the string
 ;
 	LD	A,'Y'		;head load?
 	BIT	3,(IY+5)	;yes
 	JR	NZ,MMYY4	;go
 	LD	A,'N'
 MMYY4	LD	(CO11),A	;to the string
 ;
 	LD	A,(IY+6)	;step rate
 	CALL	ASCII
 	LD	(CO9),A
 	LD	(CO9+1),BC
 ;
 	LD	A,'Y'		;skip?
 	BIT	2,(IY+5)	;yes?
 	JR	NZ,MMYY44
 	LD	A,'N'
 MMYY44	LD	(CO12),A	;to the string
 ;
 	LD	HL,COMSG	;message
 	LD	BC,COMSGL<8+13	;len + term
 	LD	A,VDLINE
 	RST	SVC		;display it
 ;
 	XOR	A		;force ZERO
 	RET			;done
 	PAGE
 ;
 ;	$WWRDIR	- write directory files to disk
 ;
 WRDIR	LD	A,(DRIVE)	;fetch drive number
 	LD	C,A		;pass it here
 	LD	A,(IY+22)	;get number of sectors
 	SUB	2		;less GAT & HIT
 	LD	B,A		;for counter
 	LD	E,2		;start sector
 	LD	HL,BUFFER+200H	;start of data
 ;
 WRDLP	PUSH	BC		;save counter
 	LD	B,0		;for sector offset
 	LD	A,SWRITE	;write system sector
 	RST	DISKIO		;write it
 	POP	BC
 ;
 	CALL	NZ,BADWRT	;if error, call monitor
 	JR	NZ,WRDLP	;retry, go again
 ;
 	INC	H		;bump buffer ptr
 	INC	E		;bump sector
 	DJNZ	WRDLP		;finish it off
 	XOR	A		;set Z
 	RET			;done, return
 ;
 	PAGE
 ;
 ;	$WRGAT	- write GAT table to disk
 ;
 WRGAT	LD	A,(DRIVE)	;get drive
 	LD	C,A		;need it here
 	LD	B,1		;one sector to write
 	LD	E,0		;sector number
 ;
 	LD	A,(IY+16)	;cylinder count
 	SUB	35		;less this
 	LD	(GATBUFF+0CCH),A
 	LD	A,VERSION	;version number
 	LD	(GATBUFF+0CBH),A
 	XOR	A
 	LD	(GATBUFF+0CDH),A
 	LD	HL,MPASSW	;master password
 	LD	(GATBUFF+0CEH),HL
 ;
 	LD	HL,GATBUFF	;data source
 	BIT	5,(IY+5)	;rigid drive?
 	JP	Z,WRDLP		;nope, continue
 	LD	A,0		;get LAREDO flag
 LFLAG	EQU	$-1
 	CP	'L'		;yes?
 	JP	NZ,WRDLP	;nope, write it back
 ;
 ;	laredo set, allocate track above directory
 ;
 	LD	L,(IY+19)	;directory track
 	INC	HL		;next track up
 	LD	A,(HL)		;get the byte
 	CP	0		;compare to nil byte
 GATNUL	EQU	$-1
 	JR	NZ,SKPTHS	;if not the same, skip
 	LD	(HL),0FFH	;nil track, set allocated
 ;
 SKPTHS	LD	HL,GATBUFF	;start of data
 	JP	WRDLP		;write it back
 ;
 	PAGE
 ;
 ;	$WRHIT	- write HIT table to disk
 ;
 WRHIT	LD	A,(DRIVE)	;fetch drive number
 	LD	C,A		;need it here
 	LD	B,1		;one sector to write
 	LD	E,1		;sector number
 	LD	HL,HITBUFF	;where data is
 	JR	WRDLP		;write it out
 ;
 	PAGE
 ;
 ;	$RDDIR	- read in the directory
 ;
 RDDIR	LD	A,(DRIVE)	;fetch drive number
 	LD	C,A		;pass here
 	LD	B,(IY+22)	;number of sectors
 	LD	E,0		;start sector
 	LD	HL,BUFFER	;start of data
 ;
 RDDLP	PUSH	BC
 	LD	B,0		;sector offset
 	LD	A,SREAD		;read directory
 	RST	DISKIO		;read the sector
 	POP	BC
 ;
 	CALL	NZ,BADRD	;call monitor if bad
 	JR	NZ,RDDLP	;retry, go again
 ;
 	INC	H		;bump buffer
 	INC	E		;bump sector
 	DJNZ	RDDLP		;finish it off
 	XOR	A		;set Z
 	RET			;done, return
 ;
 	PAGE
 ;
 ;	$HASH	- compute HASH code for file
 ;
 HASH	PUSH	IX		;save pointer
 	PUSH	BC		;need for compute
 	LD	C,0		;start hash
 	LD	B,0BH		;# chars to hash
 ;
 HASHL	LD	A,(IX+5)	;fetch a byte
 	INC	IX		;bump pointer
 	XOR	C		;'hash' it
 	RLCA
 	LD	C,A
 	DJNZ	HASHL		;finish it
 ;
 	OR	A		;see if 00
 	JR	NZ,HASHOK	;nope, OK
 	INC	A		;else make it one
 ;
 HASHOK	POP	BC		;unstack & return
 	POP	IX
 	RET
 ;
 	PAGE
 ;
 ;	$CHECKC	- check granules
 ;
 CHECKC	LD	HL,(DIRPOS)	;get position
 	BIT	7,(HL)		;extended entry?
 	RET	NZ		;yes, skip for now
 ;
 	PUSH	HL		;pass to IX
 	POP	IX
 ;
 CHECKC1	LD	B,5		;5 extents / entry
 ;
 CHECKC2	LD	A,(IX+22)	;get an extent
 ;
 	CP	0FFH		;terminator?
 	RET	Z		;yes, done
 ;
 	CP	0FEH		;extension?
 	JP	Z,CHECKC3	;yes, get it
 ;
 	LD	D,A		;save track
 	LD	A,(IX+23)	;get extent
 	AND	1FH		;# grans
 	INC	A		;make it real
 	LD	C,A		;save here
 	LD	A,(IX+23)	;get again
 	LD	E,1		;bit mask
 	RRCA			;align the bits
 	RRCA
 	RRCA
 	RRCA
 	RRCA
 	AND	7		;want top 3 only
 ;
 FINGLP	JR	Z,FINGHV	;have the gran
 	SLA	E		;shift the bit over
 	DEC	A		;continue
 	JR	FINGLP
 ;
 FINGHV	LD	HL,GATBUFF	;GAT table start
 	LD	L,D		;D = track
 ;
 RELGRNS	LD	A,(HL)		;get a byte
 	OR	E		;set the bits
 	LD	(HL),A		;put it back
 ;
 	DEC	C		;more grans?
 	JR	Z,RELGRDN	;nope, done
 	LD	A,0		;else fetch top mask
 TOPGRAN	EQU	$-1
 	SLA	E		;move test bit over
 	CP	E		;done with cylinder?
 	JR	NC,RELGRNS	;nope, continue
 ;
 	INC	L		;next cylinder
 	LD	E,1		;new mask
 	JR	RELGRNS		;continue
 ;
 RELGRDN	INC	IX		;next extent
 	INC	IX
 	DJNZ	CHECKC2		;finish it off
 	RET			;done
 ;
 CHECKC3	LD	A,(IX+23)	;get DEC for extension
 	AND	0E0H		;relative byte
 	LD	C,A		;save here
 	LD	A,(IX+23)	;get again
 	AND	1FH		;relative sector
 	LD	B,A		;BC = displacement
 	LD	HL,BUFFER+200H	;start of records
 	ADD	HL,BC		;HL => file record
 	PUSH	HL		;pass to IX
 	POP	IX
 	JP	CHECKC1		;continue
 ;
 ;
 CANTFIX	LD	HL,CANTFX	;message
 	CALL	DISPLAY		;display it
 	JP	TERMIN		;abort program
 ;
 	PAGE
 ;
 ;	$WRBOOT	- write boot track to disk
 ;
 WRBOOT	LD	C,0		;source drive
 WBOOT	EQU	$-1
 	LD	DE,0		;track/sector
 	LD	HL,BUFFER	;use this buffer
 	CALL	LOCDCT		;load IY with DCT
 	LD	A,(IY+17)	;sectors/track
 	LD	(DIRSAVE),A	;pass for write
 	LD	B,A		;for counter
 ;
 ;	read one surface on track 0
 ;
 RDBL	PUSH	HL		;save 'em
 	PUSH	BC		;counter
 ;
 	LD	A,(IY+14)	;get flags2
 	PUSH	AF		;save 'em
 	RES	7,(IY+14)	;set single den
 ;
 	LD	B,0		;rel sector
 	LD	A,DREAD		;sector read
 	RST	SVC		;get it
 ;
 	POP	BC		;get flags
 	LD	(IY+14),B	;put 'em back
 ;
 	POP	BC		;unstack
 	POP	HL
 ;
 	CALL	NZ,BADRD	;error, retry?
 	JR	NZ,RDBL		;yes, try again
 ;
 	INC	H		;bump buffer
 	INC	E		;bump sector
 	DJNZ	RDBL		;finish off the track
 ;
 ;	write track to dest disk
 ;
 WRBT1	LD	A,(DRIVE)	;fetch dest drive
 	LD	C,A		;need it here
 	CALL	LOCDCT		;find the DCT
 	LD	DE,0		;start track
 	LD	HL,BUFFER	;data is here
 	LD	B,0		;fetch # sectors
 DIRSAVE	EQU	$-1
 ;
 WRBL	PUSH	BC		;too
 ;
 	LD	A,(IY+14)	;get flags2
 	PUSH	AF		;save 'em
 	RES	7,(IY+14)	;set single den
 ;
 	LD	A,DWRITE	;write sector
 	LD	B,0		;sector offset
 	RST	DISKIO		;write it
 ;
 	POP	BC		;get flags
 	LD	(IY+14),B	;put 'it back
 ;
 	POP	BC		;unstack
 ;
 	CALL	NZ,BADWRT	;error, retry?
 	JR	NZ,WRBL		;yes, go again
 ;
 	INC	H		;bump buffer
 	INC	E		;bump sector
 	DJNZ	WRBL		;go for rest of track
 	XOR	A		;set Z
 	RET
 ;
 	PAGE
 ;
 ;	fetch and load drive specs
 ;
 XSPCBAK	OR	-1		;return NZ
 	RET			;back!
 ;
 ;
 GETSPS LD	B,97		;can't establish disk
 	LD	A,SERROR	;SVC #
 	RST	SVC		;display and return
 ;
 GETSP2	LD	A,(DRIVE)	;fetch drive number
 	LD	C,A		;need it here
 	CALL	LOCDCT		;locate the DCT
 	JR	ASKSPECS	;ask for specs
 ;
 ;
 SPECPAR	LD	A,3		;parameter error
 ;
 SPECERR	AND	7FH		;force return
 	LD	B,A		;pass error here
 	LD	A,SERROR	;SVC #
 	RST	SVC		;display it
 ;
 ASKSPECS LD	HL,SPECKS	;prompt for specs
 	LD	BC,1<8+79	;display len + key len
 	LD	DE,STRING	;key buffer
 	LD	A,VIDKEY	;SVC #
 	RST	SVC		;dislay, fetch keys
 ;
 	JR	NZ,SPECERR	;display error
 	JP	C,TERMIN	;break, abort
 ;
 	CALL	POSHL		;any input?
 	JR	NC,CKSPS	;check 'em out
 ;
 	LD	HL,HELP2	;help commands
 	CALL	DISPLAY		;show 'em
 	JR	ASKSPECS	;ask again
 ;
 ;	evaluate input
 ;
 ;	check for number of cylinders
 ;
 CKSPS	CALL	VALUE		;get number of cyls
 	JR	NZ,SPECERR	;error, display it
 	LD	(IY+16),C	;save cylinder count
 ;
 ;	check for density
 ;
 	CALL	POSHL		;more input?
 	JR	C,SPECPAR	;nope, param error
 ;
 	CALL	UCASE		;make it upper case
 	CP	'D'		;double?
 	JR	Z,SPECD		;yes, set double
 ;
 	CP	'S'		;single?
 	JR	NZ,SPECPAR	;nope, param error
 	RES	7,(IY+14)	;set single density
 	JR	NXSPC
 ;
 SPECD	SET	7,(IY+14)	;set double density
 ;
 NXSPC	INC	HL		;bump pointer
 ;
 ;	check for number of sides
 ;
 	CALL	POSHL		;any input?
 	JR	C,SPECPAR	;nope, param error
 	CALL	VALUE		;get number
 	JR	NZ,SPECERR	;nope, display error
 ;
 	LD	(IY+15),C	;save surface count
 	XOR	A		;set OK
 	RET			;back
 ;
 	PAGE
 ;
 ;	binary => ascii
 ;
 ASCII	PUSH	HL		;save it
 	CALL	ASCI		;convert part
 	LD	H,B		;save LSB
 	PUSH	HL		;on the stack
 ;
 	LD	A,C		;get MSB
 	SUB	'0'		;remove ascii
 	CALL	ASCI		;convert
 	LD	A,C		;get MSB
 	CP	'0'		;zero?
 	JR	NZ,ASCIGO1	;nope, continue
 	LD	A,' '		;else remove high 0
 ;
 ASCIGO1	POP	HL		;get LSB
 	LD	C,B		;NSB to C
 	LD	B,H		;LSB to B
 	POP	HL		;unstack
 	RET			;return, ACB
 ;
 ASCI	LD	C,'0'		;start ascii
 ;
 ASCII1	SUB	10		;check tens place
 	JR	C,ASCII2	;have it
 	INC	C		;bump ascii
 	JR	ASCII1		;try again
 ;
 ASCII2	ADD	A,'0'+10	;ascii, + last subtract
 	LD	B,A		;return it here
 	RET			;done
 ;
 ;
 VALUE	LD	A,1-1<4+13	;sys1 # 13
 	RST	OVLAY		;go direct
 ;
 	PAGE
 ;
 ;	display text string
 ;
 DISPLAY	PUSH	BC		;save 'em
 	PUSH	HL
 ;
 DISPLP	LD	A,(HL)		;get a byte
 	CP	3		;term?
 	JR	Z,DISPDN	;yes, go
 	INC	A		;FF term?
 	JR	Z,DISPDN	;yes, go
 	DEC	A		;put it back
 	LD	B,A		;need it here
 	LD	A,VDCHAR	;SVC #
 	RST	SVC		;output it
 	INC	HL		;next byte
 	JR	DISPLP		;go more
 ;
 DISPDN	POP	HL		;unstack
 	POP	BC
 	JP	PAUSE		;check for pause
 ;
 	PAGE
 ;
 ;	check for valid filespec character
 ;
 VALCHR	PUSH	HL		;save
 	PUSH	BC
 	LD	HL,VALTBL	;invalid chars
 	LD	BC,16		;length
 	CPIR			;is it here?
 	POP	BC		;unstack
 	POP	HL
 	RET			;Z = invalid
 ;
 ;
 VALTBL	DEFM	'!'
 	DEFM	'('
 	DEFM	')'
 	DEFM	','
 	DEFM	'.'
 	DEFM	'/'
 	DEFM	';'
 	DEFM	':'
 	DEFM	'@'
 	DEFM	'='
 	DEFM	'"'
 	DEFB	27H
 	DEFB	3
 	DEFB	13
 	DEFB	7BH
 	DEFB	7DH
 ;
 	PAGE
 ;
 ;	text
 ;
 ;##
 HELP1	DEFM	'drivespec, P, H, G, F, L, B=drivespec'
 	DEFB	13
 	DEFB	13
 	DEFM	'P = prompt for drive information'
 	DEFB	13
 	DEFM	'H = repair HIT table'
 	DEFB	13
 	DEFM	'G = repair GAT table'
 	DEFB	13
 	DEFM	'F = repair corrupt FILES'
 	DEFB	13
 	DEFM	'L = LOCKOUT track above directory'
 	DEFB	13
 	DEFM	'B = repair BOOT track'
 	DEFB	13
 	DEFM	'=drivespec fetches BOOT track from'
 	DEFM	' this drive'
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 ;
 HELP2	DEFM	'Cylinders, Density, Surfaces'
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 ;
 DEFNAME	DEFM	'*DIRFIX*00/00/00'
 	DEFB	0DH
 ;
 SPECKS	DEFB	'#'
 ;
 CANTFX	DEFM	'File(s) Directory Record(s) Corrupt'
 	DEFB	13
 	DEFM	'Cannot Repair Without "F" Option'
 	DEFB	13
 	DEFB	-1
 ;
 EXMSG	DEFB	13
 	DEFM	'DIRFIX '
 	DEFB	-1
 ;
 PLETEMSG DEFM	'* Completed *'
 	DEFB	13
 	DEFB	-1
 ;
 COMSG	DEFM	'$'
 CO0	DEFM	'x :'
 CO1	DEFM	'xx'
 CO2	DEFM	'xx '
 CO3	DEFM	'x" '
 CO4	DEFM	'xxxxxx #'
 CO5	DEFM	'x Cyls='
 CO6	DEFM	'xxx Sides='
 CO7	DEFM	'x Den='
 CO8	DEFM	'x Step='
 CO9	DEFM	'xxx Delay='
 CO10	DEFM	'x Hload='
 CO11	DEFM	'x Skip='
 CO12	DEFM	'x'
 COMSGL	EQU	$-COMSG
 ;
 FLPMSG	DEFM	'Floppy'
 HRDMSG	DEFM	'Rigid'
 ;
 ASKBAD	DEFM	'R>etry, S>kip, <BREAK> ? '
 ASKBADL	EQU	$-ASKBAD
 ;
 BADRMSG	DEFB	13
 	DEFM	'Disk READ Error'
 	DEFB	13
 	DEFB	-1
 ;
 BADWMSG	DEFB	13
 	DEFM	'Disk WRITE Error'
 	DEFB	13
 	DEFB	-1
 ;
 ABMSG	DEFM	'* Aborted *'
 	DEFB	13
 	DEFB	-1
 ;
 HELLO	DEFB	13
 	DEFM	'DIRFIX - '
 	DEFM	'DosPLUS II Directory Repair Utility - '
 	DEFM	'Series A.00'
 	DEFB	13
 	DEFM	'(c)(p) 1982 by MicroPower, Inc.'
 	DEFB	13
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 ;
 PMSG	DEFB	'*'
 DBUFF	EQU	$&0FF00H
 STRING	EQU	DBUFF+100H
 GATBUFF	EQU	STRING+100H
 HITBUFF	EQU	GATBUFF+100H
 BUFFER	EQU	HITBUFF+100H
 	END	ENTRY
