DOSBOO ; dosboot/asm
 ;
 	TITLE	'<DosPLUS II.A - BOOT/SYS>'
 ;
 ;	Created: 23-JUN-82	SJP/MSS
 ;
 ;	FLOPPY DISK CMDS & ADDRESSING
 ;
 FD?C	EQU	0E4H		;FDC COMMAND/STATUS
 FD?T	EQU	0E5H		;FDC TRACK REGISTER
 FD?S	EQU	0E6H		;FDC SECTOR REGISTER
 FD?D	EQU	0E7H		;FDC DATA REGISTER
 DRSL	EQU	0EFH		;DRIVE,MODE,SIDE SEL
 DMAC	EQU	0F8H		;DMA COMMAND/STATUS
 ROME	EQU	0F9H		;ROM ENABLE/DISABLE
 ;
 FSEEK	EQU	00011110B	;FDC SEEK H,V 10ms
 FREAD	EQU	10001000B	;FDC READ SECTOR
 FCLER	EQU	11010000B	;FDC FORCE CLEAR
 ;
 ;	LOCAL VARIABLE EQUIVALENCES
 ;
 OFL	EQU	0+3		;FLAGS OFFSET DCT
 OST	EQU	3+3		;SEC/TRK OFFSET DCT
 ODL	EQU	5+3		;DIR LOC OFFSET DCT
 OSG	EQU	6+3		;SEC/GRAN OFFSET DCT
 OSC	EQU	8+3		;SEC/CYL OFFSET DCT
 ;
 BOOT	EQU	1020H
 BUFER1	EQU	0E00H		;START LOAD AREA
 BUFER2	EQU	2200H		;START HIGH OVERLAYS
 BUFER3	EQU	2300H		;TEMP I/O BUFFER
 BUFER4	EQU	2400H		;BOOTSTRAP EXEC AREA
 VIDEO	EQU	0F800H		;START VIDEO MEMORY
 ;
 RELO	EQU	BUFER4-BOOT	;RELO OFFSET
 ;
 ;
 ;
 ;
 ;	RELOCATE TO NON-RESIDENT AREA
 ;
 	ORG	1000H		;BOOT LOAD ADDRESS
 ;
 START	DEFM	'BOOT'          ;BOOT CODE
 ;
 ENTRY	LD	HL,BUFER1+128	;DCT INFO
 	LD	DE,BUFER2	;TEMP BUFFER
 	LD	BC,128		;COUNT
 	XOR	A		;ZERO
 	OUT	(ROME),A	;DISABLE BOOT ROM
 	LDIR			;MOVE!
 	LD	HL,BOOT 	;START BOOT
 	LD	DE,BUFER4	;EXEC AREA
 	LD	BC,EBOOT-BOOT	;COUNT
 	LDIR			;MOVE!
 	JP	BUFER4		;EXECUTE!
 ;
 	PAGE
 ;	READ DIRECTORY FOR SYS0/SYS
 ;
 ;boot
 	LD	SP,BUFER3	;LOCATE STACK
 	LD	A,(BUFER2+ODL)	;GET DIR TRACK
 	LD	D,A		;DE = DIR TRK
 	LD	E,5		;LFN #3 (LOC OF SYS0)
 	LD	HL,BUFER3	;I/O BUFFER
 	CALL	DREAD+RELO	;READ SECTOR
 	JR	NZ,DSKERR	;IF READ ERROR
 ;
 	LD	A,(HL)		;GET BUFFER
 	CPL			;INVERT
 	AND	50H		;ACTIVE SYSTEM?
 	LD	HL,EMES1+RELO	;'NO SYSTEM'
 	JR	NZ,SYSERR	;IF NOT
 ;
 ;	CONVERT SD TO DISK ADDRESS
 ;
 	EXX			;ALT SET
 	LD	HL,(BUFER3+16H) ;HL = SD
 	LD	D,L		;TRACK
 	LD	A,H
 	AND	0E0H		;GRAN OFFSET
 	RLCA
 	RLCA
 	RLCA			;BITS 0-2
 	LD	C,A		;E = GRAN OFFSET
 	LD	A,(BUFER2+OSG)	;SECTORS/GRAN
 	LD	B,A		;B = SEC/GRAN
 	XOR	A		;ZERO
 BOOT0	ADD	A,C		;SEC/GRAN*GRAN
 	DJNZ	BOOT0		;TIL DONE
 	LD	E,A		;E = SECTOR
 	LD	HL,BUFER3+0FFH	;BUFFER -1
 	EXX			;RESTORE
 ;
 	PAGE
 ;	GET BLOCK ADDRESS AND READ
 ;
 BOOT1	CALL	BYTE+RELO	;GET BYTE
 	LD	H,A		;SAVE HEADER
 	CALL	BYTE+RELO	;BLOCK LENTH
 	LD	B,A
 	CALL	BYTE+RELO	;LSB OF BLK ADD
 	LD	L,A
 	DEC	H		;DEC COUNT
 	JR	Z,BOOT3 	;DATA BLOCK
 	DEC	H
 	JR	NZ,BOOT2	;REMARK
 ;
 ;	GET ENTRY ADDRESS & GO!
 ;
 	CALL	BYTE+RELO	;MSB ENTRY POINT
 	LD	H,A		;HL => ENTRY POINT
 	JP	(HL)		;GO!
 ;
 ;	ASSUME REMARK HEADER AND READ
 ;
 BOOT2	DEC	B		;COUNT
 	JR	Z,BOOT1 	;IF DONE
 	CALL	BYTE+RELO	;READ
 	JR	BOOT2		;TIL DONE
 ;
 BOOT3	CALL	BYTE+RELO	;GET BYTE
 	LD	H,A
 	DEC	B		;DEC COUNT
 	DEC	B
 ;
 BOOT4	CALL	BYTE+RELO	;GET BYTE
 	LD	(HL),A		;LOAD
 	INC	HL		;NEXT
 	DJNZ	BOOT4		;TIL DONE
 	JR	BOOT1		;TRY AGAIN
 ;
 ;	READ 1 BYTE FROM FILE
 ;
 BYTE	EXX			;GET ALT
 	INC	L		;NEXT
 	JR	NZ,BYTE1	;WITHIN BUFFER
 	CALL	DREAD+RELO	;READ SECTOR
 	JR	NZ,DSKERR	;IF READ ERROR
 	LD	A,(BUFER2+OSC)	;SEC/CYLINDER
 	DEC	A		;LAST SEC
 	INC	E		;NEXT SEC
 	CP	E		;END CYL?
 	JR	NC,BYTE1	;IF NOT
 	LD	E,0		;INIT SECTOR
 	INC	D		;NEXT CYL
 BYTE1	LD	A,(HL)		;GET BYTE
 	EXX			;RESTORE
 	RET
 ;
 	PAGE
 ;	DISPLAY DISK ERROR & LOCK
 ;
 DSKERR	LD	HL,EMES2+RELO	;'DISK ERROR!'
 SYSERR	LD	DE,VIDEO+990	;GET CHAR
 SYSER1	LD	A,(HL)		;GET CHAR
 	OR	A		;EOT?
 	JR	Z,SYSER2	;IF YES
 	LDI			;TO VIDEO
 	JR	SYSER1		;TIL DONE
 ;
 SYSER2	LD	A,4FH		;NO DRIVES
 	OUT	(DRSL),A	;DE-SELECT
 	HALT			;LOCK-UP
 ;
 	PAGE
 ;	READ SECTOR ROUTINE - TWO ATTEMPTS
 ;
 ;	ENT	HL =>	BUFFER
 ;		DE =	CYLINDER,SECTOR
 ;
 DREAD	CALL	DREAD1+RELO	;ATTEMPT READ
 	RET	Z		;IF READ OK
 ;
 ;	INITIALIZE DMA FOR READ
 ;
 DREAD1	PUSH	HL		;SAVE
 	LD	(DMARD+9+RELO),HL;DMA BUFFER
 	LD	HL,DMARD+RELO	;HL => INIT DATA
 	LD	BC,15<8+DMAC	;COUNT AND DMA REG
 	OTIR			;ISSUE CMD
 ;
 ;	SEEK TRACK & SEL SIDE
 ;
 	CALL	DSEEK+RELO	;SEEK TRACK
 	JR	NZ,DREAD4	;IF ERROR
 ;
 ;	TRANSFER SECTOR DATA
 ;
 	CALL	DCLR+RELO	;CLEAR FDC
 	BIT	5,A		;HEAD LOADED?
 	LD	A,FREAD 	;FDC READ CMD
 	JR	NZ,DREAD3	;IF YES
 	SET	2,A		;LOAD HEAD
 DREAD3	OUT	(FD?C),A	;ISSUE CMD
 	LD	A,87H		;START CMD
 	OUT	(DMAC),A	;START DMA
 	CALL	WAIT+RELO	;WAIT FOR COMPLETE
 	LD	A,83H		;TERM CMD
 	OUT	(DMAC),A	;TERM DMA
 	IN	A,(FD?C)	;GET STATUS
 	AND	9DH		;I/O ERROR?
 DREAD4	POP	HL		;RESTORE
 	RET
 ;
 	PAGE
 ;	DISK SEEK ROUTINE
 ;
 DSEEK	PUSH	DE		;SAVE
 	LD	A,(BUFER2+OFL)	;GET DENSITY
 	AND	80H		;DEN ONLY
 	OR	7EH		;SEL 0
 	LD	D,A		;C = MODE & SEL
 	LD	A,(BUFER2+OST)	;SEC/TRACK
 	DEC	A		;LAST SEC
 	SUB	E		;END TRACK?
 	JR	NC,DSEEK1	;IF NOT
 	RES	6,D		;SIDE 1
 	INC	A		;CORRECT
 	LD	E,A		;E = SECTOR
 DSEEK1	LD	A,E		;GET SECTOR
 	OUT	(FD?S),A	;SET SECTOR
 	LD	A,D		;GET SEL MASK
 	OUT	(DRSL),A	;SEL DRIVE & MODES
 	POP	DE		;RESTORE
 ;
 	IN	A,(FD?T)	;GET TRACK
 	SUB	D		;AT TRACK?
 	RET	Z		;NO ERRORS
 ;
 	LD	A,D		;GET CYL
 	OUT	(FD?D),A	;SET TRACK
 	LD	A,FSEEK 	;FDC SEEK CMD
 	OUT	(FD?C),A	;ISSUE CMD
 	CALL	WAIT+RELO	;WAIT FOR COMPLETE
 	IN	A,(FD?C)	;GET STATUS
 	AND	98H		;RDY,SEEK,CRC
 	RET
 ;
 	PAGE
 ;	WAIT FOR FDC COMPLETION
 ;
 WAIT	CALL	DELAY+RELO	;DELAY 140 uS
 WAIT1	IN	A,(FD?C)	;GET STATUS
 	AND	81H		;RDY,BUSY
 	DEC	A		;BUSY?
 	JR	Z,WAIT1 	;IF YES
 	RET
 ;
 ;	CLEAR FDC AND GET STATUS
 ;
 DCLR	LD	A,FCLER 	;FORCE CLEAR
 	OUT	(FD?C),A	;ISSUE CMD
 	CALL	DELAY+RELO	;140 uS
 	IN	A,(FD?C)	;GET STATUS
 	RET
 ;
 DELAY	PUSH	BC		;SAVE
 	LD	B,14		;140 uS
 	DJNZ	$		;WAIT
 	POP	BC		;RESTORE
 	RET
 ;
 ;	DMA READ INITIALIZE DATA
 ;
 DMARD	DEFB	0C3H		;WR6 - RESET
 	DEFB	08BH		;WR6 - CLEAR STATUS
 	DEFB	069H		;WE0 - PORTA FOLLOWS
 	DEFB	FD?D		;FDC DATA REGISTER
 	DEFW	256		;BLOCK LENGTH
 	DEFB	03CH		;WR1 - PORTA FIXED, I/O
 	DEFB	10H		;WR2 - PORTB INC,MEM
 	DEFB	08DH		;WR4 - BYTE, PORTB FOLOWS
 	DEFW	0000		;BUFFER ADDRESS
 	DEFB	08AH		;WR5 - STOP,RDY HIGH
 	DEFB	0CFH		;WR6 - LOAD START,CLEAR
 	DEFB	005H		;WR0 - PORTA -> PORTB
 	DEFB	0CFH		;WR6 - LOAD START,CLEAR
 ;
 ;	ERROR MESSAGES AND TEXT
 ;
 EMES1	DEFM	'NO SYSTEM!'
 	DEFB	0
 ;
 EMES2	DEFM	'DISK ERROR!'
 	DEFB	0
 ;
 EBOOT	EQU	$		;END BOOT
 	END
