; dosdatak/asm
;
; revised 03/28/83 - sjp
;
	PAGE
;
; following is the RTC interrupt service table
;
; 16 entries maximum (0-15) (32 bytes long)
; this table may cross a page boundary
; each entry is 2 bytes long
;
RTCTBL	DEFW	NILL		;-00 nil
	DEFW	NILL		;-01 nil
	DEFW	TIMTASK 	;-02 update internal clok
	DEFW	PRTTASK 	;-03 printer spooler task
	DEFW	NILL		;-04 clock (CLKTASK)
	DEFW	NILL		;-05 trace (TRCTASK)
	DEFW	NILL		;-06 alive (ALVTASK)
	DEFW	NILL		;-07 user timer (UTMTASK)
;
; the following is the data area for the clock
; the tables must be wholly within a page
;
TIME$	DEFS	1		;ticks
	DEFS	1		;seconds
	DEFS	1		;minutes
	DEFS	1		;hours
DATE$	DEFS	1		;day
	DEFS	1		;month
	DEFS	1		;year-1980
;
; following is a table of maximum time values
; (must be contiguous with the $TIME table
; and on the same page)
;
TIMETBL DEFB	30		;ticks / second
	DEFB	60		;max seconds
	DEFB	60		;max minutes
	DEFB	24		;max hours
;
; following is a list of days in each month
; leap years are adjusted for february (contiguous)
;
MONTHS	DEFB	31		;jan
	DEFB	28		;feb (leap years adj)
	DEFB	31		;march
	DEFB	30		;april
	DEFB	31		;may
	DEFB	30		;june
	DEFB	31		;july
	DEFB	31		;august
	DEFB	30		;sept
	DEFB	31		;oct
	DEFB	30		;nov
	DEFB	31		;dec
;
	PAGE
; flags and data external to DCB's
;
FLAGK1	DEFB	0	;flag1
;	7 - unused
;	6 - unused
;	5 - unused
;	4 - unused
;	3 - verify     - 1=ON, 0=OFF
;	2 - debug flag - 1=ON, 0=OFF
;	1 - force read - 1=ON, 0=OFF
;	0 - unused
;
FLAGK3	DEFB	0	;last posted error
DATAK0	DEFB	90	;floppy disk time-out
OSVER	DEFB	10H	;operating system version
DATAK1	DEFW	0	;user timer counter
DATAK2	DEFW	0	;user timer vector
DATAK5	DEFW	0	;interpreter string pointer
DATAK6	DEFW	2800H	;bottom free memory
LOMEM	EQU	DATAK6
DATAK7	DEFW	-1	;top free memory
HIMEM	EQU	DATAK7
DATAK8	DEFW	-1	;top physical memory
PHMEM	EQU	DATAK8
DATAK9	DEFS	8	;for $TRACE & $CLOCK
DATAKA	DEFS	11	;for $WILD
;
