DOSSYS ; dossys0/asm
 ;
 	TITLE	'<DOSPLUS - MODEL II OPERATING SYSTEM>'
 ;
 ;	K. Watt 	05/82, for Breeze/Qsd Inc.
 ;	S. Pagliarulo	05/82, for Micro-Systems SOFT Inc.
 ;
 ;	Copyright (c)	05/82, MicroPower Inc.
 ;
 ;
 ;
 ;	MACRO DEFINITIONS:
 ;
 ;	DEVICE I/O STARTER
 ;
 ;DEVICE	MACRO	?MASK,?OFFSET	;VARIABLES
 ;	LD	A,?MASK<5+?OFFSET
 ;	ENDM
 ;
 ;	RETURN/JP ROUTINE
 ;
 ;RETSP	MACRO			;VARIABLES
 ;	RET			;EXIT
 ;	NOP			;SPACE
 ;	NOP			;SPACE
 ;	ENDM
 ;
 ;	OVERLAY ADDRESSING
 ;
 ;OVLY	MACRO	?SYS#,?CMD#	;SET-UP FOR LOAD
 ;	LD	A,?SYS#-1<4+?CMD#
 ;	RST	18H
 ;	ENDM
 ;
 	PAGE
 ;	RESIDENT DRIVER EQUIVALENCES
 ;
 ;
 PAGE0	EQU	000H		;PAGE ADDRESS
 PAGE1	EQU	100H		;PAGE ADDRESS
 PAGE2	EQU	200H		;PAGE ADDRESS
 PAGE3	EQU	300H		;PAGE ADDRESS
 STACK	EQU	1AA0H		;START STACK AREA
 BUFFER	EQU	1B00H		;MAIN I/O BUFFER
 ;
 ;	ASCII CHARACTER EQUIVALENCES
 ;
 CR	EQU	13		;CARRIAGE RETURN
 NUL	EQU	0		;NULL CHARACTER
 ETX	EQU	3		;END TEXT
 BKSP	EQU	8		;CTL-H
 LF	EQU	10		;LINE FEED
 FF	EQU	12		;FORM FEED
 ;
 	PAGE
 ;	IO PORT VALUES CPU MODULE
 ;
 CTC0	EQU	0F0H		;CTC CHANNEL 0
 CTC1	EQU	0F1H		;CTC CHANNEL 1
 CTC2	EQU	0F2H		;CTC CHANNEL 2
 CTC3	EQU	0F3H		;CTC CHANNEL 3
 SIOAD	EQU	0F4H		;SIO CHANNEL A DATA
 SIOBD	EQU	0F5H		;SIO CHANNEL B DATA
 SIOAC	EQU	0F6H		;SIO CHANNEL A CMD/STAT
 SIOBC	EQU	0F7H		;SIO CHANNEL B CMD/STAT
 DMA	EQU	0F8H		;DMA COMMAND/STATUS
 ROME	EQU	0F9H		;ROM ENABLE/DISABLE
 ;
 ;	IO PORT VALUES FDC-PRINTER
 ;
 PIOAD	EQU	0E0H		;PRINTER & FDC INT STAT
 PIOBD	EQU	0E1H		;PRINTER DATA (OUTPUT)
 PIOAC	EQU	0E2H		;CONFIGURING PORT A
 PIOBC	EQU	0E3H		;CONFIGURING PORT B
 FDCC	EQU	0E4H		;FDC COMMAND/STATUS
 FDCT	EQU	0E5H		;FDC TRACK REGISTER
 FDCS	EQU	0E6H		;FDC SECTOR REGISTER
 FDCD	EQU	0E7H		;FDC DATA REGISTER
 DRSL	EQU	0EFH		;DRIVE,MODE,SIDE SEL
 ;
 ;	IO PORT VALUES KEYBOARD/VIDEO
 ;
 RDKBD	EQU	0FCH		;READ KEYBOARD DATA
 LCRTA	EQU	0FCH		;LOAD CRTC ADD REG
 RCTRD	EQU	0FDH		;READ CRTC DATA REG
 LCTRD	EQU	0FDH		;LOAD CTRC DATA REG
 RDRTC	EQU	0FEH		;CLEAR RTC INTERRUPT
 RDNMI	EQU	0FFH		;READ NMI/INT REG
 LBANK	EQU	0FFH		;LOAD BANK SEL REG
 ;
 ;	MACHINE INSTRUCTIONS
 ;
 LDBC	EQU	01H		;LD	BC,NNNN
 JP	EQU	0C3H		;JP	ADD
 ;
 	TITLE	'<SYSTEM I/O DRIVERS - 1.0>'
 ;	GENERAL PURPOSE I/O DRIVERS:
 ;
 ;	     $KBD	- READ KEYBOARD CHARACTER
 ;	     $DSP	- WRITE CHARACTER TO DISPLAY
 ;	     $PRT	- WRITE CHARACTER PRINTER
 ;	     $KBDW	- READ KEYBOARD W/WAIT
 ;	     $PRTS	- READ PRINTER STATUS
 ;	     $CLAI	- READ CHAR FROM COMM LINE A
 ;	     $CLAO	- WRITE CHAR TO COMM LINE A
 ;	     $CLBI	- READ CHAR FROM COMM LINE B
 ;	     $CLBO	- WRITE CHAR TO COMM LINE B
 ;	     $CLAW	- READ CHAR COMM LINE A & WAIT
 ;	     $CLBW	- READ CHAR COMM LINE B & WAIT
 ;
 	PAGE
 ;	CHARACTER I/O ROUTINES
 ;
 ;	ENT	 B =	CHARACTER
 ;
 	ORG	PAGE0
 ;
 RST0	JP	JP2DOS		;DOS WARM ENTRY
 KBD	LD	A,1<5+0		;KBD INPUT
 	JR	RESOL		;GO!
 	NOP
 ;
 RST8	JP	EXSVC		;SVC EXECUTER
 DSP	LD	A,2<5+1		;DISPLAY OUTPUT
 	JR	RESOL		;GO!
 	NOP
 ;
 RST16	JP	DISKIO		;DISK I/O MANAGER
 PRT	LD	A,2<5+2		;PRINTER OUTPUT
 	JR	RESOL		;GO!
 	NOP
 ;
 RST24	JP	OVERLY		;OVERLAY LOADER
 KBDW	LD	A,5<5+0		;KBD INPUT/WAIT
 	JR	RESOL		;GO!
 	NOP
 ;
 RST32	RET			;Z80 RST
 	NOP
 	NOP
 PRTS	LD	A,4<5+2		;PRINTER STATUS
 	JR	RESOL		;GO!
 	NOP
 ;
 RST40	RET			;Z80 RST
 	NOP
 	NOP
 CLAI	LD	A,1<5+3		;COMM LINE A INPUT
 	JR	RESOL		;GO!
 	NOP
 ;
 RST48	RET			;Z80 RST
 	NOP
 	NOP
 CLAO	LD	A,2<5+3		;COMM LINE A OUTPUT
 	JR	RESOL		;GO!
 	NOP
 ;
 RST56	JP	DEBUG		;DEBUG ENTRY
 CLBI	LD	A,1<5+4		;COMM LINE B INPUT
 	JR	RESOL		;GO!
 ;
 CLBO	LD	A,2<5+4		;COMM LINE B OUTPUT
 	JR	RESOL		;GO!
 ;
 CLAW	LD	A,5<5+3		;COMM LINE A INPUT/WAIT
 	JR	RESOL		;GO!
 ;
 CLBW	LD	A,5<5+4		;COMM LINE B INPUT/WAIT
 	JR	RESOL		;GO!
 ;
 ;	GENERAL PURPOSE CHAR I/O
 ;
 ;	ENT	 A =	I/O TYPE
 ;		 B =	CHARACTER
 ;		DE =>	DEVICE DCB
 ;
 GET	LD	A,5		;I/O TYPE
 	JR	GIO		;SKIP
 PUT	LD	A,2		;I/O TYPE
 ;
 GIO	PUSH	HL		;SAVE REG
 	PUSH	IX
 	PUSH	DE
 	POP	IX		;IX => DCB
 	JR	CHIO		;SKIP
 ;
 ;	TABLE OF INT TASK DRIVERS
 ;
 	ORG	PAGE0+60H
 ;
 	DEFW	CLKTASK 	;CLOCK TASK
 	DEFW	TRCTASK 	;TRACE TASK
 	DEFW	ALVTASK 	;ALIVE TASK
 ;
 	ORG	PAGE0+66H
 ;
 NMIVC	JP	NMICODE 	;NMI HANDLER
 ;
 	PAGE
 ;	RESOLVE DCB ADDRESS
 ;
 ;	ENT	 A =	MASK,DCB NUMBER
 ;
 ;	EXT	 A =	DEVICE MASK
 ;		IX =>	DEVICE DCB
 ;
 RESOL	PUSH	HL		;SAVE
 	PUSH	IX		;SAVE
 	PUSH	AF		;SAVE MASK
 	AND	0FH		;A = DEVICE NUMBER
 	CALL	LOCDCB		;LOCATE DCB
 	POP	AF		;GET MASK
 	RLCA
 	RLCA
 	RLCA			;TO BITS 0-2
 	AND	07H		;MASK ONLY
 ;
 ;	DEVICE CHARACTER I/O DRIVER
 ;	HANDLES DCB,FCB,NIL,ROUTE,LINK
 ;
 ;	ENT	 A =	I/O TYPE
 ;		IX =>	DEVICE DCB
 ;
 CHIO	PUSH	DE		;SAVE
 	LD	HL,CIO8 	;RETURN ADD
 	PUSH	HL		;TO STACK
 ;
 CIO1	LD	E,(IX+0)	;GET DCB TYPE
 	LD	D,A		;D = I/O TYPE
 	BIT	7,E		;FILE?
 	JP	NZ,CIOF 	;GO!
 	LD	L,(IX+3)
 	LD	H,(IX+4)	;ROUTE/LINK DCB
 	BIT	4,E		;ROUTE?
 	JR	NZ,CIO4 	;GO!
 	BIT	5,E		;LINK?
 	JR	Z,CIO2		;IF NOT
 ;
 	PUSH	AF		;I/O TYPE TO STACK
 	PUSH	HL		;LINK DCB TO STACK
 	LD	HL,CIO5 	;LINK ADD
 	PUSH	HL		;TO STACK
 ;
 CIO2	BIT	3,E		;NIL?
 	JR	NZ,CIO3 	;GO!
 	LD	A,E		;GET DCB TYPE
 	AND	D		;MASK TYPE
 	CP	D		;DEVICE SUPPORT?
 	JR	NZ,CIO3 	;IF NOT
 	LD	L,(IX+1)
 	LD	H,(IX+2)	;HL => DRIVER
 	CP	2		;INPUT?
 	JP	(HL)		;GO!
 ;
 ;	NIL DEVICE HANDLER
 ;
 CIO3	LD	A,D		;GET I/O TYPE
 	AND	1		;INPUT?
 	RET	Z		;IF NOT
 	XOR	A		;Z STATUS
 	LD	B,A		;NULL
 	RET
 ;
 CIO4	PUSH	HL
 	POP	IX		;IX => ROUTE DCB
 	JR	CIO1		;GO!
 ;
 CIO5	POP	IX		;IX => LINK DCB
 	POP	DE		;D = I/O TYPE
 	JR	NZ,CIO6 	;IF ERROR
 	LD	A,D		;A = I/O TYPE
 	BIT	0,A		;OUTPUT?
 	JR	Z,CIO1		;DO LINK
 	XOR	A		;NO ERROR
 	RET			;DONE!
 ;
 CIO6	BIT	0,D		;OUTPUT
 	JR	Z,CIO7		;IF YES
 	LD	A,D		;A = I/O TYPE
 	JR	CIO1		;DO LINK
 CIO7	OR	A		;NZ STATUS
 	RET			;DO LINK
 ;
 CIO8	POP	DE		;RESTORE REG
 	POP	IX
 	POP	HL
 	RET
 ;
 	PAGE
 ;
 ;	LOCATE DRIVE CTL TABLE
 ;
 ;	ENT	 C =	DRIVE NUMBER
 ;
 ;	EXT	 IY =>	DRIVE CTL TABLE
 ;
 LOCDCT	PUSH	HL		;SAVE
 	LD	A,C		;GET DRIVE
 	ADD	A,8		;CORRECT
 	CALL	LOCTBL		;LOCATE DCT
 	PUSH	HL
 	POP	IY		;IY => DCT
 	POP	HL		;RESTORE
 	RET
 ;
 ;	LOCATE DEVICE CTL TABLE
 ;
 ;	ENT	 A =	DEVICE NUMBER
 ;
 ;	EXT	IX =>	DEVICE CTL TABLE
 ;
 LOCDCB	PUSH	HL		;SAVE
 	CALL	LOCTBL		;LOCATE DCB
 	PUSH	HL
 	POP	IX		;IX => DCB
 	POP	HL		;RESTORE
 	RET
 ;
 ;	LOCATE DCT/DCB TABLES
 ;
 ;	ENT	 A =	DEVICE NUMBER
 ;
 ;	EXT	HL =>	DEVICE DCB/DCT
 ;
 LOCTBL	LD	H,PAGE1<-8	;H = MSB
 	ADD	A,A		;* 2
 	ADD	A,A		;* 4
 	LD	L,A		;HL => ENTRY
 	LD	A,(HL)		;A = LSB DCT
 	INC	HL
 	LD	H,(HL)		;H = MSB DCT
 	LD	L,A		;HL => DCT
 	RET
 ;
 	PAGE
 ;	DCB/DCT LOCATION TABLE
 ;
 ;	EACH TABLE ENTRY 4 BYTES:
 ;
 ;	    0-1 DCB/DCT ADDRESS
 ;	    2-3 DCB/DCT NAME 2 CHAR
 ;
 	ORG	PAGE1
 ;
 DCBTBL	DEFW	KDCB		;DEVICE 0
 	DEFM	'KI'
 	DEFW	DDCB		;DEVICE 1
 	DEFM	'DO'
 	DEFW	PDCB		;DEVICE 2
 	DEFM	'PR'
 	DEFW	CADCB		;DEVICE 3
 	DEFM	'CA'
 	DEFW	CBDCB		;DEVICE 4
 	DEFM	'CB'
 	DEFW	USER1		;DEVICE 5
 	DEFM	'U1'
 	DEFW	USER2		;DEVICE 6
 	DEFM	'U2'
 	DEFW	USER3		;DEVICE 7
 	DEFM	'U3'
 	DEFW	DCT0		;DEVICE 8
 	DEFM	'0 '
 	DEFW	DCT1		;DEVICE 9
 	DEFM	'1 '
 	DEFW	DCT2		;DEVICE 10
 	DEFM	'2 '
 	DEFW	DCT3		;DEVICE 11
 	DEFM	'3 '
 	DEFW	DCT4		;DEVICE 12
 	DEFM	'4 '
 	DEFW	DCT5		;DEVICE 13
 	DEFM	'5 '
 	DEFW	DCT6		;DEVICE 14
 	DEFM	'6 '
 	DEFW	DCT7		;DEVICE 15
 	DEFM	'7 '
 ;
 ;	VECTORED INTERRUPT TABLE
 ;
 VCTC0	DEFW	-1		;CTC 0
 VCTC1	DEFW	-1		;CTC 1
 VCTC2	DEFW	-1		;CTC 2
 VCTC3	DEFW	KBDTASK 	;CTC 3 KEYBOARD
 VCLIA	DEFW	RSINTA		;SIO A RECEIVE
 VCLIB	DEFW	RSINTB		;SIO B RECEIVE
 ;
 	PAGE
 *GET	DOSDATAK
 *GET	DOSDATAS
 	PAGE
 ;	TABLE OF SUPERVISOR CALLS
 ;
 	ORG	PAGE2
 ;
 SVCTBL	DEFW	INITIO		;0 - INITIALIZE I/O
 	DEFW	KBINIT		;1 - KEYBOARD INITIALIZE
 	DEFW	SETUSR		;2 - SET-UP USER SVC
 	DEFW	SETBRK		;3 - SET UP BREAK PROCESSING
 	DEFW	KBD		;4 - KEYBOARD CHARACTER
 	DEFW	KBLINE		;5 - KEYBOARD LINE
 	DEFW	DELAY		;6 - DELAY PROGRAM EXECUTION
 	DEFW	VDINIT		;7 - VIDEO INITIALIZE
 	DEFW	DSP		;8 - VIDEO CHARACTER
 	DEFW	VDLINE		;9 - VIDEO LINE
 	DEFW	VDGRAF		;10 - VIDEO GRAPHICS
 	DEFW	VDREAD		;11 - VIDEO READ
 	DEFW	VIDKEY		;12 - VIDEO/KEYBOARD
 	DEFW	SVBAD		;13 - UNDEFINED
 	DEFW	SVBAD		;14 - UNDEFINED
 	DEFW	DISKID		;15 - READ DISKETTE ID
 	DEFW	SVBAD		;16 - UNDEFINED
 	DEFW	PRINIT		;17 - PRINTER INITIALIZE
 	DEFW	PRT		;18 - PRINTER CHARACTER
 	DEFW	PRLINE		;19 - PRINTER LINE
 	DEFW	RANDOM		;20 - RANDOM NUMBER GEN
 	DEFW	BINDEC		;21 - BINARY/DECIMAL CONV
 	DEFW	STCMP		;22 - STRING COMPARE
 	DEFW	MPYDIV		;23 - MULTIPLY/DIVIDE
 	DEFW	BINHEX		;24 - BINARY/HEX CONV
 	DEFW	TIMER		;25 - TIMER TO INTERRUPT
 	DEFW	CURSOR		;26 - CURSOR CONTROL
 	DEFW	SCROLL		;27 - SCROLL PROTECT VIDEO
 	DEFW	LOOKUP		;28 - TABLE LOOKUP ROUTINE
 	DEFW	HLDKEY		;29 - PROCESS HOLD KEY
 	DEFW	SVBAD		;30 - UNDEFINED
 	DEFW	EXIT		;31 - @ EXIT DOS ENTRY
 	DEFW	OVERLY		;32 - OVERLAY LOADER
 	DEFW	LOCATE		;33 - LOCATE RECORD
 	DEFW	READNX		;34 - READ NEXT RECORD
 	DEFW	DIRRD		;35 - DIRECT RECORD READ
 	DEFW	JP2DOS		;36 - @ ABORT DOS ENTRY
 	DEFW	DOSCMD		;37 - DOS CMD & EXIT
 	DEFW	RETCMD		;38 - DOS CMD & RETURN
 	DEFW	ERROR		;39 - DISPLAY ERROR NUMBER
 	DEFW	OPEN		;40 - OPEN DEVICE/FILE
 	DEFW	KILL		;41 - KILL DEVICE/FILE
 	DEFW	CLOSE		;42 - CLOSE DEVICE/FILE
 	DEFW	WRITNX		;43 - WRITE NEXT RECORD
 	DEFW	DIRWR		;44 - DIRECT RECORD WRITE
 	DEFW	DATE		;45 - FETCH CURR TIME/DATE
 	DEFW	PARSER		;46 - PARSE COMMAND LINE
 	DEFW	RENAME		;47 - RENAME FILE ROUTINE
 	DEFW	SVBAD		;48 - UNDEFINED
 	DEFW	STSCAN		;49 - STRING SCAN ROUTINE
 	DEFW	SVBAD		;50 - UNDEFINED
 	DEFW	WILD		;51 - WILD CARD PARSER
 	DEFW	ERRMSG		;52 - RETURN ERROR MESSAGE
 	DEFW	RAMDIR		;53 - RAM DIRECTORY
 	DEFW	RDDIR		;54 - READ DIRECTORY
 	DEFW	RS232C		;55 - RS-232-C INITIALIZE
 	DEFW	SORT		;56 - SORT RAM ROUTINE
 	DEFW	CLRXIT		;57 - CLEAR RAM & EXIT DOS
 	DEFW	FILPTR		;58 - GET FILE POINTERS
 	DEFW	SVBAD		;59 - UNDEFINED
 	DEFW	SVBAD		;60 - UNDEFINED
 	DEFW	SVBAD		;61 - UNDEFINED
 	DEFW	SVBAD		;62 - UNDEFINED
 	DEFW	SVBAD		;63 - UNDEFINED
 	DEFW	SVBAD		;64 - UNDEFINED
 	DEFW	SVBAD		;65 - UNDEFINED
 	DEFW	SVBAD		;66 - UNDEFINED
 	DEFW	SVBAD		;67 - UNDEFINED
 	DEFW	SVBAD		;68 - UNDEFINED
 	DEFW	SVBAD		;69 - UNDEFINED
 	DEFW	SVBAD		;70 - UNDEFINED
 	DEFW	SVBAD		;71 - UNDEFINED
 	DEFW	SVBAD		;72 - UNDEFINED
 	DEFW	KBDW		;73 - KBD INPUT W/WAIT
 	DEFW	PRTS		;74 - PRINTER STATUS
 	DEFW	CLAW		;75 - COMM LINE A WAIT
 	DEFW	CLBW		;76 - COMM LINE B WAIT
 	DEFW	GET		;77 - INPUT BYTE DEVICE
 	DEFW	PUT		;78 - OUTPUT BYTE DEVICE
 	DEFW	POSN		;79 - POSN TO LOGICAL REC
 	DEFW	BKSP		;80 - BKSP LOGICAL RECORD
 	DEFW	REWD		;81 - REWIND FILE
 	DEFW	PEOF		;82 - POSN TO EOF
 	DEFW	EVAL		;83 - EVALUATE CMD LINE
 	DEFW	FSPEC		;84 - FETCH FILE SPEC
 	DEFW	RUN		;85 - LOAD & RUN PROGRAM
 	DEFW	LOAD		;86 - LOAD PROGRAM
 	DEFW	PARAM		;87 - FETCH OPTIONAL PARAMS
 	DEFW	FEXT		;88 - PLACE FILE EXTENSION
 	DEFW	FDRV		;89 - FETCH DRIVE SPEC
 	DEFW	SVBAD		;90 - UNDEFINED
 	DEFW	SCREEN		;91 - SCREEN PRINT
 	DEFW	NMICTL		;92 - ADD/KILL NMI VECTOR
 	DEFW	SVBAD		;93 - ADD/KILL DEVICE
 	DEFW	VIDRAM		;94 - VIDEO/RAM TRANSFER
 	DEFW	PRCTRL		;95 - PRINTER CONTROL
 	DEFW	CLAI		;96 - CHANNEL A RECEIVE
 	DEFW	CLAO		;97 - CHANNEL A TRANSMIT
 	DEFW	CLBI		;98 - CHANNEL B RECEIVE
 	DEFW	CLBO		;99 - CHANNEL B TRANSMIT
 	DEFW	ACTRL		;100 - CHANNEL A CONTROL
 	DEFW	BCTRL		;101 - CHANNEL B CONTROL
 	DEFW	SVBAD		;102 - UNDEFINED
 	DEFW	SVBAD		;103 - UNDEFINED
 	DEFW	SVBAD		;104 - UNDEFINED
 	DEFW	SVBAD		;105 - UNDEFINED
 	DEFW	SVBAD		;106 - UNDEFINED
 	DEFW	SVBAD		;107 - UNDEFINED
 	DEFW	SVBAD		;108 - UNDEFINED
 	DEFW	SVBAD		;109 - UNDEFINED
 	DEFW	SVBAD		;110 - UNDEFINED
 	DEFW	SVBAD		;111 - UNDEFINED
 	DEFW	SVBAD		;112 - UNDEFINED
 	DEFW	SVBAD		;113 - UNDEFINED
 	DEFW	SVBAD		;114 - UNDEFINED
 	DEFW	SVBAD		;115 - UNDEFINED
 	DEFW	SVBAD		;116 - UNDEFINED
 	DEFW	SVBAD		;117 - UNDEFINED
 	DEFW	SVBAD		;118 - UNDEFINED
 	DEFW	SVBAD		;119 - UNDEFINED
 	DEFW	SVBAD		;120 - UNDEFINED
 	DEFW	SVBAD		;121 - UNDEFINED
 	DEFW	SVBAD		;122 - UNDEFINED
 	DEFW	SVBAD		;123 - UNDEFINED
 	DEFW	SVBAD		;124 - UNDEFINED
 	DEFW	SVBAD		;125 - UNDEFINED
 	DEFW	SVBAD		;126 - UNDEFINED
 	DEFW	SVBAD		;127 - UNDEFINED
 ;
 	PAGE
 ;	VECTORS TO MISC ROUTINES
 ;
 	ORG	PAGE3
 ;
 BRKVEC	JP	JP2DOS		;SYSTEM BREAK VECTOR
 REGSAV$ JP	REGSAV		;SAVE REGISTERS
 SAVERN$ JP	SAVERN		;SET-UP FOR FCB ACTIVITY
 SAVER$	JP	SAVER		;SET-UP FOR FCB ACTIVITY
 SMULT$	JP	SMULT		;8 X 8 MULTIPLY
 SDIVD$	JP	SDIVD		;8 X 8 DIVIDE
 DMULT$	JP	DMULT		;8 X 16 MULTIPLY
 DDIVD$	JP	DDIVD		;8 X 16 DIVIDE
 TMULT$	JP	TMULT		;8 X 24 MULTIPLY
 TTIVD$	JP	TDIVD		;8 X 24 DIVIDE
 UCASE$	JP	UCASE		;CASE CONVERSION
 DBLOCK$ JP	DBLOCK		;WRITE RESIDUAL DATA
 DIRRED$ JP	DIRRED		;READ DIR FOR FILE
 DIRWRT$ JP	DIRWRT		;WRITE DIR FOR FILE
 LOCDCB$ JP	LOCDCB		;LOCATE DEVICE DCB
 LOCDCT$ JP	LOCDCT		;LOCATE DRIVE DCT
 FETMEM$	JP	FETMEM		;add high memory driver
 RECMEM$	JP	RECMEM		;restore high memory
 ;
 	PAGE
 ;	DEVICE DCB'S START HERE
 ;
 ;	definition of common DCB data
 ;
 ;+00	7 - File DCB -	1=YES, 0=NO
 ;	6 - DCT/DCB  -	1=DCT, 0=DCB
 ;	5 - Linked   -	1=YES, 0=NO
 ;	4 - Routed   -	1=YES, 0=NO
 ;	3 - Nil      -	1=YES, 0=NO
 ;	2 - @CTL support - 1=YES, 0=NO
 ;	1 - @GET support - 1=YES, 0=NO
 ;	0 - @PUT support - 1=YES, 0=NO
 ;
 ;+01,02 - DCB address
 ;+03,04 - linked/routed DCB address
 ;
 ;+05	7 - available
 ;	6 - available
 ;	5 - available
 ;	4 - available
 ;	3 - available
 ;	2 - available
 ;	1 - available
 ;	0 - Translation - 1=ON, 0=OFF
 ;
 ;+06,07 - Translation Table Address
 ;+08	- Translation Table Length
 ;
 ;+09,10 - Buffer Start Address
 ;+11,12 - Buffer Size
 ;+13,14 - Buffer Counter
 ;+15,16 - Add to Buffer Offset
 ;+17,18 - Take from Buffer Offset
 ;
 	PAGE
 ; definition of keyboard DCB (extensions)
 ;
 ;+05 -	7 - @CTL call current	- 1=YES, 0=NO
 ;	6 - BREAK off switch	- 1=YES, 0=NO
 ;	5 - BREAK processor	- 1=YES, 0=NO
 ;	4 - HOLD processor	- 1=YES, 0=NO
 ;	3 - BREAK in buffer	- 1=YES, 0=NO
 ;	2 - HOLD in buffer	- 1=YES, 0=NO
 ;	1 - Active CHAIN	- 1=YES, 0=NO
 ;	0 - Translation 	- 1=ON, 0=OFF
 ;
 KDCB	DEFB	5		;input/ctrl
 	DEFW	KBDCODE 	;driver address
 	DEFW	0		;linker/router
 	DEFB	0		;operation flag
 	DEFW	0		;translate table
 	DEFB	0		;table length
 	DEFW	KBDBUFF 	;+9,10 type buffer
 	DEFW	40		;+11,12 buff size
 	DEFW	0		;+13,14 char counter
 	DEFW	0		;+15,16 add offset
 	DEFW	0		;+17,18 take offset
 	DEFW	0		;+19,20 DO FCB
 	DEFW	0		;+21,22 BREAK processor
 ;
 	PAGE
 ; definition of display DCB (extensions)
 ;
 ;+09	- reserved
 ;+10	- char mode mask
 ;+11	- line length
 ;+12	- cursor location
 ;+14	- start scroll
 ;+16	- end scroll+1
 ;+18	- scroll count
 ;
 DDCB	DEFB	6		;output/ctl
 	DEFW	DSPCODE 	;driver address
 	DEFW	0		;linker,router DCB
 	DEFB	0		;misc flags
 	DEFB	0		;xlate table len
 	DEFW	0		;xlate table add
 	DEFB	21H		;video sel mask
 	DEFB	0		;char mode rev/nrm
 	DEFB	80		;line length
 	DEFW	VIDEO		;cursor location
 	DEFW	VIDEO		;start scroll area
 	DEFW	VIDEO+1920	;end scroll area
 	DEFW	1840		;scroll count
 ;
 	PAGE
 ; definition of printer DCB (additions)
 ;
 ;+05	7 - p/s 	- 1=serial, 0=parallel
 ;	6 - LF on CR	- 1=ON, 0=OFF
 ;	5 - graphic	- 1=YES,0=NO
 ;	4 - locase	- 1=YES,0=NO
 ;	3 - transparent - 1=ON, 0=OFF
 ;	2 - form feeds	- 1=REAL, 0=TRANSLATED
 ;	1 - tabs	- 1=REAL, 0=TRANSLATED
 ;	0 - tranlation	- 1=ON, 0=OFF
 ;
 ;+19	- printed lines/page
 ;+20	- page length
 ;+21	- line counter
 ;+22	- max chars/line
 ;+23	- char counter
 ;
 PDCB	DEFB	6		;output/ctl
 	DEFW	PRTCODE 	;driver address
 	DEFW	0		;linker/router DCB
 	DEFB	0		;+5, operation flag
 	DEFW	0		;+6,7 xlate table addr
 	DEFB	0		;+8 table length
 	DEFW	PRTBUFF 	;+9,10 buffer pointer
 	DEFW	40		;+11,12 buffer length
 	DEFW	0		;+13,14 counter
 	DEFW	0		;+15,16 adder offset
 	DEFW	0		;+17,18 taker offset
 	DEFB	60		;+19 printed lines/page
 	DEFB	66		;+20 page length
 	DEFB	0		;+21 line counter
 	DEFB	132		;+22 max chars/line
 	DEFB	0		;+23 char counter
 ;
 	PAGE
 ; definition of SIO DCB'S (extensions of standard)
 ;
 ;+05	7 - @CTL call current - 1=YES, 0=NO
 ;	6 - unused
 ;	5 - unused
 ;	4 - unused
 ;	3 - unused
 ;	2 - unused
 ;	1 - channel initialized - 1=NO, 0=YES
 ;	0 - translation - 1=ON, 0=OFF
 ;
 ;+19	- Base Port SIO (command/status)
 ;+20	- CTC port #1
 ;+21	- CTC port #2
 ;+22	- Word Length Mask
 ;+23	- Error Mask
 ;+24	- CTC R5 Mask (for PRCTRL call)
 ;
 CADCB	DEFB	7		;input/output/ctl
 	DEFW	SIOCODE 	;driver address
 	DEFW	0		;linking/routing DCB
 	DEFB	2		;+5, channel inactive
 	DEFW	0		;+6,7 translation
 	DEFB	0		;+8 translate length
 	DEFW	SIOABUF 	;+9,10 input buffer
 	DEFW	20		;+11,12 buffer size
 	DEFW	0		;+13,14 buffer counter
 	DEFW	0		;+15,16 add offset
 	DEFW	0		;+17,18 take offset
 	DEFB	0F6H		;+19 base port
 	DEFB	0F0H		;+20 CTC #1
 	DEFB	0F1H		;+21 CTC #2
 	DEFB	0FFH		;+22 word length mask
 	DEFB	0		;+23 error mask
 	DEFB	0		;+24 CTC R5 mask
 	DEFB	0		;+25 data
 ;
 CBDCB	DEFB	7		;input/output/ctl
 	DEFW	SIOCODE 	;driver address
 	DEFW	0		;linker/router
 	DEFB	2		;inactive
 	DEFW	0		;translate address
 	DEFB	0		;translate length
 	DEFW	SIOBBUF 	;buffer address
 	DEFW	20		;buffer length
 	DEFW	0		;buffer counter
 	DEFW	0		;add offset
 	DEFW	0		;take offset
 	DEFB	0F7H		;base port
 	DEFB	0F2H		;CTC #1
 	DEFB	0		;CTC #2 (dummy)
 	DEFB	0FFH		;word length mask
 	DEFB	0		;error mask
 	DEFB	0		;CTC R5 mask
 	DEFB	0		;data storage
 	PAGE
 ;	definition of USER DCB
 ;
 USER1	DEFB	8		;type flag (NIL)
 	DEFW	0		;driver address
 	DEFW	0		;linker/router
 	DEFW	0		;xlate table
 	DEFB	0		;xlat length
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 ;
 ;	definition of USER DCB
 ;
 USER2	DEFB	8		;type flag (NIL)
 	DEFW	0		;driver address
 	DEFW	0		;linker/router
 	DEFW	0		;xlate table
 	DEFB	0		;xlat length
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 ;
 ;	definition of USER DCB
 ;
 USER3	DEFB	8		;type flag (NIL)
 	DEFW	0		;driver address
 	DEFW	0		;linker/router
 	DEFW	0		;xlate table
 	DEFB	0		;xlat length
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 	DEFB	0		;reserved
 ;
 	PAGE
 ;	DRIVE DCT'S START HERE
 ;
 DCT0	DEFB	40H		;DCT DEVICE
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	00H		;FLAGS
 	DEFB	02H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	0		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 DCT1	DEFB	40H		;DCT DEVICE
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	01H		;FLAGS,NO LOG
 	DEFB	02H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	1		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 DCT2	DEFB	40H		;DCT DEVICE
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	01H		;FLAGS,NO LOG
 	DEFB	02H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	2		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 DCT3	DEFB	40H		;DCT DEVICE
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	01H		;FLAGS, NO LOG
 	DEFB	02H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	3		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 	PAGE
 DCT4	DEFB	48H		;DCT,NIL
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	21H		;FLAGS,HD,NO LOG
 	DEFB	07H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	0		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 DCT5	DEFB	48H		;DCT,NIL
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	21H		;FLAGS,HD,NO LOG
 	DEFB	07H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	1		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 DCT6	DEFB	48H		;DCT,NIL
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	21H		;FLAGS,HD,NO LOG
 	DEFB	07H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	2		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 DCT7	DEFB	48H		;DCT,NIL
 	DEFW	FHCODE		;DRIVER ADDRESS
 	DEFW	0		;LINKING DCT
 	DEFB	21H		;FLAGS,HD,NO LOG
 	DEFB	07H		;STEP RATE
 	DEFB	0		;HEAD OFFSET
 	DEFW	0		;CYL OFFSET
 	DEFB	0		;SECTOR OFFSET
 	DEFB	0		;HEAD LOCATION
 	DEFB	3		;BINARY DRIVE
 	DEFB	0		;RESERVED
 	DEFB	0,0,0,0,0,0,0,0,0,0,0
 ;
 	PAGE
 ;	EXECUTE SUPERVISOR CALL
 ;
 EXSVC	ADD	A,A		;DOUBLE FOR TABLE
 	JR	NC,SVCOK	;OK (0-127)
 SVBAD	LD	A,1		;BAD SVC
 	OR	A		;NZ STATUS
 	RET
 ;
 SVCOK	PUSH	HL		;SAVE
 	LD	L,A
 	LD	H,PAGE2<-8	;HL => ENTRY
 	LD	A,(HL)
 	INC	HL
 	LD	H,(HL)
 	LD	L,A		;HL => ROUTINE
 	EX	(SP),HL 	;RESTORE
 	RET			;GO!
 ;
 ;	GENERAL PURPOSE REGISTER SAVE
 ;
 REGSAV	EX	AF,AF'          ;SAVE AF
 	POP	AF		;GET CALLER
 	PUSH	IY		;SAVE REGISTERS
 	PUSH	IX
 	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 ;
 	PUSH	HL		;TO STACK
 	LD	HL,REGSV1	;UNSTACKER
 	EX	(SP),HL 	;TO RET ADD
 	PUSH	AF		;CALLER TO STACK
 	EX	AF,AF'          ;RESTORE AF
 	RET
 ;
 REGSV1	POP	BC		;RESTORE REG
 	POP	DE
 	POP	HL
 	POP	IX
 	POP	IY
 	RET
 ;
 *GET	RTC			;RTC SERVICES
 *GET	DOS3A			;KEYBOARD DRIVER
 *GET	DOS3B			;PRINTER DRIVER
 *GET	DOS3D			;RS232 DRIVERS
 *GET	DISP2			;DISPLAY DRIVERS
 *GET	DISKIO2 		;DISK I/O MANAGER
 *GET	DOS5			;SYSTEM ROUTINES
 *GET	DOSMISC 		;MISC ROUTINES
 *GET	OVERLAY 		;OVERLAY LOADER
 *GET	FILE2			;FILE I/O MANAGEMENT
 *GET	GETPDA			;GRANULE MANAGEMENT
 *GET	DOSBUFFK		;SPOOL BUFFER(S)
 *GET	INIT			;COLD INIT ROUTINES
 ;
 	END	START
