DOSSYS ; dossys4/asm
 ;
 	TITLE	'<DOS+II - ALLOCATE/LINK routines - 1.0>'
 ;
 ;	THIS SYSTEM IS LOW RESIDING (1C00-21FFH).
 ;	IT CONTAINS THE FOLLOWING ROUTINES:
 ;
 ;		$NEWCSD - FETCH A NEW CSD
 ;		$DIRCSD - SEARCH DIR FOR CSD
 ;		$ALLOC	- ALLOCATE ADDITIONAL SPACE
 ;		$LINK	- CREATE LINKING DIR ENTRY
 ;
 ;	Created:	06/82	1.0	sjp/mss
 ;	Updated:	06/82	1.0	sjp/mss
 ;
 	PAGE
 ;	EXTERNAL REFRENCES/ROUTINES
 ;
 SREAD	EQU	6		;READ SYSTEM SECTOR
 SWRITE	EQU	7		;WRITE SYSTEM SECTOR
 ;
 SVC	EQU	08H		;EXECUTE SVC
 DISKIO	EQU	10H		;DISK I/O MANAGER
 SMULT	EQU	030CH		;SINGLE PREC MULT
 SDIVD	EQU	030FH		;SINGLE PREC DIVIDE
 DIRRED	EQU	0324H		;READ DIRECTORY SVC
 DIRWRT	EQU	0327H		;WRITE DIRECTORY DVC
 BUFFER	EQU	1B00H		;MAIN I/O BUFFER
 ;
 ;	LOCAL VARIABLE EQUIVALENCES
 ;
 BADF	EQU	1		;BAD FUNCTION CALL
 GCYL	EQU	0CCH		;GAT CYL OFFSET
 BUFER1	EQU	2000H		;2ND I/O BUFFER
 ;
 	PAGE
 ;	TABLE OF VECTORED ROUTINES
 ;
 	ORG	1C00H		;LOW OVERLAY
 ;
 START	DEFW	RETURN		;0  - NOTHING DONE
 	DEFW	NEWCSD		;1  - FETCH ENW CSD
 	DEFW	UNDEF		;2  - UNDEFINED
 	DEFW	UNDEF		;3  - UNDEFINED
 	DEFW	UNDEF		;4  - UNDEFINED
 	DEFW	UNDEF		;5  - UNDEFINED
 	DEFW	UNDEF		;6  - UNDEFINED
 	DEFW	UNDEF		;7  - UNDEFINED
 	DEFW	UNDEF		;8  - UNDEFINED
 	DEFW	UNDEF		;9  - UNDEFINED
 	DEFW	UNDEF		;10 - UNDEFINED
 	DEFW	UNDEF		;11 - UNDEFINED
 	DEFW	UNDEF		;12 - UNDEFINED
 	DEFW	UNDEF		;13 - UNDEFINED
 	DEFW	UNDEF		;14 - UNDEFINED
 	DEFW	UNDEF		;15 - UNDEFINED
 ;
 ;	UNDEFINED SYSTEM CALL'S
 ;
 UNDEF	LD	A,BADF		;'BAD FUNCTION CALL'
 	OR	A		;NZ STATUS
 RETURN	RET
 ;
 	PAGE
 ;	GET A NEW SEGMENT DESCRIPTOR & PLACE IN DCB
 ;
 ;	EXT	 A =	GRAN OFFSET
 ;			C STATUS EXIT TO TOPCSD
 ;			NC STATUS EXIT TO CSDPDA
 ;			Z STATUS IF NO ERRORS
 ;
 NEWCSD	CALL	DIRCSD		;GET CSD
 	RET	NZ		;I/O ERROR
 	PUSH	HL		;SAVE CSD
 	LD	H,B
 	LD	L,C		;HL = DESIRED GRAN
 	OR	A		;CLR CRY
 	SBC	HL,DE		;HL = GRAN OFFSET
 	LD	A,L
 	LD	(GRAN),A
 	POP	HL		;GET SD
 	PUSH	DE
 	PUSH	IX
 	EX	(SP),HL 	;HL => DCB
 	LD	DE,20
 	ADD	HL,DE		;HL => BSD
 	POP	DE
 	LD	B,5		;SD LIST CNT
 ;
 ADJ35	LD	A,(HL)		;LSB SD
 	INC	HL
 	CP	E		;MATCH?
 	JR	NZ,ADJ4 	;IF NOT
 	LD	A,(HL)
 	XOR	D		;MATCH?
 	AND	0E0H		;IGNORE AREA LEN
 	JR	Z,ADJ6		;IF YES
 ;
 ADJ4	DEC	B
 	JR	Z,ADJ5
 	INC	HL
 	INC	HL		;SKIP OFFSET
 	INC	HL		;HL => NEXT SD
 	JR	ADJ35		;TRY ANOTHER
 ;
 ADJ5	PUSH	DE		;SD NOT FOUND, SAVE
 	EX	DE,HL		;DE => END SD LIST
 	LD	HL,-4
 	ADD	HL,DE
 	LD	BC,12
 	LDDR			;BUMP SD LIST
 	EX	DE,HL
 	POP	BC
 	POP	DE
 ;
 	XOR	A		;NO ERR
 	SCF			;TO TOPCSD
 	JR	ADJ7		;SKIP
 ;
 ADJ6	LD	(HL),D
 	EX	DE,HL
 	POP	AF		;IGNORE
 	XOR	A		;CLR CRY/NO ERR
 ;
 GRAN	EQU	$+1
 ADJ7	LD	A,0		;A = GRAN
 	RET
 ;
 	PAGE
 ;	SEARCH DIR FOR CURRENT SEGMENT DESCRIPTOR
 ;
 ;	ENT	BC =	DESIRED GRAN NUMBER
 ;		IX =>	OPEN DCB
 ;		IY =>	DRIVE CONTROL TABLE
 ;
 DIRCSD	PUSH	BC		;SAVE DESIRED GRAN
 	LD	DE,0		;INIT SEG OFFSET
 	LD	B,(IX+17)	;B = LFN
 ;
 DCBDI0	LD	A,B		;GET LFN
 	LD	(DRICWR),A	;SAVE IT
 	LD	C,(IX+16)	;DRIVE, MODE
 	CALL	DIRRED		;READ DIRECTORY
 	JR	Z,DCBD5 	;NO ERR
 	POP	BC		;IGNORE STACK
 	RET
 ;
 DCBD5	LD	BC,22
 	ADD	HL,BC		;HL => BSD
 	EX	DE,HL		;DE => BSD
 	POP	BC		;GET DESIRED GRAN
 ;
 DCBD0	LD	A,(DE)		;LSB SD
 	CP	0FEH		;END OF SD LIST?
 	JR	NC,DCBD3	;IF YES
 	INC	DE
 	LD	A,(DE)		;MSB SD
 	PUSH	HL		;SAVE SEGMENT OFFSET
 	AND	1FH		;LEN OF AREA
 	INC	A		;CORRECT
 	ADD	A,L
 	LD	L,A
 	JR	NC,DCBD1
 	INC	H		;HL = UPDATED OFFSET
 ;
 DCBD1	PUSH	HL		;SAVE UPDATED OFFSET
 	DEC	HL
 	OR	A		;CLR CRY
 	SBC	HL,BC		;WITHIN AREA?
 	POP	HL		;GET UPDATED OFFSET
 	JR	NC,DCBD2	;IF AREA FOUND
 	INC	DE		;DE => NEXT SD
 	POP	AF		;IGNORE OLD SEG OFFSET
 	JR	DCBD0		;TRY AGAIN
 ;
 DCBD2	POP	HL		;GET OLD SEG OFFSET
 	EX	DE,HL		;DE = OLD SEG OFFSET
 	LD	A,(HL)
 	DEC	HL
 	LD	L,(HL)
 	LD	H,A		;HL = SD
 	XOR	A		;NO ERR
 	RET
 ;
 DCBD3	PUSH	BC		;SAVE DESIRED GRAN
 	EX	DE,HL		;HL => SD
 	JR	NZ,DCBD4	;IF END OF SD LIST
 	INC	HL		;HL => FXDE
 	LD	B,(HL)		;B = FXDE
 	JR	DCBDI0		;KEEP LOOKING
 ;
 DCBD4	CALL	ALLOC		;ALLOCATE GRAN
 	POP	BC		;GET DESIRED GRAN
 	RET	NZ		;I/O ERROR
 	JR	DIRCSD		;LOOK AGAIN
 ;
 	PAGE
 ;	ALLOCATE ADDITIONAL SPACE TO FILE
 ;
 ;	ENT	BC =	DESIRED GRAN
 ;		DE =	SEGMENT OFFSET
 ;		HL =	TERMINATING SD
 ;		IX =>	OPEN DCB
 ;		IY =>	DRIVE CONTROL TABLE
 ;
 ALLOC	PUSH	BC		;SAVE DESIRED GRAN
 	LD	C,(IX+16)	;DRIVE
 	CALL	RDGAT		;READ GAT
 	POP	BC		;GET DESIRED GRAN
 	RET	NZ		;I/O ERROR
 	PUSH	HL		;SAVE TERM SD
 	LD	H,B
 	LD	L,C		;HL = DESIRED GRAN
 	OR	A		;CLR CRY
 	SBC	HL,DE
 	LD	B,H
 	LD	C,L
 	INC	BC
 	LD	A,(BUFER1+GCYL) ;DYNAMIC CYL COUNT
 	ADD	A,35		;CORRECT
 	LD	E,A
 	LD	A,(IY+18)	;SEC/DIR
 	DEC	A
 	DEC	A		;IGNORE GAT/HIT
 	CALL	SDIVD		;SNG PREC DIVD
 	LD	E,A		;DISK AREAS
 	LD	A,(IX+17)	;LFN/DEC
 	AND	1FH		;LOW NIB
 	CALL	SMULT		;SNG PREC MULT
 	LD	L,A
 	LD	H,BUFER1<-8	;HL => RND AREA
 	POP	DE
 	INC	DE
 ;
 ;	ATTEMPT TO EXTEND LAST SD
 ;
 	PUSH	BC
 	LD	A,E
 	AND	1EH
 	CP	16H
 	JR	Z,GETSEG
 	DEC	E
 	DEC	E
 ;
 DIRAD0	LD	A,(DE)
 	AND	1FH
 	INC	A
 	LD	C,A
 	CP	20H
 	JR	Z,DIRAD1
 ;
 ;	CALCULATE NEXT GRAN ADDRESS
 ;
 	LD	A,(DE)
 	AND	0E0H
 	RLCA
 	RLCA
 	RLCA
 	ADD	A,C
 	PUSH	DE		;SAVE
 	LD	E,A		;GRAN
 	LD	A,(IY+21)	;GRAN/CYL
 	CALL	SDIVD		;SNG PREC DIVID
 	LD	B,A		;CYLINDER
 	LD	C,E		;SECTOR
 	POP	DE		;RESTORE
 ;
 ;	CALCULATE DESIRED GRAN'S GAT BUFFER ADDRESS
 ;
 	DEC	DE		;DE => SD
 	LD	A,(DE)		;GET CYLINDER
 	INC	DE
 	ADD	A,B		;OFFSET
 	LD	L,A
 	LD	H,BUFER1<-8	;HL => GAT ADDRESS
 	LD	A,(BUFER1+GCYL) ;DYNAMIC CYL COUNT
 	ADD	A,35-1		;LAST CYL
 	CP	L		;END TABLE?
 	JR	C,DIRAD1	;IF YES
 ;
 ;	SEE IF NEXT GRAN IS AVAILABLE
 ;
 	LD	A,C		;GET GRAN
 	LD	B,(HL)		;CYL INFO
 	CALL	BYTBIT		;AVAIL?
 	JR	Z,CHKT4 	;IF YES
 ;
 ;	START A NEW SEGMENT
 ;
 DIRAD1	INC	E
 	INC	E
 	LD	A,E
 	AND	1EH
 	CP	1EH
 	JR	NZ,GETSEG
 	CALL	GATDRV		;WRITE TABLES
 	POP	BC
 	RET	NZ
 	PUSH	BC
 	CALL	LINK
 	POP	BC
 	RET	NZ
 	JP	DIRCSD
 ;
 ;	FIND NEXT AVAILABLE GRAN & START NEW SEGMENT
 ;
 GETSEG	LD	B,2		;TABLE PASSES
 CHKT0	LD	A,(BUFER1+GCYL) ;DYNAMIC CYL COUNT
 	ADD	A,35-1		;LAST CYL
 	CP	L		;END TABLE?
 	JR	C,CHKT1 	;IF YES
 	LD	A,(HL)		;GET CYL STATUS
 	INC	A		;FULL?
 	JR	NZ,CHKT2	;IF NOT
 	INC	L		;NEXT GRAN
 	JR	CHKT0		;TIL END TABLE
 ;
 CHKT1	LD	L,0		;HL => START TABLE
 	DJNZ	CHKT0		;TIL DONE
 	POP	BC		;RESTORE
 	CALL	GATDRV		;WRITE TABLES
 	RET	NZ		;I/O ERROR
 	LD	A,27		;DISK FULL
 	OR	A
 	RET
 ;
 ;	NEXT NON-FULL CYLINDER FOUND
 ;
 CHKT2	LD	A,0FFH
 	LD	(DE),A
 	LD	C,0
 	LD	B,(HL)
 ;
 CHKT3	LD	A,C
 	CALL	BYTBIT
 	JR	Z,CHKT4
 	LD	A,(DE)
 	ADD	A,20H
 	LD	(DE),A
 	INC	C
 	JR	CHKT3
 ;
 ;	RESERVE THE GRAN
 ;
 CHKT4	LD	A,C
 	CALL	SETBIT
 	OR	(HL)
 	LD	(HL),A
 ;
 ;	UPDATE THE SEGMENT DESCRIPTOR
 ;
 	DEC	E
 	LD	A,(DE)
 	INC	A
 	JR	NZ,CHKT5
 	LD	A,L
 	LD	(DE),A
 ;
 CHKT5	INC	E
 	LD	A,(DE)
 	INC	A
 	LD	(DE),A
 ;
 ;	SEE IF TOTAL NUM OF GRANS REQUIRED
 ;	HAVE BEEN ALLOCATED
 ;
 	POP	BC
 	DEC	BC
 	PUSH	BC
 	LD	A,B
 	OR	C
 	JP	NZ,DIRAD0
 	POP	BC
 ;
 ;	WRITE OUT THE NEWLY MODIFIED SYSTEM TABLES
 ;
 DRICWR	EQU	$+1
 GATDRV	LD	A,0		;GET LFN
 	LD	B,A		;B = LFN
 	AND	0E0H		;MASK
 	LD	L,A
 	LD	H,BUFFER<-8	;HL => FILE
 	BIT	4,(HL)		;FILE ACTIVE?
 	JR	NZ,GATDR1	;IF YES
 	LD	A,24		;FILE NOT IN DIR
 	OR	A
 	RET
 ;
 GATDR1	LD	C,(IX+16)	;GET DRIVE
 	CALL	WRGAT		;WRITE GAT
 	RET	NZ		;I/O ERROR
 	CALL	DIRWRT		;WRITE DIRECTORY
 	RET
 ;
 	PAGE
 ;	CHECK BIT ROUTINE
 ;
 ;	ENT	A =	BIT NUMBER
 ;		B =	BYTE TO BE TESTED
 ;
 BYTBIT	AND	7		;FORCE VALID
 	RLCA
 	RLCA
 	RLCA
 	OR	40H		;INST
 	LD	(BIT1),A	;PLACE INST
 BIT1	EQU	$+1
 	BIT	0,B		;TEST BIT!
 	RET
 ;
 ;	SET BIT ROUTINE
 ;
 ;	ENT	A =	BIT NUMBER
 ;
 SETBIT	AND	7		;FORCE VALID
 	RLCA
 	RLCA
 	RLCA
 	OR	0C7H		;INST
 	LD	(BIT2),A	;PLACE INST
 	XOR	A		;CLEAR
 BIT2	EQU	$+1
 	SET	0,A		;SET BIT!
 	RET
 ;
 	PAGE
 ;	SET UP A LINKED DIRECTORY ENTRY
 ;	FOR AN EXISTING FILE
 ;
 ;	ENT	IX =>	OPEN DCB
 ;		IY =>	DRIVE CONTROL TABLE
 ;
 ;	EXT	DE =	NEW DIR + 23
 ;			Z SET IF LINK GOOD
 ;
 ;	SEARCH THE HIT FOR AVAILABLE SLOT
 ;
 LINK	LD	C,(IX+16)	;C = DRIVE
 	CALL	RDHIT		;READ HIT
 	RET	NZ
 	LD	A,(IX+17)	;A = LFN/DEC
 	CALL	GETEN2		;SEARCH FOR NEXT AVIL ENT
 	LD	A,30		;DIRECTORY FULL
 	RET	NZ
 	LD	B,L		;GET THE FWD LFN
 	LD	A,L
 	LD	(DIRFWD),A	;SAVE THE FORWARD LINK
 ;
 ;	UPDATE THE HASH TABLE
 ;
 	LD	D,H
 	LD	E,(IX+17)	;DE = REV LFN
 	LD	A,(DE)		;GET MASTER HIT CODE
 	LD	(HL),A		;SET UP FWD LINK HIT CODE
 	CALL	WRHIT		;WRITE HIT
 	RET	NZ
 ;
 ;	CREATE A NEW DIRECTORY REC
 ;
 	CALL	DIRRED		;READ LINK DIR RECORD
 	RET	NZ
 ;
 	LD	(HL),90H	;SET LINKED AND ALLOC BIT
 	INC	L
 ;
 	PUSH	BC
 ;
 	LD	A,(DRICWR)
 	LD	(HL),A		;STORE THE REV LINK
 	INC	L
 ;
 	LD	B,20
 LINK3	LD	(HL),0		;CLEAR NAME,EXT,TDCS,ERN
 	INC	L
 	DJNZ	LINK3
 ;
 	PUSH	HL		;SAVE THE TERM SD POINTER
 	LD	B,10
 LINK4	LD	(HL),0FFH	;CLEAR 5 SEGMENT DESCRIPTORS
 	INC	L
 	DJNZ	LINK4
 ;
 	POP	DE		;DE = NEW DIR + 22
 	INC	DE		;DE = NEW DIR + 23
 ;
 	POP	BC
 	CALL	DIRWRT		;WRITE OUT NEW DIRECTORY
 	RET	NZ
 ;
 ;	PLACE FORWARD LINK IN THE LINKING DIRECTORY ENTRY
 ;
 	LD	A,(DRICWR)
 	LD	B,A		;GET THE REV LFN
 	CALL	DIRRED		;READ LINKING DIR ENTRY
 	RET	NZ
 ;
 	LD	A,L
 	ADD	A,30
 	LD	L,A		;HL = DIR +30
 	LD	(HL),0FEH
 	INC	L
 DIRFWD	EQU	$+1
 	LD	(HL),0
 	CALL	DIRWRT		;WRITE LINKING DIR ENTRY
 	RET
 ;
 	PAGE
 ;	GET AN AVAILABLE HIT (AND DIR) ENTRY
 ;
 ;	ENT	 C =	DRIVE INFO
 ;		HL =>	HIT
 ;
 ;	EXT	HL =>	AVAILABLE ENTRY
 ;			Z STATUS IF ENTRY FOUND
 ;
 ;	USE LFN 'A' IF POSSIBLE
 ;
 GETEN2	LD	L,A		;HL => PRIMARY HIT
 	CALL	GETEN3		;ATTEMPT TO LOCATE ENTRY
 	RET	Z		;IF FOUND
 ;
 ;	RE-SEARCH THE ENTIRE TABLE
 ;
 	LD	L,0		;HL => START HIT
 GETEN3	LD	A,(HL)		;GET NEXT HIT CODE
 	OR	A		;NULL?
 	RET	Z		;RET IF AVAILABLE
 	LD	A,20H		;OFFSET TO NEXT
 	ADD	A,L		;BUMP IT
 	LD	L,A		;HL => NEXT LFN
 	JR	NC,GETEN3	;JP IF IN SAME DIR REC
 	LD	A,(IY+18)	;SEC/DIR
 	SUB	3		;IGNORE GAT/HIT+1
 	INC	L		;SKIP TO NEXT DIR REC
 	CP	L		;VALID DIR REC?
 	JR	NC,GETEN3	;IF YES
 	OR	-1		;END OF HIT
 	RET
 ;
 	PAGE
 ;	READ DIRECTORY GAT
 ;
 ;	ENT	 C =	DRIVE INFO
 ;
 ;	EXT	 A =	ERROR CODE
 ;
 RDGAT	PUSH	BC		;SAVE REG
 	PUSH	DE		;SAVE REG
 	PUSH	HL
 	LD	B,0		;MSB SECTOR
 	LD	E,0		;GAT SECTOR
 	LD	HL,BUFER1	;I/O BUFFER
 	LD	A,SREAD 	;READ GAT
 	RST	DISKIO		;DO IT!
 	POP	HL		;RESTORE REG
 	POP	DE
 	POP	BC
 	RET	Z		;NO ERR
 	LD	A,20		;GAT READ ERROR
 	RET
 ;
 ;	WRITE DIRECTORY GAT
 ;
 ;	ENT	 C =	DRIVE INFO
 ;
 ;	EXT	 A =	ERROR CODE
 ;
 WRGAT	PUSH	BC		;SAVE REG
 	PUSH	DE		;SAVE REG
 	PUSH	HL
 	LD	B,0		;MSB SECTOR
 	LD	E,0		;GAT SECTOR
 	LD	HL,BUFER1	;I/O BUFFER
 	LD	A,SWRITE	;SYSTEM WRITE
 	RST	DISKIO		;DO IT!
 	POP	HL		;RESTORE REG
 	POP	DE
 	POP	BC
 	RET	Z		;NO ERROR
 	LD	A,21		;GAT WRITE ERROR
 	RET
 ;
 	PAGE
 ;	READ DIRECTORY HIT
 ;
 ;	ENT	 C =	DRIVE INFO
 ;
 ;	EXT	 A =>	ERROR CODE
 ;		HL =>	HIT BUFFER
 ;
 RDHIT	PUSH	BC		;SAVE REG
 	PUSH	DE
 	LD	B,0		;MSB SECTOR
 	LD	E,1		;HIT SECTOR
 	LD	HL,BUFER1	;I/O BUFFER
 	LD	A,SREAD 	;READ THE HIT
 	RST	DISKIO		;DO IT!
 	POP	DE		;RESTORE
 	POP	BC
 	RET	Z		;NO ERR
 	LD	A,22		;HIT READ ERROR
 	RET
 ;
 ;	WRITE DIRECTORY HIT
 ;
 ;	ENT	 C =	DRIVE INFO
 ;
 ;	EXT	 A =	ERROR CODE
 ;		HL =>	HIT BUFFER
 ;
 WRHIT	PUSH	BC		;SAVE REG
 	PUSH	DE
 	LD	B,0		;MSB SECTOR
 	LD	E,1		;HIT SECTOR
 	LD	HL,BUFER1	;I/O BUFFER
 	LD	A,SWRITE	;SYSTEM WRITE
 	RST	DISKIO		;DO IT!
 	POP	DE		;RESTORE
 	POP	BC
 	RET	Z		;NO ERROR
 	LD	A,23		;HIT WRITE ERROR
 	RET
 ;
 	END	START
