DOSSYS ; dossys6/asm
 	TITLE	'<DOSPLUS - Model II Debugging package>'
 ;
 ;	Revised: 10-AUG-81	SJP/MSS
 ;
 REV	EQU	26		;REVERSE VIDEO
 NOR	EQU	25		;NORMAL VIDEO
 HOME	EQU	20		;HOME CURSOR
 ETB	EQU	23		;ERACE TO EOL
 ;
 BADF	EQU	1		;BAD FUNCTION CALL
 DDCB?	EQU	1		;DISPLAY DCB
 KBCHAR	EQU	4		;KEYBOARD CHAR
 VDCHAR	EQU	8		;VIDEO CHARACTER
 ;
 EXIT	EQU	00H		;NORMAL PROGRAM EXIT
 SVC	EQU	08H		;EXECUTE SVC
 BREAK	EQU	0FFH		;OPCODE FOR BRKPNT
 ;
 MDSL	EQU	0FFH		;VIDEO/MODE SEL
 VIDMEM	EQU	0F800H		;VIDEO MEMORY
 ;
 DEBFLG	EQU	0199H		;DEBUG INT FLAG
 LSP	EQU	01A2H		;DSP DVR STACK
 TSP	EQU	01A4H		;TEMP STACK
 LOCDCB	EQU	032AH		;LOCATE DCB
 ;
 TSTACK	EQU	2200H		;TEMP STACK
 BRKTBL	EQU	1A1CH		;BRKPNT STORAGE - 6 BYTES
 PAGE	EQU	BRKTBL+6	;CURRENT MEMORY PAGE
 DATA	EQU	BRKTBL+8	;REGISTER STOR - 20 BYTES
 REGHL	EQU	DATA+6
 REGIX	EQU	DATA+16
 REGIY	EQU	DATA+18
 STACK	EQU	DATA+20
 PC	EQU	DATA+22
 ;
 	PAGE
 ;	TABLE OF VECTORED ROUTINES
 ;
 	ORG	1C00H
 ;
 VECTORS	DEFW	RETURN		;0  - NOTHING DONE
 	DEFW	DEBUG		;1  - DEBUG ENTRY
 	DEFW	UNDEF		;3  - UNDEFINED
 	DEFW	UNDEF		;4  - UNDEFINED
 	DEFW	UNDEF		;5  - UNDEFINED
 	DEFW	UNDEF		;6  - UNDEFINED
 	DEFW	UNDEF		;7  - UNDEFINED
 	DEFW	UNDEF		;8  - UNDEFINED
 	DEFW	UNDEF		;9  - UNDEFINED
 	DEFW	UNDEF		;10 - UNDEFINED
 	DEFW	UNDEF		;11 - UNDEFINED
 	DEFW	UNDEF		;12 - UNDEFINED
 	DEFW	UNDEF		;13 - UNDEFINED
 	DEFW	UNDEF		;14 - UNDEFINED
 	DEFW	UNDEF		;15 - UNDEFINED
 ;
 UNDEF	LD	A,BADF		;BAD!
 	OR	A		;NZ STATUS
 RETURN	RET
 ;
 	PAGE
 ;	SAVE PROGRAM STATUS
 ;
 DEBUG	POP	AF		;IGNORE
 	POP	AF		;GET AF
 ;
 	PUSH	AF		;DUMMY SLOT FOR SP
 	PUSH	IY
 	PUSH	IX
 	EX	AF,AF'
 	EXX
 	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 	PUSH	AF
 	EX	AF,AF'
 	EXX
 	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 	PUSH	AF
 ;
 	LD	HL,0
 	ADD	HL,SP		;HL => STACK
 	LD	DE,DATA
 	LD	BC,24
 	LDIR			;DATA => ALL REG
 	LD	(STACK),HL	;SAVE SP
 ;
 ;	SET-UP DISPLAY DRIVER FOR RECURSIVE
 ;
 	LD	SP,HL		;RE-INIT
 	LD	A,DDCB? 	;DISPLAY DEVICE
 	CALL	LOCDCB		;LOCATE DCB
 	LD	A,(IX+9)	;GET VIDEO MASK
 	LD	(VIDMASK),A	;SAVE MASK
 	LD	HL,(TSP)	;GET TEMP STACK
 	LD	(TSP1),HL	;SAVE IT
 	LD	HL,(LSP)	;GET DSP STACK
 	LD	(LSP1),HL	;SAVE IT
 	LD	HL,TSTACK	;TEMP STACK
 	LD	(LSP),HL	;NEW DSP STACK
 ;
 ;	RESTORE ANY BREAKPOINTS
 ;
 	LD	HL,(PC) 	;GET PC
 	DEC	HL		;ASSUME BRKPNT RST
 	LD	A,(HL)
 	CP	BREAK		;IS IT?
 	JR	NZ,RESET1
 	LD	(PC),HL 	;SAVE CORRECT PC
 RESET1	LD	HL,BRKTBL
 	LD	B,2		;NUM OF BRKPNTS
 RESET3	XOR	A
 	LD	C,2
 	LD	E,(HL)		;LSB BRKPNT
 	LD	(HL),A		;KILL IT
 	INC	HL
 	LD	D,(HL)		;MSB BRKPNT
 	LD	(HL),A		;KILL IT
 	INC	HL
 	LD	A,D
 	OR	E		;BRKPNT SET?
 	JR	Z,RESET2
 	LD	A,(DE)
 	CP	BREAK		;STILL THERE?
 	JR	NZ,RESET2
 	LD	A,(HL)		;GET INST
 	LD	(DE),A		;REPLACE IT
 RESET2	INC	HL
 	DJNZ	RESET3		;NEXT
 ;
 ;	DISPLAY STATUS & GET COMMAND
 ;
 GETCMD	LD	SP,(STACK)	;RE-INIT
 	CALL	DISP
 	LD	HL,VIDMEM+1200
 	LD	(IX+12),L
 	LD	(IX+13),H
 ;
 	CALL	INPUT1
 	CP	'G'
 	JP	Z,GO
 	CP	'O'
 	JP	Z,OUT
 ;
 	LD	HL,GETCMD
 	PUSH	HL		;RET ADDRESS ON STACK
 	CP	'S'
 	JR	Z,SHORT
 	CP	';'
 	JR	Z,IPAGE
 	CP	'-'
 	JR	Z,DPAGE
 	CP	'A'
 	JR	Z,ASCHEX
 	CP	'C'
 	JR	Z,INC1
 	CP	'D'
 	JR	Z,DSPLY
 	CP	'H'
 	JR	Z,ASCHEX
 	CP	'I'
 INC1	JP	Z,INC
 	CP	'M'
 	JP	Z,MODIFY
 	CP	'R'
 	JP	Z,REGSET
 	CP	'U'
 	JR	Z,UPDATE
 	SUB	'X'
 	RET	NZ		;INVALID CMD
 ;
 ;	LONG/SHORT FORM SWITCH
 ;
 SHORT	LD	(BRKTBL+1),A		;SAVE FLAG
 	RET
 ;
 ;	UPDATE DISPLAY AS TO STATUS
 ;
 UPDATE	CALL	KBD
 	RET	Z		;GO IF YES
 	CALL	DISP
 	JR	UPDATE
 ;
 ;	DISPLAY NEW PAGE OF MEMORY
 ;
 DSPLY	CALL	INPUT2
 	RET	Z		;IF ABORT
 	JR	STPAGE
 ;
 ;	INCREMENT MEMORY PAGE
 ;
 IPAGE	LD	BC,64		;ASSUME SHORT FORM
 SPAGE2	LD	HL,(PAGE)
 	LD	A,(BRKTBL+1)	;LONG/SHORT FLAG
 	OR	A		;GET TYPE FLAG
 	JR	Z,SPAGE1	;GO IF SHORT
 	LD	C,0		;FULL PAGE INC/DEC
 	LD	A,B
 	OR	A		;ARE WE INC?
 	JR	NZ,SPAGE1	;GO IF DEC
 	INC	B		;INC FULL PAGE
 SPAGE1	ADD	HL,BC
 STPAGE	LD	(PAGE),HL
 	RET
 ;
 ;	DECREMENT MEMORY PAGE
 ;
 DPAGE	LD	BC,-64		;ASSUME SHORT FORM
 	JR	SPAGE2
 ;
 ;	ASCII/HEX DISPLAY SWITCH
 ;
 ASCHEX	LD	(BRKTBL),A	;SET TYPE FLAG
 	RET
 ;
 ;	DISPLAY MEMORY AND/OR REGISTERS
 ;
 DISP	LD	A,HOME		;HOME
 	CALL	DSP
 	LD	A,(BRKTBL+1)	;LONG/SHORT FLAG
 	OR	A		;SHORT?
 	JR	NZ,DISP1	;GO IF NOT
 	LD	HL,DATA 	;HL => ALL REG
 	PUSH	HL		;SAVE
 	LD	HL,ASCREG
 	LD	B,12		;REG COUNT
 	JR	DISP2
 DISP2	CALL	DSP2
 	EX	(SP),HL 	;GET REG, SAVE ASCREG
 	LD	E,(HL)		;LSB REG PAIR
 	INC	HL
 	LD	D,(HL)		;MSB REG PAIR
 	INC	HL
 	PUSH	HL		;SAVE REG
 	EX	DE,HL		;HL = (REG)
 	CALL	SPACE
 	LD	A,'='
 	CALL	DSP
 	CALL	SPACE
 	CALL	BINHX2		;DSP HEX
 	LD	A,B		;A = REG
 	AND	0BH
 	CP	8		;FLAG REG?
 	JR	NZ,DISP3
 ;
 	LD	C,L		;C = FLAG REG
 	PUSH	BC		;SAVE
 	CALL	SPACE
 	LD	HL,ASCFLG
 	LD	B,8		;BIT COUNT
 DISP5	SLA	C
 	LD	A,(HL)		;A = BIT NAME
 	JR	C,DISP4
 	LD	A,'-'           ;BIT OFF
 DISP4	CALL	DSP
 	INC	HL		;HL = NEXT NAME
 	DJNZ	DISP5
 	POP	BC
 	LD	A,ETB		;CLR TO EOL
 	CALL	DSP
 	JR	DISP6
 ;
 DISP3	CALL	POINT		;DISP DATA LINE
 DISP6	CALL	CR		;DSP C/R
 	POP	HL		;GET REG
 	EX	(SP),HL 	;SAVE REG, GET REGNAM
 	DJNZ	DISP2
 	POP	HL		;KILL OFF STACK
 	LD	HL,(PAGE)
 	LD	B,4		;LINE COUNT
 	JR	DISP9
 ;
 DISP8	CALL	CR		;DSP C/R
 DISP9	PUSH	BC
 	LD	B,6
 DISPA	CALL	SPACE		;TAB6
 	DJNZ	DISPA
 	POP	BC
 	CALL	BINHX2
 	CALL	POINT		;DISP DATA LINE
 	DJNZ	DISP8
 	RET
 ;
 DISP1	LD	HL,(PAGE)
 	LD	L,0		;IGNORE LSB (EVEN PAGE)
 	LD	B,16		;LINE COUNT
 	JR	DISP9
 ;
 ASCREG	DEFM	'AF BC DE HL AF'
 	DEFB	39
 	DEFM	'BC'
 	DEFB	39
 	DEFM	'DE'
 	DEFB	39
 	DEFM	'HL'
 	DEFB	39
 	DEFM	'IX IY SP PC '
 ASCFLG	DEFM	'SZ1H1PNC'
 ;
 ;	EXIT OUT TO OPERATING SYSTEM
 ;
 OUT	LD	HL,EXIT 	;DOS VECTOR
 	SCF			;FOOL C/R
 	JR	GO5		;GO!
 ;
 ;	START EXECUTION WITH CURRENT PC
 ;
 GO	LD	B,2		;BRKPNT COUNT
 	LD	DE,BRKTBL+5
 	CALL	INPUT2
 	JR	Z,GO1		;IF TERM
 ;
 GO5	LD	(PC),HL
 GO1	JR	C,GO2		;IF C/R
 	CALL	INPUT2		;GET BRKPNT1
 	PUSH	AF
 	CALL	NZ,SETBRK
 	POP	AF
 	DJNZ	GO1
 ;
 GO2	LD	A,-1		;-1 (ON)
 	LD	(DEBFLG),A
 ;
 ;	RESTORE DISPLAY DRIVER STATUS
 ;
 GO3	LD	HL,(TSP1)	;TEMP STACK
 	LD	(TSP),HL	;RESTORE
 	LD	HL,(LSP1)	;DSP STACK
 	LD	(LSP),HL	;RESTORE
 	LD	A,(VIDMASK)	;VIDEO MASK
 	LD	(IX+9),A	;RESTORE
 	OUT	(MDSL),A	;MAKE SURE!
 ;
 	LD	HL,STACK+1
 	LD	B,11		;REG COUNT
 REST1	LD	D,(HL)
 	DEC	HL
 	LD	E,(HL)
 	DEC	HL
 	PUSH	DE		;BUILD STACK AGAIN
 	DJNZ	REST1
 	POP	AF
 	POP	BC
 	POP	DE
 	POP	HL
 	EX	AF,AF'
 	EXX
 	POP	AF
 	POP	BC
 	POP	DE
 	POP	HL
 	EX	AF,AF'
 	EXX
 	POP	IX
 	POP	IY
 ;
 	POP	HL
 	LD	SP,HL
 	LD	HL,(PC)
 	PUSH	HL
 	LD	HL,(REGHL)	;HL DATA
 	RET			;GO!!!!
 ;
 ;	SET BREAKPOINT
 ;
 ;	ENT	HL => ADDRESS OF BREAKPOINT
 ;		DE => TEMP STORAGE - 3 BYTES
 ;
 SETBRK	LD	A,(HL)
 	LD	(DE),A
 	DEC	DE
 	LD	A,BREAK
 	LD	(HL),A
 	CP	(HL)		;READ ONLY MEMORY?
 	JP	NZ,RESET1
 	LD	A,H
 	LD	(DE),A
 	DEC	DE
 	LD	A,L
 	LD	(DE),A
 	DEC	DE
 	RET
 ;
 ;	MODIFY MAIN MEMORY
 ;
 MODIFY	LD	HL,(BRKTBL+3)	;MOD ADDRESS
 	CALL	INPUT2		;GET MOD ADDRESS
 MOD2	LD	(BRKTBL+3),HL
 	RET	C		;IF C/R
 	PUSH	HL
 	CALL	DISP
 	LD	HL,VIDMEM+1040
 	LD	(IX+12),L
 	LD	(IX+13),H
 	LD	HL,(BRKTBL+3)	;MOD ADDRESS
 	CALL	BINHX2
 	PUSH	HL
 	LD	HL,VIDMEM+1120
 	LD	(IX+12),L
 	LD	(IX+13),H
 	POP	HL
 	CALL	BINHX3
 	INC	HL
 	LD	A,'-'
 	CALL	DSP
 	POP	DE		;ADD OF MOD
 	CALL	INPUT2		;GET DATA FOR MOD
 	EX	DE,HL
 	JR	Z,MOD1
 	LD	(HL),E
 MOD1	RET	C		;IF C/R
 	INC	HL		;NEXT ADDRESS
 	JR	MOD2
 ;
 ;	MODIFY REGISTER CONTENTS
 ;
 REGSET	CALL	INPUT1
 	RET	Z		;IF TERM
 	LD	C,A		;FIRST CHAR OF NAME
 	CALL	INPUT1
 	RET	Z		;IF TERM
 	LD	D,A		;SECOND CHAR OF NAME
 	LD	E,' '           ;ASSUME NORMAL
 	CALL	INPUT1
 	RET	C		;IF C/R
 	JR	Z,REG1
 	LD	E,A
 	CALL	INPUT1
 	RET	NZ		;NO TERM
 	RET	C		;IF ABORT
 REG1	LD	HL,ASCREG
 	LD	B,12
 REG3	LD	A,(HL)		;GET FIRST CHAR OF NAME
 	CP	C		;FIRST CHAR MATCH?
 	JR	Z,REG2
 	INC	HL
 REG4	INC	HL
 REG5	INC	HL
 	DJNZ	REG3
 	RET
 ;
 REG2	INC	HL
 	LD	A,(HL)		;GET SECOND CHAR OF NAME
 	CP	D		;SECOND CHAR MATCH?
 	JR	NZ,REG4
 	INC	HL
 	LD	A,(HL)
 	CP	E		;REG SET TYPE MATCH?
 	JR	NZ,REG5
 	LD	A,24
 	SUB	B
 	SUB	B
 	LD	C,A		;REG WE WANT
 	LD	B,0
 	LD	HL,DATA 	;REG STORAGE
 	ADD	HL,BC
 	PUSH	HL		;HL => REG DATA
 	LD	A,ETB		;CLEAR TO END OF LINE
 	CALL	DSP
 	POP	DE		;(DE) => REG DATA
 	CALL	INPUT2
 	RET	Z		;IF TERM
 	EX	DE,HL		;(HL) = REG DATA
 	LD	(HL),E		;LSB OF REG PAIR
 	INC	HL
 	LD	(HL),D		;MSB OF REG PAIR
 	RET
 ;
 ;	INCREMENT PC AND INC/CONTINUE
 ;
 INC	PUSH	AF		;SAVE CMD
 	LD	DE,(PC)
 	LD	A,(DE)		;GET INST
 ;
 ;	DETERMINE INSTRUCTION LENTH
 ;
 	LD	HL,TABLE1
 	CP	0DDH		;INDEX IX EXT OPCODE?
 	JR	Z,LENTH1
 	CP	0FDH		;INDEX IY EXT OPCODE?
 	JR	Z,LENTH1
 ;
 	LD	HL,TABLE2
 	CP	0EDH		;MISC EXT OPCODE?
 	JR	NZ,LENTH2
 ;
 	LD	HL,TABLE3
 ;
 LENTH1	INC	DE		;NEXT BYTE OF INST
 	LD	A,(DE)		;GET NEXT BYTE
 	DEC	DE		;CORRECT TO BEG
 ;
 LENTH2	LD	C,A		;C = INST
 LENTH3	LD	A,(HL)		;GET MASK FOR INST
 	AND	C
 	INC	HL		;COMPARE BYTE
 	CP	(HL)		;GOT INST?
 	INC	HL		;LENTH/PC FLG
 	JR	Z,LENTH4	;IF YES
 	INC	HL		;MASK/DEFAULT BYTE
 	LD	A,(HL)		;GET BYTE
 	CP	5		;DEFAULT LENTH?
 	JR	NC,LENTH3	;IF NOT
 ;
 LENTH4	LD	A,(HL)		;GET LENTH/PC FLG
 	LD	B,A		;SAVE
 	AND	0FH		;LENTH ONLY
 	LD	L,A
 	LD	H,0
 	ADD	HL,DE		;HL => BRKPNT
 	PUSH	DE		;SAVE PC
 	LD	DE,BRKTBL+5
 	CALL	SETBRK
 	POP	HL		;GET PC
 	LD	A,B		;GET LENTH/PC FLG
 	AND	0F0H		;PC FLAG ONLY
 	JR	Z,GO4		;IF PC NOT ALTERED
 	INC	HL		;POS TO ASSSUMED ADDRESS
 	CP	20H
 	JR	C,ADJPC1	;JP (HL)
 	JR	Z,ADJPC2	;JP (IX) OR JP (IY)
 	CP	40H
 	JR	C,ADJPC3	;JR NN
 	JR	Z,ADJPC4	;JP NNNN
 	CP	60H
 	JR	C,ADJPC5	;RET
 	POP	AF		;GET COMMAND
 	CP	'I'             ;INCREMENT?
 	JR	Z,ADJPC4
 ;
 GO4	JP	GO3		;GO!
 ;
 ;	ROUTINES TO ADJUST PROGRAM COUNTER
 ;
 ;	INCL.	JP (HL), JP (IX), JP (IY)
 ;		CALL's, RET's, JR's, JP's
 ;
 ADJPC5	LD	HL,(STACK)	;RET's
 ;
 ADJPC4	LD	A,(HL)		;CALL's & JP's
 	INC	HL
 	LD	H,(HL)
 	LD	L,A
 	JR	ADJOUT
 ;
 ;	CONVERT RELATIVE ADDRSSS TO ABSOLUTE
 ;
 ADJPC3	LD	C,(HL)		;RELATIVE ADDRESS
 	XOR	A		;CLR
 	BIT	7,C		;NEGATIVE?
 	JR	Z,ADJPC6	;IF NOT
 	CPL			;CORRECT
 ADJPC6	LD	B,A
 	INC	HL		;FOR ADD
 	ADD	HL,BC
 	JR	ADJOUT
 ;
 ADJPC2	LD	HL,(REGIX)
 	BIT	5,C		;JP (IX)?
 	JR	Z,ADJOUT	;IF YES
 	LD	HL,(REGIY)
 	JR	ADJOUT
 ;
 ADJPC1	LD	HL,(REGHL)
 ;
 ADJOUT	CALL	SETBRK
 	JR	GO4
 ;
 ;	TABLE(S) OF OPCODE COMPARES FOR INSTRUCTION
 ;	LENTHS, THE FORMAT IS AS FOLLOWS:
 ;
 ;	1ST BYTE = MASK BYTE
 ;	2ND BYTE = COMPARE BYTE
 ;	3RD BYTE LOW NIBBLE = INST. LENTH
 ;	3RD BYTE HIGH NIBBLE = FLAG TO ADJ PC
 ;		10H = JP (HL)
 ;		20H = JP (IX), JP (IY)
 ;		30H = JR's
 ;		40H = JP's
 ;		50H = RET's
 ;		60H = CALL's
 ;
 TABLE2	DEFB	0C7H
 	DEFB	0C0H
 	DEFB	51H
 ;
 	DEFB	0FFH
 	DEFB	0C9H
 	DEFB	51H
 ;
 	DEFB	0FFH
 	DEFB	0E9H
 	DEFB	11H
 ;
 	DEFB	0CFH
 	DEFB	1
 	DEFB	3
 ;
 	DEFB	0E7H
 	DEFB	22H
 	DEFB	03H
 ;
 	DEFB	0C7H
 	DEFB	0C2H
 	DEFB	43H
 ;
 	DEFB	0FFH
 	DEFB	0C3H
 	DEFB	43H
 ;
 	DEFB	0C7H
 	DEFB	0C4H
 	DEFB	63H
 ;
 	DEFB	0FFH
 	DEFB	0CDH
 	DEFB	063H
 ;
 	DEFB	0C7H
 	DEFB	6
 	DEFB	2
 ;
 	DEFB	0F7H
 	DEFB	0D3H
 	DEFB	2
 ;
 	DEFB	0C7H
 	DEFB	0C6H
 	DEFB	2
 ;
 	DEFB	0FFH
 	DEFB	0CBH
 	DEFB	2
 ;
 	DEFB	0F7H
 	DEFB	10H
 	DEFB	32H
 ;
 	DEFB	0E7H
 	DEFB	20H
 	DEFB	32H
 ;
 	DEFB	1
 ;
 TABLE3	DEFB	0C7H
 	DEFB	043H
 	DEFB	4
 ;
 	DEFB	0F7H
 	DEFB	45H
 	DEFB	52H
 ;
 	DEFB	2
 ;
 TABLE1	DEFB	0FEH
 	DEFB	34H
 	DEFB	3
 ;
 	DEFB	0C0H
 	DEFB	040H
 	DEFB	3
 ;
 	DEFB	0C0H
 	DEFB	80H
 	DEFB	3
 ;
 	DEFB	0FFH
 	DEFB	21H
 	DEFB	4
 ;
 	DEFB	0FFH
 	DEFB	22H
 	DEFB	4
 ;
 	DEFB	0FFH
 	DEFB	2AH
 	DEFB	4
 ;
 	DEFB	0FFH
 	DEFB	36H
 	DEFB	4
 ;
 	DEFB	0FFH
 	DEFB	0CBH
 	DEFB	4
 ;
 	DEFB	0FFH
 	DEFB	0E9H
 	DEFB	22H
 ;
 	DEFB	2
 ;
 ;	SUBROUTINE TO DISPLAY POINTED LINE
 ;
 POINT	PUSH	BC		;SAVE
 	LD	A,':'
 	CALL	DSP
 	CALL	SPACE
 ;
 	LD	B,16		;BYTE COUNT
 POINT4	CALL	SPACE
 	CALL	TRAP		;DISPLAY TRAP IF NEEDED
 	LD	A,REV
 	CALL	Z,DSP
 	LD	A,(BRKTBL)	;GET ASC/HEX TYPE FLG
 	CP	'A'
 	JR	NZ,POINT1
 	CALL	SPACE
 	LD	A,(HL)		;GET BYTE
 	CP	' '             ;CONTROL?
 	JR	C,POINT2	;IF YES
 	CP	0C0H		;SPACE CODE?
 	JR	C,POINT3	;IF NOT
 POINT2	LD	A,'.'
 POINT3	CALL	DSP
 	XOR	A		;SET Z
 POINT1	CALL	NZ,BINHX3
 	CALL	TRAP
 	LD	A,NOR
 	CALL	Z,DSP
 	LD	A,B
 	CP	9
 	CALL	Z,SPACE
 	INC	HL
 	DJNZ	POINT4
 	POP	BC		;RESTORE
 	RET
 ;
 ;	SUBROUTINE TO CHECK TRAP
 ;
 TRAP	LD	DE,(BRKTBL+3)	;TEMP STOR FOR ADD
 	PUSH	HL		;SAVE CURR MEM LOC
 	OR	A		;AT ADDRESS?
 	SBC	HL,DE		;CHECK
 	POP	HL		;RESTORE
 	RET
 ;
 ;	ROUTINE TO INPUT BYTE END CHECK TERMINATION
 ;
 ;	EXT	Z SET IF TERMINATION
 ;		C SET IF C/R
 ;
 INPUT1	PUSH	DE
 	CALL	INKEY
 	POP	DE
 	CP	13		;ENTER?
 	SCF			;C SET
 	RET	Z		;IF YES
 	PUSH	DE
 	CALL	DSP		;DSP KEY
 	POP	DE
 	CP	','             ;COMMA?
 	RET	Z		;TERM
 	CP	' '             ;SPACE BAR?
 	RET	Z		;TERM
 	CP	'A'             ;ALPHA?
 	CCF			;NC
 	RET	NC
 	AND	5FH		;KILL CASE
 	RET
 ;
 ;	ROUTINE TO INPUT HEX WORD & CONVERT
 ;
 INPUT2	CALL	INPUT1
 	RET	Z		;IF TERM
 ;
 	LD	HL,0		;INIT
 INP2	CALL	CHKHEX		;CHECK FOR VALID HEX
 	JP	C,GETCMD	;IF ABORT
 	ADD	HL,HL		; * 2
 	ADD	HL,HL		; * 4
 	ADD	HL,HL		; * 8
 	ADD	HL,HL		; * 16
 	ADD	A,L		;ADD DIGIT
 	LD	L,A		;HL = RESULT
 	CALL	INPUT1
 	JR	NZ,INP2
 	RRA			; / 2
 	ADC	A,-127
 	RET
 ;
 ;	ROUTINE TO CHECK FOR VALID HEX INPUT
 ;
 ;	EXT	C SET IF BAD HEX
 ;
 CHKHEX	SUB	30H
 	RET	C
 	ADD	A,-23
 	RET	C
 	ADD	A,6
 	JR	C,CHKHX1
 	ADD	A,7
 	RET	C
 CHKHX1	ADD	A,10
 	OR	A
 	RET
 ;
 ;	BINARY TO HEX CONVERSIONS
 ;
 BINHX3	LD	A,(HL)
 	JR	BINHX4
 ;
 BINHX2	LD	A,H
 	CALL	BINHX4
 	LD	A,L
 ;
 BINHX4	PUSH	AF
 	RRA
 	RRA
 	RRA
 	RRA
 	CALL	BINHX5
 	POP	AF
 ;
 BINHX5	AND	0FH
 	ADD	A,90H
 	DAA
 	ADC	A,40H
 	DAA
 BINHX7	JP	DSP
 ;
 ;	ROUTINE TO DISPLAY SPACE
 ;
 SPACE	LD	A,' '
 	JR	BINHX7
 ;
 ;	ROUTINE TO DISPLAY C/R
 ;
 CR	LD	A,13
 	JR	BINHX7
 ;
 ;	ROUTINE TO DISPLAY 3 CHARACTERS
 ;
 ;	ENT	HL => ASCII TEXT
 ;
 DSP2	CALL	DSP3
 	CALL	DSP3
 DSP3	LD	A,(HL)
 	INC	HL
 	JR	BINHX7
 ;
 DSP	PUSH	BC
 	LD	B,A
 	LD	A,VDCHAR
 	RST	SVC
 	LD	A,B
 	POP	BC
 	RET
 ;
 KBD	PUSH	BC
 	LD	A,KBCHAR
 	RST	SVC
 	LD	A,B
 	POP	BC
 	RET
 ;
 INKEY	CALL	KBD
 	JR	NZ,INKEY
 	RET
 ;
 VIDMASK DEFS	1		;VIDEO MASK
 TSP1	DEFS	2		;TEMP STACK
 LSP1	DEFS	2		;DSP DRIVER STACK
 ;
 	END	VECTORS
