DOSSYS ; dossys8/asm
 ;
 ;	STEVE - NOTE
 ;	following NOT implemented
 ;	current program end at 1F5FH
 ;
 RAMDIR	EQU	0
 FILPTR	EQU	0
 DISKID	EQU	0
 ;
 	TITLE	'<Dos+ II.A - SYS08/SYS>'
 ;
 	ORG	1C00H		;low residing
 ;
 ;	external support
 ;
 ERR2	EQU	2		;CHAR NOT AVAILABLE
 ERR3	EQU	3		;PARAMETER ERROR
 BADF	EQU	1		;bad function code
 SVC	EQU	8		;SVC executor
 STCMP	EQU	22		;compare strings
 PERR	EQU	3		;parameter error
 INVF	EQU	19		;invalid filespec
 CHNA	EQU	2		;character not avail
 ;
 REGSAV	EQU	0303H		;save registers
 WILDMASK EQU	018CH		;wild mask
 UCASE	EQU	031EH		;A to upper case
 ;
 CR	EQU	13		;ASCII EQU
 SPACE	EQU	' '
 ETX	EQU	3		;end of text
 JRC	EQU	38H		;JR C opcode
 JRNC	EQU	30H		;JR NC opcode
 ;
 VECTORS	DW	RETURN		;0 - return
 	DW	PARSER		;1
 	DW	WILD		;2
 	DW	RAMDIR		;3
 	DW	UNDEF		;4 - $RDDIR
 	DW	FILPTR		;5
 	DW	DISKID		;6
 	DW	SORT		;7
 	DW	SORT2		;8
 	DW	UNDEF		;9 - undefined
 	DW	UNDEF		;10
 	DW	UNDEF		;11
 	DW	UNDEF		;12
 	DW	UNDEF		;13
 	DW	UNDEF		;14
 	DW	UNDEF		;15
 ;
 ;	undefined system call
 ;
 UNDEF	LD	A,BADF		;'bad function call'
 	OR	A		;set NZ
 	RET			;back to caller
 ;
 	PAGE
 ;
 ;
 ;	$PARSER - GENERAL PURPOSE PARSING
 ;
 ;	ENT	 C =	MAX PARSE LENGTH
 ;		HL =>	TEXT BUFFER
 ;		DE =>	LIST ADDRESS BLOCK (0=NONE)
 ;
 ;	EXT	 A =	CHAR PRECEDING FIELD
 ;		 B =	ACTUAL FIELD LENGTH
 ;		 C =	NUMBER OF BYTES REMAINING
 ;		 D =	FIELD TERMINATOR
 ;		 E =	DISPLACEMENT POINTER
 ;		HL =>	FIELD POSITION
 ;
 ;		Z SET IF ENDED W/SEPERATOR
 ;		C SET IF TRAILING BLANKS
 ;
 PARSER	CALL	SETBLK		;SET-UP LIST BLOCKS
 	LD	A,-1		;-1
 	LD	(PCHR),A	;SET PREVIOUS CHAR
 	LD	(TCHR),A	;SET TERM CHAR
 	DEC	HL		;BKSP TEXT
 	PUSH	HL		;SAVE TEXT BUFF
 	LD	E,0		;DISP POINTER
 	LD	B,0		;FIELD LENGTH
 	LD	H,0		;FLAGS
 ;
 ;	CHECK FOR END PARSING
 ;
 PARS1	EX	(SP),HL 	;HL => TEXT BUFFER
 	INC	HL		;NEXT
 	INC	C
 	CP	C		;END PARSE?
 	JR	NZ,PARS2	;IF NOT
 	EX	(SP),HL 	;GET FLAGS
 	RES	6,L		;TERM FOUND - NZ
 	JR	PARS12		;SKIP OUT
 ;
 ;	GET CHAR FROM TEXT
 ;
 PARS2	LD	A,(HL)		;GET CHAR
 	DEC	C		;DEC COUNT
 	EX	(SP),HL 	;HL = FLAGS
 	BIT	7,H		;IN FIELD?
 	JR	Z,PARS3 	;IF NOT
 	INC	E		;DISP POINTER
 ;
 ;	CHECK FOR END LITERAL
 ;
 PARS3	BIT	5,H		;IN LITERAL?
 	JR	Z,PARS4 	;IF NOT
 	CP	D		;TERM LITERAL?
 	JR	NZ,PARS7	;IF NOT
 	RES	5,H		;NO LITERAL
 	SET	6,H		;END FIELD
 	JR	PARS1		;TRY AGAIN
 ;
 ;	CHECK FOR START LITERAL
 ;
 PARS4	CP	'"'             ;LITERAL?
 	JR	Z,PARS5 	;SKIP
 	CP	''''            ;LITERAL?
 	JR	NZ,PARS6	;IF NOT
 ;
 PARS5	BIT	7,H		;IN FIELD?
 	JR	NZ,PARS11	;IF NOT
 	SET	5,H		;IN LITERAL
 	LD	D,A		;LITERAL CHAR
 	JR	PARS1		;TRY AGAIN
 ;
 ;	CHECK FOR START FIELD
 ;
 PARS6	CALL	CKCHR		;CHECK CHARACTER
 	JR	NZ,PARS9	;TERM/SEPERATOR
 PARS7	BIT	7,H		;IN FIELD?
 	JR	NZ,PARS8	;IF YES
 	INC	E		;DISPLACEMENT POINTER
 	EX	(SP),HL 	;HL => TEXT BUFFER
 	DEC	HL		;BKSP
 	LD	A,(HL)		;GET CHAR
 	LD	(PCHR),A	;SET PRECEDING CHAR
 	INC	HL		;CORRECT
 	LD	(FPOS),HL	;SAVE
 	EX	(SP),HL 	;GET FLAGS
 	SET	7,H		;HAVE FIELD
 ;
 ;	CHECK FOR END FIELD
 ;
 PARS8	BIT	6,H		;END FIELD?
 	JR	Z,PARSA 	;IF NOT
 	DEC	E		;DISPLACEMENT POINTER
 	INC	C		;PARSE COUNT
 	JR	PARS12		;EXIT
 ;
 PARSA	INC	B		;ACTUAL FIELD LENGTH
 	JR	PARS1		;TRY AGAIN
 ;
 ;	SKIP TRAILING BLANKS
 ;
 PARS9	JR	C,PARS10	;IF TERMINATOR
 	CP	' '             ;BLANK?
 	JR	NZ,PARS11	;IF NOT
 	BIT	7,H		;IN FIELD?
 	JR	Z,PARS1 	;IF NOT
 	SET	6,H		;END FIELD
 	SET	0,L		;TRAIL BLANKS - C
 	JR	PARS1		;TRY AGAIN
 ;
 ;	END OF FIELD PROCESSING
 ;
 PARS10	RES	6,L		;TERM FOUND - NZ
 PARS11	LD	(TCHR),A	;SET TERM CHAR
 	BIT	7,H		;IN FIELD?
 	JR	NZ,PARS12	;IF YES
 	INC	E		;DISPLACEMENT POINTER
 	EX	(SP),HL 	;GET TEXT BUFFER
 	LD	(FPOS),HL	;SET FIELD POSN
 	EX	(SP),HL 	;GET FLAGS
 ;
 PARS12	EX	(SP),HL 	;GET TEXT BUFFER
 	LD	HL,(FPOS)	;HL => FIELD POSN
 	POP	AF		;GET FLAGS
 	LD	A,(TCHR)	;TERM CHAR
 	LD	D,A		;D = TERM CHAR
 	LD	A,(PCHR)	;PREVIOUS CHAR
 	RET
 ;
 ;	VARIABLES FOR PARSER
 ;
 FPOS	DEFS	2		;FIELD POSN
 TCHR	DEFS	1		;TERM CHAR
 PCHR	DEFS	1		;PREVIOUS CHAR
 ;
 	PAGE
 ;	CHECK IF CHAR FIELD/TERM/SEPERATOR
 ;
 ;	ENT	 A =	CHARACTER
 ;
 ;	EXT	 Z & NC IF FIELD
 ;		 NZ & C  IF TERMINATOR
 ;		 NZ & NC IF SEPERATOR
 ;
 CKCHR	PUSH	HL		;SAVE REG
 	PUSH	BC
 	LD	B,0		;MSB COUNT
 ;
 ;	CHECK FOR SPECIAL TERMINATOR
 ;
 CKCHR1	LD	HL,(LIST1)	;TERM LIST
 	LD	C,(HL)		;CHAR COUNT
 	INC	C
 	DEC	C		;NULL?
 	JR	Z,CKCHR2	;SKIP
 	INC	HL		;HL => LIST
 	CPIR			;FOUND?
 	JR	Z,CKCHR7	;TERMINATOR
 ;
 ;	CHECK FOR SPECIAL FIELD CHAR
 ;
 CKCHR2	LD	HL,(LIST2)	;FIELD LIST
 	LD	C,(HL)		;CHAR COUNT
 	INC	C
 	DEC	C		;NULL?
 	JR	Z,CKCHR3	;SKIP
 	INC	HL		;HL => LIST
 	CPIR			;FOUND?
 	JR	Z,CKCHR5	;FIELD CHAR
 ;
 ;	CHECK DEFAULT FIELD CHAR
 ;
 CKCHR3	CP	'0'             ;NUMERIC?
 	JR	C,CKCHR6	;SEPERATOR
 	CP	'9'+1           ;NUMERIC?
 	JR	C,CKCHR4	;FIELD
 	CP	'A'             ;ALPHA?
 	JR	C,CKCHR6	;SEPERATOR
 	CP	'Z'+1           ;ALPHA?
 	JR	C,CKCHR4	;FIELD
 	CP	'a'             ;ALPHA?
 	JR	C,CKCHR6	;SEPERATOR
 	CP	'z'+1           ;ALPHA?
 	JR	NC,CKCHR6	;SEPERATOR
 ;
 ;	CHECK FOR SPECIAL SEPERATOR
 ;
 CKCHR4	LD	HL,(LIST3)	;FIELD LIST
 	LD	C,(HL)		;CHAR COUNT
 	INC	C
 	DEC	C		;NULL?
 	JR	Z,CKCHR5	;SKIP
 	INC	HL		;HL => LIST
 	CPIR			;FOUND?
 	JR	Z,CKCHR6	;TERMINATOR
 ;
 ;	SET-UP TERMINATING STATUS
 ;
 CKCHR5	CP	A		;Z & NC
 	JR	CKCHR8		;SKIP W/FIELD
 CKCHR6	LD	B,A		;SAVE CHAR
 	OR	-1		;NZ & NC
 	LD	A,B		;GET CHAR
 	JR	CKCHR8		;SKIP W/SEPRATOR
 CKCHR7	LD	B,A		;SAVE CHAR
 	OR	-1		;NZ & NC
 	SCF			;NZ & C
 	LD	A,B		;GET TERM CHAR
 CKCHR8	POP	BC		;RESTORE REG
 	POP	HL
 	RET
 ;
 	PAGE
 ;	SET-UP LIST-BLOCK ROUTINE
 ;
 ;	ENT	DE =>	LIST ADD BLOCK (0=DEFAULT)
 ;
 SETBLK	PUSH	HL		;SAVE
 	XOR	A
 	CP	D		;NO LISTS?
 	JR	NZ,SETBK1	;IF NOT
 	LD	DE,DEFLBA	;DE => DEFAULT LIST
 ;
 SETBK1	CALL	GETBLK		;GET BLOCK ADD
 	LD	(LIST1),HL	;SET LIST 1
 	CALL	GETBLK		;GET BLOCK ADD
 	LD	(LIST2),HL	;SET LIST 2
 	CALL	GETBLK		;GET BLOCK ADD
 	LD	(LIST3),HL	;SET LIST 3
 	POP	HL		;RESTORE
 	RET
 ;
 ;	GET LIST FROM LIST BLOCK
 ;
 ;	ENT	DE =>	LIST BLOCK
 ;
 GETBLK	EX	DE,HL		;HL => LIST ADDRESS BLOCK
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)		;DE => LIST BLOCK
 	INC	HL
 	EX	DE,HL		;HL => LIST BLOCK
 	CP	H		;LIST BLOCK 0?
 	RET	NZ		;IF NOT
 	LD	HL,NULL 	;NULL LIST
 	RET
 ;
 ;	DEFAULT LIST BLOCKS
 ;
 DEFLBA	DEFW	0		;DEFAULT TERM BLOCK
 	DEFW	0		;DEFAULT FIELD BLOCK
 	DEFW	0		;DEFAULT SEPR BLOCK
 ;
 NULL	DEFB	0		;DEFAULT LIST-BLOCK
 ;
 ;	LIST BLOCK ADDRESSES
 ;
 LIST1	DEFW	0		;TERMINATOR LIST
 LIST2	DEFW	0		;FIELD LIST
 LIST3	DEFW	0		;SEPERATOR LIST
 ;
 	PAGE
 ;
 ;	$WILD	- SVC 51 - setup/compare wildmask
 ;
 ;	B = function code
 ;
 ;	ENT	B = 0	- set wild card mask
 ;		HL => wildmask
 ;	EXT	Z = OK
 ;		NZ = invalid mask spec
 ;
 ;	ENT	B = 1	- compare filespec with mask
 ;		HL => filespec to compare
 ;	EXT	Z = OK, match
 ;		NZ = file does not match mask
 ;
 ;	ENT	B = 2	- combine name/ext into filespec
 ;		HL => 11 byte buffer (NAME   EXT) padded
 ;		DE => 13 byte buffer to hold filespec
 ;	EXT	Z = OK
 ;		NZ = invalid filespec chars
 ;
 ;	ENT	B = 3	- compare cracked with mask
 ;		HL => cracked filespec to compare
 ;	EXT	Z = match
 ;		NZ = NO match
 ;
 WILD	CALL	REGSAV		;save registers
 	XOR	A		;check command
 	CP	B		;B = 0?
 	JR	Z,WILD0		;set mask
 ;
 	DEC	B		;B = 1?
 	JP	Z,WILD1		;compare file>mask
 ;
 	DEC	B		;B = 2?
 	JR	Z,WILD2		;un-crack filespec
 ;
 	DEC	B		;B = 3?
 	LD	A,PERR		;parameter error
 	RET	NZ		;error, return
 	JP	WILD3		;compare
 ;
 ;	combine name and ext into filespec
 ;
 WILD2	LD	B,8		;move 8 chars
 	CALL	WILD2M		;move 'em
 	RET	NZ		;invalid chars
 ;
 ;	check for extension
 ;
 	LD	A,(HL)		;get next char
 	CP	SPACE		;separator?
 	JR	Z,WILD2D	;done if yes
 ;
 ;	exists, insert an extension marker
 ;
 	LD	A,'/'		;extension mark
 	LD	(DE),A		;put in buffer
 	INC	DE		;bump pointer
 ;
 	LD	B,3		;move 3 chars
 	CALL	WILD2M		;move 'em
 	RET	NZ		;invalid chars
 ;
 ;	completed, insert CR
 ;
 WILD2D	LD	A,CR		;insert a CR
 	LD	(DE),A		;put it in
 ;
 RETURN	XOR	A		;return Z
 	RET			;done
 ;
 ;	move chars from HL => DE
 ;
 WILD2M	LD	A,(HL)		;get a char
 	CP	SPACE		;space?
 	JR	Z,WILD2N	;next char if yes
 ;
 ;	check for valid char
 ;
 	CALL	VALCHR		;is it?
 	JR	Z,WILD2B	;error, invalid char
 	LD	(DE),A		;valid, put in buffer
 ;
 	INC	DE		;bump dest
 WILD2N	INC	HL		;bump source
 	DJNZ	WILD2M		;check next one
 ;
 	XOR	A		;set Z for OK
 	RET			;done
 ;
 ;	invalid chars
 ;
 WILD2B	LD	A,INVF		;'invalid filespec'
 	OR	A		;set NZ
 	RET			;done, go back
 ;
 ;	set wildmask
 ;
 WILD0	PUSH	HL		;save string pointer
 	LD	HL,WILDMASK	;sys0 mask
 	PUSH	HL		;save for DE
 	LD	D,H		;pass to DE
 	LD	E,L
 	INC	DE		;DE = HL+1
 	LD	BC,10		;11 byte field
 	LD	(HL),'?'	;set to nil
 	LDIR			;nil the mask
 ;
 	POP	DE		;DE => wildmask
 	POP	HL		;HL => user mask
 ;
 	LD	B,8		;8 chars in name
 	CALL	WILD0M		;move it in
 	JR	Z,WILD0E	;OK, continue
 	CP	'/'		;this the bad char?
 	JR	NZ,WILD2B	;nope, go error
 ;
 WILD0E	LD	B,3		;3 char extension
 	CALL	WILD0M		;move it in
 	JR	NZ,WILD2B	;nope, error
 ;
 	XOR	A		;else for zero
 	RET			;done
 ;
 ;	move chars into wildmask field
 ;
 WILD0M	LD	A,(HL)		;fetch a char
 	CALL	CKTERM		;terminator?
 	JR	C,WILD0T	;terminator, continue
 ;
 	CALL	VALCHR		;valid character?
 	JR	Z,WILD0B	;nope, check for error
 ;
 	CP	'*'		;wild card filler?
 	JR	Z,WILD0F	;fill it up if yes
 ;
 	CALL	UCASE		;force upper case
 	LD	(DE),A		;else put in wildmask
 	INC	DE		;bump pointers
 	INC	HL
 	DJNZ	WILD0M		;go more
 ;
 WILD0R	XOR	A		;set Z flag
 	RET			;done
 ;
 ;	fill remainder of field with blanks
 ;
 WILD0F	LD	A,'?'		;use to fill
 	CALL	WILD0FS		;fill it up
 	INC	HL		;get next char
 	LD	A,(HL)		;fetch it
 	CALL	CKTERM		;terminator?
 	RET	C		;yes, return
 	JR	WILD0B		;else generate error
 ;
 WILD0FS	INC	B		;done with field?
 	DEC	B
 ;
 WILD0FF	JR	Z,WILD0R	;return if yes
 	LD	(DE),A		;put in char
 	INC	DE		;bump pointer
 	DEC	B		;less counter
 	JR	WILD0FF		;fill more?
 ;
 WILD0B	CP	'/'		;offending char?
 	RET	NZ		;nope, error
 	INC	HL		;bump pointer
 WILD0T	LD	A,20H 		;use to fill
 	JR	WILD0FS		;fill rest of field
 ;
 ;	compare filespec to mask
 ;
 WILD3	LD	DE,WILDMASK	;sys0 mask area
 	LD	B,11		;11 chars to compare
 ;
 WILD3L	LD	A,(DE)		;get a char
 	CP	'?'		;wild char?
 	JR	Z,WILD3N	;force a match
 	CP	(HL)		;same one?
 	JR	NZ,WILD3R	;nope, return
 ;
 WILD3N	INC	HL		;bump pointers
 	INC	DE
 	DJNZ	WILD3L		;check next one
 ;
 	XOR	A		;done, return with Z
 	JR	WILD3R+2	;continue
 ;
 WILD3R	LD	A,2		;'not available'
 	OR	A		;set flags
 	RET			;done
 ;
 WILD1	EX	DE,HL		;DE => filename
 	LD	HL,NAME		;buffer
 	PUSH	HL		;save pointer
 	CALL	CRACK		;open it up
 	POP	HL		;get pointer
 	JP	WILD3		;compare it now
 ;
 ;	crack open filespec
 ;
 CRACK	LD	B,11		;11 chars to fill
 	PUSH	HL		;save start
 CRACK1	LD	(HL),20H	;set nil
 	INC	HL
 	DJNZ	CRACK1		;fill more
 	POP	HL		;get pointer back
 ;
 	EX	DE,HL		;HL => filespec
 	LD	B,8		;8 chars in name
 	CALL	GETFLD		;get the field
 	LD	C,A		;save term char
 	LD	A,B		;get length
 	CP	8		;anything?
 	JR	NZ,CRACK2	;go if not
 CRACKN	LD	A,CHNA		;char not available
 	OR	A		;set NZ
 	RET
 ;
 CRACK2	LD	A,C		;get term
 	CP	'/'		;extension?
 	JR	Z,CRACK3	;yes, go
 	XOR	A		;else done
 	RET
 ;
 CRACK3	LD	B,3		;3 chars to move
 	LD	DE,NAME+8	;extension field
 	CALL	GETFLD		;get the field
 	LD	A,B
 	CP	3		;nil?
 	JR	Z,CRACKN	;no good
 	XOR	A		;else done
 	RET
 ;
 GETFLD	LD	A,(HL)		;get a character
 	CALL	VALCHR		;valid?
 	INC	HL		;bump pointer
 	RET	Z		;no, return
 	CALL	UCASE		;make it upper
 	LD	(DE),A		;put in buffer
 	INC	DE		;bump pointer
 	DJNZ	GETFLD		;go more
 ;
 	LD	A,(HL)		;get term char
 	INC	HL
 	RET			;done
 ;
 	PAGE
 ;
 ;	$VALCHR	- check for valid filespec char
 ;
 ;	EXT	Z = invalid
 ;		NZ = OK
 ;
 VALCHR	PUSH	HL		;save registers
 	PUSH	BC
 	LD	HL,CHRTBL	;invalid char table
 	LD	BC,17		;17 reserved chars
 	CPIR			;find!
 	POP	BC		;unstack
 	POP	HL
 	RET			;done
 ;
 ;	table of reserved chars
 ;
 CHRTBL	DEFM	'!'
 	DEFM	'('
 	DEFM	')'
 	DEFM	','
 	DEFM	'.'
 	DEFM	'/'
 	DEFM	';'
 	DEFM	' '
 	DEFM	':'
 	DEFM	'@'
 	DEFM	'='
 	DEFM	'"'
 	DEFB	27H
 	DEFB	ETX
 	DEFB	CR
 	DEFB	7BH
 	DEFB	7DH
 ;
 ;	$CKTERM	- check for terminator
 ;
 ;	EXT	Carry = terminator
 ;
 CKTERM	CP	CR
 	SCF
 	RET	Z
 	CP	';'
 	SCF
 	RET	Z
 	CP	ETX
 	SCF
 	RET	Z
 	OR	A
 	RET
 ;
 	PAGE
 ;
 ;	$SORT	- SVC 56
 ;	sort memory block
 ;
 ;	ENT	IX => first entry in list
 ;		DE => last entry in list
 ;		B = position of key in entry
 ;		C = length of each entry
 ;		L = length of sort key
 ;		H = 0 = ascending sort
 ;		H <> 0 = descending sort
 ;
 ;	EXT	Z = OK
 ;		NZ = A = special error code
 ;	1 = key end exceeded last byte of entry
 ;	2 = key start exceeds last byte of entry
 ;	3 = entry length =0 (invalid)
 ;	4 = key length =0 (invalid)
 ;	5 = address of first entry > last entry
 ;
 ;
 ;	$SORT2	-	- sort memory block
 ;
 ;	ENT	same as $SORT EXCEPT
 ;		DE = number of entries to sort
 ;
 ;	EXT	same as $SORT
 ;
 SORT	CALL	SETSORT		;setup sort params
 	CALL	NUMENT		;load DE with # entries
 	JR	SORTGO		;go!
 ;
 SORT2	CALL	SETSORT		;setup sort params
 ;
 SORTGO	CALL	PARSORT		;check params
 	RET	NZ		;error, return
 ;
 	LD	B,D		;load BC with entries
 	LD	C,E
 ;
 ;	sort data block, HL=> data, BC=num entries
 ;	offset and data length set into code @ sersort
 ;
 SORT0	LD	(BASE),HL	;save loop base
 	LD	D,H		;pass to DE
 	LD	E,L
 	PUSH	BC		;save counter
 	JR	SORT22		;continue next entry
 ;
 SORT1	CALL	COMPAR		;test entries
 	JR	Z,SORT22	;no change
 SORTDIR	JR	NC,SORT22	;go
 	LD	(BASE),DE	;have new low/high
 ;
 SORT22	PUSH	HL		;save pointer
 	LD	HL,0		;entry length
 ENTLEN	EQU	$-2
 	ADD	HL,DE		;point to next one
 	EX	DE,HL		;DE = next entry
 	POP	HL		;restore pointer
 ;
 	DEC	BC		;see if more
 	LD	A,B
 	OR	C
 	JR	NZ,SORT1	;finish this pass
 ;
 	LD	BC,0		;get base
 BASE	EQU	$-2
 	PUSH	HL		;save pointer
 	OR	A		;clear carry
 	SBC	HL,BC		;see if HL = (BASE)
 	POP	HL		;restore pointer
 	JR	Z,SORT3		;no change, skip
 	CALL	SWAP		;else swap entries
 ;
 SORT3	LD	BC,(ENTLEN)	;entry length
 	ADD	HL,BC		;point to next
 	POP	BC		;get counter
 	DEC	BC		;see if more to do
 	LD	A,B
 	OR	C
 	JR	NZ,SORT0	;go if more
 ;
 	XOR	A		;else done, return Z
 	RET
 ;
 ;	compare two sort entries
 ;
 COMPAR	PUSH	HL		;short push for speed
 	PUSH	DE
 	PUSH	BC
 	LD	BC,0		;sort offset
 SRTOFF	EQU	$-2
 	LD	HL,(BASE)	;get current base
 	ADD	HL,BC		;point to sort field
 	EX	DE,HL		;get current pointer
 	ADD	HL,BC		;point to sort field
 	EX	DE,HL
 	LD	B,0		;get sort length
 SRTLEN	EQU	$-1
 COMPLP	LD	A,(DE)		;get a byte
 	CP	(HL)		;same?
 	JR	NZ,COMPRT	;nope, return
 	INC	DE		;bump pointers
 	INC	HL
 	DJNZ	COMPLP		;go more
 ;
 COMPRT	POP	BC		;unstack & return
 	POP	DE
 	POP	HL
 	RET			;done, flags set
 ;
 ;	swap two sort fields
 ;
 SWAP	PUSH	HL		;quick push's
 	PUSH	DE
 	PUSH	BC
 	LD	DE,(BASE)	;get base pointer
 	LD	A,(ENTLEN)	;entry length
 	LD	B,A		;pass here
 ;
 SWAPLP	LD	C,(HL)		;get a byte
 	LD	A,(DE)		;get other
 	LD	(HL),A		;swap 'em
 	LD	A,C
 	LD	(DE),A		;this entry done
 	INC	HL		;bump pointers
 	INC	DE
 	DJNZ	SWAPLP		;finish em
 ;
 	POP	BC		;unstack & return
 	POP	DE
 	POP	HL
 	RET			;done
 ;
 ;	setup sort parameters
 ;
 SETSORT	POP	AF		;get caller address
 	CALL	REGSAV		;save all registers
 	PUSH	AF		;put caller back
 	LD	A,JRNC		;JR NC opcode
 	INC	H		;test ascending/descend
 	DEC	H		;H = 0 ?
 	JR	Z,SET0		;ascending
 	LD	A,JRC		;JR C opcode
 SET0	LD	(SORTDIR),A	;put into code
 	LD	A,L		;get key length
 	LD	(SRTLEN),A	;save it
 	PUSH	IX		;pass IX => HL
 	POP	HL
 	LD	A,B		;sort key offset
 	LD	(SRTOFF),A	;save it
 	LD	A,C		;entry length
 	LD	(ENTLEN),A	;save it
 	RET			;done, all OK
 ;
 ;	compute # entries to sort
 ;
 NUMENT	PUSH	HL		;save buff start
 	PUSH	BC		;save data
 	LD	BC,1		;start # entries
 ;
 NUMELP	OR	A		;clear carry
 	PUSH	HL		;save pointer
 	SBC	HL,DE		;test for end
 	POP	HL		;restore it
 	JR	NC,NUMHAV	;have it, go
 ;
 	INC	BC
 	LD	A,(ENTLEN)	;entry length
 	ADD	A,L		;add to pointer
 	LD	L,A		;update
 	JR	NC,NUMELP	;no page crossed
 	INC	H		;else bump page
 	JR	NUMELP
 NUMHAV	LD	D,B		;load count here
 	LD	E,C
 	POP	BC		;unstack
 	POP	HL
 	RET			;done
 ;
 ;	check for valid parameters
 ;
 PARSORT	XOR	A		;set flags
 	EX	AF,AF'		;for error
 	LD	A,(SRTLEN)	;sort field length
 	OR	A		;0 ?
 	LD	A,4		;invalid code
 	JR	Z,PARRET	;invalid
 ;
 	LD	A,C		;entry length
 	OR	A		;0 ?
 	LD	A,3		;invalid code
 	JR	Z,PARRET	;invalid
 ;
 	LD	A,B		;key posit
 	CP	C		;entry length
 	LD	A,2		;invalid code
 	JR	NC,PARRET	;invalid
 ;
 	LD	A,(SRTLEN)	;sort length
 	ADD	A,B		;add key offset
 	DEC	A		;adjust for compare
 	CP	C		;key st+len <= ent len
 	LD	A,1		;error code
 	JR	NC,PARRET	;invalid
 ;
 	LD	A,D		;see if nil length
 	OR	E
 	LD	A,5		;error code
 	JR	Z,PARRET	;invalid
 ;
 	XOR	A		;all OK
 ;
 PARRET	OR	A		;set flags
 	RET			;done
 ;
 NAME	DS	11		;work area for WILD
 ;
 	END	VECTORS
