; dpcopy2/asm - kjw/bqsd - 10/82
;
;	loop to copy data
;
LOOPER	LD	SP,(STACK)	;reset stack to top
	LD	IY,TABLE	;reset data table
	LD	A,(IY+14)	;fetch init byte
	OR	A		;data all input?
	JP	NZ,ENTRY	;nope, get user params!
;
	CALL	SERIALNOS	;setup serial #'s
;
;	prompt user to mount all required diskettes
;
	LD	HL,MSG5		;prompt text
	CALL	DISPLAY		;display prompt
	LD	B,2		;2 char input
	CALL	GETSTR		;get from keyboard
;
	LD	HL,DRIVES	;active drive table
	LD	DE,XDRIVES	;store table for lockouts
	LD	BC,4		;4 bytes long
	LDIR			;move it
;
	LD	A,(IY+18)	;use GAT to skip tracks?
	CP	'Y'		;yes?
	CALL	Z,READGAT	;yes, read the GAT table
	CALL	COPY		;copy to active diskettes
	CALL	PUTSERIAL	;insert serial numbers
	CALL	RESULT		;display copy result
;
	LD	HL,(COUNT)	;get count
	LD	DE,(COPIES)	;# copies requested
	OR	A		;clear carry flag
	SBC	HL,DE		;all copies completed?
	JR	C,LOOPER	;more to do, go!
;
	LD	HL,MSG6		;all copies completed!
	CALL	DISPLAY		;display it
	LD	B,2		;wait for <ENTER> key
	CALL	GETSTR		;get from keyboard
	JP	START		;re-start program
;
;	disk read/write error!
;
TERMIN	CALL	ERROR		;fetch read error
	JR	TERMINATE+3	;message alread displayed
;
TERMINATE
	CALL	DISPLAY		;display type of error
	LD	HL,MSG29	;source error!
	CALL	DISPLAY		;display it
	JR	LOOPER		;re-start loop
;
;	display string pointed to by HL
;
DISPLAY	LD	A,(HL)		;fetch a character
	INC	HL		;bump string pointer
	CP	03		;end of text?
	RET	Z		;yes, done!
	CALL	VOUT		;display output
	JR	DISPLAY		;continue
;
;	display char in A register
;
VOUT	PUSH	BC		;save it
	LD	B,A		;pass display char
	LD	A,@VDCHAR	;SVC #
	RST	SVC		;display output
	POP	BC		;unstack BC
	RET			;done, return
;
;	fetch keyboard input from user
;
GETSTR	LD	HL,STRING	;point to input string
	LD	A,@KBLINE	;SVC #
	RST	SVC		;fetch input
	JP	C,300H		;abort program
	LD	A,B		;get input length
	CP	1		;set flags on length
	LD	A,(HL)		;but return with char
	RET			;Z = nil input
;
;	position HL to first significant character
;
	INC	HL		;bump input pointer
POSHL	LD	A,(HL)		;fetch a char
	CP	' '		;blank?
	JR	Z,POSHL-1	;yes, skip it
	CP	','		;comma?
	JR	Z,POSHL-1	;yes, skip it
	CP	13		;terminator?
	SCF			;Carry = yes
	RET	Z		;return if input term'd
	CCF			;else clear carry flag
	RET			;return NC
;
;	fetch value from input string
;
VALUE	CALL	POSHL		;position to input
	JR	NC,VALGO	;char found, go!
	OR	-1		;set NZ for error
	RET			;return error
;
VALGO	LD	A,@VALUE	;SVC #
	RST	SVC		;fetch value
	RET			;return with BC value
;
;	setup loop to format diskettes if requested
;
COPY	XOR	A		;set current drive
	LD	(IY+2),A	;current dest drive
;
LOOPF	LD	HL,XDRIVES	;active drive table
	ADD	A,L		;add current drive
	LD	L,A		;HL => current dest drive
	LD	A,(HL)		;fetch flag
	INC	A		;FF = true
	CALL	Z,FORMAT	;format if active
	INC	(IY+2)		;bump dest drive
	LD	A,(IY+2)	;fetch new value
	CP	4		;check for 0-3
	JR	C,LOOPF		;finish if more to go
;
	LD	HL,CLRIT	;clear current line
	CALL	DISPLAY		;display it
	LD	A,(IY+17)	;check if data to go
	INC	A		;copy?
	RET	NZ		;nope, done!
;
	LD	DE,0		;set position to track 0
	LD	(TKIN),DE	;read position
;
;	setup loop to copy data
;
INNER	LD	DE,0		;fetch current track/sect
TKIN	EQU	$-2
	LD	(TKOUT),DE	;save for write
	LD	(IY+22),0	;clear # sectors in mem.
	CALL	READ1		;read max disk source
	CALL	DCOMMON		;write to all active drvs
	LD	A,(TKIN+1)	;get current track
	CP	(IY+5)		;end of disk?
	JR	C,INNER		;copy more if not
	RET			;done with copy portion
;
;	write buffer to all active dest drives
;
DCOMMON	XOR	A		;load zero
	LD	(IY+2),A	;set current dest drive
;
;	check all 4 drives for active
;
DCLP	LD	HL,XDRIVES	;active drive table
	ADD	A,L		;add current drive
	LD	L,A		;HL => drive table entry
	LD	A,(HL)		;fetch table byte
	INC	A		;FF = active?
	CALL	Z,WRITE1	;yes, write buffer
	INC	(IY+2)		;bump current drive
	LD	A,(IY+2)	;fetch result
	CP	4		;check for 0-3
	JR	C,DCLP		;go more if any left
	RET			;else all written to
;
;	format a drive
;
FORMAT	LD	A,(IY+16)	;fetch format flag
	INC	A		;true?
	RET	NZ		;nope, skip
	LD	A,(IY+2)	;get current drive
	CALL	SETDRV		;setup for activity
	LD	(MSG7A),A	;save drive # to text
	LD	HL,MSG7		;text string
	CALL	DISPLAY		;display to video
	LD	(IY+4),0	;set current track to 0
	CALL	STAT		;check drive status
	PUSH	HL		;set stack for error
	JP	NZ,REMDRIVE	;remove drive if bad
	POP	HL		;restore stack
	CALL	RESTORE		;move head to track 0
	JP	NZ,REMWRITE	;remove if bad
;
FORMLP	CALL	FFLICK		;display current track
	CALL	BUILD		;create format track
	LD	BC,BUFFER	;I/O buffer
	LD	D,(IY+4)	;get current track
	CALL	WRITETR		;write track to disk
	JR	NZ,REMWRITE	;remove if error occured
	INC	(IY+4)		;bump current track
	LD	A,(IY+4)	;fetch current track
	CP	(IY+5)		;test for disk end
	JR	C,FORMLP	;go if more to do
	RET			;else done with format
;
;	disk error on write, remove drive from table
;
REMWRITE PUSH	HL		;save
	CALL	ERROR		;display the error
	JR	REMDRIVE	;remove drive from table
;
;	disk error on read, remove drive from table
;
REMREAD	PUSH	HL		;save
	CALL	ERROR		;display error
	JR	REMDRIVE+3	;message displayed
;
REMDRIVE CALL	DISPLAY		;display error message
	LD	A,(IY+2)	;get current drive
	ADD	A,'0'		;make it ascii
	LD	(MSG21A),A	;save drive # to text
	LD	HL,MSG21	;message start
	CALL	DISPLAY		;display it
	LD	HL,XDRIVES	;active drive table
	LD	A,(IY+2)	;get current drive
	ADD	A,L		;add offset to table
	LD	L,A		;HL => drive entry
	LD	(HL),0		;set as inactive
;
;	check to see if any drives remain active
;
	LD	HL,XDRIVES	;start of table
	LD	B,4		;4 drives to check
;
CKLP	LD	A,(HL)		;fetch table byte
	INC	A		;FF = active
	JR	Z,CKDN		;go if one active
	INC	HL		;bump table pointer
	DJNZ	CKLP		;go for 4 entries
	LD	HL,MSG9		;'no destination drives'
	CALL	DISPLAY		;display it
	JP	LOOPER		;start again
;
CKDN	POP	HL		;restore it
	OR	1		;set NZ
	RET			;return to I/O caller
;
;	disk write error, display it
;
ERROR	AND	7FH		;assure a return
	PUSH	AF		;save error
	LD	A,10		;send linefeed
	CALL	VOUT		;display it
	POP	AF		;re-fetch error
	PUSH	BC		;save from SVC
	LD	B,A		;B = error code
	LD	A,@ERROR	;SVC #
	RST	SVC		;display error message
	POP	BC		;restore it
	RET			;back to caller
;
;	track 'flicker' routine for formatting
;
FFLICK	PUSH	BC		;save
	PUSH	HL		;save
	CALL	VDON		;enable video
	CALL	GETCUR		;get current cursor
;
	LD	A,':'.XOR.' '	;char to flash
	PUSH	AF		;save char on stack
	XOR	(HL)		;change to 2nd char
	LD	(HL),A		;put on video
	INC	HL		;skip 2 positions
	INC	HL
	LD	A,(IY+4)	;get current track
	CALL	ASCII		;make it ascii
	LD	(HL),C		;to video
	INC	HL		;next
	LD	(HL),A		;to video
	INC	HL		;skip over two
	INC	HL
	POP	AF		;get change char back
	XOR	(HL)		;change it
	LD	(HL),A		;put on video
	CALL	VDOFF		;video off
	POP	HL		;unstack
	POP	BC
	RET			;and return
;
;	'flicker' routines for read/write/verify
;
RFLICK	LD	A,'-'.XOR.' '	;'flicker' char
	JR	FLICKER		;go common
;
WFLICK	LD	A,'+'.XOR.' '	;'flicker' char
	JR	FLICKER		;go common
;
VFLICK	LD	A,'='.XOR.' '	;'flicker' char
;
FLICKER	LD	(FLKCHR),A	;save for stack change
	LD	(FLKBUF),BC	;save buffer for new stak
	PUSH	HL		;save
	PUSH	BC		;save
	CALL	VDON		;select video
	CALL	GETCUR		;load HL with cursor
	LD	A,0		;get 'flicker' char
FLKCHR	EQU	$-1
	PUSH	AF		;save on stack
	XOR	(HL)		;change char
	LD	(HL),A		;to video
	LD	A,D		;get track #
	CALL	ASCII		;to decimal ascii
	INC	HL		;double bump video
	INC	HL
	LD	(HL),C		;ascii MSB to video
	INC	HL		;bump video
	LD	(HL),A		;ascii LSB to video
	INC	HL		;double bump
	INC	HL
	POP	AF		;fetch 'flicker' char
	PUSH	AF		;resave on stack
	XOR	(HL)		;change video char
	LD	(HL),A		;to video
	LD	A,E		;get sector #
	CALL	ASCII		;to decimal ascii
	INC	HL		;double bump video pntr.
	INC	HL
	LD	(HL),C		;MSB ascii to video
	INC	HL		;bump video
	LD	(HL),A		;LSB ascii to video
	INC	HL		;double bump video
	INC	HL
	POP	AF		;restore 'flicker' char
	PUSH	AF		;save back on stack
	LD	BC,0		;get buffer pointer
FLKBUF	EQU	$-2
	XOR	(HL)		;set new char
	LD	(HL),A		;to video
	INC	HL		;double bump video
	INC	HL
	LD	A,B		;get MSB buffer pointer
	CALL	HEXCV		;to hex ascii
	LD	(HL),C		;MSB hex to display
	INC	HL		;bump video
	LD	(HL),A		;LSB hex to display
	INC	HL		;bump video
	LD	(HL),'0'	;set LSB address
	INC	HL		;bump video
	LD	(HL),'0'	;low LSB address
	INC	HL		;double bump video
	INC	HL
	POP	AF		;restore 'flicker' char
	XOR	(HL)		;change char on video
	LD	(HL),A		;to video
	CALL	VDOFF		;disable video
	POP	BC		;unstack 'em
	POP	HL
	RET			;done!
;
;	check disk drive status
;
STAT	PUSH	BC		;save it
	LD	A,0		;get drive number
DRIVE	EQU	$-1
	LD	C,A		;C = drive
	LD	A,$DCHECK	;check for drive ready
	RST	DISKIO		;check it out
	LD	HL,MSG24	;drive not ready
	POP	BC		;restore
	RET			;return status in Z
;
;	read max sectors into memory
;
READ1	LD	A,(IY+23)	;outer retries
	LD	(IY+6),A	;save it
;
READ1Z	LD	A,(IY+1)	;get source drive
	CALL	SETDRV		;setup for activity
	LD	(MSG25A),A	;save ascii drive to text
	LD	HL,MSG25	;start of message
	CALL	DISPLAY		;display to video
	CALL	STAT		;check drive status
	JP	NZ,TERMINATE	;can't read source disk
	LD	BC,BUFFER	;I/O buffer
	LD	IX,DAMBUFF	;for data address marks
;
READ1L	LD	(IY+4),D	;pass current track
	CALL	RFLICK		;video 'flicker'
	CALL	READ		;read the sector
	LD	A,(DAM)		;fetch DAM type
	LD	(IX),A		;save into buffer
	INC	IX		;bump buffer pointer
	JP	NZ,TERMIN	;go if error
	CALL	NEXSEC		;advance DE to next sect.
	INC	(IY+22)		;bump # sect's in RAM
	INC	B		;bump buffer pointer
	JR	Z,READ1D	;go till buffer full
	LD	A,D		;fetch current track
	CP	(IY+5)		;end of disk?
	JR	C,READ1L	;read more if not
;
READ1D	LD	A,(IY+0)	;verify flag
	LD	(TKIN),DE	;save next track/sector
	CP	'Y'		;verify on?
	RET	NZ		;done if not!
;
;	verify is ON, re-read the sectors
;
	LD	A,(IY+1)	;get source drive
	CALL	SETDRV		;setup for I/O
	LD	(MSG27A),A	;ascii to text string
	LD	HL,MSG27	;start of text
	CALL	DISPLAY		;display to video
	LD	DE,0		;get starting track
TKOUT	EQU	$-2
	LD	BC,BUFFER	;start of buffer
;
	LD	A,(IY+24)	;get inner retries
	LD	(IY+7),A	;set inner retry counter
	LD	A,(IY+22)	;get # sects in RAM
	LD	(IY+10),A	;save for current loop
	LD	IX,DAMBUFF	;start of DAM buffer
;
READ1V	LD	(IY+4),D	;pass current track
	CALL	VFLICK		;verify 'flicker'
	PUSH	BC		;save buff pointer
	LD	BC,VBUFF	;verify buffer
	CALL	READ		;read the sector
	POP	BC		;restore buff pointer
	JP	NZ,TERMIN	;go disk error
	CALL	COMPARE		;compare two sectors
	JR	NZ,READ1BB	;error, go!
	LD	A,(DAM)		;get data address mark
	CP	(IX)		;same?
	JR	Z,READ1P	;yes, go!
;
READ1BB	CALL	MOVBUF		;swap buffers if bad
	LD	A,(DAM)		;get new DAM
	LD	(IX),A		;save into buffer
	DEC	(IY+7)		;inner retry counter
	JR	NZ,READ1V	;go if more
	DEC	(IY+6)		;outer retry counter
	JP	NZ,READ1Z	;go if more
	LD	HL,MSG35	;'data mismatch'
	JP	TERMINATE	;terminate source error
;
READ1P	CALL	NEXSEC		;move DE to next sector
	LD	A,(IY+24)	;get inner retries
	LD	(IY+7),A	;save for decrementing
	INC	B		;bump buffer pointer
	INC	IX		;bump DAM buff pointer
	DEC	(IY+10)		;remaining sectors
	JR	NZ,READ1V	;go if more
	RET			;else read & verified!
;
;	write a group of sectors in RAM buffer
;
WRITE1	LD	A,(IY+23)	;get outer retries
	LD	(IY+6),A	;save for counting
;
WRITE1Z	LD	A,(IY+2)	;get current dest drive
	CALL	SETDRV		;setup for I/O
	LD	(MSG26A),A	;save ascii drive to text
	LD	HL,MSG26	;start of message
	CALL	DISPLAY		;display text
	LD	DE,(TKOUT)	;get start track/sector
	LD	BC,BUFFER	;I/O buffer start
	LD	A,(IY+22)	;get # sectors in RAM
	LD	(IY+10),A	;save for this pass
	LD	IX,DAMBUFF	;start of data markers
;
WRITE1L	LD	(IY+4),D	;pass current track
	CALL	WFLICK		;write 'flicker' routine
	LD	A,$DWRITE	;write sector command
	ADD	A,(IX)		;add for with A/M
	LD	(WRTYPE),A	;pass write type
	CALL	WRITE		;write the sector
	JP	NZ,REMWRITE	;remove the drive
	INC	IX		;bump DAM buff pointer
	INC	B		;bump buffer pointer
	CALL	NEXSEC		;advance DE to next sect.
	DEC	(IY+10)		;less sector counter
	JR	NZ,WRITE1L	;go if more
;
	LD	A,(IY+0)	;fetch verify flag
	CP	'Y'		;verify on?
	RET	NZ		;done if not
;
	LD	A,(IY+2)	;get current dest drive
	CALL	SETDRV		;setup for I/O activity
	LD	(MSG27A),A	;pass ascii to text
	LD	HL,MSG27	;message string
	CALL	DISPLAY		;display to video
	LD	DE,(TKOUT)	;get starting track/sect.
	LD	BC,BUFFER	;start of I/O buffer
	LD	A,(IY+24)	;get inner retries
	LD	(IY+7),A	;save it
	LD	A,(IY+22)	;get # sectors to go
	LD	(IY+10),A	;save for this pass
	LD	IX,DAMBUFF	;start of DAM buffer
;
VERIFY1L LD	(IY+4),D	;pass current track
	CALL	VFLICK		;verify 'flicker' sub
	PUSH	BC		;save buffer pointer
	LD	BC,VBUFF	;verify buffer
	CALL	READ		;read the sector
	POP	BC		;restore buff pointer
	JR	Z,V1OKSO	;go if no error
	CP	54		;CRC error?
	JP	NZ,REMREAD	;abort if not
	JR	V1BB		;else retry
;
V1OKSO	CALL	COMPARE		;compare data buffers
	JR	NZ,V1BB		;go error if mismatch
	LD	A,(DAM)		;get DAM type
	CP	(IX)		;match?
	JR	Z,V1OK		;go if OK
;
V1BB	CALL	REWRITE		;re-write current sector
	DEC	(IY+7)		;less retry counter
	JR	NZ,VERIFY1L	;try again if any left
	DEC	(IY+6)		;less outer retry counter
	JP	NZ,WRITE1Z	;go if more tries left
	LD	HL,MSG35	;'data mismatch'
	PUSH	HL		;setup stack
	JP	REMDRIVE	;remove if from que
;
V1OK	INC	B		;bump buffer pointer
	INC	IX		;bump DAM buff pointer
	LD	A,(IY+24)	;get inner retries
	LD	(IY+7),A	;reset it
	CALL	NEXSEC		;advance DE to next sect.
	DEC	(IY+10)		;any more to do?
	JR	NZ,VERIFY1L	;go if yes
	RET			;else written & verified!
;
;	advance DE to next sector
;
NEXSEC	INC	E		;bump sector
	INC	D		;check for track 0
	DEC	D		;yes?
	LD	A,30		;# sectors disk
	JR	NZ,NEXTD	;go if not on zero
	LD	A,27		;# sectors track 0
;
NEXTD	SUB	E		;at track end?
	RET	NZ		;nope, continue
	LD	E,A		;reset to zero
NEXGTK	INC	D		;bump track
;
;	next track, check if GAT used to skip it
;
	LD	A,(IY+18)	;use GAT to skip tracks?
	CP	'Y'		;yes?
	RET	NZ		;nope, go full disk
;
	LD	A,D		;get current track
	CP	(IY+5)		;end of disk?
	RET	NC		;yes, don't bother
;
	PUSH	HL		;save
	PUSH	BC		;save
	LD	HL,GATBUFF	;GAT buffer in RAM
	LD	L,D		;HL => GAT byte
	LD	A,(IY+19)	;GAT skip byte
	CP	(HL)		;match?
	POP	BC		;unstack
	POP	HL
	JR	Z,NEXGTK	;if nil track, advance
	RET			;else DE at used track
;
;	setup for drive activity
;
SETDRV	PUSH	BC		;save
	PUSH	IY		;save
	PUSH	IX		;save
;
	PUSH	IY		;pass to IX
	POP	IX		;IX => data table
	PUSH	AF		;save
	LD	(DRIVE),A	;save binary drive #
	LD	C,A		;C = drive #
	CALL	LOCDCT		;locate DCT
	LD	A,27		;highest sector 0
	BIT	7,(IY+13)	;check density
	JR	NZ,SETDN	;have track 0
	LD	A,(IY+22)	;sectors / cylinder
SETDN	LD	(IX+20),A	;# sectors track 0
	LD	A,(IY+22)	;get # sectors/cylinder
	LD	(IX+21),A	;density disk
	POP	AF		;get binary drive back
	ADD	A,'0'		;make it ascii
;
	POP	IX		;unstack
	POP	IY
	POP	BC
	RET
;
;	read/write sector
;
;	ENT	DE = track sector
;		(DRIVE) = binary drive #
;		BC = buffer pointer
;
READ	LD	HL,SREAD	;sector read sub
	JR	COMMON		;go common vector
;
WRITE	LD	HL,SWRITE	;sector write sub
	JR	COMMON		;go common sub
;
WRITETR	LD	HL,TWRITE	;track write sub
;
COMMON	LD	(VECTOR),HL	;save call vector
	LD	A,(IY+8)	;get # retries
	LD	(IY+9),A	;save for this loop
;
COMMLP	CALL	SETDEN		;setup DCT density
	CALL	0		;call vector
VECTOR	EQU	$-2
	RET	Z		;OK now, return
	EX	AF,AF'		;save error
	DEC	(IY+9)		;less this attempt
	JR	NZ,COMMLP	;try again if more tries
	EX	AF,AF'		;restore error
	RET			;return in error
;
SREAD	PUSH	HL		;save registers
	PUSH	DE
	PUSH	BC
;
	LD	H,B		;pass buffer to HL
	LD	L,C
	LD	A,(DRIVE)	;get drive
	LD	C,A		;C = drive #
	LD	B,0		;extended sector
	LD	A,$DREAD	;read data sector
	RST	DISKIO		;read it!
;
	POP	BC		;unstack
	POP	DE
	POP	HL
	JR	NZ,CKRERR	;check if error
	XOR	A		;assure a zero
RERROK	LD	(DAM),A		;save type of read
	XOR	A		;return to caller zero
	RET
;
CKRERR	CP	56		;directory read?
	RET	NZ		;only error allowed
	LD	A,4		;for $DWRITE1 writes
	JR	RERROK		;continue
;
;	write track
;
TWRITE	LD	A,8		;format track
	LD	(WRTYPE),A	;pass type of write
;
;	write sector
;
SWRITE	PUSH	HL		;save
	PUSH	DE		;save
	PUSH	BC		;save
;
	LD	H,B		;pass buffer
	LD	L,C
	LD	A,(DRIVE)	;get binary drive #
	LD	C,A		;pass to C
	LD	B,0		;extended sector
	LD	A,0		;get write type
WRTYPE	EQU	$-1
	RST	DISKIO		;write track/sector
;
	POP	BC		;unstack
	POP	DE
	POP	HL
	RET			;return with Z flag
;
;	fetch current cursor position into HL
;
GETCUR	LD	HL,(CURPTR)	;get indirect pointer
	LD	A,(HL)		;get LSB
	INC	HL		;next
	LD	H,(HL)		;get MSB
	LD	L,A		;HL => cursor offset
	RET			;done
;
;	setup density for I/O
;
SETDEN	PUSH	IY		;save it
	PUSH	BC		;save
	LD	BC,(DRIVE)	;get drive #
	CALL	LOCDCT		;find the DCT
	INC	D		;check for track 0
	DEC	D		;D=0?
	JR	Z,SETSNG	;yes, set single den
	SET	7,(IY+13)	;set double density
	JR	SETRET		;done, return
;
SETSNG	RES	7,(IY+13)	;set single density
;
SETRET	POP	BC		;unstack
	POP	IY
	RET			;done
;
