; dpcopy3/asm - kjw/bqsd - 10/82
;
;	restore disk drive
;
RESTORE	PUSH	BC		;save
	LD	A,(DRIVE)	;get drive #
	LD	C,A		;pass to C
	LD	A,$DHOME	;disk command
	RST	DISKIO		;restore drive
	POP	BC		;unstack
	RET			;return with Z flag
;
;	display result of last copy pass
;
RESULT	LD	HL,CLRLIN	;clear current line
	CALL	DISPLAY		;display it
	XOR	A		;set drive 0
	LD	(IY+2),A	;current dest drive
;
;	check if drive was originally active
;
RESLP	LD	HL,DRIVES	;active drive table
	ADD	A,L		;add this drive
	LD	L,A		;HL => table entry
	LD	A,(HL)		;fetch byte
	INC	A		;FF = active
	JR	NZ,RESNXT	;go if not
;
;	check if drive is still active
;
	LD	A,(IY+2)	;get drive again
	LD	HL,XDRIVES	;current drive table
	ADD	A,L		;add offset
	LD	L,A		;HL => table entry
	LD	A,(HL)		;fetch it
	INC	A		;drive still active?
	JR	NZ,BADDRV	;nope, do not use!
;
	LD	HL,(COUNT)	;fetch completed counter
	INC	HL		;bump for good copy
	LD	(COUNT),HL	;re-save count
	LD	A,(IY+2)	;get current drive #
	ADD	A,'0'		;add ascii to it
	LD	(MSG30A),A	;save into text string
	LD	HL,MSG30	;start of message
	CALL	DISPLAY		;display it
	LD	A,(IY+3)	;serial numbering on?
	CP	'*'		;off?
	JR	Z,RESFEED	;yes, continue
	CALL	SHOWSER		;display serial number
	JR	RESNXT		;continue
;
BADDRV	LD	A,(IY+2)	;get current drive #
	ADD	A,'0'		;add ascii to it
	LD	(MSG31A),A	;to text string
	LD	HL,MSG31	;start of message
	CALL	DISPLAY		;display it
	LD	A,(IY+3)	;serial numbering?
	CP	'*'		;off?
	JR	Z,RESFEED	;go if yes
	CALL	SHOWSER		;else display number
	JR	RESNXT		;continue
;
RESFEED	LD	A,10		;send linefeed
	CALL	VOUT		;to the display
;
RESNXT	INC	(IY+2)		;bump current drive #
	LD	A,(IY+2)	;fetch result
	CP	4		;0-3?
	JR	C,RESLP		;do next if more
;
;	display completed counter
;
	LD	DE,(COUNT)	;get completed counter
	LD	HL,MSG32A	;text where it goes
	LD	A,@BINDEC	;SVC #
	LD	B,0		;direction flag
	RST	SVC		;load string
;
	LD	DE,(COPIES)	;get # copies requested
	LD	HL,MSG32B	;text where it goes
	LD	A,@BINDEC	;SVC #
	RST	SVC		;load string with ascii
;
	LD	HL,MSG32	;start of message
	JP	DISPLAY		;display and return
;
SHOWSER	CALL	FSER		;fetch serial number
	EX	DE,HL		;HL => serial #
	LD	DE,SERMSGA	;message where it goes
	LD	C,(IY+15)	;serial # length
	LD	B,0		;BC = length
	LDIR			;move into text string
	LD	HL,SERMSG	;start of message
	JP	DISPLAY		;display & return
;
FSER	LD	A,(IY+2)	;get current drive
	ADD	A,A		;double for table
	PUSH	HL		;save HL
	LD	HL,SERTBL	;start of lookup table
	ADD	A,L		;add offset to table
	LD	L,A		;put it back
	JR	NC,NOTBND	;not sector boundary
	INC	H		;else bump page pointer
NOTBND	LD	E,(HL)		;fetch LSB entry
	INC	HL		;bump pointer
	LD	D,(HL)		;fetch MSB entry
	POP	HL		;restore HL
	RET			;DE => serial # storage
;
;	build track in memory
;
BUILD	LD	A,(IY+4)	;get current track
	OR	A		;on track zero?
	CALL	Z,ZBUFF		;if yes, clear buffer
	JP	BUILDTRK	;build track in memory
;
;	test buffer memory
;
TESTMEM	POP	HL		;get caller address
	CALL	VDOFF		;make sure RAM is there
	LD	SP,(STACK)	;reset stack
	PUSH	HL		;leave caller address
	LD	HL,VBUFF	;start of ram buffer
	LD	DE,VBUFF+1	;start +1
	LD	BC,-1-VBUFF	;length of buffer
	LD	(HL),-1		;set all bits on
	LDIR			;fill all memory with -1
;
;	allow setting time for memory retension
;
	LD	HL,VBUFF	;start of buffer
TESTLP	LD	A,-1		;load FF
	CP	(HL)		;all bits still on?
	JR	NZ,BADMEM	;nope, error!
;
	LD	(HL),A		;to buffer
	CP	(HL)		;still there?
	JR	NZ,BADMEM	;nope, error!
	CPL			;reverse to all bits off
	LD	(HL),A		;load it
	CP	(HL)		;still there?
	JR	NZ,BADMEM	;nope, go error
;
	LD	A,0AAH		;10101010 pattern
	LD	(HL),A		;to ram
	NOP			;short settle
	CP	(HL)		;still there?
	JR	NZ,BADMEM	;nope, error
	CPL			;01010101 pattern
	LD	(HL),A		;to ram
	NOP			;short settle
	CP	(HL)		;still there?
	JR	NZ,BADMEM	;nope, error
;
	LD	A,0CCH		;11001100 pattern
	LD	(HL),A		;to ram
	CP	(HL)		;still there?
	JR	NZ,BADMEM	;nope, error
	CPL			;00110011 pattern
	LD	(HL),A		;to ram
	CP	(HL)		;still there?
	JR	NZ,BADMEM	;nope, error
	INC	HL		;bump buffer pointer
	LD	A,H		;check for any more
	OR	L		;any bits on?
	JR	NZ,TESTLP	;go till 0000H wrap
	RET			;all memory OK
;
BADMEM	LD	HL,MSG34	;'faulty memory'
	CALL	DISPLAY		;display it
;
DEAD	JP	DEAD
;
;	compare BC to (VBUFF) buffers
;
COMPARE	PUSH	HL		;save
	PUSH	DE		;save
	PUSH	BC		;save
	LD	D,B		;pass buffer to DE
	LD	E,C
	LD	HL,VBUFF	;HL = verify buffer
	LD	B,0		;256 bytes non-track 0
	LD	A,(IY+4)	;current track
	OR	A		;on zero?
	JR	NZ,COMPLP	;nope, go!
	LD	B,128		;128 bytes track 0
;
COMPLP	LD	A,(DE)		;fetch a byte
	CP	(HL)		;same byte?
	JR	NZ,COMPRET	;nope, data mismatch!
	INC	DE		;bump buffers
	INC	HL
	DJNZ	COMPLP		;go for 256 bytes
COMPRET	POP	BC		;unstack
	POP	DE
	POP	HL
	RET			;return with Z status
;
BUILDTRK LD	HL,DORDER	;double density
	LD	A,(IY+4)	;get current track
	OR	A		;on track 0?
	LD	A,1		;sector length disk
	JR	NZ,FIGBUILD	;go if not
	LD	HL,SORDER	;single density track 0
	LD	A,0		;sector length track 0
;
FIGBUILD LD	(SLEN),A	;save sector length
	LD	C,(HL)		;get # sectors / track
	INC	HL		;bump table
	LD	E,(HL)		;fetch sector order table
	INC	HL		;bump table
	LD	D,(HL)		;get MSB sector order
	INC	HL		;bump
	CALL	ORDNEW		;rotate sector table
	PUSH	DE		;leave sectors on stack
	LD	DE,BUFFER	;create track image here
	EX	DE,HL		;HL => build buffer
	CALL	MOVEIN		;gap 1
	CALL	MOVEIN		;index
	CALL	MOVEIN		;gap 1
	LD	(DESVE),DE	;save gap pointer
;
SECLP	CALL	MOVEIN		;gap 1 & 3
	CALL	MOVEIN		;gap 1 & 3
	LD	(HL),0FEH	;ID header
	INC	HL
	LD	A,(IY+4)	;get cylinder
	LD	(HL),A		;to buffer
	INC	HL
	LD	(HL),0		;side zero
	INC	HL
	EX	(SP),HL		;fetch sector table
	LD	A,(HL)		;get sector #
	INC	HL		;bump table
	EX	(SP),HL		;leave back on stack
	LD	(HL),A		;to buffer
	INC	HL
	LD	(HL),1		;sector length
SLEN	EQU	$-1
	INC	HL
	LD	(HL),0F7H	;generate CRC's
	INC	HL
	CALL	MOVEIN		;gap 2
	CALL	MOVEIN		;gap 2
	CALL	MOVEIN		;gap 2
	LD	(HL),0FBH	;data header
	INC	HL
	CALL	FILLDATA	;fill sector data
	LD	(HL),0F7H	;generate CRC's
	INC	HL
	CALL	MOVEIN		;gap 3
	LD	DE,0		;fetch table start
DESVE	EQU	$-2
	DEC	C		;next sector
	JR	NZ,SECLP	;finish this track
	INC	SP		;remove table from stack
	INC	SP
	DEC	DE		;get fill byte
	LD	A,(DE)		;fetch it
	JP	FILL		;fill remainder of track
;
SORDER	DEFB	27		;# sectors track 0
	DEFW	ORDERS		;sector order on track
;
	DEFB	11,0FFH		;gap 1
	DEFB	01,0FCH		;gap 1
	DEFB	20,0FFH		;gap 1
;
	DEFB	03,000H		;gap 1 & 3
	DEFB	03,000H		;gap 1 & 3
;
	DEFB	11,0FFH		;gap 2
	DEFB	03,000H		;gap 2
	DEFB	03,000H		;gap 2
;
	DEFB	11,0FFH		;gap 3
;
	DEFB	00,0FFH		;gap 4
	DEFB	00,0FFH		;gap 4
;
ORDERS	DEFB	00,09,18,01,10,19,02,11,20,03,12,21,04,13
	DEFB	22,05,14,23,06,15,24,07,16,25,08,17,26
;
DORDER	DEFB	30		;sectors / track
	DEFW	ORDERD		;sector order table
;
	DEFB	22,04EH		;gap 1
	DEFB	01,0FCH		;gap 1
	DEFB	40,04EH		;gap 1
;
	DEFB	08,000H		;gap 1 & 3
	DEFB	03,0F5H		;gap 1 & 3
;
	DEFB	22,04EH		;gap 2
	DEFB	12,000H		;gap 2
	DEFB	03,0F5H		;gap 2
;
	DEFB	24,04EH		;gap 3
;
	DEFB	00,04EH		;gap 4
	DEFB	00,04EH		;gap 4
;
ORDERD	DEFB	00,10,20,01,11,21,02,12,22,03
	DEFB	13,23,04,14,24,05,15,25,06,16
	DEFB	26,07,17,27,08,18,28,09,19,29
;
MOVEIN	LD	A,(DE)		;fetch fill length
	INC	DE		;bump table
	LD	B,A		;B = length to fill
	LD	A,(DE)		;fetch fill byte
	INC	DE		;bump table
;
FILL	LD	(HL),A		;pass byte to buffer
	INC	HL		;bump buffer pointer
	DJNZ	FILL		;fill for B length
	RET			;done
;
FILLDATA LD	A,(IY+4)	;get current track
	OR	A		;on track 0?
	LD	A,128		;256 bytes disk sectors
	PUSH	BC		;save it
	LD	BC,6DB6H	;fill pattern
	JR	NZ,FILLA	;go if not track 0
	LD	BC,0E5E5H	;single density fill
	LD	A,64		;128 byte sectors on 0
;
FILLA	LD	(HL),B		;MSB to buffer
	INC	HL		;bump buff pointer
	LD	(HL),C		;LSB to buffer
	INC	HL		;bump pointer
	DEC	A		;less counter
	JR	NZ,FILLA	;finish if more to do
	POP	BC		;unstack
	RET			;sector data filled
;
;	remove extraneous data for format build
;
ZBUFF	LD	HL,BUFFER	;build buffer
	LD	DE,BUFFER+1	;start +1
	LD	BC,-1-BUFFER	;length of free ram
	LD	(HL),0		;clear byte to zero
	LDIR			;clear all bytes to zeros
	RET			;buffer is clean
;
;	convert binary A to CA decimal ascii
;
ASCII	LD	C,'0'		;starting MSB digit
;
ASC1	SUB	10		;remove 10's place
	JR	C,ASC2		;go if found
	INC	C		;bump ascii
	JR	ASC1		;try again
;
ASC2	ADD	A,'0'+10	;last sub + ascii
	RET			;CA = decimal ascii
;
;	compute serial numbers
;
SERIALNOS
	LD	A,(IY+3)	;get serial # flag
	CP	'*'		;serial #'s on?
	RET	Z		;nope, skip it
;
	CP	'Y'		;auto serial #'s?
	JR	Z,DOAUTO	;yes, go auto
;
;	fetch each serial # from operator
;
	XOR	A		;set drive 0
	LD	(IY+2),A	;save current drive
;
SERLP	LD	HL,DRIVES	;active drive table
	ADD	A,L		;add offset to curr drive
	LD	L,A		;HL => drive entry
	LD	A,(HL)		;fetch flag
	INC	A		;FF = active?
	CALL	Z,GETSER	;yes, get serial #
	INC	(IY+2)		;bump current drive #
	LD	A,(IY+2)	;fetch result
	CP	4		;0-3?
	JR	C,SERLP		;go if more
	RET			;all serial #'s loaded
;
;	compute serial #'s automatically
;
DOAUTO	XOR	A		;set drive 0
	LD	(IY+2),A	;set current drive
;
AUTOLP	LD	HL,DRIVES	;active drive table
	ADD	A,L		;add curr drive offset
	LD	L,A		;HL => drive flag
	LD	A,(HL)		;fetch flag
	INC	A		;active drive?
	CALL	Z,ASERIAL	;get serial # if yes
	INC	(IY+2)		;bump current drive
	LD	A,(IY+2)	;fetch result
	CP	4		;0-3?
	JR	C,AUTOLP	;go if more to do
	RET			;all serial #'s computed
;
;	fetch serial # and increment for next
;
ASERIAL	CALL	FSER		;get table pointer
	LD	HL,SERX		;current serial #
	LD	C,(IY+15)	;get serial # length
	LD	B,0		;BC = length
	PUSH	BC		;save length
	LDIR			;move current => drive
	POP	BC		;BC = serial # length
	LD	HL,SERX		;current serial #
	DEC	BC		;length -1
	ADD	HL,BC		;HL => last digit
	LD	B,C		;B = remaining length
;
NEWSER	LD	A,(HL)		;fetch serial # byte
	INC	A		;increment it
	LD	(HL),A		;back to the buffer
	CP	'9'+1		;still numeric?
	RET	C		;yes, return
	LD	(HL),'0'	;reset byte
	DEC	HL		;point to next MSB digit
	DJNZ	NEWSER		;finish it off
	RET			;number incremented
;
;	fetch serial # from operator
;
GETSER	LD	A,(IY+2)	;get current drive
	ADD	A,'0'		;make it ascii
	LD	(MSG38A),A	;to prompt text
	LD	HL,MSG38	;start of message
	CALL	DISPLAY		;display it
	LD	B,(IY+15)	;get serial # length
	CALL	GETSTR		;get keyboard input
	LD	A,B		;fetch length
	CP	(IY+15)		;correct length?
	JR	NZ,GETSER	;nope, ask again
	CALL	FSER		;fetch buffer address
	LD	C,B		;C = length
	LD	B,0		;BC = length
	LDIR			;move input to table
	RET			;serial # loaded
;
;	insert serial # on all active drives
;
PUTSERIAL LD	A,(IY+3)	;get serial # flag
	CP	'*'		;serial #'s ON?
	RET	Z		;nope, skip it
;
	LD	HL,MSG39	;'installing numbers'
	CALL	DISPLAY		;display it
	XOR	A		;set drive 0
	LD	(IY+2),A	;set current drive
;
PUTSLP	LD	HL,XDRIVES	;active drive table
	ADD	A,L		;add offset for drive
	LD	L,A		;HL => entry for drive
	LD	A,(HL)		;fetch flag
	INC	A		;FF = active?
	CALL	Z,THISONE	;yes, write serial #
	INC	(IY+2)		;bump current drive
	LD	A,(IY+2)	;fetch result
	CP	4		;0-3?
	JR	C,PUTSLP	;go if more
	RET			;serial #'s installed!
;
;	insert serial # on current drive
;
THISONE	LD	A,(IY+2)	;get current drive
	CALL	SETDRV		;setup for I/O
	LD	BC,BUFFER	;I/O buffer to use
	LD	D,(IY+11)	;track for serial #
	LD	E,(IY+12)	;sector for serial #
	LD	(IY+4),D	;set current track
	CALL	READ		;read the sector
	JP	NZ,REMREAD	;error, remove from que!
	CALL	DOTHIS		;insert number in buffer
	LD	A,0		;get type of DAM read
DAM	EQU	$-1
	LD	(DAMBUFF),A	;save into buffer
	ADD	A,$DWRITE	;create write command
	LD	(WRTYPE),A	;save type of write
	CALL	WRITE		;write the sector
	JP	NZ,REMWRITE	;error, remove from que!
;
	LD	A,(IY+0)	;get verify flag
	CP	'Y'		;verify on?
	JR	NZ,SKSVER	;nope, skip verify
	PUSH	BC		;save I/O buffer
	LD	BC,VBUFF	;verify buffer
	CALL	READ		;read the sector back
	POP	BC		;BC = original buffer
	JP	NZ,REMREAD	;error, remove drive
	CALL	COMPARE		;else compare sectors
	JR	NZ,SKSBB	;data mismatch!
	LD	A,(DAM)		;get DAM byte
	LD	L,A		;save for test
	LD	A,(DAMBUFF)	;get original byte
	CP	L		;match?
	JR	Z,SKSVER	;yes, go!
;
SKSBB	LD	HL,MSG35	;'data mismatch'
	PUSH	HL		;setup stack for error
	JP	REMDRIVE	;display & remove drive
;
SKSVER	RET			;done, number installed!
;
;	insert serial # into I/O buffer
;
DOTHIS	PUSH	DE		;save track/sector
	PUSH	BC		;save buff pointer
	CALL	FSER		;load DE with serial #
	EX	DE,HL		;HL => drives number
	LD	DE,BUFFER	;I/O buffer
	LD	E,(IY+13)	;byte offset for number
	LD	C,(IY+15)	;get serial # length
	LD	B,0		;BC = length
	LDIR			;move serial # to buffer
	POP	BC		;unstack 'em
	POP	DE
	RET			;serial # installed
;
;	convert binary A to hex ascii CA
;
HEXCV	LD	B,A		;save original here
	RRCA			;align high=>low nybble
	RRCA
	RRCA
	RRCA
	CALL	HEXTST		;create hex nybble
	LD	C,A		;C = MSB digit
	LD	A,B		;fetch original
;
HEXTST	AND	0FH		;mask off high bits
	ADD	A,'0'		;create ascii
	CP	'9'+1		;digit 0-9?
	RET	C		;yes, return
	ADD	A,7		;adjust for A-F
	RET			;A = digit
;
;	move verify buffer to I/O buffer for retry
;
MOVBUF	PUSH	DE		;save track/sector
	PUSH	BC		;save buffer
	LD	D,B		;pass buffer to DE
	LD	E,C
	LD	HL,VBUFF	;verify buffer
	LD	BC,100H		;length
	LDIR			;move it!
	POP	BC		;unstack
	POP	DE
	RET			;done, VBUFF=>I/O buff
;
;	error on verify, re-write current sector
;
REWRITE	CALL	WRITE		;write the sector
	JP	NZ,REMWRITE	;error, abort!
	RET			;else OK
;
;	load GAT sector into memory for track skipping
;
READGAT	LD	A,(IY+1)	;get binary source drive
	CALL	SETDRV		;setup for I/O
	CALL	STAT		;check drive status
	JP	NZ,TERMINATE	;error, abort program
	LD	BC,BUFFER	;I/O buffer
	LD	DE,0		;read track 0/sector 0
	LD	(IY+4),D	;pass current track
	CALL	READ		;read the sector
	JP	NZ,TERMIN	;error, abort!
	PUSH	BC		;save I/O buffer
	LD	BC,VBUFF	;verify buffer
	CALL	READ		;read again
	POP	BC		;unstack
	JP	NZ,TERMIN	;error, go!
	CALL	COMPARE		;both the same?
	JR	NZ,READGAT	;nope, try again
	LD	A,(VBUFF+2)	;get directory track
	LD	D,A		;D = track
	LD	E,0		;sector 0
	LD	BC,GATBUFF	;storage buffer
	LD	(IY+4),D	;save current track
	CALL	READ		;read directory sector
	JP	NZ,TERMIN	;error, abort!
	PUSH	BC		;save buff pointer
	LD	BC,VBUFF	;verify buffer
	CALL	READ		;read again
	POP	BC		;restore buffer
	JP	NZ,TERMIN	;error, abort!
	CALL	COMPARE		;same data?
	JR	NZ,READGAT	;nope, try again
	RET			;else GAT loaded to RAM
;
;	rotate sector order table for skewing
;
ORDNEW	PUSH	BC		;save positions
	PUSH	DE
	PUSH	HL
	EX	DE,HL		;HL => sector table
	LD	B,8		;8 rotations / track
	DEC	C		;# sectors/track -1
;
ORDNEW1	PUSH	BC		;save counter
	LD	A,(HL)		;fetch table byte
	PUSH	HL		;save table start
	INC	HL		;bump table pointer
;
ORDNEW2	LD	E,(HL)		;get next byte
	LD	(HL),A		;insert last byte
	LD	A,E		;get new
	INC	HL		;bump pointer
	DEC	C		;less this sector
	JR	NZ,ORDNEW2	;finish off track
	POP	HL		;table start
	LD	(HL),A		;insert byte to 1st slot
	POP	BC		;unstack counter
	DJNZ	ORDNEW1		;for # skews to perform
	POP	HL		;unstack 'em
	POP	DE
	POP	BC
	RET			;sector table rotated
;
;	buffers
;
DBUFF	EQU	$&0FF00H	;last even page
GATBUFF	EQU	DBUFF+100H	;first even page free
;
DAMBUFF	EQU	GATBUFF+100H	;DAM storage buffer
VBUFF	EQU	DAMBUFF+100H	;verify I/O buffer
BUFFER	EQU	VBUFF+100H	;actual I/O buffer
;
