FIND   ; find/asm - kjw/bqsd - 07/82
 ;
 	TITLE	'<Dos+ II - Find/Replace Utility - A.00>'
 ;
 	ORG	2200H		;high overlay area
 ;
 BINDEC	EQU	21		;binary<=>decimal
 SETBRK	EQU	3		;setup break processor
 HLDKEY	EQU	29		;hold processor
 FDRV	EQU	89		;fetch drive spec
 FSPEC	EQU	84		;fetch file spec
 OPEN	EQU	40		;open file
 SERROR	EQU	39		;display error
 VIDKEY	EQU	12		;keyboard/video
 POSN	EQU	79		;position to record
 READNX	EQU	34		;read next record
 WRITNX	EQU	43		;write next record
 BINHEX	EQU	24		;binary<=>hex
 KBCHAR	EQU	4		;char from keyboard
 VDCHAR	EQU	8		;char to video
 ;
 SVC	EQU	08H		;execute SVC
 DISKIO	EQU	10H		;execute disk I/O
 OVLY	EQU	18H		;execute system overlay
 ;
 REGSAV	EQU	0303H		;save registers
 OVLYH	EQU	019DH		;high overlay in memory
 TOPMEM	EQU	0180H		;top of memory
 UCASE	EQU	031EH		;convert A to upper case
 LOCDCT	EQU	032DH		;locate DCT
 ;
 DCHECK	EQU	0		;check drive ready
 DREAD	EQU	3		;read sector
 DWRITE	EQU	5		;write sector
 ;
 NOTIN	EQU	58		;device not available
 ;
 	PAGE
 ;
 ;	program entry point
 ;
 ENTRY	LD	(STACK),SP	;save the stack
 	LD	A,-1
 	LD	(OVLYH),A
 ;
 	PUSH	HL		;save command pointer
 	LD	HL,HELLO	;sign on message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,0		;turn off break
 	LD	A,SETBRK	;SVC #
 	RST	SVC		;do it
 ;
 	LD	A,HLDKEY	;SVC #
 	LD	B,0		;turn off hold processor
 	RST	SVC		;do it
 ;
 	POP	HL		;restore pointer
 ;
 	XOR	A		;clear the flags
 	LD	(FLAGB),A	;save it
 ;
 ;	evaluate input parameters
 ;
 SCAN	CALL	POSHL		;position to a char
 	JP	C,APARMS	;nil, prompt for input
 ;
 	CP	'@'		;diplay matches?
 	JR	NZ,CNTSCN	;nope, continue
 ;
 	LD	A,-1		;set display flag
 	LD	(FLAGB),A	;save it
 	INC	HL		;bump pointer
 	JR	SCAN		;continue scan
 ;
 CNTSCN	CP	':'		;drive given?
 	JR	Z,ZAPDRV	;yes, do a drive
 ;
 	CP	'!'		;filespec force?
 	JP	Z,ZAPFIL-1	;yes, continue
 ;
 	PUSH	HL		;see if numerical
 	CALL	VALUE		;yes?
 	POP	HL		;restore pointer
 	JP	NZ,ZAPFIL	;nope, must be a file
 ;
 ;	looking through memory
 ;
 	CALL	VALUE		;get the start addr
 	JP	NZ,ERROR	;param error
 	LD	(ADDR1),BC	;save it
 ;
 	LD	BC,(TOPMEM)	;default end address
 	LD	(ADDR2),BC	;save it
 	LD	A,1		;set type of search
 	LD	(TYPE),A	;set the flag
 ;
 	CALL	POSHL		;more input?
 	JP	C,ASKSTR	;nope, prompt for string
 ;
 	CALL	CKSTR		;check for valid string
 	JP	Z,SCANSTR	;yes, scan it
 ;
 	CALL	VALUE		;check for end address
 	JP	NZ,ERROR	;param error
 	LD	(ADDR2),BC	;save end address
 ;
 	PAGE
 ;
 ;	data source scanned, check string
 ;
 CONT	CALL	POSHL		;get next char
 	JP	C,ASKSTR	;prompt if nil
 	CALL	CKSTR		;check if valid string
 	JP	Z,SCANSTR	;yes, go!
 	JP	MERROR		;nope, param error
 ;
 ;	searching through a drive
 ;
 ZAPDRV	INC	HL		;bump pointer to name
 	LD	A,FDRV		;SVC #
 	RST	SVC		;find the drive
 	JP	NZ,ERROR	;error, try again
 	SUB	8		;make it 0-7
 ;
 	LD	(DRIVE),A	;else save the drive
 	LD	A,2		;set type to DISK
 	LD	(TYPE),A	;save it
 ;
 ;	drive found, check track, sector, sector count
 ;
 	XOR	A		;set defaults
 	LD	(TRACK),A	;def track
 	LD	(SECTOR),A	;def sector
 ;
 	LD	BC,-1		;default bunch of sects
 	LD	(SCOUNT),BC	;sector count
 ;
 	CALL	POSHL		;any input?
 	JP	C,ASKSTR	;nope, prompt for string
 	CALL	CKSTR		;check for a string
 	JP	Z,SCANSTR	;it is, scan it
 	CALL	VALUE		;else get the value
 	JR	NZ,ERROR	;param error
 	LD	A,C		;get the LSB
 	LD	(TRACK),A	;save track
 ;
 	CALL	POSHL		;more?
 	JP	C,ASKSTR	;nope, get string
 	CALL	CKSTR		;is it a string?
 	JP	Z,SCANSTR	;yes, scan it
 	CALL	VALUE		;else get numeric
 	JR	NZ,ERROR	;param error
 	LD	A,C		;get LSB
 	LD	(SECTOR),A	;save sector
 ;
 	CALL	POSHL		;more?
 	JP	C,ASKSTR	;nope, get string
 	CALL	CKSTR		;is it a string?
 	JP	Z,SCANSTR	;yes, scan it
 	CALL	VALUE		;else get the value
 	JR	NZ,ERROR	;invalid, param error
 	LD	(SCOUNT),BC	;save sector count
 ;
 	JR	CONT		;have source, continue
 ;
 ;	looking through a file
 ;
 	INC	HL		;bump pointer from !
 ;
 ZAPFIL	LD	DE,DCB		;file DCB area
 	LD	A,FSPEC		;SVC #
 	RST	SVC		;fetch filespec
 	JR	NZ,ERROR	;bad, prompt again
 ;
 	PUSH	HL		;save string pointer
 	LD	HL,OLIST	;param list for OPEN
 	LD	A,OPEN		;SVC #
 	INC	DE		;actual DCB
 	RST	SVC		;open the file
 	POP	HL		;restore pointer
 	JR	NZ,ERROR	;bad, display why
 ;
 	LD	A,3		;set type of search
 	LD	(TYPE),A	;set flag
 ;
 	LD	BC,0		;default start sector
 	LD	(POSIT),BC	;file position
 ;
 	CALL	POSHL		;more input?
 	JR	C,ASKSTR	;nope, prompt for it
 	CALL	CKSTR		;is it a string?
 	JR	Z,SCANSTR	;yes, scan it
 ;
 	PUSH	HL		;save pointer
 	CALL	VALUE		;numeric?
 	POP	HL
 	JR	NZ,SCANSTR	;nope, must be string
 	CALL	VALUE		;else reposition
 	LD	(POSIT),BC	;save file start record
 	JP	CONT		;source done, continue
 ;
 	PAGE
 ;
 ;	error vectors
 ;
 MERROR	LD	A,47		;required param missing
 	JR	ERROR		;continue
 UERROR	POP	HL		;fix stack, string parse
 ;
 PERROR	LD	A,3		;parameter error
 ;
 ERROR	AND	7FH		;make sure it returns
 	LD	B,A		;pass here for SVC
 	LD	A,SERROR	;SVC #
 	RST	SVC		;display the error
 ;
 ;	prompt user for parameters
 ;
 APARMS	LD	HL,PMSG		;prompt string
 	LD	BC,1<8+255	;length + key length
 	LD	DE,STRING	;input buffer
 	LD	A,VIDKEY	;SVC #
 	RST	SVC		;display, fetch input
 ;
 	JR	NZ,ERROR	;error, display it
 	JP	C,TERMIN	;abort program, break
 ;
 	CALL	POSHL		;any input?
 	JP	NC,SCAN		;yes, check it out
 ;
 	LD	HL,HELP1	;help commands
 	CALL	DISPLAY		;display 'em
 	JR	APARMS		;ask again
 ;
 	PAGE
 ;
 ;	evaluate input string
 ;
 CKSTR	CP	27H		;single quote?
 	RET	Z		;yes, return Z
 	CP	'"'		;double quote?
 	RET	Z		;yes, return Z
 	CP	'#'		;byte/word list?
 	RET			;Z = yes, NZ = no string
 ;
 ;	prompt user to input string
 ;
 ASKSTR	LD	HL,STRMSG	;prompt message
 	LD	BC,1<8+255	;length + key input
 	LD	DE,STRING	;input buffer
 	LD	A,VIDKEY	;SVC #
 	RST	SVC		;display, fetch keys
 ;
 	JR	NZ,ERROR	;error, why
 	JP	C,TERMIN	;break, abort
 ;
 	CALL	POSHL		;any input?
 	JR	NC,SCANSTR	;yes, fetch it
 ;
 	LD	HL,HELP2	;help params
 	CALL	DISPLAY		;display 'em
 	JR	ASKSTR		;continue, ask again
 ;
 ;	evaluate input string
 ;
 SCANSTR	XOR	A		;clear out the params
 	LD	(STRLEN),A	;string length
 	LD	(REPLEN),A	;replacement length
 ;
 	LD	DE,SSTRING	;source string buffer
 	LD	BC,STRLEN	;point to flag
 	OR	80H		;set flag bit
 	LD	(FLAG),A	;save it
 	JR	SCANREP		;continue
 ;
 GETREPL	LD	BC,REPLEN	;replacement length
 	LD	DE,RSTRING	;replacement buffer
 	INC	HL		;bump pointer past mark
 ;
 ;
 SCANREP	CALL	POSHL		;position to next field
 	JP	C,SCANDON	;finished with scan
 ;
 	CP	27H		;single quote?
 	JR	Z,LITIND	;literal independent scan
 ;
 	CP	'"'		;double quote?
 	JR	Z,LITDEP	;literal dependent search
 ;
 	CP	'#'		;numerical list?
 	JR	Z,NUMIND	;yes, numerical independ
 ;
 	LD	A,0C0H		;set compare flags
 	LD	(FLAG),A	;save 'em
 	JR	QIND		;continue independ
 ;
 ;
 ;
 LITIND	LD	A,80H		;set literal flag
 	LD	(FLAG),A	;save it
 ;
 	INC	HL		;bump pointer
 INDLP	LD	A,(HL)		;fetch a byte
 	CP	'>'		;replace marker?
 	JR	Z,GETREPL	;yes, get it
 ;
 	CALL	CKTERM		;terminator?
 	JP	C,SCANDON	;done if yes
 ;
 	CP	27H		;string term?
 	JR	Z,STRDON	;yes, done
 ;
 	CALL	UCASE		;case indep, make it up
 	LD	(DE),A		;put it back
 	INC	DE		;bump pointer
 	LD	A,(BC)		;fetch length
 	INC	A		;+ 1
 	LD	(BC),A		;put it back
 	JR	INDLP-1		;continue
 ;
 ;	string completed
 ;
 STRDON	INC	HL		;bump pointer
 	CALL	POSHL		;position to next field
 	JP	C,SCANDON	;finished, continue
 ;
 	CP	'>'		;replace flag?
 	JR	Z,GETREPL	;yes, get it
 	JR	SCANREP		;get next field
 ;
 ;
 ;
 LITDEP	XOR	A		;set literal flags
 	LD	(FLAG),A	;save 'em
 ;
 	INC	HL		;bump pointer
 DEPLP	LD	A,(HL)		;fetch a character
 	CP	'>'		;replace flag?
 	JR	Z,GETREPL	;yes, get it
 ;
 	CALL	CKTERM		;terminator?
 	JR	C,SCANDON	;yes, finished
 ;
 	CP	'"'		;string terminator?
 	JR	Z,STRDON	;yes, check for repl
 ;
 	LD	(DE),A		;into buffer direct
 	INC	DE		;bump pointer
 	LD	A,(BC)		;fetch length
 	INC	A		;bump it
 	LD	(BC),A		;put it back
 	JR	DEPLP-1		;go next character
 ;
 ;
 ;
 QIND	LD	A,(HL)		;fetch a char
 	CP	'>'		;replace flag?
 	JR	Z,GETREPL	;yes, get it
 ;
 	CALL	CKTERM		;terminator?
 	JR	C,SCANDON	;yes, go!
 ;
 	CALL	UCASE		;make it upper case
 	LD	(DE),A		;put into buffer
 	INC	DE		;bump pointers
 	INC	HL		;input string
 	LD	A,(BC)		;fetch length
 	INC	A		;bump it
 	LD	(BC),A		;put it back
 	JR	QIND		;next char
 ;
 ;
 ;
 NUMIND	PUSH	HL		;save input pointer
 	LD	HL,FLAG		;flag byte
 	LD	(HL),0		;clear 'em all
 	POP	HL		;restore pointer
 ;
 	INC	HL		;next char
 	CP	(HL)		;two ##'s
 	JR	Z,WORDLIST-1	;yes, fetch words
 ;
 BYTELIST CALL	POSHL		;position to field
 	JR	C,SCANDON	;done, go!
 ;
 	CALL	CKSTR		;string start?
 	JP	Z,SCANREP
 ;
 	CP	'>'		;replace flag?
 	JP	Z,GETREPL	;yes, get it
 ;
 	PUSH	BC		;save len counter
 	CALL	VALUE		;fetch the value
 	JP	NZ,UERROR	;unstack, param error
 ;
 	LD	A,B		;check MSB
 	OR	A		;non-zero?
 	JP	NZ,UERROR	;yes, invalid byte
 ;
 	LD	A,C		;fetch the byte
 	LD	(DE),A		;put into buffer
 	INC	DE		;bump pointer
 ;
 	POP	BC		;get counter back
 	LD	A,(BC)		;fetch it
 	INC	A		;bump it
 	LD	(BC),A		;put it back
 	JR	BYTELIST	;next byte
 ;
 ;
 ;
 	INC	HL		;bump pointer
 WORDLIST CALL	POSHL		;position to field
 	JR	C,SCANDON	;nothing, done
 ;
 	CALL	CKSTR		;string start?
 	JP	Z,SCANREP	;yes, check next field
 ;
 	CP	'>'		;replace flag?
 	JP	Z,GETREPL	;yes, get it
 ;
 	PUSH	BC		;save counter
 	CALL	VALUE		;fetch the value
 	JP	NZ,UERROR	;pop the stack
 ;
 	LD	A,C		;get LSB
 	LD	(DE),A		;put in string
 	INC	DE		;bump pointer
 	LD	A,B		;get MSB
 	LD	(DE),A		;put in string
 	INC	DE		;bump it
 ;
 	POP	BC		;get counter byte
 	LD	A,(BC)		;fetch it
 	INC	A		;bump it
 	INC	A		;by 2 for word
 	LD	(BC),A		;put it back
 	JR	WORDLIST	;next word
 ;
 ;	all parameters scanned
 ;
 SCANDON	LD	A,0		;get length of string
 STRLEN	EQU	$-1
 	OR	A		;zero?
 	JR	NZ,SHOWSRC	;nope, display it
 ;
 	LD	HL,NULLMSG	;null string!
 	CALL	DISPLAY		;display it
 	JP	ASKSTR		;prompt for it
 ;
 ;
 SHOWSRC	LD	E,A		;need length here
 	LD	HL,SRCMSG	;source string message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,SSTRING	;source string buffer
 	CALL	SHOWIT		;display it
 ;
 	LD	A,0		;see if any replacement
 REPLEN	EQU	$-1
 	OR	A		;yes?
 	JR	NZ,SHOWDES	;yes, show it
 ;
 	LD	HL,NORMSG	;no replacement
 	CALL	DISPLAY		;display it
 	JP	PERFORM		;go!
 ;
 SHOWDES	LD	E,A		;save length here
 	LD	A,(STRLEN)	;get source length
 	CP	E		;test for repl length
 	JR	NC,CONTDES	;OK, continue
 ;
 	LD	E,A		;truncate to source len
 	LD	(REPLEN),A	;save it
 ;
 	CALL	ASCII		;make it ascii
 	LD	(REPLM),A	;put into string
 	LD	(REPLM+1),BC	;new length
 	LD	HL,TRUNMSG	;truncated message
 	CALL	DISPLAY		;display it
 ;
 CONTDES	LD	HL,DESMSG	;replacement message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,RSTRING	;replacement string
 	CALL	SHOWIT		;display it
 	JP	PERFORM		;go to it!
 ;
 ;	display a string in expanded format
 ;
 SHOWIT	LD	A,(FLAG)	;fetch flag byte
 	BIT	6,A		;numeric?
 	LD	A,(HL)		;fetch a byte
 	JR	Z,SHOWA		;yes, do it
 ;
 	CP	'?'		;wildcard?
 	JR	NZ,SHOWA	;nope, display it
 ;
 	PUSH	DE		;save
 	PUSH	HL
 	LD	HL,SHOWQST	;wild display
 	CALL	DISPLAY		;do it
 ;
 	POP	HL
 	JR	SHOWNEXT	;next byte
 ;
 SHOWA	CALL	HEXCV		;convert to HEX ascii
 	PUSH	DE		;set stack
 ;
 	LD	A,C		;send out characters
 	CALL	VOUT		;out to video
 	LD	A,B
 	CALL	VOUT
 	LD	A,'H'		;show as HEX
 	CALL	VOUT
 	LD	A,'='
 	CALL	VOUT
 ;
 	LD	A,(HL)		;fetch character
 	CP	20H		;displayable?
 	JR	C,DOPER		;nope, use default
 ;
 	CP	0C0H
 	JR	C,OKPER
 ;
 DOPER	LD	A,5FH		;default
 ;
 OKPER	CALL	VOUT		;send it out
 ;
 	LD	A,' '		;gap
 	CALL	VOUT
 	CALL	VOUT
 	CALL	VOUT
 ;
 SHOWNEXT INC	HL		;bump pointer
 	POP	DE		;restore stack
 	DEC	E		;less string length
 	JR	NZ,SHOWIT	;more?, go if yes
 	RET			;else done, return
 ;
 	PAGE
 ;
 ;	program exit vectors
 ;
 TERMIN	LD	HL,EXMSG	;exiting message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,ABMSG	;aborted
 	CALL	DISPLAY		;display it
 ;
 LEAVE	LD	SP,0		;reset stack
 STACK	EQU	$-2
 	XOR	A		;return ZERO
 	RET			;back to caller
 ;
 	PAGE
 ;
 ;	position HL to first significant character
 ;	return CARRY if it is a terminator byte
 ;
 	INC	HL		;bump pointer
 POSHL	LD	A,(HL)		;fetch a character
 ;
 	CP	' '		;separator?
 	JR	Z,POSHL-1	;skip if yes
 	CP	','		;sep?
 	JR	Z,POSHL-1	;yes, skip it
 ;
 CKTERM	CP	13		;terminator?
 	SCF
 	RET	Z		;yes, return
 	CP	';'		;term?
 	SCF
 	RET	Z		;yes, back
 	CP	3		;term?
 	SCF
 	RET	Z		;yes, go back
 ;
 	CP	A		;clear C, set Z
 	RET			;done
 ;
 ;
 VALUE	LD	A,1-1<4+13	;sys1, #13
 	RST	OVLY		;fetch it!
 ;
 	PAGE
 ;
 ;	disk I/O error monitor
 ;
 ;	ENT	A = error number
 ;
 ;	EXT	Z = SKIP
 ;		NZ = RETRY
 ;		BREAK abort directly to @TERMIN
 ;
 ;
 ;	bad write monitor
 ;
 BADWRT	LD	(ERRNO),A	;save error number
 	CALL	REGSAV		;save registers
 ;
 	LD	HL,BADWMSG	;bad write message
 	JR	DOBAD		;continue with common
 ;
 ;	read error monitor
 ;
 BADRD	LD	(ERRNO),A	;save number
 	SUB	56		;read sys sect?
 	RET	Z		;yes, skip error
 	DEC	A		;read del sect?
 	RET	Z		;yes, skip it
 ;
 	CALL	REGSAV		;save 'em
 	LD	HL,BADRMSG	;bad read message
 ;
 ;
 DOBAD	CALL	DISPLAY		;display message
 ;
 	LD	B,0		;fetch error number
 ERRNO	EQU	$-1
 	RES	7,B		;assure a return
 	LD	A,SERROR	;SVC #
 	RST	SVC		;display error
 ;
 ;	prompt for retry, skip, break
 ;
 GETBAD	LD	HL,ASKBAD	;prompt message
 	LD	BC,ASKBADL<8+1	;length + key input len
 	LD	DE,STRING	;input buff
 	LD	A,VIDKEY	;SVC #
 	RST	SVC		;display, input
 ;
 	JP	NZ,ERROR	;error, display it
 	JP	C,TERMIN	;abort
 ;
 	LD	A,(HL)		;fetch the key
 	CALL	UCASE		;make it upper
 ;
 	CP	'S'		;skip?
 	RET	Z		;yes, back
 ;
 	CP	'R'		;retry?
 	JR	NZ,GETBAD	;nope, error
 	OR	-1		;set NZ
 	RET			;done, return
 ;
 	PAGE
 ;
 ;	binary to ascii conversion
 ;
 ASCII	PUSH	HL		;save it
 	CALL	ASCI		;convert part
 	LD	H,B		;save LSB
 	PUSH	HL		;on stack
 ;
 	LD	A,C		;get MSB
 	SUB	'0'		;remove ascii
 	CALL	ASCI		;convert
 ;
 	LD	A,C		;fetch
 	CP	'0'		;leading zero?
 	JR	NZ,ASCIGO1	;no, continue
 	LD	A,' '		;else change to space
 ASCIGO1	POP	HL		;get LSB back
 	LD	C,B		;adjust digits
 	LD	B,H
 	POP	HL		;restore HL
 	RET			;return ACB = ascii dec.
 ;
 ASCI	LD	C,'0'		;start ascii
 ASCII1	SUB	10		;remove 10's place
 	JR	C,ASCII2	;have it, go!
 	INC	C		;bump ascii
 	JR	ASCII1		;continue
 ;
 ASCII2	ADD	A,'0'+10	;ascii + last subtract
 	LD	B,A		;return it here
 	RET			;done
 ;
 	PAGE
 ;
 ;	advance DE to the next sector
 ;
 NEXSEC	INC	E		;bump sector
 	LD	A,(IY+22)	;fetch top sector
 	SUB	E		;at end of cylinder?
 	RET	NZ		;nope, return
 ;
 	LD	E,A		;reset to 0
 	LD	A,D		;fetch track
 	CP	(IY+16)		;end of disk?
 	RET	NC		;don't bump if yes
 	INC	D		;else OK
 	RET			;done
 ;
 	PAGE
 ;
 ;	convert binary to HEX ascii
 ;
 HEXCV	LD	B,A		;save byte
 	RRCA			;align to low bits
 	RRCA
 	RRCA
 	RRCA
 	CALL	HEXTST		;convert to hex
 	LD	C,A		;save here
 ;
 	LD	A,B		;fetch again
 	CALL	HEXTST		;convert
 	LD	B,A		;return it here
 	RET			;done, CB = hex ascii
 ;
 HEXTST	AND	0FH		;mask high bits
 	ADD	A,'0'		;make it ascii
 	CP	'9'+1		;out of numeric range?
 	RET	C		;nope, OK
 	ADD	A,7		;adjust for A-F
 	RET			;done
 ;
 ;
 WRLNO	LD	A,BINDEC	;binary => decimal
 	LD	B,0		;direction flag
 	RST	SVC		;convert it
 	RET			;done
 ;
 	PAGE
 ;
 ;	begin proceedure
 ;
 PERFORM	LD	HL,0		;clear # matches
 	LD	(MATCHES),HL	;save it
 ;
 	LD	A,13		;send out a linefeed
 	CALL	VOUT		;display it
 ;
 	LD	A,0		;fetch the flag
 TYPE	EQU	$-1
 	DEC	A
 	JP	Z,SCANMEM	;scan memory
 ;
 	DEC	A
 	JP	Z,SCANDISK	;scan disk
 ;
 	DEC	A		;scan file
 	LD	A,47		;required not found
 	JP	NZ,ERROR	;show and prompt again
 ;
 	PAGE
 ;
 ;	looking through a file for matches
 ;
 SCANFILE LD	BC,0		;get file position
 POSIT	EQU	$-2
 	LD	DE,DCB+1	;DCB area
 	LD	A,POSN		;SVC #
 	RST	SVC		;position to file
 ;
 	JP	NZ,ERROR	;can't start it
 ;
 ;	loop for whole file
 ;
 FILELP	LD	BC,(POSIT)	;fetch posit
 	LD	DE,DCB+1	;DCB for file
 	LD	A,POSN		;SVC #
 	RST	SVC		;position to file
 ;
 	JR	Z,FILEOK	;no error, continue
 	CP	28		;end of file?
 	JP	Z,COMPLETE	;terminate if yes
 	CP	29		;out of range
 	JP	Z,COMPLETE	;yes, completed
 	JP	ERROR		;else display error
 ;
 FILEOK	LD	A,READNX	;SVC #
 	RST	SVC		;read it
 	CALL	NZ,BADRD	;error monitor if bad
 	JR	NZ,FILELP	;retry if asked for
 ;
 	XOR	A		;load zero
 	LD	(FLAGC),A	;set condition flag
 ;
 	CALL	IFMATCH3	;check for a match
 ;
 	LD	HL,(POSIT)	;get position
 	INC	HL		;bump it
 	LD	(POSIT),HL	;put it back
 	JR	FILELP		;continue
 ;
 ;
 IFMATCH3 CALL	PAUSE		;check for abort
 ;
 	LD	HL,IOBUFF	;disk I/O buffer
 	LD	DE,SSTRING	;source string
 	LD	A,(STRLEN)	;fetch string length
 	LD	C,A		;pass it here
 	XOR	A		;set 0
 	SUB	C		;get complement
 	LD	C,A		;put it back
 ;
 MAT3LP	PUSH	HL		;save pointers
 	PUSH	DE
 	LD	A,(STRLEN)	;string length
 	LD	B,A		;pass it here
 	CALL	COMPARE		;compare 'em
 	POP	DE		;unstack
 	POP	HL
 	JR	NZ,NOTMAT3	;no match, continue
 ;
 	LD	A,(FLAGB)	;check if to be displayed
 	OR	A		;zero?
 	JR	Z,M3CONT	;yes, don't display
 ;
 	PUSH	HL		;save again
 	PUSH	BC
 	LD	A,L		;get relative byte
 	CALL	HEXCV		;convert to hex
 	LD	(FMN2),BC	;to the string
 ;
 	PUSH	DE		;save it
 	LD	DE,(POSIT)	;get file position
 	LD	HL,FMN1		;string
 	CALL	WRLNO		;move ascii to string
 	LD	HL,FMMG		;message
 	CALL	DISPLAY		;display it
 	POP	DE		;unstack
 	POP	BC
 	POP	HL
 ;
 ;
 M3CONT	PUSH	HL		;save pointer
 	LD	HL,(MATCHES)	;get # matches
 	INC	HL		;bump it
 	LD	(MATCHES),HL	;put it back
 	POP	HL		;restore
 ;
 	LD	A,(REPLEN)	;check if replacement
 	OR	A		;yes?
 	JR	Z,NOTMAT3	;nope, skip it
 ;
 	PUSH	HL		;move replacement string
 	PUSH	DE		;over the source string
 	PUSH	BC
 	EX	DE,HL
 	LD	HL,RSTRING	;replacement string
 	LD	C,A
 	LD	B,0
 	LDIR			;move it in
 	POP	BC
 	POP	DE
 	POP	HL
 	LD	A,(FLAGC)	;get matches this sector
 	INC	A		;bump it
 	LD	(FLAGC),A	;put it back
 ;
 ;
 NOTMAT3	INC	HL		;bump data pointer
 	DEC	C		;less real length
 	JR	NZ,MAT3LP	;go more if not done
 ;
 	LD	A,(FLAGC)	;see if update flag set
 	OR	A		;zero?
 	RET	Z		;yes, skip it
 ;
 ;
 WRTGAN	LD	BC,(POSIT)	;get file position
 	LD	DE,DCB+1	;file DCB
 	LD	A,POSN		;SVC #
 	RST	SVC		;position it
 	JP	NZ,ERROR	;error, abort
 ;
 	LD	A,WRITNX	;write next record
 	RST	SVC		;do it
 	CALL	NZ,BADWRT	;error monitor if bad
 	JR	NZ,WRTGAN	;try again
 	RET			;else return
 ;
 	PAGE
 ;
 ;	scanning memory
 ;
 SCANMEM	LD	DE,(ADDR1)	;get low address
 	LD	HL,SCM1		;string address
 	LD	B,0		;direction flag
 	LD	A,BINHEX	;SVC #
 	RST	SVC		;move hex to string
 ;
 	LD	DE,(ADDR2)	;get high address
 	LD	HL,SCM2		;text area
 	LD	A,BINHEX	;SVC #
 	LD	B,0		;direction flag
 	RST	SVC		;move it in
 ;
 	LD	HL,SCMM		;source match message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,0		;fetch top mem addr
 ADDR2	EQU	$-2
 	LD	DE,0		;fetch low mem addr
 ADDR1	EQU	$-2
 	OR	A		;clear carry
 	SBC	HL,DE		;fetch length
 ;
 	LD	BC,(STRLEN)	;load C with length
 	LD	B,0		;BC = string length
 	OR	A		;clear carry
 	SBC	HL,BC		;HL = buffer length
 	LD	B,H		;give to BC
 	LD	C,L		;BC = # bytes to check
 ;
 	LD	HL,(STRLEN)	;get string length
 	LD	A,(REPLEN)	;replacement length
 	LD	H,A		;H = source, L = repl
 	EX	DE,HL		;DE = length bytes
 ;
 ;
 MEMLP	PUSH	HL		;save pointers
 	PUSH	DE
 	PUSH	BC
 ;
 	CALL	IFMATCH1	;match here?
 	POP	BC
 	POP	DE
 	POP	HL
 ;
 	INC	HL		;bump memory pointer
 	DEC	BC		;less counter
 	LD	A,B		;any more?
 	OR	C
 	JR	NZ,MEMLP	;yes, continue
 ;
 	PAGE
 ;
 ;	program completed
 ;	display matches and exit
 ;
 COMPLETE LD	DE,0		;get number matches
 MATCHES	EQU	$-2
 	LD	HL,MATCNT	;where in string
 	CALL	WRLNO		;move it in
 ;
 	LD	HL,MATMSG	;message text
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,EXMSG+1	;exiting message
 	CALL	DISPLAY		;display it
 ;
 	LD	HL,FINMSG	;completed
 	CALL	DISPLAY		;display it
 	JP	LEAVE		;exit program ZERO
 ;
 ;
 ;
 IFMATCH1 CALL	PAUSE		;check for BREAK
 ;
 	LD	B,E		;pass parameters
 	LD	C,D
 	LD	DE,SSTRING	;source string
 	PUSH	HL		;save pointer
 	CALL	COMPARE		;match?
 	POP	HL		;unstack
 	RET	NZ		;nope, not this one
 ;
 	LD	DE,(MATCHES)	;fetch # matches
 	INC	DE		;bump it
 	LD	(MATCHES),DE	;put it back
 ;
 	LD	A,0		;get display flag
 FLAGB	EQU	$-1
 	OR	A		;zero?
 	JR	Z,CONTMT1	;yes, don't display
 ;
 	PUSH	BC		;save from ascii
 	LD	A,H		;get memory address
 	CALL	HEXCV		;to hex
 	LD	(MMEMN),BC	;to the string
 	LD	A,L		;get LSB address
 	CALL	HEXCV		;to hex
 	LD	(MMEMN+2),BC	;to the string
 ;
 	PUSH	HL		;save it
 	LD	HL,MMEM		;memory match
 	CALL	DISPLAY		;display it
 	POP	HL
 ;
 	POP	BC		;unstack
 ;
 CONTMT1	LD	A,C		;replacement?
 	OR	A		;zero?
 	RET	Z		;no, done
 ;
 ;
 	EX	DE,HL		;swap pointers
 	LD	HL,RSTRING	;replacement string
 	LD	B,0		;BC = length
 	LDIR			;move it in
 	RET			;done
 ;
 ;
 COMPARE	LD	A,0		;fetch flags
 FLAG	EQU	$-1
 	BIT	6,A		;wild allowed?
 	JR	NZ,QCOMPARE	;yes, go
 ;
 	BIT	7,A		;independent case?
 	JR	NZ,ACOMPARE	;yes, go
 ;
 COMPLP	LD	A,(DE)		;fetch a byte
 	CP	(HL)		;exact?
 	RET	NZ		;nope, return
 ;
 	INC	DE		;bump pointers
 	INC	HL
 	DJNZ	COMPLP		;more?
 	RET			;done, return Z
 ;
 QCOMPARE BIT	7,A		;with case convert?
 	JR	NZ,QACOMPAR	;yes, go
 ;
 AQCOMP	LD	A,(DE)		;fetch a byte
 	CP	'?'		;wild?
 	JR	Z,SKPQ		;yes, force match
 	CP	(HL)		;exact match?
 	RET	NZ		;nope, return
 ;
 SKPQ	INC	DE		;bump pointers
 	INC	HL
 	DJNZ	AQCOMP		;more?
 	RET			;done, return Z
 ;
 QACOMPAR LD	A,(DE)		;fetch a byte
 	CP	'?'		;wild?
 	JR	Z,SKPQA		;yes, match
 	LD	A,(HL)		;fetch string byte
 	CALL	UCASE		;make it upper
 	EX	DE,HL		;swap pointers
 	CP	(HL)		;match?
 	EX	DE,HL		;put 'em back
 	RET	NZ		;nope, return
 ;
 SKPQA	INC	DE		;bump pointers
 	INC	HL
 	DJNZ	QACOMPAR	;more?
 	RET			;done, return Z
 ;
 ACOMPARE LD	A,(HL)		;fetch a byte
 	CALL	UCASE		;make it upper
 	EX	DE,HL		;swap pointers
 	CP	(HL)		;same?
 	EX	DE,HL		;put 'em back
 	RET	NZ		;nope, return
 ;
 	INC	HL		;bump pointers
 	INC	DE
 	DJNZ	ACOMPARE	;go more?
 	RET			;done, return Z
 ;
 	PAGE
 ;
 ;	check for PAUSE
 ;
 PAUSE	LD	A,KBCHAR	;SVC #
 	RST	SVC		;fetch a key
 	RET	NZ		;nothing, return
 ;
 	LD	A,B		;fetch the char
 	CP	3		;break?
 	JP	Z,TERMIN	;yes, abort
 ;
 	OR	A		;hold?
 	RET	NZ		;nope, return
 ;
 PUAWT	LD	A,KBCHAR	;SVC #
 	RST	SVC		;get a key
 	JR	NZ,PUAWT	;wait here for it
 ;
 	LD	A,B		;fetch key
 	CP	3		;break?
 	JP	Z,TERMIN	;yes, abort
 	OR	A		;hold?
 	JR	NZ,PUAWT	;wait if not
 	RET			;else done
 ;
 	PAGE
 ;
 ;	looking through disk for string
 ;
 SCANDISK LD	A,(DRIVE)	;fetch the drive
 	LD	C,A		;need it here
 	CALL	LOCDCT		;locate the DCT
 ;
 	LD	A,DCHECK	;check drive
 	RST	DISKIO		;check out the drive
 	LD	A,NOTIN		;drive not in system
 	JP	NZ,ERROR	;error, abort
 ;
 	LD	BC,0		;fetch # sectors
 SCOUNT	EQU	$-2
 ;
 ;
 DISKLP	PUSH	BC		;save counter
 	LD	C,0		;fetch drive
 DRIVE	EQU	$-1
 	LD	B,0		;high sector
 	LD	DE,0		;fetch track/sector
 SECTOR	EQU	$-2
 TRACK	EQU	$-1
 ;
 	LD	HL,IOBUFF	;I/O disk buffer
 	LD	A,DREAD		;disk command
 	RST	DISKIO		;read it
 	POP	BC
 ;
 	CALL	NZ,BADRD	;read error, go monitor
 	JR	NZ,DISKLP	;read it again
 ;
 	PUSH	BC		;save 'em
 	PUSH	DE
 ;
 	XOR	A		;clear update flag
 	LD	(FLAGC),A	;save it
 	CALL	IFMATCH2	;check for a match
 	POP	DE		;unstack
 	POP	BC
 ;
 	DEC	BC		;any more sectors?
 	LD	A,B
 	OR	C
 	JP	Z,COMPLETE	;nope, done
 ;
 	CALL	NEXSEC		;advance next sector
 	LD	(SECTOR),DE	;save new sector
 	JP	Z,COMPLETE	;end of disk, done
 	JR	DISKLP		;else continue
 ;
 ;
 IFMATCH2 CALL	PAUSE		;check for BREAK
 	LD	HL,IOBUFF	;where data is
 	LD	DE,SSTRING	;source string
 	LD	A,(STRLEN)	;string length
 	LD	C,A		;need it here
 	XOR	A		;fetch 0-C
 	SUB	C
 	LD	C,A		;put it back
 ;
 MAT2LP	PUSH	HL		;save 'em
 	PUSH	DE
 	LD	A,(STRLEN)	;string length
 	LD	B,A
 	CALL	COMPARE		;compare 'em
 	POP	DE
 	POP	HL
 ;
 	JR	NZ,NOTMAT2	;no match, continue
 ;
 	LD	A,(FLAGB)	;display the match?
 	OR	A		;zero?
 	JR	Z,M2CONT	;yes, don't display
 ;
 	PUSH	HL		;save
 	PUSH	BC
 	LD	A,(DRIVE)	;get drive
 	ADD	A,'0'		;make it ascii
 	LD	(M2DR),A	;to the string
 ;
 	LD	A,(TRACK)	;get track
 	CALL	ASCII		;make it ascii
 	LD	(M2TR),A	;to the string
 	LD	(M2TR+1),BC
 ;
 	LD	A,(SECTOR)	;fetch sector
 	CALL	ASCII		;to ascii
 	LD	(M2SC),A	;to the string
 	LD	(M2SC+1),BC
 ;
 	LD	A,L		;get relative byte
 	CALL	HEXCV		;to hex
 	LD	(M2BT),BC	;to the string
 ;
 	LD	HL,M2MSG	;msg to display
 	CALL	DISPLAY		;display it
 	POP	BC		;unstack
 	POP	HL
 ;
 M2CONT	PUSH	HL		;save
 	LD	HL,(MATCHES)	;bump # matches
 	INC	HL
 	LD	(MATCHES),HL	;put it back
 	POP	HL
 ;
 	LD	A,(REPLEN)	;any replacement?
 	OR	A		;zero?
 	JR	Z,NOTMAT2	;yes, don't
 ;
 	PUSH	HL		;save 'em
 	PUSH	DE
 	PUSH	BC
 	EX	DE,HL		;swap
 	LD	HL,RSTRING	;replacement string
 	LD	C,A
 	LD	B,0
 	LDIR			;move it in
 ;
 	POP	BC
 	POP	DE
 	POP	HL
 ;
 	LD	A,(FLAGC)	;bump # matches this sect
 	INC	A
 	LD	(FLAGC),A	;put it back
 ;
 NOTMAT2	INC	HL		;bump pointer
 	DEC	C		;more?
 	JR	NZ,MAT2LP	;yes, go
 ;
 	LD	A,0		;see if to be updated
 FLAGC	EQU	$-1
 	OR	A		;zero matches?
 	RET	Z		;yes, no need to write
 ;
 WRAGN	LD	DE,(SECTOR)	;get sector
 	LD	HL,IOBUFF	;I/O buffer
 	LD	A,(DRIVE)	;get drive
 	LD	C,A		;need it here
 	LD	B,0		;sect offset
 ;
 	LD	A,D		;get track
 	CP	(IY+19)		;directory?
 	JR	Z,NOTIDR	;yes, don't do it
 ;
 	LD	A,DWRITE	;sector write
 	RST	DISKIO		;write it out
 	CALL	NZ,BADWRT	;error monitor
 	JR	NZ,WRAGN	;retry
 	RET			;else done
 ;
 ;
 NOTIDR	PUSH	HL		;save it
 	LD	HL,NOTDIRM	;message
 	CALL	DISPLAY		;display it
 	POP	HL
 	RET			;done
 ;
 	PAGE
 ;
 ;	display driver
 ;
 DISPLAY	PUSH	BC		;save 'em
 	PUSH	HL
 ;
 DISPLP	LD	A,(HL)		;fetch a char
 	INC	A		;term?
 	JR	Z,DISPDN	;yes, done
 	DEC	A		;put it back
 ;
 	CALL	VOUT		;display it
 	INC	HL		;bump pointer
 	JR	DISPLP		;do more
 ;
 DISPDN	POP	HL		;unstack
 	POP	BC
 	JP	PAUSE		;check for pause
 ;
 ;
 VOUT	PUSH	AF		;save the char
 	LD	B,A		;give to B
 	LD	A,VDCHAR	;display driver
 	RST	SVC		;display it
 	POP	AF		;restore char
 	RET			;done
 ;
 	PAGE
 ;
 ;	parameter list for file OPEN
 ;
 OLIST	DEFW	IOBUFF
 	DEFW	IOBUFF
 	DEFW	0000H
 	DEFB	'R'
 	DEFB	0
 	DEFB	'F'
 	DEFB	0
 	DEFB	0
 ;
 ;	text area
 ;
 ;##
 SHOWQST	DEFM	'???=?   '
 	DEFB	-1
 ;
 FMMG	DEFM	'File Match @ Relative Sector '
 FMN1	DEFM	'xxxxx, Relative Byte '
 FMN2	DEFM	'xxH'
 	DEFB	13
 	DEFB	-1
 ;
 SCMM	DEFB	13
 	DEFM	'Searching Memory From '
 SCM1	DEFM	'xxxxH - '
 SCM2	DEFM	'xxxxH'
 	DEFB	13
 	DEFB	-1
 ;
 NOTDIRM	DEFM	'On Directory, Not Updating'
 	DEFB	13
 	DEFB	-1
 ;
 M2MSG	DEFM	'Disk Match, Drive '
 M2DR	DEFM	'x, Cylinder'
 M2TR	DEFM	'xxx, Sector'
 M2SC	DEFM	'xxx, Relative Byte '
 M2BT	DEFM	'xxH'
 	DEFB	13
 	DEFB	-1
 ;
 MMEM	DEFM	'Memory Match at '
 MMEMN	DEFM	'xxxxH.          '
 	DEFB	-1
 ;
 MATMSG	DEFB	13
 MATCNT	DEFM	'xxxxx total matches'
 	DEFB	13
 	DEFB	-1
 ;
 NORMSG	DEFM	'No Replacement'
 	DEFB	13
 	DEFB	-1
 ;
 NULLMSG	DEFM	'Null String'
 	DEFB	13
 	DEFB	-1
 ;
 SRCMSG	DEFM	'Source:'
 	DEFB	13
 	DEFB	-1
 ;
 DESMSG	DEFM	'Replacement:'
 	DEFB	13
 	DEFB	-1
 ;
 TRUNMSG	DEFB	13
 	DEFM	'Replacement Too Long, Truncated To '
 REPLM	DEFM	'xxx Characters'
 	DEFB	13
 	DEFB	-1
 ;
 STRMSG	DEFB	'#'
 ;
 HELP1	DEFB	13
 	DEFM	'@,:a,b,c,d,s,>t'
 	DEFB	13
 	DEFM	'@,filespec,eeee,s,>t'
 	DEFB	13
 	DEFM	'@,ffff,gggg,s,>t'
 	DEFB	13
 	DEFM	'(@ = display matches)
 	DEFB	13
 	DEFM	':a,b,c,d      = '
 	DEFM	'Drive, Cylinder, Sector, Sector Count'
 	DEFB	13
 	DEFM	'filespec,eeee = '
 	DEFM	'Filespec starting at '
 	DEFM	'eeee relative sector'
 	DEFB	13
 	DEFM	'ffff,gggg     = '
 	DEFM	'Memory Start, End Addresses'
 	DEFB	13
 	DEFM	's              = string to locate'
 	DEFB	13
 	DEFM	'>t             = '
 	DEFM	'replacement string'
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 ;
 HELP2	DEFM	'string    = "abcde????fgh" = '
 	DEFM	'literal, case depend'
 	DEFB	13
 	DEFM	'          = '
 	DEFB	27H
 	DEFM	'abcde????fgh'
 	DEFB	27H
 	DEFM	' = '
 	DEFM	'literal, case independ'
 	DEFB	13
 	DEFM	'          = abcde????fgh   = '
 	DEFM	'? matches anything, case independ'
 	DEFB	13
 	DEFM	'          = # a,b,c,...    = '
 	DEFM	'byte list (1 byte each)'
 	DEFB	13
 	DEFM	'          = ## a,b,c,...   = '
 	DEFM	'word list (2 bytes each)'
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 ;
 EXMSG	DEFB	13
 	DEFM	'FIND '
 	DEFB	-1
 ;
 ABMSG	DEFM	'* Aborted *'
 	DEFB	13
 	DEFB	-1
 ;
 FINMSG	DEFM	'* Completed *'
 	DEFB	13
 	DEFB	-1
 ;
 ASKBAD	DEFM	'R>etry, S>kip, <BREAK> ? '
 ASKBADL	EQU	$-ASKBAD
 ;
 BADRMSG	DEFM	'Disk READ Error !'
 	DEFB	13
 	DEFB	-1
 ;
 BADWMSG	DEFM	'Disk WRITE Error'
 	DEFB	13
 	DEFB	-1
 ;
 HELLO	DEFB	13
 	DEFM	'FIND - '
 	DEFM	'DosPLUS II Find/Replace Utility - '
 	DEFM	'Series A.00'
 	DEFB	13
 	DEFM	'(c)(p) 1982 by MicroPower, Inc.'
 	DEFB	13
 	DEFB	13
 	DEFB	13
 	DEFB	-1
 ;
 PMSG	DEFB	'*'
 ;
 DCB	DEFS	50		;file DCB area
 DBUFF	EQU	$&0FF00H
 STRING	EQU	DBUFF+100H	;lowest even page
 SSTRING	EQU	STRING+100H	;source string
 RSTRING	EQU	STRING+200H	;replacement string
 IOBUFF	EQU	STRING+300H	;disk I/O buffer
 ;
 	END	ENTRY
