; hboot2/asm - sjp/mss - 08/82
;
	TITLE	'<DOS+ II.A - Model II Bootstrap loader>'
;
;	Created: 26-AUG-82	SJP/MSS
;
;	HARD DISK CMDS & ADDRESSING
;
CTC	EQU	0C1H		;HDC CTC
HD@D	EQU	0C8H		;HDC DATA REGISTER
HD@S	EQU	0CBH		;HDC SECTOR REGISTER
HD@L	EQU	0CCH		;HDC CYL LOW
HD@H	EQU	0CDH		;HDC CYL HIGH
HD@Q	EQU	0CEH		;HDC SIZE/HEAD/DRIVE
HD@C	EQU	0CFH		;HDC COMMAND/STATUS
DRSL	EQU	0EFH		;DRIVE,MODE,SIDE SEL
ROME	EQU	0F9H		;ROM ENABLE/DISABLE
;
HHOME	EQU	00010000B	;HDC HOME
HREAD	EQU	00100000B	;HDC READ
;
;	LOCAL VARIABLE EQUIVALENCES
;
OFL	EQU	0+3		;FLAGS OFFSET DCT
OST	EQU	3+3		;SEC/TRK OFFSET DCT
ODL	EQU	5+3		;DIR LOC OFFSET DCT
OSG	EQU	6+3		;SEC/GRAN OFFSET DCT
OSC	EQU	8+3		;SEC/CYL OFFSET DCT
;
BUFFR0	EQU	0000H		;DCT LOAD BUFFER
BUFFR1	EQU	1000H		;BOOT LOAD BUFFER
BUFFR2	EQU	2500H		;START HIGH OVERLAYS
BUFFR3	EQU	2600H		;TEMP I/O BUFFER
BUFFR4	EQU	2700H		;BOOTSTRAP EXEC AREA
VIDEO	EQU	0F800H		;START VIDEO MEMORY
;
@OFF	EQU	BUFFR4-27AFH	;RELO OFFSET
;
	PAGE
;	RELOCATE TO NON-RESIDENT AREA
;
HBOOT	DEFM	'/* END BOOT */'
;
	LD	HL,BUFFR0	;DCT INFO
	LD	DE,BUFFR2	;TEMP BUFFER
	LD	BC,128		;COUNT
	XOR	A		;ZERO
	OUT	(ROME),A	;DISABLE BOOT ROM
	LDIR			;MOVE!
	LD	HL,BUFFR2+3	;HL => DCT FLAGS
	SET	5,(HL)		;HD BOOT
	LD	HL,BUFFR1+BOOT-HBOOT
	LD	DE,BUFFR4	;EXEC AREA
	LD	BC,EBOOT-BOOT	;COUNT
	LDIR			;MOVE!
	JP	BUFFR4		;EXECUTE!
;
	PAGE
;	READ DIRECTORY FOR SYS0/SYS
;
BOOT	LD	SP,BUFFR3	;LOCATE STACK
	LD	A,10H
	OUT	(CTC),A 	;INIT CTC
	LD	A,0CH
	OUT	(CTC),A 	;INIT CTC
	LD	A,20H		;SIZE/DRIVE/HEAD
	OUT	(HD@Q),A	;SEL DRIVE
	LD	A,HHOME 	;RAMPED SEEK
	OUT	(HD@C),A	;ISSUE HOME CMD
	CALL	HBUSY+@OFF	;WAIT TIL READY
;
	LD	A,(BUFFR2+ODL)	;GET DIR TRACK
	LD	D,A		;DE = DIR TRK
	LD	E,4		;LFN @3 (LOC OF SYS0)
	LD	HL,BUFFR3	;I/O BUFFER
	CALL	BREAD+@OFF	;READ SECTOR
	JR	NZ,DSKERR	;IF READ ERROR
;
	LD	A,(HL)		;GET BUFFER
	CPL			;INVERT
	AND	50H		;ACTIVE SYSTEM?
	LD	HL,EMES1+@OFF	;'NO SYSTEM'
	JR	NZ,SYSERR	;IF NOT
;
;	CONVERT SD TO DISK ADDRESS
;
	EXX			;ALT SET
	LD	HL,(BUFFR3+16H) ;HL = SD
	LD	D,L		;TRACK
	LD	A,H
	AND	0E0H		;GRAN OFFSET
	RLCA
	RLCA
	RLCA			;BITS 0-2
	LD	C,A		;E = GRAN OFFSET
	LD	A,(BUFFR2+OSG)	;SECTORS/GRAN
	LD	B,A		;B = SEC/GRAN
	XOR	A		;ZERO
BOOT0	ADD	A,C		;SEC/GRAN*GRAN
	DJNZ	BOOT0		;TIL DONE
	LD	E,A		;E = SECTOR
	LD	HL,BUFFR3+0FFH	;BUFFER -1
	EXX			;RESTORE
;
	PAGE
;	GET BLOCK ADDRESS AND READ
;
BOOT1	CALL	BYTE+@OFF	;GET BYTE
	LD	H,A		;SAVE HEADER
	CALL	BYTE+@OFF	;BLOCK LENTH
	LD	B,A
	CALL	BYTE+@OFF	;LSB OF BLK ADD
	LD	L,A
	DEC	H		;DEC COUNT
	JR	Z,BOOT3 	;DATA BLOCK
	DEC	H
	JR	NZ,BOOT2	;REMARK
;
;	GET ENTRY ADDRESS & GO!
;
	CALL	BYTE+@OFF	;MSB ENTRY POINT
	LD	H,A		;HL => ENTRY POINT
	JP	(HL)		;GO!
;
;	ASSUME REMARK HEADER AND READ
;
BOOT2	DEC	B		;COUNT
	JR	Z,BOOT1 	;IF DONE
	CALL	BYTE+@OFF	;READ
	JR	BOOT2		;TIL DONE
;
BOOT3	CALL	BYTE+@OFF	;GET BYTE
	LD	H,A
	DEC	B		;DEC COUNT
	DEC	B
;
BOOT4	CALL	BYTE+@OFF	;GET BYTE
	LD	(HL),A		;LOAD
	INC	HL		;NEXT
	DJNZ	BOOT4		;TIL DONE
	JR	BOOT1		;TRY AGAIN
;
;	READ 1 BYTE FROM FILE
;
BYTE	EXX			;GET ALT
	INC	L		;NEXT
	JR	NZ,BYTE1	;WITHIN BUFFER
	CALL	BREAD+@OFF	;READ SECTOR
	JR	NZ,DSKERR	;IF READ ERROR
	LD	A,(BUFFR2+OSC)	;SEC/CYLINDER
	DEC	A		;LAST SEC
	INC	E		;NEXT SEC
	CP	E		;END CYL?
	JR	NC,BYTE1	;IF NOT
	LD	E,0		;INIT SECTOR
	INC	D		;NEXT CYL
BYTE1	LD	A,(HL)		;GET BYTE
	EXX			;RESTORE
	RET
;
	PAGE
;	DISPLAY DISK ERROR & LOCK
;
DSKERR	LD	HL,EMES2+@OFF	;'DISK ERROR!'
SYSERR	LD	DE,VIDEO+990	;GET CHAR
SYSER1	LD	A,(HL)		;GET CHAR
	OR	A		;EOT?
	JR	Z,SYSER2	;IF YES
	LDI			;TO VIDEO
	JR	SYSER1		;TIL DONE
;
SYSER2	LD	A,4FH		;NO DRIVES
	OUT	(DRSL),A	;DE-SELECT
	HALT			;LOCK-UP
;
	PAGE
;	READ SECTOR ROUTINE
;
;	ENT	HL =>	BUFFER
;		DE =	CYLINDER,SECTOR
;
BREAD	PUSH	BC		;SAVE REGISTERS
	PUSH	DE
	PUSH	HL
;
;	UPDATE TASK FILE
;
	LD	A,D
	OUT	(HD@L),A	;CYLINDER NUMBER
	XOR	A
	OUT	(HD@H),A	;CYLINDER NUMBER
	LD	A,E
	SRL	A		;/2 (512 BYTES)
	OUT	(HD@S),A	;SECTOR NUMBER
;
;	HD INPUT OPERATION
;
	LD	BC,0<8+HD@D	;COUNT & DATA REG
	BIT	0,E		;ODD?
	JR	NZ,$+9		;SKIP
	LD	A,HREAD 	;READ FOR UPDATE
	OUT	(HD@C),A	;ISSUE CMD
	CALL	HBUSY+@OFF	;WAIT
	INIR			;READ DATA
;
;	GET HD ERROR STATUS
;
BREAD2	IN	A,(HD@C)	;GET STATUS
	AND	1		;ERROR?
;
	POP	HL		;RESTORE REG
	POP	DE
	POP	BC
	RET
;
;	WAIT FOR HDC READY
;
HBUSY	IN	A,(HD@C)	;HDC STATUS
	RLCA			;BUSY?
	JR	C,HBUSY 	;WAIT
	RET
;
;	ERROR MESSAGES AND TEXT
;
EMES1	DEFM	'NO SYSTEM!'
	DEFB	0
;
EMES2	DEFM	'DISK ERROR!'
	DEFB	0
;
	DC	HBOOT+512-$,0	;FILL DATA
;
EBOOT	EQU	$		;END BOOT
;
