INIT   ; init/asm
 	TITLE	'<DOS+II Cold start initialization>'
 ;
 ;	SYSTEM INITIALIZATION
 ;
 KEYBUFF	EQU	1AA0H		;keyboard buffer
 VDLIN	EQU	9		;VIDEO LINE ROUTINE
 SVC	EQU	8		;EXECUTE SVC
 HOME	EQU	27		;HOME/CLS
 VCTC	EQU	40H		;CTC INT VECTOR
 BUFER1	EQU	1C00H		;use low ovly as buffer
 BUFER2	EQU	2500H		;DCT data
 $DREAD	EQU	3		;read data sector
 $SREAD	EQU	6		;read system sector
 ;
 	ORG	1C00H		;LOW OVERLAY
 ;
 START	DI			;KILL INT
 	LD	SP,STACK	;INIT STACK
 	IM	2		;MODE II
 	LD	A,PAGE1<-8	;MSB INT VECTOR
 	LD	I,A		;SET INT VECTOR
 ;
 ;	LOCATE TOP OF MEMORY
 ;
 	LD	HL,-1		;HIGHEST ADD
 ;
 START1	LD	A,(HL)		;GET BYTE
 	CPL			;INVERT
 	LD	(HL),A		;SAVE
 	CP	(HL)		;ANY MEMORY?
 	CPL			;RESTORE
 	LD	(HL),A		;RESTORE
 	JR	Z,START2	;IF YES
 	LD	A,H		;GET ADDRESS
 	SUB	20H		;8K BLOCKS
 	LD	H,A		;NEW ADDRESS
 	JR	START1		;TIL DONE
 ;
 START2	LD	(DATAK7),HL	;TOP FREE MEMORY
 	LD	(DATAK8),HL	;TOP PHY MEMORY
 ;
 ;	INITIALIZE I/O ROUTINES
 ;
 	LD	HL,BUFER2+3	;HL => DCT INFO
 	LD	DE,DCT0+14	;DE => DCT+14
 	LD	BC,11		;INFO LEN
 	LDIR			;MOVE!
 ;
 	LD	HL,IDATA	;INIT DATA
 	LD	E,(HL)		;DEVICE COUNT
 	INC	HL		;NEXT
 START3	LD	B,(HL)		;DEVICE ADDRESS
 	INC	HL		;NEXT
 	LD	C,(HL)		;COUNT
 	INC	HL		;NEXT
 	OTIR			;DO IT!
 	DEC	E		;DONE?
 	JR	NZ,START3	;TIL DONE
 ;
 ;	INITIALIZE NMI/INT ROUTINES
 ;
 	LD	A,(DDCB+9)	;VIDEO/RTC MASK
 	OUT	(LBANK),A	;ENABLE RTC
 ;
 	IN	A,(RDKBD)	;CLEAR KBD INT
 	EI
 ;
 ;	clear screen in case of LOGO = N
 ;
 	LD	B,1BH		;code
 	CALL	DSP		;display it
 	JP	INITMORE	;continue!
 ;
 ;	INIT DATA FOR Z80 PIO
 ;
 IDATA	DEFB	9		;DEVICE COUNT
 ;
 	DEFB	5		;DATA COUNT
 	DEFB	PIOAC		;PIOA CONFIG
 	DEFB	000H		;INT VECTOR
 	DEFB	0CFH		;BIT MODE
 	DEFB	0F7H		;I/O MASK
 	DEFB	037H		;INT OFF
 	DEFB	0FEH		;INT MASK
 ;
 	DEFB	3		;DATA COUNT
 	DEFB	PIOBC		;PIOB CONFIG
 	DEFB	000H		;INT VECTOR
 	DEFB	00FH		;OUTPUT MODE
 	DEFB	007H		;NO INT
 ;
 ;	INIT DATA FOR Z80 SIO
 ;
 	DEFB	9		;DATA COUNT
 	DEFB	SIOAC		;DEVICE ADRESS
 	DEFB	18H		;CHANNEL RESET
 	DEFB	4		;WR4
 	DEFB	44H		;X16,S=1
 	DEFB	3		;WR3
 	DEFB	0C1H		;W=7,RX
 	DEFB	5		;WR5
 	DEFB	0EAH		;DTR,W=8,TX,RTS
 	DEFB	1+10H		;RES INT,WR1
 	DEFB	00H		;DISABLE ALL INT
 ;
 	DEFB	9		;DATA COUNT
 	DEFB	SIOBC		;DEVICE ADRESS
 	DEFB	18H		;CHANNEL RESET
 	DEFB	4		;WR4
 	DEFB	44H		;X16,S=1
 	DEFB	3		;WR3
 	DEFB	0C1H		;W=7,RX
 	DEFB	5		;WR5
 	DEFB	0EAH		;DTR,W=7,TX,RTS
 	DEFB	1+10H		;RES INT,WR1
 	DEFB	00H		;DISABLE ALL INT
 ;
 ;	INIT DATA FOR Z80 CTC
 ;
 	DEFB	3		;DATA COUNT
 	DEFB	CTC0		;DEVICE ADDRESS
 	DEFB	47H		;RESET,TC FOLLOWS
 	DEFB	0DH		;TIME CONSTANT 9600 BAUD
 	DEFB	VCTC		;INT VECTOR
 ;
 	DEFB	2		;DATA COUNT
 	DEFB	CTC1		;DEVICE ADDRESS
 	DEFB	47H		;RESET,TC FOLLOWS
 	DEFB	0DH		;TIME CONSTANT 9600 BAUD
 ;
 	DEFB	2		;DATA COUNT
 	DEFB	CTC2		;DEVICE ADDRESS
 	DEFB	07H		;RESET,TC FOLLOWS
 	DEFB	34H		;TIME CONSTANT 300 BAUD
 ;
 	DEFB	2		;DATA COUNT
 	DEFB	CTC3		;DEVICE ADDRESS
 	DEFB	0C7H		;RESET,TC FOLLOWS
 	DEFB	01H		;TIME CONSTANT
 ;
 ;	INIT DATA FOR HD IO
 ;
 	DEFB	3		;DATA COUNT
 	DEFB	0C1H		;DEVICE ADDRESS
 	DEFB	00H
 	DEFB	10H
 	DEFB	0CH
 ;
 	ORG	1D00H		;need a page for buffer
 ;
 ;	block of LOGO data here (max 5 pages)
 ;	insert graphic portion of display
 ;
 LOGO2	EQU	$		;start
 ;
 ;	data here
 ;
 LOGO2L	EQU	$-LOGO2
 ;
 	ORG	2200H		;high overlay area
 ;
 ;
 ;	read in control information from sector 2
 ;
 INITMORE LD	DE,0002H	;tk0, sec2
 	LD	HL,BUFER1	;use high ovly buffer-100
 	LD	B,D		;sec offset
 	LD	C,D		;drive
 	CALL	LOCDCT		;find the DCT
 	LD	A,(IY+14)	;get flags
 	PUSH	AF		;save 'em
 	RES	7,(IY+14)	;set single density
 	LD	A,$DREAD	;disk command
 	RST	10H		;read the sector
 ;
 	POP	BC		;fetch the flag
 	LD	(IY+14),B	;put back into DCT
 ;
 	LD	L,10H		;data
 	EX	DE,HL		;exchange
 	LD	HL,FLAG		;flag byte
 	LD	(HL),-1		;set all prompts
 	JR	NZ,READMR	;disk error, go!
 ;
 ;
 	LD	(HL),0		;turn 'em off
 ;
 	LD	A,(DE)		;get a byte
 	INC	A		;date prompt?
 	JR	NZ,GOCKLO	;nope, skip
 ;
 	SET	7,(HL)		;ask for date
 ;
 GOCKLO	INC	E		;next byte
 	LD	A,(DE)		;get it
 	INC	A		;logo display?
 ;
 	SET	6,(HL)		;display logo
 ;
 GOCKDA	INC	E		;next byte
 	LD	A,(DE)		;fetch it
 	INC	A		;time prompt?
 	JR	NZ,READMR	;go if done
 ;
 	SET	5,(HL)		;set time prompt
 ;
 ;
 READMR	LD	A,(FLAG)	;get flag
 	AND	40H		;LOGO?
 	JR	Z,CKDATE	;don't display it
 ;
 ;	display logo blocks
 ;
 	LD	HL,LOGO1	;block 1 (text)
 	LD	BC,LOGO1L<8+13	;len + term
 	CALL	VDLINE		;display it
 ;
 	LD	HL,LOGO2	;block 2 (graphic)
 	LD	DE,LOGO2L	;get length of data
 ;
 LOGD1	INC	D		;any more full pages?
 	DEC	D		;0?
 	JR	NZ,LOGD2	;yes, go!
 	INC	E		;any more part pages?
 	DEC	E
 	JR	Z,CKDATE	;done with logo!
 ;
 	LD	D,E		;remaining bytes
 	CALL	VDGRAF		;send 'em
 	JR	CKDATE		;done!
 ;
 LOGD2	PUSH	DE		;save count
 	LD	D,0FFH		;255 bytes
 	CALL	VDGRAF		;video graphics
 	POP	DE		;restore counter
 	DEC	D		;less page
 	INC	DE		;less 255 bytes done
 	JR	LOGD1		;continue
 ;
 CKDATE	LD	A,(FLAG)	;get flag
 	AND	80H		;DATE?
 	JR	Z,VALDATE	;nope, valid date?
 ;
 ;	prompt for date
 ;
 GETDATE	LD	HL,DATEPMT	;prompt
 	LD	BC,DATEPMTL<8+0	;len + term
 	LD	DE,KEYBUFF	;keyboard buffer
 	CALL	VIDKEY		;fetch/display
 	JR	NZ,VALDATE	;error, forget it
 	JR	C,VALDATE	;break, don't clear it
 ;
 ;	fetch the data from the string
 ;
 	LD	B,1		;command
 	CALL	DATE		;load it
 	JR	NZ,GETDATE	;error, ask again
 ;
 ;	check for valid date field in DATE$
 ;
 VALDATE	LD	HL,DATE$	;start of data
 	LD	A,(HL)		;get day of month
 	CP	32		;too big?
 	CALL	NC,CLRIT	;yes, clear it out
 ;
 	LD	A,(DATE$+1)	;get month
 	CP	13		;too big?
 	CALL	NC,CLRIT	;yes, clear it out
 ;
 	LD	A,(DATE$+2)	;get year
 	CP	8		;too big?
 	CALL	NC,CLRIT	;yes, clear it out
 ;
 ;	check for time input
 ;
 CKTIME	LD	A,(FLAG)	;get flag
 	AND	20H		;time?
 	JR	Z,VALTIME	;valid?
 ;
 ;	prompt for TIME$
 ;
 GETTIME	LD	HL,TIMEPMT	;prompt
 	LD	BC,TIMEPMTL<8+0	;len + term
 	LD	DE,KEYBUFF	;keyboard buffer
 	CALL	VIDKEY		;display & fetch
 	JR	NZ,VALTIME	;error, can it!
 	JR	C,VALTIME	;break, don't change
 ;
 ;	load data into TIME$
 ;
 	LD	B,2		;command
 	CALL	DATE		;load TIME$
 	JR	NZ,GETTIME	;error, ask again
 ;
 ;	check for valid TIME$
 ;
 VALTIME	LD	HL,TIME$+1	;start of time
 	LD	A,(HL)		;get seconds
 	CP	61		;too big?
 	CALL	NC,CLRIT	;yes, clear field
 ;
 	LD	A,(TIME$+2)	;get minutes
 	CP	61		;too big?
 	CALL	NC,CLRIT	;yes, clear it
 ;
 	LD	A,(TIME$+3)	;get hours
 	CP	25		;too big?
 	CALL	NC,CLRIT	;yes, clear
 ;
 ;	check for an auto command
 ;
 	LD	E,0		;sector
 	LD	B,E		;extended sector
 	LD	HL,BUFER1	;buffer
 	LD	C,E		;drive 0
 	LD	A,$SREAD	;system read
 	RST	10H		;read the GAT
 	JP	NZ,CLRXIT	;error, exit to DOS
 ;
 ;	check for any auto command
 ;
 	LD	IY,BUFER1+0E0H	;start of data
 	LD	A,(IY)		;get AUTO
 	CP	13		;nil?
 	JP	Z,CLRXIT	;yes, exit to DOS
 ;
 	LD	DE,KEYBUFF	;system key buffer
 	LD	BC,2000H	;B=looper, C=counter
 	LD	HL,FLAG		;flag byte
 	LD	(HL),C		;set to 0
 ;
 PARAUTO	LD	A,(IY)		;get a char
 	CP	'!'		;non-breakable?
 	JR	Z,NOBRK		;yes, set it up
 	CP	'#'		;no-display?
 	JR	Z,NODSP		;yes, set it up
 	CP	13		;C/R
 	JR	NZ,PARPUT	;nope, continue
 	LD	B,1		;force last char
 	JR	PARBAK		;continue
 ;
 PARPUT	LD	(DE),A		;put into buffer
 	INC	DE		;bump pointer
 	INC	C		;bump char count
 PARBAK	INC	IY		;bump source
 	DJNZ	PARAUTO		;go for 32 chars
 	LD	A,13		;force in a C/R
 	LD	(DE),A		;to the buffer
 	INC	C		;+ C/R
 ;
 ;	completed, check for to be displayed
 ;
 	BIT	1,(HL)		;set from #
 	LD	HL,KEYBUFF	;start of data
 	JR	NZ,NOSHOW	;don't show it
 ;
 	INC	C		;check for nil
 	DEC	C
 	JP	Z,CLRXIT	;yes, back to DOS
 ;
 	LD	B,C		;get length
 	LD	C,0		;terminator
 	CALL	VDLINE		;display it
 ;
 NOSHOW	JP	DOSCMD		;execute command
 ;
 NOBRK	BIT	0,(HL)		;already set?
 	JR	NZ,PARPUT	;ignore it
 	SET	0,(HL)		;only allow it once
 ;
 	LD	A,KDCB?		;get keyboard
 	CALL	LOCDCB		;find it
 	SET	6,(IX+5)	;turn off break key
 	JR	PARBAK		;continue
 ;
 NODSP	BIT	1,(HL)		;alread set?
 	JR	NZ,PARPUT	;skip if yes
 	SET	1,(HL)		;turn it on
 	JR	PARBAK		;continue
 CLRIT	LD	(HL),0		;load all 0's
 	INC	HL
 	LD	(HL),0
 	INC	HL
 	LD	(HL),0
 	DEC	HL
 	DEC	HL
 	RET			;done
 ;
 FLAG	DEFB	0		;for command interpret
 ;
 ;	MESSAGES AND TEXT
 ;
 LOGO1	DEFM	'DosPLUS II - '
 	DEFM	'Model II Disk Operating System - '
 	DEFM	'Series A.00'
 	DEFB	13
 	DEFM	'(c)(p) Copyright 1982 by '
 	DEFM	'MicroPower, Inc.'
 	DEFB	13
 	DEFB	13
 LOGOL1	EQU	$-LOGO
 ;
 DATEPMT	DEFM	'Date: '
 DATEPMTL EQU	$-DATEPMT
 ;
 TIMEPMT	DEFM	'Time: '
 TIMEPMTL EQU	$-TIMEPMT
 ;
