; int/asm - interrupt interceptor
;
	ORG	5200H
;
ENTRY	LD	A,(4012H)	;get old vector
	LD	(OLD1),A	;save it
	LD	HL,(4013H)	;get vector
	LD	(OLD1+1),HL	;save it
;
	DI			;disable for change
	LD	A,0C3H		;'JP' opcode
	LD	(4012H),A	;save it
	LD	HL,TASK		;interrupt driver
	LD	(4013H),HL	;save it
	EI			;done!
;
	RET			;back to DOS
;
DISABLE	LD	A,(OLD1)	;get old
	LD	(4012H),A	;put it back
	PUSH	HL		;must save it
	LD	HL,(OLD1+1)	;get vector
	LD	(4013H),HL	;save it
	POP	HL		;restore stack
	RET			;back to DOS
;
TASK	PUSH	AF		;save it
	LD	A,(3C3FH)	;get char from video
	XOR	10101010B	;change it
	LD	(3C3FH),A	;put it back on video
;
	LD	A,(3840H)	;get keyboard last row
	AND	4		;remove?
	CALL	NZ,DISABLE	;turn us off
;
;	clear interrupt latch
;
	LD	A,(4)		;read ROM
	CP	30H		;mod III?
	JR	Z,CLEAR3	;yes, go!
;
CLEAR1	LD	A,(37E0H)	;clear interrupt
	JR	CLEARED		;done!
;
CLEAR3	IN	A,(0ECH)	;clear interrupt
;
CLEARED	POP	AF		;stack back
	EI			;can enable now
	RET			;back to foreground
;
OLD1	DEFB	0,0,0		;3 byte saver
;
	END	ENTRY
