OVERLA ; overlay/asm
 	TITLE	'<OVERLAY - SYSTEM OVERLAY LOADER - 1.0>'
 ;
 LD	EQU	1		;LD	BC
 CR	EQU	13		;C/R
 ERR24	EQU	24		;FILE NOT FOUND
 ERR31	EQU	31		;PROGRAM NOT FOUND
 ;
 ;	NON-RESIDENT SVC ROUTINES
 ;
 JP2DOS	LD	A,1-1<4+4	;NORMAL SYSTEM ENTRY
 	RST	18H
 DOSCMD	LD	A,1-1<4+2	;INTERPRET CMD & EXIT
 	RST	18H
 RETCMD	LD	A,1-1<4+3	;INTERPERT CMD & RETURN
 	RST	18H
 EXIT	LD	A,1-1<4+4	;NORMAL SYSTEM ENTRY
 	RST	18H
 CLRXIT	LD	A,1-1<4+6	;CLEAR RAM & ABORT
 	RST	18H
 EVAL	LD	A,1-1<4+7	;EVALUATE COMMAND LINE
 	RST	18H
 FSPEC	LD	A,1-1<4+8	;FETCH FILE SPEC
 	RST	18H
 PARAM	LD	A,1-1<4+9	;FETCH OPTIONAL PARAMS
 	RST	18H
 FEXT	LD	A,1-1<4+10	;PLACE FILE EXTENSION
 	RST	18H
 FDRV	LD	A,1-1<4+11	;FETCH DRIVE SPEC
 	RST	18H
 ;
 OPEN	LD	A,2-1<4+1	;OPEN/INIT DEVICE/FILE
 	RST	18H
 RENAME	LD	A,2-1<4+2	;RENAME DEVICE/FILE
 	RST	18H
 ;
 KILLO	LD	A,3-1<4+1	;KILL OPEN FILE
 	RST	18H
 CLOSE	LD	A,3-1<4+2	;CLOSE DEVICE/FILE
 	RST	18H
 ;
 ERROR	LD	A,5-1<4+1	;POST ERROR MESSAGE
 	RST	18H
 ERRMSG	LD	A,5-1<4+2	;FETCH ERROR MESSAGE
 	RST	18H
 ;
 DEBUG	PUSH	AF		;SAVE!
 	LD	A,6-1<4+1	;ENTER DEBUGGER
 	RST	18H
 ;
 INITIO	LD	A,7-1<4+9	;init all I/O
 	RST	18H		;go!
 KBINIT	LD	A,7-1<4+1	;KEYBOARD INIT
 	RST	18H
 VDINIT	LD	A,7-1<4+2	;VIDEO INIT
 	RST	18H
 PRINIT	LD	A,7-1<4+3	;PRINTER INIT
 	RST	18H
 RS232C	LD	A,7-1<4+4	;RS232 INIT
 	RST	18H
 DATE	LD	A,7-1<4+5	;FETCH TIME/DATE
 	RST	18H
 SORT	LD	A,8-1<4+7	;SORT RAM TABLE
 	RST	18H
 PRCTRL	LD	A,7-1<4+6	;PRINTER CONTROL
 	RST	18H
 ACTRL	LD	A,7-1<4+7	;CL A CONTROL
 	RST	18H
 BCTRL	LD	A,7-1<4+8	;CL B CONTROL
 	RST	18H
 ;
 PARSER	LD	A,8-1<4+1	;PARSE TEXT STRING
 	RST	18H
 WILD	LD	A,8-1<4+2	;WILD CARD PARSER
 	RST	18H
 RAMDIR	LD	A,8-1<4+3	;RAM DIRECTORY
 	RST	18H
 RDDIR	LD	A,8-1<4+4	;READ DIRECTORY
 	RST	18H
 FILPTR	LD	A,8-1<4+5	;GET FILE POINTERS
 	RST	18H
 DISKID	LD	A,8-1<4+6	;READ DISK ID'S
 	RST	18H
 ;
 	PAGE
 ;	$OVERLAY - SYSTEM OVERLAY LOADER
 ;
 ;	ENT	 A =	LOAD COMMAND
 ;
 ;		BIT:	  7	HIGH/LOW FLAG
 ;			6-4	LFN-3
 ;			3-0	COMMAND VECTOR
 ;
 OVERLY	INC	SP		;IGNORE
 	INC	SP		;CALLER
 ;
 OVRLY0	PUSH	HL		;SAVE
 	LD	HL,OVRLY4	;RET ADD
 	EX	(SP),HL 	;TO STACK
 ;
 	PUSH	HL		;SAVE REGISTERS
 	PUSH	DE
 	PUSH	BC
 	PUSH	AF
 ;
 ;	DEBUG OFF - SAVE STATUS
 ;
 	LD	HL,FLAG1S	;DEBUG INT FLAG
 	LD	B,(HL)		;GET STATUS
 	LD	(HL),0		;NO DEBUG INT
 	INC	HL		;FLAG2S
 	LD	(HL),B		;SAVE STATUS
 	INC	HL		;FLAG3S
 	LD	(HL),A		;SAVE SYSTM/CMD
 ;
 ;	CHECK/LOAD SYSTEM OVERLAY
 ;
 	LD	HL,OVLYL	;LOW OVERLAY NUMBER
 	LD	DE,LOENT	;LOW ENTRY POINT
 	OR	A		;LOW OVERLAY?
 	JP	P,OVRLY1	;IF YES
 	INC	HL		;HIGH OVERLAY NUMBER
 	LD	DE,HIENT	;HIGH ENTRY POINT
 OVRLY1	AND	0F0H		;IGNORE CMD
 	CP	(HL)		;MATCH?
 	LD	(HL),A		;SET OVERLAY
 	JR	Z,OVRLY2	;IF YES
 ;
 	CALL	OVRLY5		;LOAD FILE
 	JR	NZ,OVRLY8	;I/O ERROR
 	EX	DE,HL		;DE => ENTRY POINT
 	LD	(HL),E		;SET ENTRY
 	INC	HL
 	LD	(HL),D		;SET ENTRY
 	JR	OVRLY3		;SKIP
 ;
 ;	GET ENTRY POINT AND GO!
 ;
 OVRLY2	EX	DE,HL		;HL => ENTRY
 	LD	E,(HL)		;GET ENTRY
 	INC	HL
 	LD	D,(HL)		;GET ENTRY
 ;
 OVRLY3	POP	AF		;RET ADD
 	AND	0FH		;IGNORE SYS
 	ADD	A,A		;* 2
 	LD	L,A
 	LD	H,0		;HL = OFFSET
 	ADD	HL,DE		;HL => ADDRESS
 	LD	A,(HL)
 	INC	HL
 	LD	H,(HL)
 	LD	L,A		;HL => ROUTINE
 	POP	BC		;RESTORE REG
 	POP	DE
 	EX	(SP),HL
 	RET			;GO!
 ;
 ;	RESTORE DEBUG STATUS
 ;
 OVRLY4	PUSH	AF		;SAVE
 	LD	A,(FLAG2S)	;GET DEBUG FLAG
 	LD	(FLAG1S),A	;SET DEBUG FLAG
 	POP	AF		;RESTORE
 	RET			;OVERLAY DONE!
 ;
 ;	SET-UP SYSTEM OVERLAY'S DCB
 ;
 ;	ENT	 A =	SYSTEM (0-15)
 ;
 OVRLY5	PUSH	DE		;SAVE REG
 	PUSH	IY
 	RLCA
 	RLCA
 	RLCA
 	RLCA			;SYSTEM TO LSB
 	ADD	A,3		;CORRECT (MAKE LFN)
 	LD	B,A		;B = ASSUMED LFN
 	LD	C,0		;DRIVE
 	CALL	LOCDCT		;LOCATE DCT
 	LD	A,B		;GET LFN
 	SUB	(IY+18) 	;END DIR?
 	JR	C,OVRLY6	;IF NOT
 	OR	20H		;CORRECT LFN
 	LD	B,A		;B = TRUE LFN
 ;
 OVRLY6	LD	IY,SYSDCB	;SYSTEM DCB
 	LD	(IY+17),B	;SET LFN
 	LD	(IY+01),0	;ATTRIB
 	LD	(IY+10),0	;LSB NRN
 ;
 	CALL	DIRRED		;READ DIRECTORY
 	JR	NZ,OVRLY7	;ERROR!
 	LD	A,(HL)		;GET TYPE
 	CPL			;INVERT
 	AND	50H		;AVTIVE SYSTEM?
 	LD	A,24		;FILE NOT FOUND
 	JR	NZ,OVRLY7	;HUH?
 ;
 	LD	DE,16H		;SD OFFSET
 	ADD	HL,DE		;HL => SD LIST
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)		;DE = 1ST SD
 	LD	(IY+20),E	;SET 1ST SD
 	LD	(IY+21),D	;SET 1ST SD
 ;
 	LD	DE,SYSDCB	;DE => DCB
 	CALL	LDPG1		;LOAD OVERLAY!
 ;
 OVRLY7	POP	IY		;RESTORE REG
 	POP	DE
 	RET
 ;
 ;	OVERLAY ERROR HANDLER
 ;
 OVRLY8	LD	HL,FLAG3S	;CURR LOAD COMMAND
 	BIT	7,(HL)		;LOW?
 	INC	HL		;HL => OVLYL
 	JR	Z,OVRLY9	;IF LOW
 	INC	HL		;HL => OVLYH
 OVRLY9	LD	(HL),-1 	;UNDEFINED
 	LD	HL,MES1+13	;'SYSTEM ERROR'
 	CALL	B2H		;GET CODE
 	LD	HL,MES1 	;'SYSTEM ERROR'
 	LD	BC,16<8+CR	;COUNT & TERM
 	CALL	VDLINE		;VIDEO LINE
 	CALL	KBDW		;WAIT FOR KEY
 	JP	CLRXIT		;ABORT!
 ;
 MES1	DEFM	'System error 00H'
 ;
 	PAGE
 ;	LOAD/EXECUTE PROGRAM FILE
 ;
 ;	ENT	DE =>	DCB
 ;
 RUN	PUSH	HL		;SAVE
 	LD	HL,FLAGK1	;SYSTEM FLAGS
 	SET	1,(HL)		;FORCE READ
 	PUSH	HL		;SAVE FLAGS
 	CALL	LOAD		;LOAD FILE
 	EX	(SP),HL 	;HL => FLAGS
 	RES	1,(HL)		;FORCE READ OFF
 	LD	B,A		;B = CODE
 	JP	NZ,ERROR	;I/O ERROR
 	BIT	2,(HL)		;DEBUG ON?
 	INC	DE		;NEXT
 	LD	A,(DE)		;GET ATTRIB
 	LD	BC,(DATAK6)	;BC => LOW MEMORY
 	LD	DE,(DATAK7)	;DE => HIGH MEMORY
 	POP	HL		;HL => ENTRY
 	EX	(SP),HL 	;RESTORE
 	RET	Z		;NO DEBUG
 	AND	7		;ATTRIB
 	CP	6		;EXEC?
 	JP	C,DEBUG 	;GO DEBUG!
 	RET			;EXECUTE!
 ;
 ;	LOAD PROGRAM FILE ROUTINE
 ;
 ;	ENT	 DE =>	FILE DCB
 ;
 LOAD	LD	HL,PLIST	;HL => PARAM LIST
 	CALL	OPEN		;OPEN FILE!
 	JR	Z,LDPG1 	;NO ERROR
 	CP	ERR24		;FILE NOT FOUND?
 	JR	NZ,LDER1	;IF NOT
 	LD	A,ERR31 	;PROGRAM NOT FOUND
 	JR	LDER1		;HANDLE ERROR
 ;
 LDPG1	LD	C,-1		;INIT BUFF LOC
 LDPG2	CALL	GETBYT		;GET BYTE
 	CP	' '             ;CONTROL?
 	JR	NC,LDER3	;NON-PROGRAM FILE
 	LD	H,A		;H = CTL BYTE
 	CALL	GETBYT		;GET BYTE
 	LD	B,A		;B = COUNT
 	CALL	GETBYT		;GET BYTE
 	LD	L,A		;L = LSB ADD
 	DEC	H		;DATA?
 	JR	Z,LDPG5 	;GO!
 	DEC	H		;TERM?
 	JR	NZ,LDPG4	;GO!
 ;
 ;	GET PROGRAM ENTRY POINT
 ;
 LDPG3	CALL	GETBYT		;GET BYTE
 	LD	H,A		;HL = ADDRESS
 	XOR	A		;NO ERRORS
 	RET
 ;
 ;	READ FILE LOAD REMARK
 ;
 LDPG4	DEC	B		;NEXT
 	JR	Z,LDPG2 	;DONE
 	CALL	GETBYT		;GET BYTE
 	JR	LDPG4		;TIL DONE
 ;
 ;	READ PROGRAM DATA BLOCK
 ;
 LDPG5	CALL	GETBYT		;GET BYTE
 	LD	H,A		;HL = ADDRESS
 	DEC	B		;NEXT
 	DEC	B		;NEXT
 ;
 LDPG6	CALL	GETBYT		;GET BYTE
 	LD	(HL),A		;LOAD BYTE
 	CP	(HL)		;OK?
 	JR	NZ,LDER4	;BAD LOAD!
 	INC	HL		;NEXT
 	DJNZ	LDPG6		;TIL DONE
 	JR	LDPG2		;TRY AGAIN
 ;
 ;	READ 1 BYTE FROM FILE
 ;
 GETBYT	INC	C		;NEXT
 	JR	NZ,GTBYT1	;NO READ
 	CALL	READNX		;READ SECTOR
 	JR	NZ,LDER0	;I/O ERROR
 ;
 GTBYT1	PUSH	BC		;SAVE B
 	LD	B,BUFFER<-8	;BC => DATA
 	LD	A,(BC)		;GET DATA
 	POP	BC		;RESTORE B
 	RET
 ;
 ;	LOAD ERROR HANDLERS
 ;
 LDER3	LD	A,34		;NON-PROGRAM FILE
 	DEFB	LD		;DUMMY INST
 LDER4	LD	A,35		;MEMORY FAULT
 	PUSH	BC
 LDER0	POP	BC		;IGNORE CALLER
 LDER1	OR	80H		;ABORT!
 	RET			;
 ;
 ;	OPEN PARAM LIST FOR LOAD
 ;
 PLIST	DEFW	BUFFER		;BUFADR
 	DEFW	BUFFER		;RECADR
 	DEFW	0		;EODAD
 	DEFB	'R'             ;READ
 	DEFB	0		;LRL
 	DEFB	'F'             ;FIXED LENGTH
 	DEFB	3		;OPEN NEW LRL
