; ref/asm - sjp/mss - 08/82
;
	TITLE	'<BASIC Refrence program - Ver 1.2>'
;
;	Created: 26-FEB-81	SJP/MSS
;
;	Revised: 01-MAR-81	SJP/MSS
;	Revised: 30-DEC-81	SJP/MSS
;
;	BASIC CODES FOR KEYWORDS
;
DATA	EQU	133		;DATA
REM	EQU	144		;REM
FIELD	EQU	161		;FIELD
EQUAL	EQU	215		;=
;
;	MISC ROM BASIC ROUTINES
;
CPHLSP	EQU	20H		;CP (HL) & (SP)
GETCHR	EQU	28H		;GET NEXT CHAR
CPHLDE	EQU	30H		;CP HL & DE
;
DOUT	EQU	57EEH		;DEVICE OUTPUT
SNERR	EQU	2EF5H		;SYNTAX ERROR
FCERR	EQU	330EH		;ILL FUNCTION CALL
BAS1	EQU	4DD7H		;BIN TO DEC CONV
BAS2	EQU	57DBH		;SCAN KBD FOR BREAK
BASIC	EQU	2FA7H		;ENTER BASIC
;
DEVFL	EQU	2B44H		;DEVICE FLAG
KTABLE	EQU	2853H		;KEYWORD TABLE
;
;	RESERVED BASIC ADDRESSES
;
EXIT	EQU	0000H		;DOS EXIT VECTOR
CURLIN	EQU	2B4DH		;CURRENT LINE NUM
PGMBEG	EQU	2B4FH		;START BASIC TEXT
FACC	EQU	2E0CH		;FLOAT ACC
;
SVC	EQU	8		;EXECUTE SVC
VDLINE	EQU	9		;VIDEO LINE
EMEM	EQU	27FFH		;END AVAIL MEMORY
;
	ORG	2200H
;
;	CHECK IF UNDER BASIC
;
START	LD	HL,12		;GET RET ADDRESS
	ADD	HL,SP
	LD	SP,HL
	POP	HL
	LD	DE,EXIT 	;DOS EXIT VECTOR
	OR	A		;CLR CRY
	SBC	HL,DE
	JR	NZ,START1	;UNDER BASIC
;
	LD	HL,TITLE	;'PROGRAM TITLE'
	LD	BC,TL<8+13	;LEN+TERM
	LD	A,VDLINE	;VIDEO LINE
	RST	SVC		;DO IT!
	RST	EXIT		;RETURN
;
;	RESTORE BASIC STATUS
;
START1	LD	IX,FLAGS	;IX => PRM FLGS
	POP	HL		;IGNORE CALLER
	POP	HL		;IGNORE CALLER
	POP	HL		;GET CODE STRING
	POP	AF		;IGNORE CALLER
;
	RST	CPHLSP		;CP (HL) TO NEXT
	DEFM	','             ;SYNTAX
;
;	SINGLE REFRENCE PARAM
;
	CP	'S'             ;SINGLE REF?
	JR	NZ,XPRM1	;IF NOT
;
	SET	7,(IX+0)	;FLAG SINGLE
	RST	GETCHR		;GET NEXT CHAR
	RST	CPHLSP		;CP (HL) TO NEXT
	DEFB	','             ;SYNTAX
	JR	C,SPRM2 	;LINE REF
;
	CALL	CKALP		;CHECK ALPHA
	JP	C,SNERR 	;IF NOT
	JR	Z,SPRM1 	;IF ALPHA
;
	SET	0,(IX+0)	;KEYWORD REF
	LD	(IX+1),1	;KEY PASS
	LD	BC,8000H	;LSB
	LD	E,0		;NSB
	LD	D,(HL)		;MSB
	JR	SPRM3		;SKIP
;
SPRM1	SET	1,(IX+0)	;VAR REF
	LD	(IX+1),2	;VAR PAS
	CALL	FVAR		;FETCH VAR
	JR	SPRM3		;SKIP
;
SPRM2	SET	2,(IX+0)	;LINE REF
	LD	(IX+1),3	;LINE PASS
	CALL	DECBIN		;CONVERT
	JP	C,SNERR 	;OVERFLOW
;
SPRM3	RST	GETCHR		;GET NEXT CHAR
	JR	Z,SPRM4 	;END STMNT
	RST	CPHLSP		;CP (HL) TO NEXT
	DEFM	','             ;SYNTAX
	CP	'P'             ;PRINTER OUTPUT?
	JP	NZ,FCERR	;IF NOT
	LD	A,1		;PRINTER
	LD	(DEVFL),A	;SET DEVICE
	JR	SPRM3		;TIL EOS
;
SPRM4	LD	HL,CURR 	;CURR REF
	LD	(HL),C		;LSB
	INC	HL
	LD	(HL),B
	INC	HL		;NEXT
	LD	(HL),E		;NSB
	INC	HL		;NEXT
	LD	(HL),D		;MSB
;
	LD	HL,-1		;SIGNAL
	LD	(CURLIN),HL	;COMMAND MODE
;
;	SINGLE REFRENCE HERE
;
SREF1	LD	HL,(PGMBEG)	;HL => START TEXT
	RES	4,(IX+0)	;TABLE EMPTY
;
;	CHECK IF PASS COMPLETE
;
SREF2	LD	A,(HL)		;MSB POINT
	INC	HL		;NEXT
	OR	(HL)		;END TEXT?
	INC	HL		;HL => LINE NUM
	JR	NZ,SREF3	;IF NOT
;
;	CHECK IF REF COMPLETE
;
	BIT	4,(IX+0)	;DATA IN TABLE?
	CALL	NZ,OUTREF	;IF YES
	JP	BASIC		;EXIT
;
;	SET-UP FOR NEXT LINE
;
SREF3	CALL	SLINE		;SCAN LINE
	JR	SREF2		;TIL DONE
;
;
;	CROSS-REFRENCE PARAM
;
XPRM1	CP	'L'             ;LINES?
	JR	NZ,XPRM2	;IF NOT
	SET	2,(IX+0)	;LINE REF
	JR	XPRM5		;TIL DONE
;
XPRM2	CP	'V'             ;VARIABLES?
	JR	NZ,XPRM3	;IF NOT
	SET	1,(IX+0)	;VAR REF
	JR	XPRM5		;TIL DONE
;
XPRM3	CP	'K'             ;KEYWORDS?
	JR	NZ,XPRM4	;IF NOT
	SET	0,(IX+0)	;KEY REF
	JR	XPRM5		;TIL DONE
;
XPRM4	CP	'P'             ;PRINTER?
	JP	NZ,FCERR	;IF NOT
	LD	A,1		;PRINTER
	LD	(DEVFL),A	;SET DEVICE
;
XPRM5	RST	GETCHR		;GET NEXT CHAR
	JR	Z,XPRM6 	;IF EOS
	RST	CPHLSP
	DEFM	','             ;DELIM?
	JR	XPRM1		;SKIP
;
XPRM6	LD	HL,-1		;SIGNAL
	LD	(CURLIN),HL	;COMMAND MODE
;
;	CROSS-REFRENCE HERE
;
XREFI	LD	A,(IX+1)	;REF TYPE
	DEC	A		;CORRECT
	JP	M,BASIC 	;EXIT
	RLCA
	RLCA
	RLCA
	OR	46H		;A = BIT INST
	LD	(BIT),A 	;SET INST
BIT	EQU	$+3
	BIT	0,(IX+0)	;TYPE WANTED?
	JR	NZ,XREF2	;IF YES
;
XREF1	DEC	(IX+1)		;NEXT TYPE
	JR	XREFI		;IF MORE
;
;	ADVANCE NEXT REFRENCE
;
XREF2	LD	HL,CURR
	LD	(HL),0
	INC	HL
	LD	(HL),0
	INC	HL
	LD	(HL),0
	INC	HL
	LD	(HL),0
;
XREF3	LD	BC,4		;COUNT
	LD	HL,CURR 	;HL => CURR REF
	LD	DE,LAST 	;DE => LAST REF
	LDIR			;LAST REF = CUR REF
;
	DEC	HL		;NEXT
	LD	(HL),-1
	DEC	HL		;NEXT
	LD	(HL),-1
	DEC	HL		;NEXT
	LD	(HL),-1 	;CURR REF UNDEF
	DEC	HL
	LD	(HL),-1
;
	LD	HL,(PGMBEG)	;HL => START TEXT
	RES	4,(IX+0)	;TABLE EMPTY
;
;	CHECK IF PASS COMPLETE
;
XREF4	LD	A,(HL)		;MSB POINT
	INC	HL		;NEXT
	OR	(HL)		;END TEXT?
	INC	HL		;HL => LINE NUM
	JR	NZ,XREF5	;IF NOT
;
;	CHECK IF REF COMPLETE
;
	BIT	4,(IX+0)	;DATA IN TABLE?
	JR	Z,XREF1 	;NEXT TYPE
	CALL	OUTREF		;OUTPUT TABLE
	CALL	BAS2		;SCAN KBD
	JR	XREF3		;NEXT
;
XREF5	CALL	SLINE		;SCAN LINE
	JR	XREF4		;TIL DONE
;
;
;	ROUTINE TO SCAN TEXT LINE
;
SLINE	RES	5,(IX+0)	;END DATA/REM
	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;DE = CUR LINE NUM
	LD	(LINE),DE	;SAVE LINE NUM
;
;	GET NEXT REFRENCE
;
SLIN0	RES	6,(IX+0)	;END FIELD
;
SLIN1	RST	GETCHR		;GET NEXT BYTE
	JR	NZ,SLIN2	;NOT END STMNT
	OR	A		;EOL?
	JR	NZ,SLIN0	;IF NOT
	JP	SLINB		;FIND EOL
;
SLIN2	JR	C,SLIN7 	;NUMERIC
;
	CP	'"'             ;LITERAL?
	JR	NZ,SLIN4	;IF NOT
;
SLIN3	RST	GETCHR		;GET NEXT BYTE
	CP	'"'             ;END LITERAL?
	JR	Z,SLIN1 	;IF YES
	OR	A		;EOL?
	JR	NZ,SLIN3	;IF NOT
	JP	SLINB		;FIND EOL
;
SLIN4	CALL	CKALP		;CHECK ALPHA
	JR	C,SLIN1 	;SPECIAL
	JR	Z,SLIN9 	;VARIABLE
	CP	DATA		;DATA STMNT?
	JR	Z,SLIN5 	;IF YES
	CP	REM		;REM STMNT?
	JR	Z,SLIN5 	;IF NOT
	CP	FIELD		;FIELD STMNT?
	JR	NZ,SLIN6	;IF NOT
	SET	6,(IX+0)	;FLAG FIELD
	JR	SLIN6		;SKIP
;
SLIN5	SET	5,(IX+0)	;REM/DATA STMNT
;
;	KEYWORD REFRENCE
;
SLIN6	BIT	0,(IX+0)	;K PARAM SET?
	JR	Z,SLINF 	;NEXT REF
	LD	A,(IX+1)	;PASS FLAG
	DEC	A		;KEYWORD PASS?
	JR	NZ,SLINF	;NEXT REF
	LD	BC,8000H	;LSB
	LD	E,0		;NSB
	LD	D,(HL)		;D = KEYWORD
	CALL	CKREF		;CHK FOR NEW REF
;
SLINF	BIT	5,(IX+0)	;REM/DATA?
	JR	Z,SLIN1 	;IF NOT
	JP	SLINB		;NEXT LINE
;
;	LINE NUM REFRENCE
;
SLIN7	BIT	2,(IX+0)	;L PARAM SET?
	JR	Z,SLIN8 	;IF NOT
	LD	A,(IX+1)	;PASS FLAG
	CP	3		;LINE PASS?
	JR	NZ,SLIN8	;IF YES
;
	CALL	DECBIN		;CONVERT
	JR	C,SLIN8 	;OVERFLOW
	CALL	CKREF		;CHECK REF
	JR	SLIN1		;NEXT REF
;
;	SKIP LINE REFRENCE
;
SLIN8	RST	GETCHR		;GET NEXT BYTE
	JR	C,SLIN8 	;IF NUMERIC
	DEC	HL		;BKSP
	JR	SLIN1		;TRY AGAIN
;
;	VARIABLE REFRENCE
;
SLIN9	BIT	1,(IX+0)	;V PARAM SET?
	JR	Z,SLINA 	;IF NOT
	LD	A,(IX+1)	;PASS FLAG
	CP	2		;VAR PASS?
	JR	NZ,SLINA	;IF NOT
;
	BIT	6,(IX+0)	;FIELD STMNT?
	JR	Z,SLINC 	;IF NOT
;
	LD	A,(HL)		;GET CHAR
	CP	'A'             ;AS?
	JR	NZ,SLINC	;IF NOT
	RST	GETCHR		;NEXT CHAR
	CP	'S'             ;AS?
	JR	Z,SLIND 	;IF YES
	DEC	HL		;BKSP
	JR	SLINC		;SKIP
;
SLIND	RST	GETCHR		;GET NEXT CHAR
	CALL	CKALP		;VAR?
	JR	Z,SLINC 	;IF YES
	DEC	HL		;BKSP
	JP	SLIN1		;TRY AGAIN
;
SLINC	CALL	FVAR		;FETCH VAR NAME
	CALL	CKREF		;CHECK REF
	JP	SLIN1		;NEXT REF
;
;	SKIP VARIABLE REF
;
SLINA	RST	GETCHR		;GET NEXT BYTE
	JR	C,SLINA 	;VARIABLE
	CALL	CKALP		;CHECK ALPHA
	JR	Z,SLINA 	;VARIABLE
	DEC	HL		;BKSP
	JP	SLIN1		;TRY AGAIN
;
;	FIND END OF LINE
;
SLINB	XOR	A		;ZERO
	LD	C,A
	LD	B,A		;BC = COUNT
	CPIR			;LOOK!
	RET
;
;	CHECK REFRENCE ROUTINE
;
;	ENT	 C =	LSB REF
;		 B =	NSB REF
;		 E =	NSB REF
;		 D =	MSB REF
;
;	CHECK IF MATCH REFRENCE
;
CKREF	PUSH	HL		;SAVE => LINE
	LD	HL,CURR+3	;HL => LAST REF
	LD	A,(HL)		;MSB
	DEC	HL		;HL => NSB
	SUB	D
	JR	NZ,CKRF1	;NON EQUATE
	LD	A,(HL)		;NSB
	DEC	HL		;HL => LSB
	SBC	A,E
	JR	NZ,CKRF1	;NON EQUATE
	LD	A,(HL)		;NSB
	DEC	HL
	SBC	A,B
	JR	NZ,CKRF1	;NON EQUATE
	LD	A,(HL)		;LSB
	SBC	A,C
	JR	Z,CKRF2 	;REF = CURR
;
CKRF1	JR	C,CKRF5 	;REF > CURR
;
;	CHECK IF NEW REFRENCE
;
	BIT	7,(IX+0)	;SINGLE REF?
	JR	NZ,CKRF5	;IF YES
;
	LD	HL,LAST+3	;HL => LAST REF
	LD	A,(HL)		;MSB
	DEC	HL		;HL => NSB
	SUB	D
	JR	NZ,CKRF6	;NON EQUATE
	LD	A,(HL)		;NSB
	DEC	HL		;HL => LSB
	SBC	A,E
	JR	NZ,CKRF6	;NON EQUATE
	LD	A,(HL)		;NSB
	DEC	HL
	SBC	A,B
	JR	NZ,CKRF6	;NON EQUATE
	LD	A,(HL)		;LSB
	SBC	A,C
;
CKRF6	JR	NC,CKRF5	;REF <= LAST
;
;	SAVE NEW REFRENCE
;
	LD	HL,CURR 	;HL => CURR REF
	LD	(HL),C
	INC	HL
	LD	(HL),B		;LSB
	INC	HL
	LD	(HL),E		;NSB
	INC	HL
	LD	(HL),D		;MSB
	RES	4,(IX+0)	;TABLE EMPTY
;
;	REFRENCE TO TABLE
;
CKRF2	LD	HL,TABLE
	LD	BC,(LINE)	;LINE NUM
	BIT	4,(IX+0)	;DATA IN TABLE?
	JR	Z,CKRF4 	;IF NOT
;
	LD	HL,(POSN)	;TABLE POSN
	INC	HL
	LD	A,(HL)		;LAST LINE
	CP	B		;SAME LINE?
	DEC	HL
	JR	NZ,CKRF3	;IF NOT
	LD	A,(HL)		;LAST LINE
	CP	C		;SAME LINE?
	JR	Z,CKRF4 	;IF YES
;
CKRF3	LD	DE,EMEM-2	;END AVAIL MEM
	RST	CPHLDE		;TABLE FULL?
	JR	NC,CKRF5	;IF YES
	INC	HL
	INC	HL		;HL => NEXT TBL POS
;
CKRF4	LD	(POSN),HL	;SAVE TBL POSN
;
	LD	(HL),C		;SAVE MATCH
	INC	HL
	LD	(HL),B		;SAVE MATCH
	SET	4,(IX+0)	;DATA IN TABLE
;
CKRF5	POP	HL		;HL => LINE TEXT
	RET
;
;	OUTPUT CURRENT REFRENCE
;
OUTREF	LD	A,(IX+1)	;REF TYPE
	DEC	A
	JR	Z,OUTRF1	;KEYWORDS
	DEC	A
	JR	Z,OUTRF4	;VARIABLES
;
;	LINE REFRENCE OUTPUT
;
	LD	B,8		;TAB
	LD	DE,(CURR+2)	;GET REF
	CALL	BINDEC		;CONVERT
	CALL	OUTLIN		;OUTPUT
	JR	OUTRF5		;OUTPUT TABLE
;
;	KEYWORD REFRENCE OUTPUT
;
OUTRF1	LD	B,8		;TAB
	LD	A,(CURR+3)	;GET TOKEN
	SUB	127
	LD	C,A		;SAVE
	LD	HL,KTABLE	;KEYWORD TABLE
;
OUTRF2	LD	A,(HL)		;GET KEYWORD
	INC	HL		;NEXT
	OR	A		;CHK HIGH BIT
	JP	P,OUTRF2	;TIL START
	DEC	C		;CORRECT?
	JR	NZ,OUTRF2	;IF NOT
	AND	7FH		;IGNORE HIGH BIT
;
OUTRF3	CALL	OUTBYT		;OUTPUT CHAR
	LD	A,(HL)		;NEXT CHAR
	INC	HL		;NEXT
	OR	A		;GET HIGH BIT
	JP	P,OUTRF3	;TIL DONE
	JR	OUTRF5		;OUTPUT TABLE
;
;	VARIABLE REFRENCE OUTPUT
;
OUTRF4	LD	B,8		;TAB COUNT
	LD	HL,CURR+3
	LD	A,(HL)		;1ST CHAR
	DEC	HL
	CALL	OUTBYT		;OUTPUT
	LD	A,(HL)		;2ND CHAR
	DEC	HL
	CP	' '             ;1 CHAR NAME?
	CALL	NZ,OUTBYT	;OUTPUT
	LD	A,(HL)		;VAR TYPE
	DEC	HL
	CP	' '
	CALL	NZ,OUTBYT	;OUTPUT
	LD	A,(HL)		;ARRAY TYPE
	CALL	OUTBYT		;OUTPUT
;
;	OUTPUT REFRENCE TABLE
;
OUTRF5	LD	HL,TABLE	;REF TABLE
OUTRF6	LD	A,' '           ;SPACE
	CALL	OUTBYT
	JR	NZ,OUTRF6	;TAB
;
	LD	C,9		;REF/LINE
OUTRF7	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;DE = REF LINE
	INC	HL
	PUSH	HL		;SAVE => REF LINE
	CALL	BINDEC		;CONVERT
	CALL	OUTLIN		;OUTPUT
	POP	DE		;GET => REF LINE
;
	LD	HL,(POSN)	;LAST REF
	RST	CPHLDE		;END TABLE?
	EX	DE,HL		;HL => REF LINE
	JP	C,CR		;C/R & EXIT
;
	LD	A,' '           ;SPACE
	CALL	OUTBYT		;OUTPUT
	DEC	C		;END LINE?
	JR	NZ,OUTRF7	;IF NOT
	CALL	CR		;OUTPUT C/R
	POP	BC		;CLEAN STACK
	CALL	BAS2		;SCAN KBD
	PUSH	BC		;FIX STACK
	LD	B,8		;TAB
	JR	OUTRF6		;TIL EXIT
;
;	FETCH VARIABLE ROUTINE
;
;	EXT	 D =	MSB VAR NAME
;		 E =	NSB VAR NAME
;		 B =	VAR TYPE
;		 C =	ARRAY TYPE
;
FVAR	LD	D,(HL)		;1ST CHAR
	RST	GETCHR		;GET NEXT BYTE
	JR	Z,VAR3		;IF EOS
	JR	C,VAR4		;2 CHAR NAME
	CALL	CKALP		;CHECK ALPHA
	JR	Z,VAR4		;IF ALPHA
;
VAR3	DEC	HL		;BKSP
	LD	A,' '           ;DEFAULT
VAR4	LD	E,A		;E = 2ND CHAR
;
VAR5	RST	GETCHR		;GET NEXT BYTE
	JR	Z,VAR7		;IF EOL
	JR	C,VAR5		;IF NUMERIC
	CALL	CKALP		;CHECK ALPHA
	JR	Z,VAR5		;VARIABLE
	JR	NC,VAR7 	;TOKEN
;
VAR6	CP	'%'             ;INT?
	JR	Z,VAR8
	CP	'!'             ;SNG?
	JR	Z,VAR8
	CP	'$'             ;STR?
	JR	Z,VAR8
	CP	'#'             ;DBL?
	JR	Z,VAR8
;
VAR7	DEC	HL		;BKSP
	LD	A,' '           ;DEFAULT
VAR8	LD	B,A		;DEFAULT
;
	RST	GETCHR		;GET NEXT BYTE
	CP	'('             ;ARRAY?
	JR	Z,VAR9		;IF YES
;
	DEC	HL		;BKSP
	LD	A,' '           ;DEFAULT
VAR9	LD	C,A		;C = ARRAY
	RET
;
;	DECIMAL TO BINARY CONVERSION
;
DECBIN	LD	DE,0		;INIT RESULT
	DEC	HL		;BKSP
;
DECBN1	RST	GETCHR		;GET NEXT BYTE
	JR	C,DECBN2	;IF NUMERIC
	LD	BC,8000H	;LSB RESULT
	DEC	HL		;BKSP
	RET
;
DECBN2	SUB	'0'             ;KILL ASCII
	LD	C,A
	LD	B,0		;BC = DIGIT
	PUSH	HL		;SAVE
	LD	HL,6552 	;MAX LINE SIZE/10
	RST	CPHLDE		;OVERFLOW?
	JR	C,DECBN3	;IF YES
	LD	H,D
	LD	L,E		;HL = BIN
	ADD	HL,HL		; * 2
	ADD	HL,HL		; * 4
	ADD	HL,DE		; * 5
	ADD	HL,HL		; * 10
	ADD	HL,BC		;HL = RESULT
	EX	DE,HL		;DE = RESULT
	POP	HL		;GET => NUMBER
	JR	DECBN1		;NEXT
;
DECBN3	POP	HL		;RESTORE
	RET
;
;	BINARY TO DECIMAL CONVERSION
;
BINDEC	PUSH	BC		;SAVE REG
	LD	(FACC),DE	;SET BIN TO ACC
	LD	HL,TBUFF	;TEMP BUFF
	PUSH	HL		;SAVE BUFFER
	LD	BC,0		;NO FORMAT
	CALL	BAS1		;CONVERT
	POP	HL		;GET TEMP BUFF
	POP	BC		;GET REG
	RET
;
;	CHECK IF CHAR ALPHA
;
CKALP	CP	'A'             ;ALPHA?
	RET	C		;SPECIAL
	CP	127		;ALPHA?
	RET	NC
	CP	A		;Z STAT
	RET
;
;	OUTPUT LINE HANDLER
;
OUTLIN	LD	A,(HL)		;GET CHAR
	OR	A		;EOL?
	RET	Z		;EXIT
	CALL	OUTBYT		;OUTPUT
	INC	HL		;NEXT
	JR	OUTLIN		;TIL DONE
;
;	OUTPUT BYTE HANDLER
;
CR	LD	A,13		;C/R
OUTBYT	CALL	DOUT		;SAVE
	DEC	B		;TAB (IF USED)
	RET
;
;	MESSAGES AND TEXT STRINGS
;
TITLE	DEFB	13
	DEFM	'REF - BASIC 1.2 Program Referencer - Series A.00'
	DEFB	13
	DEFM	'(c)(p) Copyright 1982 by MicroPower, Inc.'
	DEFB	13
	DEFB	13
TL	EQU	$-TITLE
;
;	VARIABLES AND DATA
;
FLAGS	DEFB	0		;MISC FLAGS
	DEFB	3		;REF TYPE
;
LINE	DEFS	2		;CURRENT LINE
POSN	DEFS	2		;TABLE POSN
CURR	DEFS	4		;CURRENT REF
LAST	DEFS	4		;LAST REF
TBUFF	DEFS	7		;TEMP BUFF
;
TABLE	EQU	$		;REFRENCE TABLE
;
	END	START
