SORT   	PAGE
 ;
 ;	$SORT	- SVC 56
 ;	sort memory block
 ;
 ;	ENT	IX => first entry in list
 ;		DE => last entry in list
 ;		B = position of key in entry
 ;		C = length of each entry
 ;		L = length of sort key
 ;		H = 0 = ascending sort
 ;		H <> 0 = descending sort
 ;
 ;	EXT	Z = OK
 ;		NZ = A = special error code
 ;	1 = key end exceeded last byte of entry
 ;	2 = key start exceeds last byte of entry
 ;	3 = entry length =0 (invalid)
 ;	4 = key length =0 (invalid)
 ;	5 = address of first entry > last entry
 ;
 ;
 ;	$SORT2	-	- sort memory block
 ;
 ;	ENT	same as $SORT EXCEPT
 ;		DE = number of entries to sort
 ;
 ;	EXT	same as $SORT
 ;
 SORT	CALL	SETSORT		;setup sort params
 	CALL	NUMENT		;load DE with # entries
 	JR	SORTGO		;go!
 ;
 SORT2	CALL	SETSORT		;setup sort params
 ;
 SORTGO	CALL	PARSORT		;check params
 	RET	NZ		;error, return
 ;
 	LD	B,D		;load BC with entries
 	LD	C,E
 ;
 SORT0	LD	(BASE),HL	;save loop base
 	LD	D,H		;pass to DE
 	LD	E,L
 	PUSH	BC		;save counter
 	JR	SORT22		;continue next entry
 ;
 SORT1	CALL	COMPAR		;test entries
 	JR	Z,SORT22	;no change
 SORTDIR	JR	NC,SORT22	;go
 	LD	(BASE),DE	;have new low/high
 ;
 SORT22	PUSH	HL		;save pointer
 	LD	HL,0		;entry length
 ENTLEN	EQU	$-2
 	ADD	HL,DE		;point to next one
 	EX	DE,HL		;DE = next entry
 	POP	HL		;restore pointer
 ;
 	DEC	BC		;see if more
 	LD	A,B
 	OR	C
 	JR	NZ,SORT1	;finish this pass
 ;
 	LD	BC,0		;get base
 BASE	EQU	$-2
 	PUSH	HL		;save pointer
 	OR	A		;clear carry
 	SBC	HL,BC		;see if HL = (BASE)
 	POP	HL		;restore pointer
 	JR	Z,SORT3		;no change, skip
 	CALL	SWAP		;else swap entries
 ;
 SORT3	LD	BC,(ENTLEN)	;entry length
 	ADD	HL,BC		;point to next
 	POP	BC		;get counter
 	DEC	BC		;see if more to do
 	LD	A,B
 	OR	C
 	JR	NZ,SORT0	;go if more
 ;
 	XOR	A		;else done, return Z
 	RET
 ;
 ;	compare two sort entries
 ;
 COMPAR	PUSH	HL		;short push for speed
 	PUSH	DE
 	PUSH	BC
 	LD	BC,0		;sort offset
 SRTOFF	EQU	$-2
 	LD	HL,(BASE)	;get current base
 	ADD	HL,BC		;point to sort field
 	EX	DE,HL		;get current pointer
 	ADD	HL,BC		;point to sort field
 	EX	DE,HL
 	LD	B,0		;get sort length
 SRTLEN	EQU	$-1
 COMPLP	LD	A,(DE)		;get a byte
 	CP	(HL)		;same?
 	JR	NZ,COMPRT	;nope, return
 	INC	DE		;bump pointers
 	INC	HL
 	DJNZ	COMPLP		;go more
 ;
 COMPRT	POP	BC		;unstack & return
 	POP	DE
 	POP	HL
 	RET			;done, flags set
 ;
 ;	swap two sort fields
 ;
 SWAP	PUSH	HL		;quick push's
 	PUSH	DE
 	PUSH	BC
 	LD	DE,(BASE)	;get base pointer
 	LD	A,(ENTLEN)	;entry length
 	LD	B,A		;pass here
 ;
 SWAPLP	LD	C,(HL)		;get a byte
 	LD	A,(DE)		;get other
 	LD	(HL),A		;swap 'em
 	LD	A,C
 	LD	(DE),A		;this entry done
 	INC	HL		;bump pointers
 	INC	DE
 	DJNZ	SWAPLP		;finish em
 ;
 	POP	BC		;unstack & return
 	POP	DE
 	POP	HL
 	RET			;done
 ;
 ;	setup sort parameters
 ;
 SETSORT	POP	AF		;get caller address
 	CALL	REGSAV		;save all registers
 	PUSH	AF		;put caller back
 	LD	A,JRNC		;JR NC opcode
 	INC	H		;test ascending/descend
 	DEC	H		;H = 0 ?
 	JR	Z,SET0		;ascending
 	LD	A,JRC		;JR C opcode
 SET0	LD	(SORTDIR),A	;put into code
 	LD	A,L		;get key length
 	LD	(SRTLEN),A	;save it
 	PUSH	IX		;pass IX => HL
 	POP	HL
 	LD	A,B		;sort key offset
 	LD	(SRTOFF),A	;save it
 	LD	A,C		;entry length
 	LD	(ENTLEN),A	;save it
 	RET			;done, all OK
 ;
 ;	compute # entries to sort
 ;
 NUMENT	PUSH	HL		;save buff start
 	PUSH	BC		;save data
 	LD	BC,1		;start # entries
 ;
 NUMELP	OR	A		;clear carry
 	PUSH	HL		;save pointer
 	SBC	HL,DE		;test for end
 	POP	HL		;restore it
 	JR	NC,NUMHAV	;have it, go
 ;
 	INC	BC
 	LD	A,(ENTLEN)	;entry length
 	ADD	A,L		;add to pointer
 	LD	L,A		;update
 	JR	NC,NUMELP	;no page crossed
 	INC	H		;else bump page
 	JR	NUMELP
 NUMHAV	LD	D,B		;load count here
 	LD	E,C
 	POP	BC		;unstack
 	POP	HL
 	RET			;done
 ;
 ;	check for valid parameters
 ;
 PARSORT	XOR	A		;set flags
 	EX	AF,AF'		;for error
 	LD	A,(SRTLEN)	;sort field length
 	OR	A		;0 ?
 	LD	A,4		;invalid code
 	JR	Z,PARRET	;invalid
 ;
 	LD	A,C		;entry length
 	OR	A		;0 ?
 	LD	A,3		;invalid code
 	JR	Z,PARRET	;invalid
 ;
 	LD	A,B		;key posit
 	CP	C		;entry length
 	LD	A,2		;invalid code
 	JR	NC,PARRET	;invalid
 ;
 	LD	A,(SRTLEN)	;sort length
 	ADD	A,B		;add key offset
 	DEC	A		;adjust for compare
 	CP	C		;key st+len <= ent len
 	LD	A,1		;error code
 	JR	NC,PARRET	;invalid
 ;
 	LD	A,D		;see if nil length
 	OR	E
 	LD	A,5		;error code
 	JR	Z,PARRET	;invalid
 ;
 	XOR	A		;all OK
 ;
 PARRET	OR	A		;set flags
 	RET			;done
 ;
