; sr/asm - sjp/mss - 08/82
;
	TITLE	'<BASIC Search/replace program - Ver1.0>'
;	Created: 03-MAR-81 - Revised: 03-MAR-81
;
;	MISC ROM BASIC ROUTINES
;
CPHLSP	EQU	20H		;CP (HL) & (SP)
GETCHR	EQU	28H		;GET NEXT CHAR
CPHLDE	EQU	30H		;CP HL & DE
;
FCERR	EQU	330EH		;ILL FUNCTION CALL
BAS0	EQU	44D8H		;TEST FOR STRING
BAS1	EQU	3775H		;EVALUATE EXPRESSION
BAS2	EQU	5CB7H		;CURRENT STR ADD TO HL
BAS4	EQU	3D55H		;EXPAND BASIC TEXT
BAS5	EQU	57DBH		;SCAN KBD FOR BREAK
BAS6	EQU	4A31H		;OUTPUT LINE NUMBER
BAS7	EQU	56B6H		;OUTPUT CHARACTER
BAS8	EQU	3D4CH		;OUTPUT LINE TEXT
BAS9	EQU	57BAH		;OUTPUT C/R
BAS10	EQU	30F5H		;ENCODE STMNT
BAS11	EQU	303BH		;INSERT LINE
BAS12	EQU	30BCH		;GET START & END LINES
BAS14	EQU	30D8H		;SEARCH FOR LINE
BAS15	EQU	30A4H		;UPDATE POINTERS
BAS16	EQU	586EH		;INIT VAR & CLOSE
BAS17	EQU	2F0FH		;CHECK MEMORY SIZE
BASIC	EQU	2FA7H		;EXIT TO READY
;
;	RESERVED BASIC ADDRESSES
;
EXIT	EQU	0000H		;DOS EXIT VECTOR
CURLIN	EQU	2B4DH		;CURRENT LINE NUM
PGMBEG	EQU	2B4FH		;START BASIC TEXT
INPBUF	EQU	2BADH		;INPUT BUFFER LOC
CURNUM	EQU	2CF7H		;CURRENT LINE NUM
PGMEND	EQU	2D04H		;END PROGRAM TEXT
;
SVC	EQU	8		;EXECUTE SVC
VDLINE	EQU	9		;VIDEO LINE ROUTINE
;
	ORG	2200H
;
;	CHECK IF UNDER BASIC CONTROL
;
START	LD	HL,12		;GET RET ADDRESS
	ADD	HL,SP
	LD	SP,HL
	POP	HL		;HL = RET ADD
	LD	DE,EXIT 	;DOS VECTOR
	OR	A		;CLR CRY
	SBC	HL,DE		;UNDER BASIC?
	JR	NZ,START1	;EXIT DOS
;
	LD	HL,TITLE	;'PROGRAM TITLE'
	LD	BC,TL<8+13	;LEN+TERM
	LD	A,VDLINE	;OUTPUT LINE
	RST	SVC
	RST	EXIT		;RETURN
;
;	GET OPTIONAL PARAMETERS
;
START1	POP	HL		;IGNORE CALLER
	POP	HL		;IGNORE CALLER
	POP	HL		;GET CODE STRING
	POP	AF		;IGNORE CALLER
;
;	CHECK FOR EXPRESSIONS
;
	RST	CPHLSP		;CP (HL) TO NEXT
	DEFM	','             ;SYNTAX
;
;	GET SEARCH STRING
;
	LD	DE,SSTR 	;DE => MOVE AREA
	CALL	GTSTR		;GET STRING
	JP	Z,FCERR 	;IF NULL
;
;	GET REPLACE STRING
;
	RST	GETCHR		;GET NEXT CHAR
	JR	Z,SRCH1 	;END STMNT
;
	RST	CPHLSP		;CP (HL) TO NEXT
	DEFM	','             ;SYNTAX
	JR	C,SRCH1 	;IF NUMERIC
	LD	(RFLG),A	;REPLACE FLAG
	LD	DE,RSTR 	;DE => MOVE AREA
	CALL	GTSTR		;GET STRING
;
;	GET START/END LINES
;
	RST	GETCHR		;GET NEXT CHAR
	JR	Z,SRCH1 	;IF EOT
;
	RST	CPHLSP		;CP (HL) TO NEXT
	DEFM	','             ;SYNTAX
	JR	C,SRCH1 	;IF NUMERIC
;
SRCH1	CALL	BAS12		;GET START & END LINES
	PUSH	BC		;SAVE START LINE
	LD	HL,-1
	LD	(CURLIN),HL	;SIGNAL COMMAND MODE
	POP	HL		;HL => START LINE
;
;	GET NEXT AVAILABLE LINE
;
SRCH2	POP	DE		;DE = END NUM
	LD	A,(HL)
	INC	HL		;NEXT
	OR	(HL)		;BC => NEXT LINE
	INC	HL		;NEXT
	JR	Z,SRCH3 	;IF YES
;
	LD	A,(RFLG)	;REPLACE FLAG
	OR	A		;REPLACING?
	CALL	Z,BAS5		;IF NOT, SCAN KBD
;
;	GET LINE NUMBER AND POSITION
;
	LD	C,(HL)
	INC	HL
	LD	B,(HL)		;BC = LINE NUMBER
	INC	HL		;HL => POSITION
	PUSH	BC		;SAVE LINE NUM
	EX	(SP),HL 	;GET NUM, SAVE POS
	EX	DE,HL		;DE = NUM, HL = END NUM
	RST	CPHLDE		;DONE?
	JR	NC,SRCH4	;IF NOT
;
;	EXIT PROGRAM ROUTINE
;
	POP	BC		;CLEAN STACK
;
SRCH3	LD	A,(RFLG)	;REPLACE FLAG
	OR	A		;REPLACE ANYTHING?
	JP	Z,BASIC 	;IF NOT
	CALL	BAS15		;UPDATE POINTERS
	CALL	BAS16		;CLOSE FILES & INIT
	JP	BASIC		;READY ROUTINE
;
;	EXPAND LINE FOR SEARCH/REPLACE
;
SRCH4	EX	(SP),HL 	;GET POSN, SAVE END
	PUSH	HL		;SAVE => TEXT
	LD	(CURNUM),DE	;SAVE CURRENT NUM
	XOR	A
	LD	(AFLG),A	;NO ADJUSTMENTS
	CALL	BAS4		;EXPAND LINE
	LD	HL,INPBUF	;HL => EXPAND TEXT
	PUSH	HL		;SAVE POINTER
	CALL	FEOL		;GET EOL
	POP	DE		;DE => EXPAND TEXT
	SBC	HL,DE		;GET LINE LEN
	LD	A,L		;C = LINE+EOL LEN
	LD	(LEN),A 	;SAVE LENTH
	LD	C,A		;C = LENTH
	LD	HL,SSTR 	;HL => SRCH INFO
	LD	B,(HL)		;B = SRCH LEN
	INC	HL		;HL => SRCH STRING
;
;	SCAN LINE FOR SEARCH STRING
;
;	ENT	 B =	SEARCH LEN
;		 C =	REMAINING LEN
;		DE =>	LINE POSITION
;		HL =>	SEARCH STRING
;
SCAN1	PUSH	HL		;SAVE LENTHS
	PUSH	BC		;SAVE STR POS
	PUSH	DE		;SAVE SRCH STRING
;
SCAN2	DEC	C		;END LINE?
	JR	Z,SCAN3 	;IF YES
;
	LD	A,(DE)		;GET LINE CHAR
	CP	(HL)		;MATCH?
	JR	NZ,SCAN3	;IF NOT
	INC	DE		;NEXT
	INC	HL		;NEXT
	DJNZ	SCAN2		;TIL END STR
	JR	SCAN5		;MATCH, SKIP
;
SCAN3	POP	DE		;GET SRCH STR
	POP	BC		;GET 1ST CHAR
	POP	HL		;GET LENTHS
	INC	DE		;NEXT
	DEC	C		;END LINE?
	JR	NZ,SCAN1	;IF NOT
	JR	INSRT		;ATTEMPT INSERT
;
;	CHECK FOR REPLACE OPTION
;
SCAN5	LD	A,(RFLG)	;REPLACE FLAG
	OR	A		;REPLACE?
	JR	NZ,REPL 	;IF YES
;
;	DISPLAY LINE CONTAINING STRING
;
SCAN8	POP	AF		;CLEAN STACK
	POP	AF
	POP	AF
	POP	HL		;HL => CODE LINE
	CALL	OUTLIN		;DISPLAY LINE
	CALL	FEOL		;FIND NEXT LINE
	JR	SRCH2		;NEXT LINE
;
;	REPLACE SEARCH STRING
;
;	ENT	 C =	REMAINING LENTH
;		DE =>	END SRCH STRING
;		SP =>	START SRCH STRING
;		SP+2 => SEARCH STRING
;
REPL	LD	A,(SSTR)	;SRCH STRING LEN
	LD	B,A		;B = LEN
	LD	A,(LEN) 	;LENTH LINE
	DEC	A		;IGNORE EOL
	SUB	B		;LEN = LEN - SRCH
	LD	B,A		;B = LEN - SRCH
	LD	A,(RSTR)	;REP STRING LEN
	ADD	A,B		;LEN = LEN + REP
	JP	C,REP2		;TOO LONG
	INC	A		;ADD EOL
	LD	(LEN),A 	;ADJ LENTH
;
;	REMOVE SRCH STRING FROM LINE
;
	EX	DE,HL		;HL => END SRCH STR
	POP	DE		;GET START POS
	POP	AF		;IGNORE LENTHS
	LD	B,A		;SET SRCH LEN
	PUSH	BC		;SAVE LENTHS
	PUSH	DE		;SAVE IT
	LD	B,0		;BC = REMAIN LENTH
	LDIR			;DO IT!
;
	LD	(AFLG),A	;LINE ADJUSTED
;
;	INSERT REPLACE STRING IF ANY
;
	LD	A,(RSTR)	;REPLACE STRING
	OR	A		;ANY REPLACE?
	JR	Z,REP1		;IF NOT
;
	LD	C,A		;BC = LEN REPLACE
	POP	AF		;IGNORE START POS
	DEC	DE		;DE => END LINE
	LD	L,E
	LD	H,D		;HL => END LINE
	ADD	HL,BC		;HL => NEW END LINE
	EX	DE,HL		;SWAP FOR BUMP
	POP	BC		;GET REMAIN LEN
	PUSH	BC		;SAVE IT
	LD	B,0		;BC = REMAIN LEN
	LDDR			;BUMP!
	EX	DE,HL		;DE => INSERT-1
	INC	DE		;DE => INSERT
	LD	HL,RSTR 	;HL => REPLACE-1
	LD	C,(HL)		;C = REP LEN
	INC	HL		;HL => REPLACE
	LDIR			;INSERT!
	POP	BC		;BC = LENTHS
	POP	HL		;HL => SRCH STRING
	JR	SCAN1		;TRY AGAIN
;
REP1	POP	DE		;BC = LENTHS
	POP	BC		;DE => REMAIN STRING
	POP	HL		;HL => SRCH STRING
	JR	SCAN1		;TRY AGAIN
;
;	INSERT LINE IN TEXT IF ADJUSTED
;
INSRT	POP	HL		;HL => CUR LINE
	LD	D,H
	LD	E,L		;DE => CUR LINE
	DEC	DE
	DEC	DE
	DEC	DE
	DEC	DE
	CALL	FEOL		;LOCATE NEXT
	LD	A,(AFLG)	;ADJ FLAG
	OR	A		;LINE ADJ?
	JP	Z,SRCH2 	;TIL DONE
;
;	DELETE LINE FROM PROGRAM
;
	PUSH	DE		;SAVE => LINE
	CALL	OUTLIN		;DISPLAY LINE
	EX	DE,HL		;DE => END LINE
	LD	HL,(PGMEND)	;HL => END PROGRAM
	OR	A		;CLR CRY
	SBC	HL,DE		;HL = LENTH REMAIN PROG
	LD	B,H
	LD	C,L		;BC = LENTH REMAIN
	POP	HL		;HL => LINE
	PUSH	BC		;SAVE BLK LEN
	EX	DE,HL		;SWAP FOR MOVE
	LDIR			;DELETE!
;
;	INSERT NEW ENCODED LINE
;
	PUSH	DE		;SAVE => END PROGRAM
	LD	HL,INPBUF	;HL => EXPANDED LINE
	CALL	BAS10		;ENCODE IT
	POP	DE		;GET => END PROGRAM
	LD	H,D
	LD	L,E		;HL => END PROGRAM
	ADD	HL,BC		;HL => NEW END PROGRAM
	CALL	CKMEM		;MEMORY AVAIL?
	LD	(PGMEND),HL	;SET NEW END
	DEC	DE		;DE => END PROGRAM
	DEC	HL		;HL => NEW END
	EX	DE,HL		;SWAP FOR BUMP
	POP	AF		;GET BLK LENTH
	PUSH	BC		;SAVE LINE LEN
	PUSH	AF		;SAVE BLK LEN
	POP	BC		;BC = BLK LEN
	LDDR			;BUMP!
	INC	HL
	INC	HL
	LD	(HL),H		;DUMMY MSB
	INC	HL		;HL => LINE NUMBER
	LD	BC,(CURNUM)	;GET LINE NUM
	LD	(HL),C
	INC	HL
	LD	(HL),B		;SET LINE NUM
	INC	HL
	EX	DE,HL		;DE => INSERT
	LD	HL,INPBUF-2	;HL => NEW LINE+2
	POP	BC		;BC = LINE LEN
	DEC	BC
	DEC	BC		;IGNORE POINT
	DEC	BC
	DEC	BC		;IGNORE LINE NUM
	LDIR			;INSERT!
	EX	DE,HL		;HL => NEXT LINE
	JP	SRCH2		;TRY AGAIN
;
;	ERROR MESSAGE HANDLERS
;
REP2	LD	HL,MES1 	;'TOO LONG'
	CALL	BAS8		;OUPUT
	JP	SCAN8		;SKIP
;
;	S/R TO GET SEARCH/REPLACE STRINGS
;
;	ENT	DE =>	STRING STORAGE AREA
;		HL =>	SEARCH/REPLACE EXPRESSION
;
GTSTR	PUSH	DE		;SAVE MOVE AREA
	CALL	BAS1		;EVALUATE EXPRESION
	CALL	BAS0		;MAKE SURE STRING
	DEC	HL		;BKSP
	EX	(SP),HL 	;SAVE CODE STRING
	PUSH	HL		;SAVE MOVE AREA
	CALL	BAS2		;STR ADD TO HL
	POP	DE		;GET MOVE AREA
	LD	A,(HL)		;C = STR LENTH
	LD	(DE),A		;SAVE STR LENTH
	OR	A		;NULL?
	JR	Z,GTSTR1	;IF YES
	INC	DE		;MOVE AREA+1
	INC	HL		;HL => STR ADDRESS
	LD	C,A		;C = STR LENTH
	LD	B,0		;BC = STR LENTH
	LD	A,(HL)		;LSB
	INC	HL		;NEXT
	LD	H,(HL)		;MSB
	LD	L,A		;HL => STRING
	LDIR			;MOVE STRING
GTSTR1	POP	HL		;GET CODE STRING
	RET
;
;	DISPLAY BASIC LINE
;
OUTLIN	PUSH	HL		;SAVE
	PUSH	HL
	LD	HL,(CURNUM)	;HL = LINE NUM
	CALL	BAS6		;OUTPUT LINE NUM
	POP	HL
	LD	A,(HL)
	CP	9		;TAB?
	JR	Z,$+7		;SKIP
	LD	A,' '           ;BLANK
	CALL	BAS7		;OUTPUT CHAR
	LD	HL,INPBUF	;EXPANDED LINE
	CALL	BAS8		;OUTPUT LINE
	CALL	BAS9		;OUTPUT C/R
	POP	HL		;RESTORE
	RET
;
;	FIND END OF CODE LINE
;
FEOL	XOR	A		;ZERO
FEOL1	CP	(HL)		;EOL?
	INC	HL		;NEXT
	JR	NZ,FEOL1	;IF NOT
	RET
;
;	CHECK MEMORY SIZE
;
CKMEM	PUSH	DE		;SAVE
	PUSH	HL
	EX	DE,HL		;DE => MEMORY
	LD	HL,65478	;LAST VALID ADD
	OR	A		;CLR CRY
	SBC	HL,DE		;ADD => VALID?
	JR	C,CKMEM1	;IF YES
	ADD	HL,SP		;VALID-ADD+SP OK?
	POP	HL		;RESTORE
	POP	DE
	RET	C
;
CKMEM1	CALL	BAS15		;ADJUST POINTERS
	INC	HL
	LD	(PGMEND),HL	;SET END MEMORY
	LD	E,6+6		;?OM ERROR
	JP	BAS17		;ERROR HANDLER
;
TITLE	DEFB	13
	DEFM	'SR - BASIC 1.2 Global Search/Replace - Series A.00'
	DEFB	13
	DEFM	'(c)(p) Copyright 1982 by MicroPower, Inc.'
	DEFB	13
TL	EQU	$-TITLE
;
MES1	DEFM	'Line too long to edit'
	DEFB	13
	DEFB	0
;
;	VARIABLES AND DATA
;
RFLG	DEFB	0
LEN	DEFS	1
AFLG	DEFS	1
;
SSTR	DEFS	256
RSTR	DEFS	256
;
	END	START
