; sysgen/asm - sjp/mss - 08/82
;
	TITLE	'<DOSPLUS II.A - System generation>'
;
;	This program is designed to place a SYSTEM
;	on any supported media. In the case of DDEN 8"
;	media, we will attempt to re-format cylinder 0
;	to SDEN for ROM compatability.
;
;	Created: 29-OCT-81	SJP/MSS
;
	PAGE
;	ERROR CODE EQUIVALENCES
;
EC08	EQU	8		;DRIVE NOT READY
EC15	EQU	15		;DISK WRITE PROTECTED
EC17	EQU	17		;DIR READ ERROR
EC18	EQU	18		;DIR WRITE ERROR
EC28	EQU	28		;READ AT EOF
EC29	EQU	29		;READ PAST EOF
EC68	EQU	68		;INVALIDE DEVICESPEC
EC72	EQU	72		;PROTECTED DEVICE
EC82	EQU	82		;NO MEMORY!
;
;	LOCAL VARIABLE EQUIVALENCES
;
ETX	EQU	3		;ASCII ETX
CR	EQU	13		;ASCII C/R
SVC	EQU	08H		;EXECUTE SVC
DIO	EQU	10H		;DISK I/O MANAGER
OVL	EQU	18H		;OVERLAY LOADER
;
;	EXTERNAL SVC EQUIVALENCES
;
VDCHAR	EQU	8		;VIDEO CHARACTER
KBLINE	EQU	5		;KEYBOARD LINE
VDLINE	EQU	9		;DISPLAY LINE HANDLER
ERROR	EQU	39		;POST AN ERROR MESSAGE
CLOSE	EQU	42		;CLOSE A CHANNEL
ABORT	EQU	57		;ABNORMAL EXIT
READNX	EQU	34		;READ LOGICAL RECORD
WRITNX	EQU	43		;WRITE LOGICAL RECORD
FSPEC	EQU	84		;FETCH FILESPEC
;
;	EXTERNAL I/O EQUIVALENCES
;
DCHECK	EQU	0		;CHECK IF DRIVE AVAIL
DHOME	EQU	1		;HOME/INIT DRIVE
DREAD	EQU	3		;READ DISK SECTOR
DVERF	EQU	4		;VERIFY DISK SECTOR
DWRITE	EQU	5		;WRITE DISK SECTOR
SREAD	EQU	6		;READ SYSTEM SECTOR
SWRITE	EQU	7		;WRITE SYSTEM SECTOR
DFORM	EQU	8		;FORMAT TRACK
;
;	EXTERNAL SYSTEM EQUIVALENCES
;
EXIT	EQU	0000H		;NORMAL PROGRAM EXIT
LMEM$	EQU	0171H		;START FREE MEMORY
HMEM$	EQU	0173H		;TOP FREE MEMORY
REGSAV	EQU	0303H		;SAVE REGISTERS
SDIVD	EQU	030FH		;8 X 8 DIVIDE
DDIVD	EQU	0315H		;8 X 16 DIVIDE
LOCDCT	EQU	032DH		;LOCATE DCT
STACK	EQU	1A00H		;STACK LOCATION
ENDRES	EQU	2200H		;END RESIDENT CODE
;
	PAGE
;	DISPLAY TITLE AND COPYRIGHT
;
	ORG	2200H
;
START	LD	SP,STACK	;INIT STACK
	PUSH	HL		;SAVE CMD LINE
	LD	HL,TITLE	;'PROGRAM TITLE'
	LD	BC,TL<8+CR	;LEN + TERM
	LD	A,VDLINE	;OUTPUT
	RST	SVC
	JP	NZ,POSTE	;IF ERROR
;
;	LOCATE AVAILABLE BUFFERS
;
	LD	HL,(LMEM$)	;HL => LOW MEM
	LD	BC,ENDPGM	;BC => FREE MEM
	OR	A		;CLR CRY
	SBC	HL,BC		;BC => LOW
	JR	C,$+9
	LD	BC,(LMEM$)	;GET LOW
	LD	C,0		;EVEN PAGE
	INC	B		;NEXT PAGE
	LD	(BUFER1),BC	;GAT BUFFER
	INC	B		;NEXT
	LD	(BUFER2),BC	;HIT BUFFER
	INC	B
	LD	(BUFER3),BC	;I/O BUFFER
	INC	B
	LD	(BUFER4),BC	;I/O BUFFER
	LD	HL,5400 	;5K
	ADD	HL,BC		;HL => END BUFFER
	LD	A,EC82		;NO MEMORY!
	JP	C,POSTE 	;NO MEMORY!
	LD	BC,(HMEM$)	;HL => TOP
	SBC	HL,BC		;HL => BUFFER
	JP	NC,POSTE	;NO MEMORY!
	POP	HL		;GET CMD LINE
;
	PAGE
;	INPUT TARGET DRIVE SPEC
;
	CALL	POSHL		;POSITION HL
	JR	NZ,FDRV 	;NON-TERMINATOR
;
INPDRV	LD	B,'*'           ;PROMPT
	LD	A,VDCHAR	;VIDEO CHARACTER
	RST	SVC		;OUTPUT
	JP	NZ,POSTE	;IF ERROR
	LD	HL,DCB2 	;TEMP BUFFER
	LD	B,10		;INPUT LEN
	LD	A,KBLINE	;KEYBOARD LINE
	RST	SVC		;INPUT LINE
	JR	C,INPDR1	;IF (BREAK)
	LD	A,C		;GET TERM
	OR	A		;FULL?
	JR	Z,INPDRV	;TRY AGAIN
	CALL	POSHL		;POSITION HL
	JR	Z,INPDRV	;IF TERM
	JR	FDRV		;SKIP
;
INPDR1	LD	HL,MES1 	;'PROGRAM TERMINATED'
	LD	BC,M1L<8+CR	;LEN+TERM
	LD	A,VDLINE	;VIDEO LINE
	RST	SVC
	RST	EXIT
;
;	FECTH DRIVE SPECIFICATION
;
FDRV	LD	DE,DCB1 	;SOURCE DCB
	LD	A,FSPEC 	;FETCH DRIVE SPEC
	RST	SVC
	JP	NZ,POSTE	;GET DRIVE
	LD	A,(DE)		;FLAGS
	AND	0C0H		;BITS 6 & 7
	CP	080H		;OK?
	LD	B,EC68		;INVALID DRIVE
	JP	NZ,POSTB	;TRY AGAIN
	LD	A,(DE)		;GET FLAGS
	AND	0FH		;DEVICE NUMBER
	SUB	8		;CORRECT
	LD	B,EC72		;PROTECTED DEVICE
	JP	Z,POSTB 	;IF SYSTEM DEVICE
	LD	(DRV2),A	;SAVE DRIVE
	LD	C,A		;C = DRIVE
	CALL	LOCDCT		;LOCATE DCT
;
	PAGE
;	READ TARGET DISK'S DCT
;
	LD	A,DCHECK	;DISK CHECK
	RST	DIO		;DRIVE READY?
	LD	B,EC08
	JP	NZ,POSTB	;NOT READY
	LD	B,EC15
	JP	C,POSTB 	;WRITE PROT
;
	LD	A,DHOME 	;DISK HOME
	RST	DIO		;HOME DRIVE
	RES	7,(IY+13)	;START SDEN
	LD	DE,2		;TRACK,SEC
	LD	B,D		;BE = SECTOR
	LD	HL,(BUFER1)	;GAT BUFFER
	LD	A,DVERF 	;DISK VERIFY
	RST	DIO		;ATTEMPT READ
	JR	Z,RDGAT 	;NO ERRORS
	SET	7,(IY+13)	;DDEN
	LD	A,DVERF 	;DISK VERIFY
	RST	DIO		;ATTEMPT READ
	JP	NZ,POSTE	;I/O ERROR
	LD	A,-1		;TRUE
	LD	(FTK),A 	;FORMAT FLAG
;
;	READ TARGET GAT/HIT TABLES
;
RDGAT	SET	0,(IY+5)	;FORCE LOG-IN
	LD	B,3		;SEC COUNT
	LD	E,0		;E = SECTOR
;
RDGAT1	PUSH	BC		;SAVE COUNT
	LD	B,0		;BE = SECTOR
	LD	A,SREAD 	;SYSTEM READ
	RST	DIO		;READ GAT TABLE
	POP	BC		;GET COUNT
	JP	NZ,POSTE	;I/O ERROR
	INC	E		;HIT SECTOR
	INC	H		;HIT BUFFER
	DJNZ	RDGAT1		;TIL DONE
	LD	A,(IY+18)	;DIR LOCATION
	LD	(DDIR),A	;DEST DIR
;
;	CHECK FOR INVALID FILES
;
	LD	HL,(BUFER2)	;HL => HIT
	INC	L		;SKIP BOOT/SYS
	INC	L		;SKIP DIR/SYS
	LD	A,(HL)		;GET HIT CODE
	OR	A		;NULL?
	JP	NZ,ERR1 	;CONTAINS DATA
	INC	L		;NEXT
	JR	NZ,$-6		;TIL DONE
;
	PAGE
;	CHECK FOR SPECIAL BOOT WRITE
;
	BIT	5,(IY+5)	;HD?
	JR	Z,CKFOR 	;IF NOT
	LD	E,(IY+1)
	LD	D,(IY+2)	;DE => DRIVER
	LD	HL,ENDRES-1	;END RESIDENT CODE
	OR	A		;CLR CRY
	SBC	HL,DE		;RESIDENT DRIVER?
	JP	C,PSYS		;IF NOT
;
;	CORRECT BOOT/SYS ALLOCATION
;
	LD	A,(IY+16)	;SEC/TRACK
	CP	18		;BIG ENOUGH?
	JP	C,ERR2		;CAN'T DO IT!
	LD	E,A		;E = SEC/TRACK
	LD	A,(IY+19)	;SEC/GRAN
	CALL	SDIVD		;TS/GS
	INC	E
	DEC	E		;PARTIAL GRAN?
	JR	NZ,$+3		;IF YES
	DEC	A		;CORRECT
	LD	HL,(BUFER3)	;HL => BOOT/SYS
	LD	DE,23		;OFFSET
	ADD	HL,DE		;HL => GRANS
	LD	(HL),A		;CORRECT
;
	LD	HL,(BUFER1)	;HL => GAT
	LD	E,A		;E = COUNT-1
	LD	A,0		;INIT CODE
	CALL	BSET		;SET BIT
	DEC	E		;NEXT
	JP	P,$-4		;TIL DONE
	LD	(HL),A		;TO GAT
;
;	WRITE UPDATED BOOT/SYS
;
	LD	HL,(BUFER3)	;HL => BOOT/SYS
	LD	E,2
	LD	B,0		;BE = SECTOR
	LD	A,SWRITE	;SYSTEM WRITE
	RST	DIO		;WRITE BOOT
	JP	NZ,POSTE	;IF ERROR
;
	PAGE
;	SET LOGO/TIME/DATE FLAGS
;
	LD	DE,2		;CYL,SEC
	LD	A,DREAD 	;DISK READ
	RST	DIO		;READ DCT/FLAGS
	JP	NZ,POSTE	;IF ERROR
	LD	A,-1		;TRUE
	LD	L,16		;HL => FLAGS
	LD	(HL),A		;(ON)
	INC	L
	LD	(HL),A		;(ON)
	INC	L
	LD	(HL),A		;(ON)
	LD	L,0		;HL => BUFFER
	LD	A,DWRITE	;DISK WRITE
	RST	DIO		;WRITE FLAGS
	JP	NZ,POSTE	;IF ERROR
;
;	PLACE BOOT/SYS ON DISK
;
	LD	HL,HBOOT	;HL => BOOT
	LD	DE,18
	LD	A,DWRITE	;DISK WRITE
	RST	DIO		;DO IT!
	JP	NZ,POSTE	;IF ERROR
	INC	E		;NEXT SECTOR
	INC	H		;NEXT BUFFER
	LD	A,DWRITE	;DISK WRITE
	RST	DIO		;DO IT!
	JP	NZ,POSTE	;IF ERROR
	JP	PSYS		;SKIP
;
	PAGE
;	CHECK FOR CYLINDER FORMAT
;
CKFOR	LD	A,(FTK) 	;FORMAT FLAG
	OR	A		;SDEN CYL 0?
	JP	Z,PSYS		;NO FORMAT
	BIT	7,(IY+5)	;8"?
	JP	NZ,PSYS
	BIT	7,(IY+13)	;DDEN DISK?
	JP	Z,PSYS		;IF NOT
;
;	SAVE/CONFIG DEST DCT
;
	PUSH	IY
	POP	HL		;HL => DCT
	LD	DE,13		;PERISH OFFSET
	ADD	HL,DE		;HL => PERISH
	PUSH	HL
	LD	DE,SAVDCT	;SAVE AREA
	LD	BC,10		;COUNT
	LDIR			;DO IT!
	POP	DE
	LD	HL,TK0DCT	;SPECIAL DCT
	LD	BC,10		;COUNT
	LDIR			;INIT
	SET	0,(IY+5)	;FORCE LOG
;
;	CONFIG SOURCE DCT
;
	LD	C,0		;SYSTEM DRIVE
	CALL	LOCDCT		;LOCATE SYSTEM
	PUSH	IY
	POP	HL
	LD	DE,13		;PERISH OFFSET
	ADD	HL,DE		;HL => PERISH
	EX	DE,HL		;DE => PERISH
	LD	HL,TK0DCT	;SPECIAL DCT
	LD	BC,10		;COUNT
	LDIR			;INIT
	SET	0,(IY+5)	;FORCE LOG
;
	PAGE
;	RE-FORMAT CYLINDER 0
;
	LD	A,(DRV2)	;TARGET DRIVE
	LD	C,A		;C = DRIVE
	CALL	LOCDCT		;IY => TARGET DCT
	LD	A,DHOME 	;DISK HOME
	RST	DIO		;HOME DRIVE
	LD	D,0		;CYLINDER
	CALL	FCYL		;FORMAT CYLINDER
	JP	NZ,POSTE	;I/O ERROR
	LD	HL,(BUFER1)	;HL => GAT
	LD	(HL),-1 	;ALL GRANS
;
;	READ BOOT FROM SOURCE
;
	LD	HL,(BUFER3)	;I/O BUFFER
	LD	DE,0		;CYL,SEC
	LD	BC,0		;SEC,DRIVE
;
RBOT1	LD	A,DREAD 	;DISK READ
	RST	DIO
	JP	NZ,POSTE	;I/O ERROR
	PUSH	BC		;SAVE
	LD	BC,128		;OFFSET
	ADD	HL,BC		;NEXT BUFFER
	POP	BC		;RESTORE
	LD	A,26		;LAST SECTOR
	INC	E		;NEXT SECTOR
	CP	E		;DONE?
	JR	NC,RBOT1	;WAIT TIL DONE
;
;	CORRECT CONFIG FOR SYSTEM
;
	LD	A,(SAVDCT+4)	;DIR LOC
	LD	HL,(BUFER3)	;I/O BUFFER
	LD	L,2		;SEC 0+2
	LD	(HL),A		;TO SECTOR
	LD	L,128+2 	;SEC 1+2
	LD	(HL),A		;TO SECTOR
	INC	H		;SEC 3
	LD	L,3		;SEC 3+3
	LD	DE,SAVDCT	;SAVED INFO
	EX	DE,HL		;SWAP
	LD	BC,10		;COUNT
	LDIR			;MOVE!
	LD	A,-1		;TRUE
	LD	E,16		;FLAGS OFFSET
	LD	(DE),A		;(ON)
	INC	E
	LD	(DE),A		;(ON)
	INC	E
	LD	(DE),A		;(ON)
;
	PAGE
;	WRITE BOOT INFO TO TARGET
;
	LD	HL,(BUFER3)	;I/O BUFFER
	LD	DE,0		;CYL,SEC
	LD	B,D		;BE = SECTOR
	LD	A,(DRV2)
	LD	C,A		;C = DRIVE
;
WBOT1	LD	A,DWRITE	;DISK WRITE
	RST	DIO
	JP	NZ,POSTE	;I/O ERROR
	PUSH	BC		;SAVE
	LD	BC,128		;OFFSET
	ADD	HL,BC		;NEXT BUFFER
	POP	BC		;RESTORE
	LD	A,26		;LAST SECTOR
	INC	E		;NEXT SECTOR
	CP	E		;DONE?
	JR	NC,WBOT1	;WAIT TIL DONE
;
;	POSITION TO INITIAL CYL & GRAN
;
;	ENT	IY =>	DEST DCT
;
PSYS	LD	A,(DDIR)	;DEST DIR LOC
	SUB	2
	LD	D,A		;INIT CYL
	LD	E,0		;INIT GRAN
	LD	BC,2<8+0	;LFN, DRV
;
	PAGE
;	READ SOURCE SYSTEM FILE ENTRY
;
;	ENT	 B =	LOGICAL FILE NUMBER
;		 C =	SOURCE DRIVE NUMBER
;		 D =	CYLINDER NUMBER
;		 E =	GRAN OFFSET
;
RDSYS	LD	HL,(BUFER3)	;SOURCE BUFF
	CALL	ADJLFN		;ADJUST LFN
	CALL	DIRRD		;READ FILE'S ENTRY
	JP	NZ,POSTE	;I/O ERROR
;
RSYS1	LD	A,(HL)		;GET ENTRY
	CPL			;INVERT
	AND	50H		;DEL,SYS
	JP	NZ,NEXT1	;IF DELETED
;
;	MOVE FILE ENTRY TO TARGET
;
	PUSH	HL		;SAVE SYS ENTRY
	PUSH	BC		;SAVE DRV, LFN
;
	PUSH	DE		;SAVE OFFSET
	PUSH	HL		;SAVE SYS ENTRY
	LD	A,(DRV2)	;TARGET DRIVE
	LD	C,A		;C = DRIVE
	CALL	ADJLFN		;ADJUST LFN
	LD	HL,(BUFER4)	;DEST BUFF
	CALL	DIRRD		;READ DEST
	JP	NZ,POSTE	;I/O ERROR
	EX	DE,HL		;DE => DEST ENTRY
	POP	HL		;HL => SYS ENTRY
	PUSH	DE		;SAVE DEST ENTRY
	LD	BC,32		;COUNT
	LDIR			;COPY!
	POP	HL		;GET DEST ENTRY
	POP	DE		;GET OFFSET
;
;	SET-UP CORRECT FILE ENTRY
;
	PUSH	HL		;SAVE DEST ENTRY
	PUSH	DE		;SAVE OFFSET
	LD	DE,14H		;OFFSET
	ADD	HL,DE		;HL => LOF
	LD	A,(HL)		;LSB LOF
	INC	L
	LD	H,(HL)		;MSB LOF
	LD	L,A		;HL = LOF
	POP	DE		;GET OFFSET
;
	CALL	BLDSD		;BUILD SD
	EX	DE,HL		;DE = SD
	EX	(SP),HL 	;HL => DEST ENTRY
;
	PUSH	HL		;SAVE DEST ENTRY
	LD	BC,16H		;OFFSET
	ADD	HL,BC		;HL => SD LIST
	LD	(HL),E		;SD
	INC	L		;NEXT
	LD	(HL),D		;SD
	LD	(CSD),DE	;SAVE SD
	POP	HL		;GET DEST ENTRY
	POP	DE		;GET NEW OFFSET
	POP	BC		;GET LFN, SYS DRV
;
	PUSH	BC		;SAVE LFN, SYS DRV
	LD	A,(DRV2)	;TARGET DRIVE
	LD	C,A		;C = DRIVE
	CALL	ADJLFN		;ADJUST LFN
	CALL	DIRWR		;WRITE ENTRY
	JP	NZ,POSTE	;I/O ERROR
	POP	BC		;GET LFN, SYS DRV
;
;	CALCULATE & PLACE HIT CODE
;
	LD	A,L		;LSB DIR ENTRY
	ADD	A,5		;NAME OFFSET
	LD	L,A		;HL => FILE NAME
	CALL	HASH		;GEN HAS CODE
	LD	HL,(BUFER2)	;HL => HIT
	LD	L,B		;L = LFN
	LD	(HL),A		;PLACE CODE
	POP	HL		;GET SOURCE ENTRY
;
	PAGE
;	SET-UP SOURCE & DEST FILE DCB'S
;
;	ENT	 B =	LOGICAL FILE NUMBER
;		 C =	SOURCE DRIVE
;		HL =>	SOURCE DIR ENTRY
;
	PUSH	DE		;SAVE NEW OFFSET
	PUSH	BC		;SAVE LFN, SYS DRV
;
	CALL	ADJLFN		;ADJUST LFN
	LD	IX,DCB1
	LD	IY,OLIST	;OPEN LIST
	CALL	SETDCB		;SET-UP OPEN DCB
	LD	(IX+1),20H	;SET STATUS
	LD	HL,DCB1 	;SOURCE DCB
	LD	DE,DCB2 	;DEST DCB
	LD	BC,40		;COUNT
	LDIR			;COPY!
	POP	BC
	PUSH	BC
	LD	A,(DRV2)	;GET DRIVE
	LD	C,A
	CALL	ADJLFN		;ADJUST LFN
	LD	(DCB2+16),BC	;TO DCB
	LD	HL,(CSD)	;GET SD
	LD	(DCB2+20),HL	;TO DCB
;
;	COPY FILE TO TARGET DISK
;
COPY1	LD	DE,DCB1 	;SOURCE DCB
	LD	HL,(BUFER3)	;START BUFFER
;
COPY2	LD	(DCB1+3),HL	;TO DCB
	INC	H
	LD	A,READNX
	RST	SVC		;READ SECTOR
	JR	Z,COPY2 	;NO ERRORS
	CP	EC28		;EOF?
	JR	Z,COPY3 	;DONE
	CP	EC29		;PAST EOF?
	JP	NZ,POSTE	;DONE
;
COPY3	LD	(TEMP),HL	;SAVE END BUFF
	LD	DE,DCB2
	LD	HL,(BUFER3)	;START BUFFER
;
COPY4	LD	(DCB2+3),HL	;TO DCB
	LD	A,WRITNX	;WRITE SECTOR
	RST	SVC
	JP	NZ,POSTE	;IF ERROR
	LD	A,(TEMP+1)	;END BUFFER
	DEC	A
	INC	H		;NEXT
	CP	H
	JR	NC,COPY4	;MORE?
;
	POP	BC		;GET LFN, SYS DRV
	POP	DE		;GET NEW OFFSET
;
	PAGE
;	GET NEXT AVAILABLE SYSTEM FILE
;
NEXT1	LD	A,B		;LFN
	INC	B		;NEXT
	CP	20		;DONE?
	JP	C,RDSYS 	;IF NOT
;
;	WRITE UPDATED TABLES AND EXIT
;
NEXT3	LD	A,(DRV2)	;TARGET DRIVE
	LD	C,A		;C = DRIVE
	LD	E,0		;GAT SECTOR
	LD	B,E
	LD	HL,(BUFER1)	;GAT BUFFER
	LD	A,SWRITE	;SYSTEM WRITE
	RST	DIO		;WRITE SECTOR
	JR	NZ,POSTE	;I/O ERROR
	INC	E		;GAT SECTOR
	INC	H		;GAT BUFFER
	LD	A,SWRITE	;SYSTEM WRITE
	RST	DIO		;WRITE SECTOR
	JR	NZ,POSTE	;I/O ERROR
	RST	EXIT		;ALL DONE!
;
	PAGE
;	POST ERROR MESSAGE AND EXIT
;
ERR1	LD	HL,ERMES1	;'ILLEGAL FILES'
	LD	BC,E1L<8+CR
	JR	ERRX
ERR2	LD	HL,ERMES2	;'BAD CONFIG'
	LD	BC,E2L<8+CR
ERRX	LD	A,VDLINE	;VIDEO LINE
	RST	SVC
	LD	A,ABORT 	;ABNORMAL EXIT
	RST	SVC		;GO!
;
;	POST DISK ERROR AND EXIT
;
POSTE	AND	7FH		;NO ABORT
	LD	B,A		;B = CODE
POSTB	LD	A,ERROR 	;POST ERROR
	RST	SVC
	LD	A,ABORT 	;ABNORMAL EXIT
	RST	SVC		;GO!
;
	PAGE
;	CHECK & ALLOCATE SEGMENT SPACE
;
;	ENT	 D =	CYLINDER NUMBER
;		 E =	GRAN OFFSET
;		HL =	FILE LENTH
;		IY =>	SYSTEM CALC DATA
;
;	EXT	 D =	NEW CYLINDER
;		 E =	NEW GRAN OFFSET
;		HL =	SEGMENT DESCRIPTOR
;
BLDSD	PUSH	BC		;SAVE
	LD	A,(IY+19)	;SEC/GRAN
	CALL	DDIVD		;DBL PREC DIVD
	OR	A		;PARTIAL GRAN?
	JR	Z,$+3		;IF NOT
	INC	HL		;FULL GRAN
	LD	B,L		;B = GRAN COUNT
;
;	CHECK FOR VALID SEGMENT SPACE
;
;	ENT	 B =	GRANULES REQUIRED
;		 D =	START CYLINDER
;		 E =	GRAN OFFSET
;
BLDSD3	PUSH	BC		;SAVE COUNT
	PUSH	DE		;SAVE OFFSET
BLDSD4	LD	HL,(BUFER1)	;HL => GAT
	LD	L,D		;HL => GAT ADD
	LD	A,(HL)		;GET INFO
	CALL	BBIT		;CHECK BIT
	PUSH	AF		;SAVE STAT
	LD	A,(IY+20)	;GRAN/CYL
	INC	E		;NEXT GRAN
	SUB	E		;END CYL?
	JR	NZ,$+4		;IF NOT
	LD	E,A		;NEW GRAN
	INC	D		;NEXT CYL
	POP	AF		;GRAN ALLOC?
	JR	Z,BLDSD6	;IF NOT
	POP	AF		;IGNORE OFFSET
	POP	BC		;RESTORE COUNT
	JR	BLDSD3		;TRY AGAIN
;
BLDSD6	DJNZ	BLDSD4		;TIL DONE
	POP	DE		;RESTORE REG
	POP	BC
;
	PAGE
;	ALLOCATE SEGMENT SPACE
;
;	ENT	 B =	GRANULES REQUIRED
;		 D =	START CYLINDER
;		 E =	GRAN OFFSET
;
	PUSH	BC		;SAVE REG
	PUSH	DE
BLDSD7	LD	HL,(BUFER1)	;HL => GAT
	LD	L,D		;HL => GAT ADD
	LD	A,(HL)		;GET DATA
	CALL	BSET		;ALLOC GRAN
	LD	(HL),A		;SET DATA
	LD	A,(IY+20)	;GRAN/CYL
	INC	E		;NEXT GRAN
	SUB	E		;END CYL?
	JR	NZ,$+4		;IF NOT
	LD	E,A		;NEW GRAN
	INC	D		;NEXT CYL
	DJNZ	BLDSD7		;TIL DONE
	POP	HL		;RESTORE REG
	POP	BC
;
;	BUILD SEGMENT DESCRIPTOR
;
;	ENT	 B =	GRANULES REQUIRED
;		 H =	START CYLINDER
;		 L =	GRAN OFFSET
;
	LD	A,L		;A = GRAN OFFSET
	LD	L,H		;L = CYL
	RRCA			;BITS 0-3
	RRCA
	RRCA			;TO BITS 5-7
	DEC	B		;GRANS-1
	OR	B		;A = GRAN DESCRIPT
	LD	H,A		;HL = SEG DESCRIPT
	POP	BC		;RESTORE
	RET
;
	PAGE
;	SET BINARY BIT ROUTINE
;
;	ENT	 E =	BIT NUMBER
;		 A =	BYTE
;
BSET	PUSH	AF		;SAVE BYTE
	LD	A,E		;GET BIT
	AND	7		;FORCE VALID
	RLCA
	RLCA
	RLCA			;BITS 4-5
	OR	0C7H		;SET INST
	LD	(BIT1),A
	POP	AF		;GET BYTE
BIT1	EQU	$+1
	SET	0,A		;DO IT!
	RET
;
;	TEST BINARY BIT ROUTINE
;
;	ENT	 E =	BIT NUMBER
;		 A =	BYTE
;
BBIT	PUSH	AF		;SAVE BYTE
	LD	A,E		;GET BIT
	AND	7		;FORCE VALID
	RLCA
	RLCA
	RLCA			;BITS 4-5
	OR	47H		;BIT INST
	LD	(BIT2),A
	POP	AF		;GET BYTE
BIT2	EQU	$+1
	BIT	0,A		;DO IT!
	RET
;
;	GENERATE A HASH CODE
;
;	ENT	HL =>	CRACKED FILESPEC
;
HASH	PUSH	BC		;SAVE
	LD	BC,11<8+0	;COUNT & INIT CODE
HASH1	LD	A,(HL)		;GET CHAR
	INC	L		;NEXT
	XOR	C		;ACCUMULATE
	RLCA			; * 2
	LD	C,A		;C = CODE
	DJNZ	HASH1		;THROUGH NAME
	POP	BC		;RESTORE
	OR	A		;ZERO?
	RET	NZ
	INC	A		;FORCE NON-ZERO
	RET
;
	PAGE
;	READ DIRECTORY FOR SPECIFIC FILE
;
;	ENT	 B =	LFN
;		 C =	DEVICE NUMBER
;		HL =>	I/O BUFFER
;
DIRRD	PUSH	BC		;SAVE
	PUSH	DE		;SAVE
	CALL	DIRLFN		;CONVERT LFN
	PUSH	HL		;SAVE => FILE
	LD	L,0		;HL => BUFFER
	LD	A,SREAD 	;SYSTEM READ
	RST	DIO
	POP	HL		;HL => FILE
	POP	DE		;RESTORE
	POP	BC
	RET	Z		;NO ERRORS
	LD	A,EC17		;DIR READ ERROR
	RET
;
;	WRITE DIRECTORY FOR SPECIFIC FILE
;
;	ENT	 B =	LFN
;		 C =	DEFAULT DRIVE INFO
;
DIRWR	PUSH	BC		;SAVE
	PUSH	DE		;SAVE
	CALL	DIRLFN		;CONVERT LFN
	PUSH	HL		;SAVE => FILE
	LD	L,0		;HL => BUFFER
	LD	A,SWRITE	;SYSTEM WRITE
	RST	DIO
	POP	HL		;HL => FILE
	POP	DE		;RESTORE
	POP	BC
	RET	Z		;NO ERRORS
	LD	A,EC18		;DIR WRITE ERROR
	RET
;
	PAGE
;	CONVERT LFN TO DIRECTORY LOCATION
;
;	ENT	 B =	LOGICAL FILE NUMBER
;		 C =	DEFAULT DRIVE INFO
;		HL =>	I/O BUFFER
;
;	EXT	DE =	CYLINDER, SECTOR
;		HL =>	DIRECTORY ENTRY
;
DIRLFN	LD	A,B		;LFN
	AND	0E0H		;BUFF
	LD	L,A
	XOR	B		;SEC
	ADD	A,2		;CORRECT
	LD	E,A
	LD	B,0		;BE = SECTOR
	RET
;
;	ADJUST FILE'S LFN AS NEEDED
;
;	ENT	 C =	DEVICE NUMBER
;		 B =	LFN
;
;	EXT	 B =	ADJUSTED LFN
;
ADJLFN	CALL	LOCDCT		;LOCATE DCT
	LD	A,B		;GET LFN
	ADD	A,2		;CORRECT
	SUB	(IY+17) 	;DIR LENGTH
	RET	C		;OK
	OR	20H		;NEXT ENTRY
	LD	B,A		;B = LFN
	RET
;
;	SET-UP OPEN FILE DCB
;
SETDCB	LD	A,2-1<4+4	;S2 - SETDCB
	RST	OVL		;GO!
;
;	POSITION HL TO NON-SEPERATOR
;
	INC	HL		;NEXT
POSHL	LD	A,(HL)		;GET CHAR
	CP	' '             ;BLANK?
	JR	Z,POSHL-1	;SKIP
	CP	','             ;TERM?
	JR	Z,POSHL-1	;SKIP
	CP	CR		;C/R?
	RET	Z		;ALL DONE
	CP	';'             ;C/R?
	RET	Z		;ALL DONE
	CP	ETX		;END TEXT?
	RET
;
	PAGE
;	SUBROUTINE TO FORMAT CYLINDER
;
;	ENT	 C =	DEVICE NUMBER
;		 D =	CYLINDER NUMBER
;
FCYL	PUSH	BC		;SAVE REG
	PUSH	DE
;
;	LAYOUT FORMAT TRACK
;
	LD	C,(IY+16)	;SEC/TRACK
	LD	A,D
	LD	(CYL1),A	;SET CYLINDER
	LD	DE,INTER	;DE => SECTOR SEQ
	PUSH	DE		;SAVE SEC SEQ
	LD	DE,STBL 	;DE => FORMAT TABLE
	LD	HL,(BUFER4)	;I/O BUFFER
	CALL	SET		;GAP 1
	CALL	SET		;INDEX
	CALL	SET		;GAP 1
	LD	(TBL),DE	;SAVE TABLE POS
;
TBL	EQU	$+1
FCYL10	LD	DE,0		;TABLE POS
	CALL	SET		;GAP 1 & 3
	CALL	SET		;GAP 1 & 3
;
	LD	(HL),0FEH	;ID AM
	INC	HL
CYL1	EQU	$+1
	LD	(HL),0		;CYLINDER NUM
	INC	HL
	LD	(HL),0		;SIDE NUM
	INC	HL
;
	EX	(SP),HL 	;HL => SEC NUM
	LD	A,(HL)
	INC	HL		;NEXT SEC
	EX	(SP),HL 	;RESTORE
;
	LD	(HL),A		;SECTOR NUM
	INC	HL
	LD	(HL),0		;SECTOR LEN
	INC	HL
	LD	(HL),0F7H	;2 CRC'S
	INC	HL
;
	CALL	SET		;GAP 2
	CALL	SET		;GAP 2
	CALL	SET		;GAP 2
;
	LD	(HL),0FBH	;DATA AM
	INC	HL
	LD	B,128		;SEC LEN
	LD	A,06CH		;DATA 0-F4 ONLY
	CALL	SET1		;FILL DATA
	LD	(HL),0F7H	;2 CRC'S
	INC	HL
;
	CALL	SET		;GAP 3
	DEC	C		;NEXT SECTOR
	JR	NZ,FCYL10	;TIL ALL SET
;
	CALL	SET		;GAP 4
	CALL	SET		;GAP 4
;
	POP	DE		;FLUSH STACK
	POP	DE
	POP	BC
;
;	WRITE FORMATTED BUFFER
;
	LD	E,0		;INIT SECTOR
	LD	B,0		;BE = SECTOR
	LD	HL,(BUFER4)	;I/O BUFFER
	LD	A,DFORM 	;FORMAT!
	RST	DIO
	RET
;
;	SUBROUTINE TO SET UP GAPS & DATA FIELDS
;
;	ENT	DE =>	FORMAT TABLE
;		HL =>	FORMAT BUFFER
;
SET	LD	A,(DE)		;DATA LENTH
	INC	DE		;NEXT
	LD	B,A		;B = DATA LENTH
	LD	A,(DE)		;DATA BYTE
	INC	DE		;NEXT
;
SET1	LD	(HL),A		;WRITE DATA
	INC	HL		;NEXT
	DJNZ	SET1		;TIL DONE
	RET
;
	PAGE
;	OPEN PARAMETER LIST
;
OLIST	DEFW	-1		;BUFADR
	DEFW	-1		;RECADR
	DEFW	0		;EOFADR
	DEFB	'W'             ;ACCESS TYPE
	DEFB	0		;LRL
	DEFB	'F'             ;FIXED
	DEFB	2		;CREATE CODE
;
;	SPECIAL CYL 0 DCT INFO
;
TK0DCT	DEFB	40H		;SDEN
	DEFB	1		;SURFACE COUNT
	DEFB	-1		;CYL COUNT
	DEFB	27		;SEC/TRACK
	DEFB	-1		;DIR LENGTH
	DEFB	-1		;DIR LOCATION
	DEFB	27		;SEC/GRAN
	DEFB	1		;GRANS/CYL
	DEFW	27		;SEC/CYL
;
;	STORAGE FOR DEST DCB
;
SAVDCT	DEFS	10		;PERISH INFO
;
	PAGE
;	SINGLE DENSITY FORMAT TABLE
;
STBL	DEFB	11
	DEFB	0FFH		;GAP 1
	DEFB	1
	DEFB	0FCH		;GAP 1
	DEFB	20
	DEFB	0FFH		;GAP 1
;
	DEFB	3
	DEFB	00H		;GAP 1 & 3
	DEFB	3
	DEFB	00H		;GAP 1 & 3
;
	DEFB	11
	DEFB	0FFH		;GAP 2
	DEFB	3
	DEFB	00H		;GAP 2
	DEFB	3
	DEFB	00H		;GAP 2
;
	DEFB	11
	DEFB	0FFH		;GAP 3
;
	DEFB	0
	DEFB	0FFH		;GAP 4
	DEFB	0
	DEFB	0FFH		;GAP 4
;
;	SECTOR INTERLEAVE TABLE
;
INTER	DB	0,14,1,15,2,16,3,17
	DB	4,18,5,19,6,20,7,21
	DB	8,22,9,23,10,24,11,25
	DB	12,26,13
;
	PAGE
;	MESSAGES AND TEXT STRINGS
;
TITLE	DEFB	CR
	DEFM	'SYSGEN - DosPLUS II System Generation - Series A.00'
	DEFB	CR
	DEFM	'(c)(p) Copyright 1982 by MicroPower, Inc.'
	DEFB	CR
	DEFB	CR
TL	EQU	$-TITLE
;
MES1	DEFM	'Program Terminated'
M1L	EQU	$-MES1
ERMES1	DEFM	'Disk contains illegal files'
E1L	EQU	$-ERMES1
ERMES2	DEFM	'Target drive CONFIG invalid'
E2L	EQU	$-ERMES2
;
*GET	HBOOT2			;HARD DISK BOOT
;
	PAGE
;	VARIABLES AND DATA
;
DDIR	DEFS	1		;DEST DIR LOC
FTK	DEFS	1		;FORMAT FLAG
DRV2	DEFS	1		;TARGET DRIVE
CSD	DEFS	2		;CURRENT SD
TEMP	DEFS	2		;STACK SAVE
BUFER1	DEFS	2		;GAT BUFFER
BUFER2	DEFS	2		;HIT BUFFER
BUFER3	DEFS	2		;I/O BUFFER
BUFER4	DEFS	2		;I/O BUFFER
DCB1	DEFS	41		;SOURCE FILE DCB
DCB2	DEFS	41		;TARGET FILE DCB
;
ENDPGM	EQU	$<-8+1<8	;FREE MEMORY
;
	END	START
